subroutine sg_map(task,line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sg_map
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !
  !     Support for commands
  !       UV_RESTORE
  !       UV_MAP
  ! and   MX (eventually, not coded yet)
  !
  ! Compute a map from a CLIC UV Sorted Table  by Gridding and Fast Fourier
  ! Transform, using adequate virtual memory space for optimisation. Also
  ! allows removal of Clean Components in the UV data and restoration of
  ! the clean image.
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean components
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !     a beam image or cube
  !     a LMV cube  (dirty or clean)
  !
  ! To be implemented
  !     Optionally, a Residual UV table
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: task ! Caller (MX or UV_MAP or UV_RESTORE)
  character(len=*), intent(in) :: line ! Command line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  real(8) new(3)
  real(4) rmega,uvmax,uvmin,uvma
  integer wcol,mcol(2),rcol,sblock
  integer ier
  logical one, sorted, shift, found(3)
  character(len=message_length) :: chain
  real cpu0, cpu1
  real(8) :: freq
  integer nx,ny,nu,nv,nc,nb,mx,my
  !
  logical do_cct, do_slow, do_copy
  integer, parameter :: o_slow = 2
  integer, parameter :: o_copy = 1
  !
  integer, save :: saved_mcol(2)=[0,0]
  integer, save :: saved_wcol=0
  !
  ! Print *,'DO_WEIG at start ',do_weig
  !
  themap%beam = 0
  call sic_get_inte('MAP_BEAM_STEP',themap%beam,error)
  !
  do_cct = task.eq.'UV_RESTORE'
  !
  do_slow = sic_present(o_slow,0)
  do_copy = sic_present(o_copy,0)
  !
  error = .false.
  !
  if (do_cct) then
    !
    ! Subtract all Clean Components
    if (.not.associated(duv)) then
      call map_message(seve%e,task,'No UV data loaded')
      error = .true.
    endif
    if (.not.allocated(dcct)) then
      call map_message(seve%e,task,'No CCT data available')
      error = .true.
    endif
    if (error) return
  endif
  !
  call map_prepare(task,themap,error)
  if (error) return
  !
  one = .true.
  call sic_get_inte('WCOL',wcol,error)
  call sic_get_inte('MCOL[1]',mcol(1),error)
  call sic_get_inte('MCOL[2]',mcol(2),error)
  !
  call sic_get_logi('UV_SHIFT',shift,error)
  if (shift) then
    ! Read MAP_RA, MAP_DEC, MAP_ANGLE
    call map_get_radecang(task,found,new,error)
    if (error)  return
    if (.not.all(found)) then
      call map_message(seve%e,task,'MAP_RA and MAP_DEC must be defined')
      error = .true.
      return
    endif
  else
    new(:) = 0.d0
  endif
  !
  ! First sort the input UV Table, leaving UV Table in UV_*
  call gag_cpu(cpu0)
  call uv_sort (error,sorted,shift,new,uvmax,uvmin)
  if (error) return
  if (.not.sorted) then
    ! Redefine SIC variables (mandatory)
    call sic_delvariable ('UV',.false.,error)
    call sic_mapgildas ('UV',huv,error,duv)
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  call map_parameters(task,themap,freq,uvmax,uvmin,error)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  !
  nx = themap%size(1)
  ny = themap%size(2)
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  !
  ! Define the number of output channels
  nc = huv%gil%nchan
  if (do_cct .and. nc.ne.hcct%gil%dim(2)) then
    Print *,'Mismatch number of channels between HUV ',nc,' and CCT ',hcct%gil%dim(2)
  endif
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  nc = mcol(2)-mcol(1)+1
  !
  ! Find out how many beams are required
  call map_beams(task,themap%beam,huv,nx,ny,nb,nc)
  !
  ! Check if Weights have changed by MCOL choice
  !!PRINT *,'DO_WEIG before ',do_weig
  if (any(saved_mcol.ne.mcol) .or. nb.gt.1) do_weig = .true.
  if (saved_wcol.ne.wcol) do_weig = .true.
  !!PRINT *,'DO_WEIG just after ',do_weig,' nb ',nb
  saved_mcol = mcol
  saved_wcol = wcol
  !
  if (method%method.eq.'MX') do_weig = .true. ! Test
  if (do_weig) then
    call map_message(seve%i,task,'Computing weights ')
    if (allocated(g_weight)) deallocate(g_weight)
    if (allocated(g_v)) deallocate(g_v)
    allocate(g_weight(nv),g_v(nv),stat=ier)
    if (ier.ne.0) goto 98
  else
    call map_message(seve%i,task,'Re-using weight space')
  endif
  !
  rmega = 512.0
  ier = sic_ramlog('SPACE_MAPPING',rmega)
  !
  ! In fast mode, an intermediate Large FFT is used
  ! The maximum number of threads should also play a role here,
  ! but we assume the user has accounted for this in its definition
  ! of SPACE_MAPPING
  !
  if (do_cct.and..not.do_slow) then
    mx = max(nx,min(4*nx,4096))
    my = max(ny,min(4*ny,4096))
    sblock = max(int(256.0*rmega*1024.0)/mx/my,1)
  else
    sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  endif
  !
  ! New Beam place
  if (allocated(dbeam)) then
    call sic_delvariable ('BEAM',.false.,error)
    deallocate(dbeam)
  endif
  call gildas_null(hbeam)
  !
  ! Process sorted UV Table according to the number of beams produced
  !
  hbeam%gil%ndim = 3
  hbeam%gil%dim(1:4)=[nx,ny,nb,1]
  if (nb.gt.1) then
    allocate(hbeam%r3d(nx,ny,nb),dbeam(nx,ny,1,nb),stat=ier)
    rcol = 0
  else
    allocate(dbeam(nx,ny,1,1),stat=ier)
    hbeam%r3d => dbeam(:,:,:,1)
    rcol = (mcol(2)+mcol(1))/2
  endif
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error on DBEAM')
    error =.true.
    return
  endif
  !
  if (do_cct) then
    hcct%r3d => dcct
    !
    ! New residual image
    if (allocated(dresid)) then
       call sic_delvariable ('RESIDUAL',.false.,error)
       deallocate(dresid)
    endif
    allocate(dresid(nx,ny,nc),stat=ier)
    !
    call gildas_null(hresid)
    hresid%gil%ndim = 3
    hresid%gil%dim(1:3) = (/nx,ny,nc/)
    hresid%r3d => dresid
    !
    if (allocated(dclean)) then
       call sic_delvariable ('CLEAN',.false.,error)
       deallocate(dclean)
    endif
    allocate(dclean(nx,ny,nc),stat=ier)
    hclean%r3d => dclean
    !
    call uvmap_and_restore (task,themap,   &
       &    huv, hbeam, hresid,   &
       &    nx,ny,nu,nv, duv,   &
       &    g_weight, g_v, do_weig,  &
       &    rcol,wcol,mcol,sblock,cpu0,error,uvma, &
       &    method, do_cct, hcct, hclean, do_slow, do_copy)
    !!PRINT *,'DO_WEIG after ',do_weig
    !
    ! Specify clean beam parameters
    hclean%gil%reso_words = 3
    hclean%gil%majo = method%major
    hclean%gil%mino = method%minor
    hclean%gil%posa = pi*method%angle/180.0
    !
    ! Get extrema
    call map_minmax(hclean)
    !
    hclean%loca%size = nx*ny*nc
    hclean%gil%ndim = 3
    hclean%gil%dim(1:3) = (/nx,ny,nc/)
    call sic_mapgildas ('CLEAN',hclean,error,dclean)
    call sic_mapgildas ('RESIDUAL',hresid,error,dresid)
    !
    save_data(code_save_clean) = .true.
    save_data(code_save_resid) = .true.
  else
    !
    ! New dirty image
    if (allocated(ddirty)) then
       call sic_delvariable ('DIRTY',.false.,error)
       deallocate(ddirty)
    endif
    allocate(ddirty(nx,ny,nc),stat=ier)
    !
    call gildas_null(hdirty)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1:3) = (/nx,ny,nc/)
    hdirty%r3d => ddirty
    call sic_mapgildas('DIRTY',hdirty,error,ddirty)
    !
    call uvmap_and_restore (task,themap,   &
       &    huv, hbeam, hdirty,   &
       &    nx,ny,nu,nv, duv,   &
       &    g_weight, g_v, do_weig,  &
       &    rcol,wcol,mcol,sblock,cpu0,error,uvma, &
       &    method, do_cct, hcct, hclean, do_slow, do_copy)
    !!PRINT *,'DO_WEIG after ',do_weig
    !
    save_data(code_save_beam) = .true.
    save_data(code_save_dirty) = .true.
    !
    call new_dirty_beam
    !
    ! Define Min Max
    call map_minmax(hdirty)
    !
    d_max = hdirty%gil%rmax
    if (hdirty%gil%rmin.eq.0) then
       d_min = -0.03*hdirty%gil%rmax
    else
       d_min = hdirty%gil%rmin
    endif
  endif
  !
  ! Re-shape the beam, and reset the 4-D pointer,
  ! but show it as a 3-D array in SIC
  if (nb.gt.1) then
    dbeam(:,:,:,:) = reshape(hbeam%r3d,[nx,ny,1,nb])
    deallocate(hbeam%r3d)
  endif
  !
  hbeam%r4d => dbeam
  hbeam%gil%dim(1:4)=[nx,ny,1,nb]
  hbeam%gil%ndim = 4
  !
  ! Transpose the header appropriately
  hbeam%gil%convert(:,4) = hbeam%gil%convert(:,3)
  hbeam%gil%faxi = 4
  hbeam%char%code(4) = 'VELOCITY' ! Frequency would be better...
  hbeam%gil%convert(:,3) = 1.d0
  hbeam%char%code(3) = 'FIELD'    ! Pseudo-mosaic
  hbeam%gil%ndim = 4
  !
  call sic_mapgildas('BEAM',hbeam,error,dbeam)
  !
  if (.not.error) call map_message(seve%i,task,'Successful completion')
  !
  !
  if (task.ne.'MX') goto 99
  !
99 continue
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  !!PRINT *,'DO_WEIG at end ',do_weig
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
  !
102 format(a,f9.2)
  !
end subroutine sg_map
!
subroutine uvmap_and_restore (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,r_weight, w_v, do_weig,    &
     &    rcol,wcol,mcol,sblock,cpu0,error,uvmax, &
     &    method, do_cct,hcct,hclean,do_slow,do_copy)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uvmap_and_restore
  use clean_def
  use clean_default
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   a different beam per channel.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  ! (optionally) a list of Clean components
  !
  ! Output :
  ! a beam image
  ! a DIRTY or RESIDUAL and CLEAN cube
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx   ! X size
  integer, intent(in) :: ny   ! Y size
  integer, intent(in) :: nu   ! Size of a visibilities
  integer, intent(in) :: nv   ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout), target :: r_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)         ! V values
  logical, intent(inout) :: do_weig
  !
  real, intent(inout) :: cpu0        ! CPU
  real, intent(inout) :: uvmax       ! Maximum baseline
  integer, intent(inout) :: sblock   ! Blocking factor
  integer, intent(inout) :: rcol     ! Reference frequency channel
  integer, intent(inout) :: wcol     ! Weight channel
  integer, intent(inout) :: mcol(2)  ! First and last channel
  logical, intent(inout) :: error
  logical, intent(in) :: do_cct
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: hcct
  type (gildas), intent(inout) :: hclean
  logical, intent(in) :: do_slow
  logical, intent(in) :: do_copy
  !
  ! Global variables:
  !
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  type (gridding) :: conv
  character(len=32) :: cname
  !
  integer :: nchan    ! Number of channels
  integer :: ndata    ! Size of data
  integer :: nbeam    ! Number of beams
  integer :: schunk   ! Number of channels per chunk
  integer :: nblock   ! Number of blocks/chunks ( = nbeam if nbeam.gt.1)
  integer :: ier, icmax
  real(kind=8) :: freq
  integer ctypx,ctypy
  integer lcol,fcol
  real wall,cpu1
  real xparm(10),yparm(10)
  real(8) :: vref,voff,vinc
  real(kind=4) :: loff,boff
  integer ndim, nn(2), lx, ly, kz1
  integer kz,iz,ic,kc,kb,jc,lc
  character(len=message_length) :: chain
  !
  real :: rms, null_taper(4), wold
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:),  w_grid(:,:), walls(:)
  real, allocatable :: w_weight(:)
  real, allocatable :: beam(:,:)
  real, allocatable :: w_mapu(:), w_mapv(:)
  real, allocatable :: local_wfft(:)
  real uvcell(2)
  real support(2)
  real(8) local_freq
  !
  integer :: ithread,othread,nthread
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  logical :: local_error
  logical :: compute_weight
  !
  integer :: maxic, icc, no, niter
  integer, allocatable :: mic(:)    ! Number of clean components per channel
  real, allocatable :: ouv(:,:)     ! Residual Visibilities
  real, allocatable :: ccou(:,:,:)  ! Transpose, compressed Clean Component List
  type (cct_par), allocatable :: p_cct(:)
  type(clean_par) :: my_method
  real :: my_major, my_minor, my_angle
  integer :: ix_min,ix_max,iy_min,iy_max
  real :: bmin,bmax
  character(len=12) :: fname
  integer :: grid_code
  integer(kind=4) :: lastchanblock,firstchanblock
  !$ integer(kind = OMP_lock_kind) :: lck_weight, lck_grid
  !
  grid_code = 0
  call sic_get_inte('MAP_GRID_CODE',grid_code,error)
  !
  ! Code:
  elapsed_s = 0
  elapsed_e = 0
  error = .false.
  ndata = nx*ny
  nchan = huv%gil%nchan
  nbeam = hbeam%gil%dim(3)
  !
  schunk = map%beam
  null_taper = 0
  !
  if (schunk.ne.1 .and. nbeam.gt.1) then
    write(chain,'(a,i6,a)') 'Processing ',schunk,' channels per beam'
    call map_message(seve%w,rname,chain)
  endif
  if (nbeam.eq.1) then
    !
    ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
    if (sblock.gt.0) then
      nblock = (nchan+sblock-1)/sblock
      kz = mod(nchan,sblock)
      if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
        if (nblock.ne.1) nblock = nblock-1
      endif
      sblock = (nchan+nblock-1)/nblock
      schunk = min(sblock,nchan)
    else
      schunk = nchan
      nblock = 1
    endif
    !$ nthread = omp_get_max_threads()
    if (nblock.lt.nthread) then
      nblock = min(nthread,nchan)
      sblock = (nchan+nblock-1)/nblock
      write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
        & sblock,' channels for Threading'
      call map_message(seve%w,rname,chain)
      schunk = sblock
    endif
    write(chain,'(A,I6,A,I8,A)') 'Using ',nblock,' blocks of ',&
        & schunk
    call map_message(seve%w,rname,chain)
  else
    nblock = nbeam  ! For the Nesting of OMP parallel codes
  endif
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nchan))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nchan
  else
    mcol(2) = max(1,min(mcol(2),nchan))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nchan)
  nchan = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  if (rcol.eq.0) then
    freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  else
    freq = gdf_uv_frequency(huv, dble(rcol) )
  endif
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Process sorted UV Table according to the type of beam produced
  !
  allocate (w_w(nv),w_weight(nv),walls(nbeam),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Weight arrays')
    error = .true.
    return
  endif
  w_v(:) = uvdata(2,1:nv)
  !
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%e,rname,chain)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  !
  ! Get FFT's and beam work spaces
  allocate (tfgrid(schunk+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
    & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
    & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate TF arrays')
    error = .true.
    return
  endif
  !
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Prepare grid correction,
  call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
  call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call gdf_copy_header(huv,hbeam,error)
  hbeam%gil%dopp = 0.0  ! Nullify the Doppler factor
  !
  hbeam%gil%ndim = 3
  hbeam%gil%dim(1) = nx
  hbeam%gil%dim(2) = ny
  hbeam%gil%dim(3) = nbeam
  hbeam%gil%dim(4) = 1
  hbeam%gil%convert(1,1) = nx/2+1
  hbeam%gil%convert(1,2) = ny/2+1
  hbeam%gil%convert(2,1) = 0
  hbeam%gil%convert(2,2) = 0
  hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
  hbeam%gil%convert(3,2) = map%xycell(2)
!    hbeam%gil%convert(1,3) = vref-fcol+1     ! for 1 per channel
! From UV_COMPRESS
!    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
!    uvout%gil%ref(1) = (2.0*uvout%gil%ref(1)+nc-1.0)/2/nc
!    uvout%gil%vres = nc*uvout%gil%vres
!    uvout%gil%fres = nc*uvout%gil%fres
!
! Strictly speaking, this is true only if there is more than one beam
! but the information is only used in this case anyway
  hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+schunk+1.d0)/2/schunk ! Correct
  hbeam%gil%convert(2,3) = voff
  hbeam%gil%proj_words = 0
  hbeam%gil%extr_words = 0
  hbeam%gil%reso_words = 0
  hbeam%gil%uvda_words = 0
  hbeam%gil%type_gdf = code_gdf_image
  !
  hbeam%char%code(1) = 'ANGLE'
  hbeam%char%code(2) = 'ANGLE'
  hbeam%char%code(3) = 'VELOCITY'
  hbeam%gil%xaxi = 1
  hbeam%gil%yaxi = 2
  hbeam%gil%faxi = 3
  hbeam%gil%majo = 0.0
  hbeam%loca%size = nx*ny*nbeam
  !
  ! Prepare the dirty map header
  call gdf_copy_header(hbeam,hdirty,error)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1) = nx
  hdirty%gil%dim(2) = ny
  hdirty%gil%dim(3) = nchan
  hdirty%gil%dim(4) = 1
  hdirty%gil%convert(1,3) = vref-fcol+1
  hdirty%gil%convert(2,3) = voff
  hdirty%gil%convert(3,3) = vinc
  hdirty%gil%proj_words = def_proj_words
  hdirty%gil%uvda_words = 0
  hdirty%gil%type_gdf = code_gdf_image
  hdirty%char%code(1) = 'RA'
  hdirty%char%code(2) = 'DEC'
  hdirty%char%code(3) = 'VELOCITY'
  call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
                  hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hdirty%gil%pang = 0.d0     ! Defined in table.
    hdirty%gil%a0 = hdirty%gil%ra
    hdirty%gil%d0 = hdirty%gil%dec
  else
    hdirty%gil%ptyp = p_azimuthal
    hdirty%gil%pang = huv%gil%pang ! Defined in table.
    hdirty%gil%a0 = huv%gil%a0
    hdirty%gil%d0 = huv%gil%d0
  endif
  hdirty%char%syst = 'EQUATORIAL'
  hdirty%gil%xaxi = 1
  hdirty%gil%yaxi = 2
  hdirty%gil%faxi = 3
  hdirty%gil%extr_words = 0          ! extrema not computed
  hdirty%gil%reso_words = 0          ! no beam defined
  hdirty%gil%nois_words = 2
  hdirty%gil%majo = 0
  hdirty%char%unit = 'Jy/beam'
  hdirty%loca%size = nx*ny*nchan
  !
  ! Smooth the beam
  hbeam%gil%convert(3,3) = vinc*schunk
  hbeam%gil%vres = schunk*vinc
  hbeam%gil%fres = schunk*hbeam%gil%fres
  !
  if (do_cct) then
    call gdf_copy_header(hdirty,hclean,error)
    maxic = hcct%gil%dim(3)
    no = 7+3*schunk
    allocate (ouv(no,huv%gil%dim(2)), &
    &   ccou(3,maxic,schunk), mic(schunk), p_cct(maxic), stat=ier)
  else
    no = 7+3*schunk
    allocate (ouv(no,huv%gil%dim(2)), stat=ier)
    maxic = 0
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV data allocation error')
    error = .true.
    return
  endif
  !
  cname = rname
  !
  error = .false.
  if (nbeam.gt.1) then
    !$ othread = omp_get_max_threads()
    !$ nthread = min(othread,nbeam)
    !$ call omp_set_num_threads(nthread)
  else
    ! Set a lock if Nbeam is One
    if (omp_uvmap_lock) then
    !$ call omp_init_lock(lck_weight)
    !$ call omp_init_lock(lck_grid)
    endif
  endif
  !$ elapsed_s = omp_get_wtime()
  !
  ! Print *,'WCOL ',wcol,' RCOL ',rcol,' FREQ '
  !
  ! Loop over blocks
  !
  !$OMP PARALLEL if (nblock.gt.1) DEFAULT(none) &      ! For UV_MAP first
  !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &
  !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
  !$OMP PRIVATE(local_wfft,chain,firstchanblock,lastchanblock) &
  !$OMP PRIVATE(local_freq,support,wall,rms,uvcell,local_error) &
  !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1,jc,lc, cname) &
  !$OMP SHARED(walls,schunk,nbeam) &
  !$OMP SHARED(nu,nv,nx,ny,nchan,ndata,fcol,lcol,lx,ly, nthread) &
  !$OMP SHARED(map,null_taper,error) &
  !$OMP SHARED(conv,freq,do_weig, r_weight) &
  !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname) &
  !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread) &
  !$OMP SHARED(maxic,hcct,hclean,no,do_cct,do_slow,method,do_copy) & ! For RESTORE
  !$OMP PRIVATE(mic,niter,ccou,ouv,p_cct) &
  !$OMP PRIVATE(ix_min,ix_max,iy_min,iy_max,bmin,bmax,icmax) &
  !$OMP PRIVATE(my_method,fname,compute_weight) SHARED(my_major, my_minor, my_angle) &
  !$OMP SHARED(lck_weight, lck_grid, omp_uvmap_lock, omp_debug) & ! Lock mechanism for grid & weight
  !$OMP SHARED(rcol, wold, wcol, grid_code)
  kz = 1 ! test for bug below
  !
  ! Print *,'KZ ',kz,' NChan ',nchan,' ndata ',ndata
  my_method = method
  my_method%method = 'RESTORE'
  !
  ! Loop over blocks
  !$OMP DO SCHEDULE(STATIC)
  do ic = fcol,lcol,schunk                !
    ! Set a Lock
    lc = min(lcol,ic+schunk-1) ! Last channel in the block (in input unit)
    kz = lc-ic+1 ! Width of the chunk, may be different from schunk in last block
    ! First and last channels in block in output unit
    firstchanblock = ic-fcol+1 
    lastchanblock = lc-fcol+1
    !
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !$ elapsed_s = omp_get_wtime()
    !$ write(cname,'(A,A,I0,A)') trim(rname),'(',ic,')' 
    !
    jc = min(lcol,ic+schunk/2)            ! The default weight channel here...
    if (nbeam.eq.1) jc = wcol             ! Reset the default weight channel
    !!Print *,'JC ',jc,' Wcol ',wcol, ic, lcol,schunk
    compute_weight = do_weig
    !$ if (nbeam.eq.1 .and. omp_uvmap_lock) then
    ! One will get the lock, the others will not compute the weights
    !$   if (do_weig .and. (ic.le.wcol .and. ic+schunk.gt.wcol) ) then
    !$     call omp_set_lock(lck_weight)
    !$     Print *,'Thread ',ithread,' got WEIGHT lock ',do_weig,' WCOL ',ic,' < ',wcol &
    !$       ,' < ',ic+schunk
    !$   else
    !$     compute_weight = .false.
    !$   endif
    !$ endif
    !Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', Schunk ',schunk
    !
    kb = (ic-fcol)/schunk+1
    if (kb.gt.nbeam .or. kb.lt.1) then
      !
      ! *** Actually, this is perfectly acceptable in the One Beam, Many Chunks case
      if (nbeam.gt.1) Print *,'Programming error, expected 0 < ',kb,' < ',nbeam+1
      kb = nbeam
    endif
    !
    w_w(:) = uvdata(7+3*jc,:)
    wold = sump(nv,w_w)
    !
    ! Search for a non empty weight channel
    if (wold.eq.0) then
      do kc=ic,lc 
        if (kc.ne.jc) then
          w_w(:) = uvdata(7+3*kc,:)
          wold = sump(nv,w_w)
          if (wold.ne.0) then
            jc = kc
            exit
          endif
        endif
      enddo
    endif
    !
    if (wold.eq.0) then
       write(chain,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
       hbeam%r3d(:,:,kb) = 0
       do kc=firstchanblock,lastchanblock
          hdirty%r3d(:,:,kc) = 0
       end do
      walls(kb) = 0.0
      if (nbeam.eq.1) then
        call map_message(seve%e,rname,chain)
        error = .true.
      else
        call map_message(seve%w,rname,chain)
      endif
      !
      ! One should release the Lock if only one beam is needed...
      cycle
    else
      wall = 1e-3/sqrt(wold)
      !!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
      !!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Compute the weights from this
    !
    if (compute_weight) then
       local_error = .false.
      call doweig (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,    &            ! U, V pointers
         &    jc,     &            ! Weight channel
         &    map%uniform(1),   &  ! Uniform UV cell size
         &    w_weight,   &        ! Weight array
         &    map%uniform(2),   &  ! Fraction of weight
         &    w_v,              &  ! V values
         &    local_error,      &
         &    grid_code)           ! Gridding method (for tests)
      if (local_error)  then
        error = .true.
        ! One should release the Lock if only one beam is needed...
        cycle
      endif
      !
      ! Should also plug the TAPER here, rather than in DOFFT later  !
      call dotape (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    map%taper,  &        ! Taper
         &    w_weight)            ! Weight array
      !
      ! Re-normalize the weights and re-count the noise
      wall = sump(nv,w_weight)
      if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
      !
      ! Declare the weight ready
      if (nbeam.eq.1) then
        if (do_weig) r_weight = w_weight
        !$ if (omp_uvmap_lock) then
        !$ Print *,'Thread ',ithread,' Unsetting LCK Weight ',do_weig, compute_weight
        !$ call omp_unset_lock(lck_weight)  ! Release the lock
        !$ endif
      endif
    else
      !$  if (nbeam.eq.1 .and. omp_uvmap_lock) then
      !$    if (omp_debug) Print *,'Thread ',ithread,' waiting for lck_weight ',do_weig
      !$    call omp_set_lock(lck_weight)    ! Wait for the Lock to be grasped
      !$    if (omp_debug) Print *,'Thread ',ithread,' got lck_weight ',do_weig
      !$    call omp_unset_lock(lck_weight)  ! and free it immediately
      !$  endif
      chain = 'Reusing weights'
      !$ write(chain(20:),'(a,i4)') ' - Thread ',ithread
      call map_message(seve%i,cname,chain)
      w_weight = r_weight
      !
      wall = sump(nv,w_weight)
      if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
    endif
    !
    wall = 1e-3/sqrt(wall)
    write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
    call prnoise(cname,trim(chain),wall,rms)
    walls(kb) = wall
    !
    ! Then compute the Dirty Beam
    if (rcol.eq.0) then
      local_freq = gdf_uv_frequency(huv, dble(ic))
    else
      local_freq = freq
    endif
    uvcell = map%uvcell * (freq / local_freq)
    support = map%support * (freq / local_freq)
    !
    call docoor (lx,-uvcell(1),w_mapu)
    call docoor (ly,uvcell(2),w_mapv)
    !
    ! Optionally remove the Clean components
    icmax = 0
    !
    if (maxic.ne.0) then
      ! Compact the Clean components first
      call uv_clean_sizes(hcct,hcct%r3d,mic,ic,lc)
      icmax = maxval(mic)
      if (icmax.ne.0) then
        call uv_squeeze_clean(nchan,hcct%r3d,ccou, mic,ic,lc)
        freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
        if (do_slow) then
          call uv_removes_clean(huv,uvdata,ouv,kz,mic,ccou,freq,ic,lc)
          !!Print *,'Done remove clean SLOW'
        else
          call uv_removef_clean(hdirty,uvdata,ouv,kz,mic,ccou,freq,ic,lc)
          !!Print *,'Done remove clean FAST'
        endif
      else
        if (do_copy) call uv_extract_clean(uvdata,ouv,kz,ic,lc)
        call map_message(seve%w,cname,'No valid Clean Component')
      endif
      !$  elapsed_e = omp_get_wtime()
      !$  elapsed = elapsed_e - elapsed_s
      !$  write(chain,'(a,f9.2,a)') 'Finished Subtract Clean ',elapsed
      !$  call map_message(seve%i,cname,chain)
    else if (do_copy) then
      call uv_extract_clean(uvdata,ouv,kz,ic,lc)
    endif
    !
    if (.not.do_copy .and. icmax.eq.0) then
      !$ if (omp_debug) Print *,'No copy '
      !
      ! Compute FFT's
      call dofft (nu,nv,          &   ! Size of visibility array
           &    uvdata,           &   ! Visibilities
           &    1,2,              &   ! U, V pointers
           &    ic,               &   ! First channel to map
           &    kz,lx,ly,         &   ! Cube size
           &    tfgrid,           &   ! FFT cube
           &    w_mapu,w_mapv,    &   ! U and V grid coordinates
           &    support,uvcell,null_taper, &  ! Gridding parameters
           &    w_weight,w_v,     &    ! Weight array + V Visibilities
           &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
    else
      !$ if (omp_debug) Print *,'With copy '
      call dofft (no,nv,          &   ! Size of visibility array
           &    ouv,              &   ! Visibilities
           &    1,2,              &   ! U, V pointers
           &    1,                &   ! First channel to map
           &    kz,lx,ly,         &   ! Cube size
           &    tfgrid,           &   ! FFT cube
           &    w_mapu,w_mapv,    &   ! U and V grid coordinates
           &    support,uvcell,null_taper, &  ! Gridding parameters
           &    w_weight,w_v,     &    ! Weight array + V Visibilities
           &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
      !
    endif
    !
! *** Compute the beam only if needed ***
! **** Put a LOCK around this in case of only One Beam but multi-thread ****
    !
    kz1 = kz+1
    call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
    call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
    beam = 0.0
    call cmtore (ftbeam, beam ,nx,ny)
    call chkfft (beam, nx,ny, error)
    !!Print *,'NU,NV ',nu,nv
    !!Print *,'IC ',ic
    !!Print *,'KZ,LX,LY ',kz,lx,ly
    !!Print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
    !!Print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
    !!Print *, ' '
    if (error) then
      Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1),' NO ',no
      Print *,'Local freq ',local_freq
      Print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' Schunk ',schunk
      call map_message(seve%e,rname,'Inconsistent pixel size')
      cycle
    endif
    !
    ! Compute grid correction,
    ! Normalization factor is applied to grid correction, for further
    ! use on channel maps.
    !
    !
    ! Make beam, not normalized
    call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
    !
    ! Normalize and Free beam
    call docorr (beam,w_grid,nx*ny)
    !
    ! Fit beam if needed
    if (do_cct) then
      my_method%major = 0
      my_method%minor = 0
      my_method%bzone=[1,1,nx,ny]
      call maxmap(beam,nx,ny,my_method%bzone,   &
          &      bmax,ix_max,iy_max,   &
          &      bmin,ix_min,iy_min)
      my_method%beam0 = [ix_max,iy_max]
      my_method%ibeam = kb
      !$OMP CRITICAL
      if (ic.eq.fcol) then
        fname = rname  ! Print beam
      else
        fname = ' '    ! Do not print beam
      endif
      call fibeam (fname,beam,nx,ny,   &
       &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
       &    my_method%major,my_method%minor,my_method%angle,   &
       &    hbeam%gil%convert,error)
      !
      my_major = my_method%major
      my_minor = my_method%minor
      my_angle = my_method%angle
      ! Print *,'fit results ',my_method%major, my_method%minor, my_method%angle
      !$OMP END CRITICAL
    endif
    !
    !
! *** End of LOCK in case of One Beam ***
    ! Wait for gridding correction to be computed
!    if (nbeam.eq.1) then
!      !$   if (ic.eq.fcol) then
!      !$     Print *,'Thread ',ithread,' freeing lck_grid'
!      !$     call omp_unset_lock(lck_grid)  ! Release the lock
!      !$   else
!      !$     Print *,'Thread ',ithread,' waiting for lck_grid'
!      !$     call omp_set_lock(lck_grid)    ! Wait for the Lock to be grasped
!      !$     Print *,'Thread ',ithread,' got lck_grid'
!      !$     call omp_unset_lock(lck_grid)  ! and free it immediately
!      !$   endif
!    endif
! *** End of One Beam region ***
    !
    ! Write beam
    hbeam%r3d(:,:,kb) = beam
    !
    ! Now extracts the Image planes...
    do iz=1,kz
      call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,beam,nx,ny)
      call docorr (beam,w_grid,ndata)
      ! Write the subset
      kc = ic-fcol+iz
      hdirty%r3d(:,:,kc) = beam
      !
      if (do_cct) then
        !
        ! And add the Clean Components
        ! Recover the component list in pixels
        !
        niter = mic(iz)
        do icc = 1,mic(iz)
          !
          ! The NINT is required because of rounding errors
          p_cct(icc)%ix = nint( (ccou(1,icc,iz)-hdirty%gil%convert(2,1)) /  &
              &        hdirty%gil%convert(3,1) + hdirty%gil%convert(1,1))
          p_cct(icc)%iy = nint( (ccou(2,icc,iz)-hdirty%gil%convert(2,2)) /  &
              &        hdirty%gil%convert(3,2) + hdirty%gil%convert(1,2))
          p_cct(icc)%value = ccou(3,icc,iz)
        enddo
        !
        ! Compute Clean image and add back residual
        if (niter.gt.0) then
          my_method%n_iter = niter
          call clean_make90(my_method,hclean,hclean%r3d(:,:,kc),p_cct)
          hclean%r3d(:,:,kc) = hclean%r3d(:,:,kc) + hdirty%r3d(:,:,kc)
        else
          hclean%r3d(:,:,kc) = hdirty%r3d(:,:,kc)
        endif
        ! Make sure the next Clean Component is empty 
        if (niter.lt.maxic) p_cct(niter+1)%value = 0 ! Required
      endif
      !
    enddo
    !
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End plane ',kc,' Time ',elapsed &
      & ,' Thread ',ithread
    call map_message(seve%d,cname,chain)
    !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$ if (nbeam.gt.1) call omp_set_num_threads(othread)
  if (error) return
  !
  if (nbeam.eq.1) do_weig = .false.
  !
  method%major = my_major
  method%minor = my_minor
  method%angle = my_angle
  !
  call gag_cpu(cpu1)
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  if (elapsed.eq.0) then
    write(chain,102) 'Finished maps CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished maps Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,rname,chain)
  !
  call map_minmax(hdirty)
  !
  wall = maxval(walls(1:nbeam))
  call prnoise(rname,'Expected',wall,rms)
  hdirty%gil%noise = wall
  hclean%gil%noise = wall ! Also for the Restored clean map
  !  !
  ! Delete scratch space
  error = .false.
  if (nbeam.ne.1)  deallocate(w_grid)
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  return
  !
102 format(a,f9.2,a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
end subroutine uvmap_and_restore
!
subroutine uv_removes_clean(huv,duv,ouv,nc,mic,dcct,freq,first,last, &
  & beams)
  use image_def
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table.
  !       Semi-Slow version using interpolation from pre-tabulated
  !       Sin/Cos, which could still be optimized
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: huv   ! header of UV data set
  real, intent(in) :: duv(:,:)      ! UV data set
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: mic(:)     ! Number of Clean Components
  real, intent(out) :: ouv(:,:)     ! Extracted UV data set
  real, intent(in) :: dcct(:,:,:)   ! Clean component
  real(8), intent(in) :: freq       ! Apparent observing frequency
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  real, intent(in), optional :: beams(3) ! Mosaic primary beam (0 = single)
  !
  real(8) :: pidsur            ! 2*pi*D/Lambda
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
  real(8) :: phase, cp, sp
  real(4) :: rvis, ivis, b2, dxy, value
  integer ii, ir, iw
  integer oi, or, ow
  integer ic,iv,jc,kc
  !
  integer :: nv    ! Number of visibilities
  integer :: no, icmax
  !
  pidsur = f_to_k * freq
  !
  nv = huv%gil%dim(2)  ! Number of Visibilities
  no = ubound(mic,1)
  if (no.lt.last-first+1 .or. no.gt.ubound(dcct,3)) then
    Print *,'Remove Clean Slow dimension error ',no,last-first+1,ubound(dcct,3)
  endif
  icmax = maxval(mic)
  if (icmax.gt.ubound(dcct,2))  then
    Print *,'Remove Clean Slow -- too many Clean Comp.',icmax,ubound(dcct,2)
  endif
  ! Mosaic : Get 1/e width from FWHM
  b2 = 0.
  if (present(beams)) then
    if (beams(1).ne.0.) b2 = 4.d0*log(2.d0)/beams(1)**2
  endif
  !
  ! Remove clean component from UV data set
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP    & SHARED(duv,ouv,dcct)  SHARED(pidsur,nv,first,last,mic) &
  !$OMP    & PRIVATE(iv,jc,ic,kc,ir,ii,iw,or,oi,ow,phase,rvis,ivis,cp,sp) &
  !$OMP    & PRIVATE(dxy,value) SHARED(b2,beams)
  !
  !$OMP DO SCHEDULE(DYNAMIC,1)
  do iv=1,nv
    ouv(1:7,iv) = duv(1:7,iv)
    do jc = first,last  ! Channels
      ir = 5+3*jc
      ii = 6+3*jc
      iw = 7+3*jc
      kc = jc-first+1
      or = 5+3*kc
      oi = 6+3*kc
      ow = 7+3*kc
      ouv(or,iv) = duv(ir,iv)
      ouv(oi,iv) = duv(ii,iv)
      do ic = 1,mic(kc)  ! Clean components
        if (dcct(3,ic,kc).ne.0) then
          if (b2.ne.0) then
            ! In case of Mosaics, multiply by beam value
            dxy = ((dcct(1,ic,kc)-beams(2))**2+(dcct(2,ic,kc)-beams(3))**2)*b2
            if (dxy.gt.16.0) cycle ! Too faint anyway ...
            value = dcct(3,ic,kc)*exp(-dxy)
          else
            value = dcct(3,ic,kc)
          endif
          phase = (ouv(1,iv)*dcct(1,ic,kc) + ouv(2,iv)*dcct(2,ic,kc))*pidsur
          call cossin(phase,cp,sp)
          rvis = value*cp
          ivis = value*sp
          ouv(or,iv) = ouv(or,iv) - rvis   ! Subtract
          ouv(oi,iv) = ouv(oi,iv) - ivis
        else
          Print *,'Premature end of work for channel ',jc
          exit ! End of work, jump to next channel
        endif
      enddo  ! Clean components
      ouv(ow,iv) = duv(iw,iv)
    enddo  ! Channels
  enddo ! Visibilities
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine uv_removes_clean
!
subroutine uv_squeeze_clean(nc,ccin,ccou, mic, first, last)
  use image_def
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compact the component list by summing up all values at the
  !   same position in a range of channels.
  !   The output list has a transposed order
  !-----------------------------------------------------------------
  integer, intent(in) :: nc         ! Number of channels
  real, intent(in) :: ccin(:,:,:)   ! Initial Clean Component List
  real, intent(out) :: ccou(:,:,:)  ! Resulting list
  integer, intent(inout) :: mic(:)  ! Number of Clean component per channel
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  !
  integer :: ii,jj,ic,jc
  integer :: ki    ! Number of different components per channel
  logical doit
  !
  ccou = 0
  !
  do ic=first,last
    jc = ic-first+1
    ki = 0
    do ii=1,mic(jc)
      if (ccin(3,ic,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,jj,jc).eq.ccin(1,ic,ii)) then
            if (ccou(2,jj,jc).eq.ccin(2,ic,ii)) then
              doit = .false.
              ccou(3,jj,jc) = ccou(3,jj,jc) + ccin(3,ic,ii)
              exit
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          ccou(1:3,ki,jc) = ccin(1:3,ic,ii)
        endif
      endif
    enddo
    mic(jc) = ki
  enddo
end subroutine uv_squeeze_clean
!
subroutine uv_removef_clean(hdirty,duv,ouv,nc,mic,dcct,freq,first,last, &
  & beams)
  use image_def
  use mapping_interfaces, except_this => uv_removef_clean
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  !   This version is for tranpose CCT data (3,ncomp,nchannels)
  !   and uses an intermediate FFT for speed
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hdirty  ! header of Dirty image
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: mic(:)     ! Number of Clean Components
  real, intent(in) :: duv(:,:)      ! Input visibilities
  real, intent(out) :: ouv(:,:)     ! Output visibilities
  real, intent(in) :: dcct(:,:,:)   ! Clean components
  real(8), intent(in) :: freq       ! Apparent observing frequency
  integer, intent(in) :: first      ! First
  integer, intent(in) :: last       ! and last channel
  real, intent(in), optional :: beams(3) ! Mosaic primary beam (in radians)
  !
  integer :: nv    ! Number of visibilities
  integer :: mv    ! Size of a visibility
  integer :: nx,ny
  integer :: mx,my
  integer :: kx,ky
  real :: rx,ry,b2,dxy
  real :: value
  complex, allocatable :: cfft(:,:,:)
  real, allocatable :: comp(:,:), work(:)
  integer :: iplane,ic,ix,iy,iv,ier, dim(2)
  logical :: error
  real(8) :: xinc, yinc, xref, yref, xval, yval
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  nv = ubound(duv,2)    ! Number of Visibilities
  mv = 7+3*nc
  mx = hdirty%gil%dim(1)
  my = hdirty%gil%dim(2)
  !
  ! Define the image size
  rx = log(float(mx))/log(2.0)
  kx = nint(rx)
  if (kx.lt.rx) kx = kx+1
  nx = 2**kx
  ry = log(float(my))/log(2.0)
  ky = nint(ry)
  if (ky.lt.ry) ky = ky+1
  ny = 2**ky
  kx = max(nx,ny)
  kx = min(4*kx,4096)
  !
  ! If the image is already fine enough, use it "as is"
  !    even if it is not a power of two...
  nx = max(kx,mx)  ! max(kx,nx) for power of two
  ny = max(kx,my)  ! max(kx,ny) for power of two
  !
  !
  ! Get Virtual Memory & compute the FFT
  allocate(comp(mx,my),cfft(nx,ny,nc),work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'UV_RESTORE','uv_removef_clean -- allocation error')
    error = .true.
    return
  endif
  !
  xref = hdirty%gil%convert(1,1)
  yref = hdirty%gil%convert(1,2)
  xval = hdirty%gil%convert(2,1)
  yval = hdirty%gil%convert(2,2)
  xinc = hdirty%gil%convert(3,1)
  yinc = hdirty%gil%convert(3,2)
  dim = [nx,ny]
  !
  b2 = 0.
  if (present(beams)) then
    if (beams(1).ne.0.) b2 = 4.d0*log(2.d0)/beams(1)**2
  endif
  !  call fourt_plan(ftbeam,dim,2,1,1)
  !
  !$OMP PARALLEL DEFAULT(none) SHARED(dcct,cfft) &
  !$OMP    & SHARED(nc,mic,nx,ny,mx,my,dim,xinc,yinc,xref,yref,xval,yval) &
  !$OMP    & PRIVATE(iplane,ic,ix,iy,value) PRIVATE(comp,work) &
  !$OMP    & PRIVATE(dxy) SHARED(b2,beams)
  !
  !$OMP DO
  do iplane=1,nc
    comp = 0.
    do ic=1,mic(iplane)
      if (dcct(3,ic,iplane).eq.0) exit
      !
      if (b2.ne.0) then
        ! In case of Mosaics, multiply by beam value
        dxy = ((dcct(1,ic,iplane)-beams(2))**2+(dcct(2,ic,iplane)-beams(3))**2)*b2
        if (dxy.gt.16.0) cycle ! Too faint anyway ...
        value = dcct(3,ic,iplane)*exp(-dxy)
      else
        value = dcct(3,ic,iplane)
      endif
      ! The NINT is required because of rounding errors
      ix = nint( (dcct(1,ic,iplane)-xval) / xinc + xref )
      iy = nint( (dcct(2,ic,iplane)-yval) / yinc + yref )
      comp(ix,iy) = comp(ix,iy) + value
    enddo
    !
    call plunge_real (comp,mx,my,cfft(:,:,iplane),nx,ny)
    ! FOURT is now Thread-safe for the non-FFTW version.
    call fourt(cfft(:,:,iplane),dim,2,1,1,work)
    call recent(nx,ny,cfft(:,:,iplane))
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Extract the visibility subset
  do iv = 1,nv
    ouv(1:7,iv) = duv(1:7,iv)
    ouv(8:mv,iv) = duv(5+3*first:7+3*last,iv)
  enddo
  !
  ! Interpolate and subtract the model visibilities
  call do_smodel(ouv,mv,nv,cfft,nx,ny,nc,freq,xinc,yinc,1.0)
  !
  deallocate(comp,cfft)
end subroutine uv_removef_clean
!
subroutine cossin(phase,rcos,rsin)
  !-------------------------------------------------------
  ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
  ! using (not yet clever) interpolation from a precise
  ! loop-up table
  !
  ! A solution using Taylor expansion and symmetries
  ! would be faster and more accurate
  !-------------------------------------------------------
  real(8), intent(inout) :: phase
  real(8), intent(out) :: rcos
  real(8), intent(out) :: rsin

!!  integer, intent(inout) :: ier
!!  real(8), intent(in) :: maxerr
!!  real(8), intent(inout) :: themax
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: mcos=2048
  integer, save :: ncos = 0
  real(8), save :: cosine(mcos)
  real(8), save :: sine(mcos)
  real(8), save :: rstep
  real(8) :: rdeg
  integer :: i
  logical :: minus
  !
  rcos = cos(phase)
  rsin = sin(phase)
  return
  !
  if (ncos.eq.0) then
    ncos = mcos
    rstep = 2.01d0*pi/mcos
    do i=1,ncos
      rdeg = (i-1)*rstep
      cosine(i) = cos(rdeg)
      sine(i) = sin(rdeg)
    enddo
  endif
  !
  if (phase.ge.0) then
    minus =.false.
    rdeg = modulo(phase,2.0d0*pi)+0.5d0*rstep
  else
    minus = .true.
    rdeg = modulo(-phase,2.0d0*pi)+0.5d0*rstep
  endif
  rdeg = rdeg/rstep
  i = int(rdeg)
  rdeg = rdeg - i
  i = i+1
  rcos = (1.0-rdeg)*cosine(i) + rdeg*cosine(i+1)
  rsin = (1.0-rdeg)*sine(i) + rdeg*sine(i+1)
  if (minus) rsin = -rsin
end subroutine cossin
!
subroutine uv_extract_clean(duv,ouv,nc,first,last)
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_MAP  &  UV_RESTORE
  !     Extract a subset of visibilities
  !-----------------------------------------------------------------
  integer, intent(in) :: nc         ! Number of channels
  real, intent(in) :: duv(:,:)      ! Input visbilities
  real, intent(out) :: ouv(:,:)     ! Output visibilities
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  !
  integer :: iv, nv
  !
  nv = ubound(duv,2)                ! Number of Visibilities
  !
  do iv=1,nv
    ouv(1:7,iv) = duv(1:7,iv)
    ouv(8:,iv) = duv(5+3*first:7+3*last,iv)
  enddo
end subroutine uv_extract_clean
!
subroutine uv_clean_sizes(hcct,ccin, mic, first, last)
  use image_def
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compute the actual number of components
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: ccin(:,:,:)   ! Clean component table
  integer, intent(out) :: mic(:)    ! Number of iterations per channel
  integer, intent(in) :: first      ! First
  integer, intent(in) :: last       ! and last channel
  integer :: nc
  integer :: ni, ki
  integer :: i,ic,jc
  !
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mic(:) = ni ! Up to the last one
  do ic=first,last
    jc = ic-first+1
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        mic(jc) = i-1
        exit
      endif
    enddo
  enddo
end subroutine uv_clean_sizes
!
subroutine do_smodel (visi,nc,nv,a,nx,ny,nf,freq,xinc,yinc,factor)
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING   Support for UV_RESTORE
  !
  !     Remove model visibilities from UV data set.
  !     Interpolate from a grid of values obtained by FFT before.
  !-----------------------------------------------------------------
  integer, intent(in) :: nc ! Visibility size
  integer, intent(in) :: nv ! Number of visibilities
  integer, intent(in) :: nx ! X size
  integer, intent(in) :: ny ! Y size
  integer, intent(in) :: nf ! Number of frequencies
  real, intent(inout) :: visi(:,:)    ! Computed visibilities
  real(8), intent(in) :: freq         ! Effective frequency
  real, intent(in)  :: factor         ! Flux factor
  complex, intent(in) ::  a(:,:,:)    ! FFT
  real(8), intent(in) :: xinc,yinc    ! Pixel sizes
  !
  real(8), parameter :: clight=299792458d0
  real(8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
  complex(8) :: aplus,amoin,azero,afin
  integer i,if,ia,ja
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    ia = int(kwx)
    if (ia.le.1) cycle
    if (ia.ge.nx) cycle
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ja = int(kwy)
    if (ja.le.1) cycle
    if (ja.ge.ny) cycle
    !
    xr = kwx - ia
    yr = kwy - ja
    do if=1,nf
      !
      ! Interpolate (X or Y first, does not matter in this case)
      aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
   &          - 2.d0*a(ia,ja+1,if) )*xr   &
   &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
   &          + a(ia,ja+1,if)
      azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
   &          - 2.d0*a(ia,ja,if) )*xr   &
   &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
   &          + a(ia,ja,if)
      amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
   &          - 2.d0*a(ia,ja-1,if) )*xr   &
   &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
   &          + a(ia,ja-1,if)
      ! Then Y (or X)
      afin = ( (aplus+amoin-2.d0*azero)   &
   &          *yr + aplus-amoin )*yr*0.5d0 + azero
      !
      visi(5+3*if,i) =  visi(5+3*if,i) - real(afin)*factor
      visi(6+3*if,i) =  visi(6+3*if,i) - imag(afin)*factor
    enddo
  enddo
end subroutine do_smodel
!

subroutine uv_preview(line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, except_this => uv_preview
  use gbl_message
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  !   UV_PREVIEW   [/FILE UvData.uvt]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  ! Global
  character(len=*), parameter :: rname='UV_PREVIEW'
  integer, parameter :: o_file=1
  !
  ! Local
  type(gildas) :: hfile
  integer :: n
  character(len=filename_length) :: name
  logical :: do_insert
  !
  do_insert = sic_lire().eq.0
  error = .false.
  call sic_delvariable('SPECTRUM',.false.,error)
  call sic_delvariable('CLIPPED',.false.,error)
  call sic_delvariable('CHANNEL_LIST',.false.,error)
  call sic_delvariable('PREVIEW',.false.,error)
  !
  if (sic_present(o_file,0)) then
    ! /FILE option
    call gildas_null(hfile,type='UVT')
    call sic_ch(line,o_file,1,name,n,.true.,error)
    if (error) return
    call sic_parse_file(name,' ','.uvt',hfile%file)
    !
    call gdf_read_header(hfile,error)
    if (error) return
    hfile%loca%size = 0
    !
    call uv_preview_sub(hfile,line,error)
    !
  else
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    huv%r2d => duv
    call uv_preview_sub(huv,line,error)
  endif
  !
  if (error) return
  if (do_insert) call sic_insert_log(line)
  !
end subroutine uv_preview
!
subroutine uv_preview_sub (huv,line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types 
  use imager_interfaces, except_this => uv_preview_sub
  use gbl_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  !   UV_PREVIEW   [/FILE UvData.uvt]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  type(gildas), intent(inout) :: huv
  !
  ! Global
  include 'gbl_memory.inc'
  character(len=*), parameter :: rname='UV_PREVIEW'
  ! Local
  character(len=80) :: chain
  character(len=message_length) :: mess
  integer(kind=4) :: ntaper
  integer(kind=index_length) :: nvisi, nchan
  type (gildas), save :: htab, hclip 
  integer(kind=index_length) :: nhist, mhist, lc
  integer :: it,jc,kc,jv,kr,kw,ier
  real :: wtot, rtot, ww, rr, uvmin, uvmax, blank, wsum, rms
  real :: tapermin, tapermax, tapercurrent, tapersquare, taperfactor
  integer :: ib,nb,ksum, fchan, lchan
  real, allocatable :: uv(:), taper(:), wall(:), wreal(:), wplus(:), vtaper(:)
  real, allocatable :: weights(:,:), poids(:,:,:), spec(:,:,:)
  real, pointer :: clip_data(:)
  integer, allocatable, save :: mylines(:)
  integer, allocatable :: kplus(:)
  integer :: mvisi,nt, ithread, nthread
  real :: clip_value, correlation_factor, rmsdiff, rmstheo 
  real :: amed, amin, amax, noise_ratio, ctaper
  logical :: debug=.false.
  !
  ! Common beam identification if any
  integer :: irange(2),krange,mrange,i
  integer, allocatable :: ranges(:)
  integer(kind=address_length) :: jpr
  type(sic_descriptor_t) :: desc
  logical found
  !
  ! EDGE_FREQUENCIES
  real(kind=8) :: tmp 
  real(kind=8), allocatable, save :: edge_freq(:,:) 
  integer, allocatable, save :: edge_chan(:,:) 
  integer :: nlines
  integer(kind=index_length) :: dim(4)
  !
  call sic_get_logi('DEBUG',debug,error)
  !
  if (associated(htab%r2d)) deallocate(htab%r2d)
  if (associated(hclip%r2d)) deallocate(hclip%r2d)
  if (allocated(mylines)) deallocate(mylines)
  if (allocated(edge_freq)) deallocate(edge_freq,edge_chan)
  !
  nvisi = huv%gil%nvisi
  !
  ntaper = 4
  call sic_i4(line,0,1,ntaper,.false.,error)
  if (ntaper.lt.1 .or. ntaper.gt.10) then
    call map_message(seve%e,rname,'Number of tapers out of range 1-10')
    error = .true.
    return
  endif
  !
  clip_value = 3.5
  call sic_r4(line,0,2,clip_value,.false.,error)
  if (clip_value.lt.1.0 .or. clip_value.gt.7.0) then
    call map_message(seve%e,rname,'Clipping value outside of recommended [1-7] range')
    error = .true.
    return
  endif
  !
  fchan = 0 ! Offset for channel numbers
  lchan = huv%gil%nchan
  if (huv%loca%size.eq.0 .and. lchan.gt.40) then    
    ! Drop 5 % at each edge
    fchan = huv%gil%nchan/20
    lchan = 19*fchan
  endif
  write(mess,'(A,I0,A,I0,A)') 'Selecting channel range [',fchan+1,',',lchan,']'
  call map_message(seve%i,rname,mess)
  !
  ! If UV_CHECK BEAM has been used, 
  ! restrict the range to the most significant (bad edge recognition)
  call sic_descriptor('BEAM_RANGES',desc,found)
  if (found) then
    jpr = gag_pointer(desc%addr,memory)
    allocate(ranges(desc%dims(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do i=1,desc%dims(2)
      call i4toi4(memory(jpr+2*(i-1)),irange,2)
      ranges(i) = irange(2)-irange(1)
    enddo
    mrange = 0
    do i=1,desc%dims(2)  
      if (ranges(i).gt.mrange) then
        mrange = ranges(i)
        krange = i
      endif
    enddo
    !
    ranges(krange) = 0 ! hide the largest range
    if (any(ranges.gt.mrange/2)) then
      call map_message(seve%w,rname,'More than 2 significant beam regions')
    else
      call i4toi4(memory(jpr+2*(krange-1)),irange,2)
      fchan = irange(1)
      lchan = irange(2)
      write(chain,'(A,I0,A,I0,A,I0,A)') 'Channel range restricted to [',fchan,',',lchan, &
        & '] from BEAM_RANGES[',krange,']'
      call map_message(seve%i,rname,chain)
    endif  
  endif
  !
  nchan = lchan-fchan
  ! Default histogram size (after NCHAN definition)
  mhist = max(8,nint(sqrt(real(nchan))))
  nhist = max(8,mhist)
  call sic_i8(line,0,3,nhist,.false.,error) 
  !
  if (nchan.eq.1) then
    write(chain,'(A,I0,A)') 'Single channel, no possible preview'
    call message_colour(1)
    call map_message(seve%w,rname,chain)
    call message_colour(-1)
    return
  else if (nchan.le.32) then
    write(chain,'(A,I0,A)') 'Too few channels [',nchan,'], display only'
    call message_colour(1)
    call map_message(seve%w,rname,chain)
    call message_colour(-1)
    nhist = 1
  else if (nhist.lt.8) then
    write(chain,'(A,I0,A,I0,A)') 'Histogram size ',nhist,' out of recommended range [8-',mhist,']'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else if (nhist.gt.mhist)  then
    write(chain,'(A,I0,A,I0,A)') 'Histogram size ',nhist,' out of recommended range [8-',mhist,']'
    call map_message(seve%w,rname,chain)
  endif
  ! 
  call gildas_null(htab)
  call gdf_copy_header(huv,htab,error)
  !
  htab%gil%ndim = 2
  htab%gil%dim(1) = nchan
  htab%gil%dim(2) = ntaper+2
  !
  allocate(htab%r2d(nchan,ntaper+2),wplus(ntaper),kplus(ntaper), &
    & wall(ntaper),wreal(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Define the Tapers here
  if (huv%loca%size.ne.0) then
    allocate(uv(nvisi),taper(nvisi),stat=ier)
    uv(:) = huv%r2d(1,1:nvisi)**2 + huv%r2d(2,1:nvisi)**2
    if (huv%gil%basemax.eq.0 .or. huv%gil%basemin.eq.0) then
      uvmax = 0.0
      uvmin = 1e36
      do jv=1,huv%gil%nvisi
        ww = uv(jv) 
        if (ww.gt.0.0) then
          uvmax = max(uvmax,ww)
          uvmin = min(uvmin,ww)
        endif
      enddo
      if (uvmin.gt.uvmax) uvmin = uvmax
      huv%gil%basemax = sqrt(uvmax)
      huv%gil%basemin = sqrt(uvmin)
    endif
    tapermax = huv%gil%basemax
    if (huv%gil%nteles.ge.1) then
      tapermin = 3*max(huv%gil%teles(1)%diam,huv%gil%basemin)
    else
      tapermin = 3*huv%gil%basemin
    endif
  else if (huv%gil%basemax.eq.0) then
    call map_message(seve%w,rname,'No Baseline extrema, can only guess tapers')
    tapermax = 1000.0
    tapermin = 45.0
  else
    tapermax = huv%gil%basemax
    if (huv%gil%nteles.ge.1) then
      tapermin = 3*max(huv%gil%teles(1)%diam,huv%gil%basemin)
    else
      tapermin = 3*huv%gil%basemin
    endif
  endif
  taperfactor = log(tapermax/tapermin)/(ntaper-1)/log(2.0)
  tapercurrent = tapermax
  mess = 'Taper values: [ None'
  nt = len_trim(mess)+1
  !
  allocate(vtaper(ntaper),stat=ier)
  !
  vtaper(1) = 0.
  do it=2,ntaper
    tapercurrent = tapercurrent/2.0**taperfactor
    vtaper(it) = tapercurrent
    write(mess(nt:),'(A,F8.1)') ',',tapercurrent
    nt = nt+9
  enddo
  mess(nt:nt)=']'
  call map_message(seve%i,rname,mess(1:nt))
  ! 
  ! Initialize X Axis
  htab%r2d = 0.0
  do jc=1,nchan
    htab%r2d(jc,1) = (jc+fchan-huv%gil%ref(1))*huv%gil%vres + huv%gil%voff
  enddo
  !
  ! Compute various spectra
  !
  if (huv%loca%size.ne.0) then
    tapercurrent = tapermax
    !
    do it = 1, ntaper
      if (it.eq.1) then
        taper = 1.0
      else
        tapercurrent = tapercurrent/2.0**taperfactor
        tapersquare = tapercurrent**2        
        taper(:) = exp(-uv(:)/tapersquare)
      endif
      ksum = 0
      wsum = 0
      !$OMP PARALLEL DEFAULT(none)  &
      !$OMP & SHARED (fchan,nchan,nvisi,htab,huv,taper,it,ntaper) &
      !$OMP & PRIVATE (kr,kw,wtot,rtot,rr,ww,jc,jv) &
      !$OMP & REDUCTION(+:wsum,ksum) 
      !$OMP DO
      do jc = 1,nchan
        kr = 5 + 3*(jc+fchan)
        kw = 7 + 3*(jc+fchan) 
        wtot = 0
        rtot = 0
        do jv = 1,nvisi
          ww = huv%r2d(kw,jv) * taper(jv)
          if (ww.gt.0.0) then
            rr = huv%r2d(kr,jv) * ww
            wtot = wtot+ww
            rtot = rtot+rr
          endif
        enddo
        !
        ! This is a channel average - Ksum counts the number of channels
        if (wtot.gt.0) then
          htab%r2d(jc,it+1) = rtot/wtot
          if (it.eq.1) then
            htab%r2d(jc,ntaper+2) = wtot
          endif
          ksum = ksum+1
          wsum = wsum+wtot
        endif 
        !
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      wplus(it) = wsum
      !
      ! Estimate the RMS noise for each taper
      wall(it) = wsum/ksum
    enddo
  else
    ! Shift the reference channel by Fchan
    htab%gil%ref(1) = htab%gil%ref(1)-fchan
    !
    ! Define blocking factor, on largest data file
    mvisi = imager_nitems(huv,1) ! Visibilities at once
    mvisi = min(mvisi,huv%gil%dim(2))
    ! Allocate spaces for each array
    allocate(huv%r2d(huv%gil%dim(1),mvisi),weights(nchan,ntaper),stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error ',huv%gil%dim(1), mvisi
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    wplus = 0.
    kplus = 0
    weights = 0.0
    !
    ! Loop on blocks
    nthread = 1
    !$ nthread = omp_get_max_threads()
    allocate(spec(nchan,ntaper,nthread),poids(nchan,ntaper,nthread),stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error ',nchan,ntaper,nthread
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    do ib=1,huv%gil%nvisi,mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',huv%gil%dim(2),mvisi
      call map_message(seve%i,rname,mess)
      huv%blc(2) = ib
      huv%trc(2) = min(huv%gil%nvisi,ib-1+mvisi)
      nvisi = huv%trc(2)-huv%blc(2)+1
      call gdf_read_data(huv,huv%r2d,error)
      if (error) return
      !
      ! On this block, increment the htab array
      !
      spec = 0.
      poids = 0.
      !$OMP PARALLEL DEFAULT(none)  &
      !$OMP & SHARED (fchan,nchan,nvisi,htab,huv,vtaper,ntaper,poids,spec) &
      !$OMP & PRIVATE (kr,kw,rr,ww,jc,jv,it,ctaper,ithread) 
      ithread = 1
      !$ ithread = omp_get_thread_num()+1      
      !$OMP DO
      do jv = 1,nvisi
        do it = 1,ntaper
          if (it.eq.1) then
            ctaper = 1.0
          else
            ctaper = exp(-(huv%r2d(1,jv)**2 + huv%r2d(2,jv)**2)/vtaper(it)**2)
          endif
          !
          do jc = 1,nchan
            kw = 7 + 3*(jc+fchan)   ! Weight            
            ww = huv%r2d(kw,jv) * ctaper
            if (ww.gt.0.0) then
              poids(jc,it,ithread) = poids(jc,it,ithread) + ww
              kr = 5 + 3*(jc+fchan)   ! Real part
              rr = huv%r2d(kr,jv) * ww
              ! I need to fix that in Parallel mode with Temporary arrays...
              spec(jc,it,ithread) = spec(jc,it,ithread) + rr
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !
      do ithread=1,nthread
        do it=1,ntaper
          do jc=1,nchan
            htab%r2d(jc,it+1) = htab%r2d(jc,it+1) + spec(jc,it,ithread)
          enddo
          do jc=1,nchan
            weights(jc,it) = weights(jc,it) + poids(jc,it,ithread)
          enddo
        enddo
      enddo
      !
      ! next block
    enddo
    !
    deallocate(spec,poids,stat=ier)
    !
    ! Final reduction of Weights and Spectrum
    wplus = 0.0
    ksum = 0
    do jc = 1,nchan
      if (weights(jc,1).ne.0) then
        ksum = ksum+1
        wplus(1) = wplus(1) + weights(jc,1)
      endif
    enddo
    do it = 2,ntaper
      do jc = 1,nchan
        wplus(it) = wplus(it) + weights(jc,it)
      enddo
    enddo
    !
    ! Normalize to get the correct spectrum
    htab%r2d(:,ntaper+2) = weights(:,1)  ! Natural weights
    do it=1,ntaper
      do jc=1,nchan
        htab%r2d(jc,it+1) = htab%r2d(jc,it+1) / weights(jc,it) 
      enddo
    enddo
    !
    ! Estimate the RMS noise for each taper
    do it=1,ntaper
      wall(it) = wplus(it)/ksum
    enddo
  endif
  ! Print noise estimate
  wall = 1e-3/sqrt(wall)    ! Units are Jy and MHz
  rmstheo = wall(1)
  call prnoise(rname,'Natural',rmstheo,rms)
  !
  ! We need to define a Blanking value outside of the range
  blank = minval(htab%r2d)
  if (blank.gt.0) then
    htab%gil%bval = -2.0*blank
    htab%gil%eval = blank
  else if (blank.lt.0) then
    htab%gil%bval = 3.0*blank
    htab%gil%eval = -blank
  else
    htab%gil%bval = -1.0
    htab%gil%eval = 0.0
  endif
  do it=2,ntaper+1
    where (htab%r2d(:,ntaper+2).eq.0) htab%r2d(:,it) = htab%gil%bval
  enddo
  !
  call sic_mapgildas('SPECTRUM',htab,error,htab%r2d)
  call sic_defstructure('PREVIEW',.true.,error)
  !
  ! Clip them to compute the histograms
  if (nhist.gt.1) then
    wall(2:ntaper) = 0.0
    !
    ! Evaluate the channel correlation factor and/or noise scaling factor
    it = 2
    lc = 0
    do jc=1,nchan-1
      kc = jc+1
      if (htab%r2d(jc,ntaper+2).ne.0 .and. htab%r2d(kc,ntaper+2).ne.0) then
        lc = lc+1
        wreal(lc) = htab%r2d(jc,it)-htab%r2d(kc,it)
      endif
    enddo
    ! A one pass median filtering is required to estimate the noise,
    ! because lines can be narrow.
    call median_filter (wreal,lc,htab%gil%bval,htab%gil%eval,amed,amin,amax)
    call comp_r4_rms_blank (wreal,lc,rmsdiff,htab%gil%bval,htab%gil%eval)
    rmsdiff =  rmsdiff / sqrt(2.0) 
    noise_ratio = 1.0
    if (rmsdiff.lt.0.9*rmstheo) then
      write(chain,'(A,1PG10.2,A,1PG10.2)') 'Theoretical RMS ',rmstheo, &
      & ' larger than Difference RMS ',rmsdiff
      call message_colour(4)
      call map_message(seve%w,rname,chain)
      correlation_factor = rmstheo/rmsdiff
      write(chain,'(A,1PG10.2,A,1PG10.2)') 'Estimated correlation factor ', &
        & rmstheo/rmsdiff
      call map_message(seve%i,rname,chain)
      call message_colour(-1)
    else if (rmsdiff.gt.1.1*rmstheo) then
      noise_ratio = rmsdiff/rmstheo
      if (noise_ratio.gt.3.0) then
        call median_filter (wreal,lc,htab%gil%bval,htab%gil%eval,amed,amin,amax)
        call comp_r4_rms_blank (wreal,lc,rmsdiff,htab%gil%bval,htab%gil%eval)
        rmsdiff = rmsdiff / sqrt(2.0)
        noise_ratio = rmsdiff/rmstheo
      endif
      call message_colour(4)
      write(chain,'(A,1PG10.2,A,1PG10.2)') 'Theoretical RMS ',rmstheo, &
        & ' smaller than Difference RMS ',rmsdiff
      call map_message(seve%w,rname,chain)
      noise_ratio = rmsdiff/rmstheo
      call message_colour(1)
      write(chain,'(A,1PG10.2,A,1PG10.2)') 'Noise should be rescaled by ', & 
        & noise_ratio
      call map_message(seve%i,rname,chain)
      call message_colour(-1)
      noise_ratio = min(2.,noise_ratio)
    endif
    wall = noise_ratio*wall
    !
    !
    !
    call gildas_null(hclip)
    call gdf_copy_header(htab,hclip,error)
    allocate(hclip%r2d(nchan,ntaper+2),mylines(nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'CLIP allocation error')
      error = .true.
      return
    endif
    !
    nb = 0    ! Empty channel list
    !
    hclip%r2d = htab%r2d
    !
    correlation_factor = 1.0
    do it=2,ntaper+1
      clip_data => hclip%r2d(:,it)
      call clip_lineregions(rname,clip_data,nchan,nhist,  &
        & hclip%gil%bval,hclip%gil%eval,clip_value, &
        & debug,wall(it-1),noise_ratio) 
      call guess_lineregions(clip_data,nchan,       &
        & hclip%gil%bval,hclip%gil%eval,            &
        & mylines,nb)
    enddo
    !
    call sic_mapgildas('CLIPPED',hclip,error,hclip%r2d)
    if (nb.gt.0) then
      call clip_expand(mylines,nchan,nb)
      hclip%r2d(:,1) = 0.0
      do ib=1,nb
        hclip%r2d(mylines(ib),1) = 1.0
      enddo
      !
      ! Add channel offset
      mylines = mylines + fchan
      call sic_def_inte('PREVIEW%CHANNELS',mylines,1,nb,.false.,error)
      !
      ! Find edges of contiguous regions
      allocate(edge_freq(2,nb), edge_chan(2,nb) ,stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'PREVIEW allocation error')
        error = .true.
        return
      endif
      call channel_to_edges(mylines,nb,edge_chan,nlines)
      !
      ! Convert to Rest Frequencies
      edge_freq = (edge_chan - huv%gil%ref(1))*huv%gil%fres + huv%gil%freq
      if (huv%gil%fres.lt.0) then
        do i = 1,nlines
          tmp = edge_freq(1,i)
          edge_freq(1,i) = edge_freq(2,i)
          edge_freq(1,i) = tmp
        enddo
      endif
      dim(1:2) = [2,nlines]
      call sic_def_dble('PREVIEW%FREQUENCIES',edge_freq,2,dim,.false.,error)
      call sic_def_inte('PREVIEW%EDGES',edge_chan,2,dim,.false.,error)
    endif
  endif
  !
  call exec_program('@ uv_preview') 
  call exec_program('@ preview_lines')  
  !
end subroutine uv_preview_sub
!
subroutine fit_parabola(n,x,y,a,b,c,d)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! Find the characteristics of a parabola
  ! Parabola definition a + b.x + c.x^2
  !---------------------------------------------------------------------
  integer, intent(in) :: n  ! Number of values
  real, intent(in) :: x(n)  ! X coordinates
  real, intent(in) :: y(n)  ! Y values
  real, intent(inout) :: a    ! Constant term
  real, intent(inout) :: b    ! Linear term
  real, intent(inout) :: c    ! Second order term
  real, intent(inout) :: d    ! rms of fit
  !
  real :: a0, a1, a2, a3, a4
  real :: b0, b1, b2, d1
  integer :: m, k
  !
  a0 = 1; a1 = 0; a2 = 0; a3 = 0; a4 = 0
  b0 = 0; b1 = 0; b2 = 0
  k = 0
  do m = 1, n
    if (y(m).gt.0) then
      a1 = a1 + x(m)
      a2 = a2 + x(m) * x(m)
      a3 = a3 + x(m) * x(m) * x(m)
      a4 = a4 + x(m) * x(m) * x(m) * x(m)
      b0 = b0 + y(m)
      b1 = b1 + y(m) * x(m)
      b2 = b2 + y(m) * x(m) * x(m)
      k = k+1
    endif
  enddo
  !
  ! Protect against severe clipping: do not change values, and set RMS 0
  if (k.le.3) then
    d = 0.0
    return
  endif
  a1 = a1 / k; a2 = a2 / k; a3 = a3 / k; a4 = a4 / k
  b0 = b0 / k; b1 = b1 / k; b2 = b2 / k
  d = a0 * (a2 * a4 - a3 * a3) - a1 * (a1 * a4 - a2 * a3) + a2 * (a1 * a3 - a2 * a2)
  a = b0 * (a2 * a4 - a3 * a3) + b1 * (a2 * a3 - a1 * a4) + b2 * (a1 * a3 - a2 * a2)
  a = a / d
  b = b0 * (a2 * a3 - a1 * a4) + b1 * (a0 * a4 - a2 * a2) + b2 * (a1 * a2 - a0 * a3)
  b = b / d
  c = b0 * (a1 * a3 - a2 * a2) + b1 * (a2 * a1 - a0 * a3) + b2 * (a0 * a2 - a1 * a1)
  c = c / d
  !
  ! Evaluation of standard deviation d
  d = 0.
  do m = 1, n
    if (y(m).gt.0) then
      d1 = y(m) - a - b * x(m) - c * x(m) * x(m)
      d = d + d1 * d1
    endif
  enddo
  d = SQRT(d / (k - 3))
end subroutine fit_parabola
!
subroutine clip_lineregions(rname,data,nchan,nhist,bval,eval,clip,debug,rms, &
  & noise_ratio)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => clip_lineregions
  !
  ! @ public
  !
  character(len=*), intent(in) :: rname
  integer(kind=index_length), intent(in) :: nchan   ! Data size
  integer(kind=index_length), intent(in) :: nhist   ! Histogram size
  real, intent(inout) :: data(nchan)                ! Data to be clipped
  real, intent(in) :: bval, eval                    ! Blanking values to be used
  real, intent(in) :: clip                          ! Clipping level in Sigma
  logical, intent(in) :: debug                      ! Debug printout
  real, intent(in) :: rms                           ! Expected rms noise
  real, intent(in) :: noise_ratio                   ! Noise scaling factor
  !
  real, allocatable :: hist(:,:), logv(:), temp(:)  ! Small automatic array
  real :: amed, amin,amax,aoff
  real :: a,b,c,d,mu,sigma,peak,logbase
  logical :: error, goon
  integer :: jc,ier, count
  integer(kind=index_length) :: mloc(1)
  integer(kind=4) :: mhist
  character(len=80) :: chain
  !
  error = .false.
  mhist = nhist   ! Integer(4) version
  ! Arrays 
  allocate(hist(mhist,2), logv(mhist), temp(nchan), stat=ier)
  if (ier.ne.0) return
  !
  ! Define the Histogram range around the median
  temp = data
  call median_filter (temp,nchan,bval,eval,aoff,amin,amax)
  !
  goon = (amin.lt.amax)     ! Protect against fully constant data (0 in models...)
  amed = (amin+amax)/2.0
  count = 0
  do while (goon) 
    ! Use NHIST here
    call histo44(temp,nchan,hist,nhist,2,amin,amax,bval,eval)
    !
    ! Apply Caruana algorithm : the Log of a Gaussian is a Parabola
    logv(:) = log(hist(:,1)+1.0)       ! Bias by 1 to avoid Log(0)
    logbase = maxval(logv)-4.0         ! Truncate wings
    where (logv.lt.logbase) logv=0.0
    ! Use MHIST there
    call fit_parabola(mhist,hist(1:mhist,2),logv,a,b,c,d)
    if (debug) print *,' A B C D ',a,b,c,d
    !
    ! Now back to Gaussian characteristics
    mu = -b/(2.0*c)             ! Position
    sigma = sqrt(-1.0/(2.0*c))  ! Sigma
    peak = exp(a-b**2/(4.0*c))  ! Intensity (biased)
    if (debug) then
      count= count+10
      do jc=1,mhist
        write(count,*) hist(jc,2), logv(jc), a+b*hist(jc,2)+c*hist(jc,2)**2, d
      enddo
      close(unit=count)
      count = count-10
    endif    
    !
    ! Treat the confusion case: the Gaussian  peak should be close 
    ! to the maximum of the Histogram - if not, this must be line 
    ! contamination
    if (debug) Print *,'Peak ',log(peak),' MaxVal ',maxval(logv),' D ',d
    amed = mu                   ! Define the position of maximum 
    if (count.eq.8) then
      goon = .false.
    else if (d.gt.0.25 .or. log(peak).lt.maxval(logv)-d) then
      ! If not converged, the Maximum can be wrong - iterate
      mloc = maxloc(hist,1)
      amed = hist(mloc(1),2)
      amin = amed-2.0*sigma
      amax = amed+2.0*sigma
      if (debug) Print *,count,': Min ',amin,' Median ',aoff,' Max ',amax,' Rms ',sigma
      count = count+1
    else
      goon = .false.
    endif
    if (debug) then
      call gr4_give('X',nhist,hist(:,2))
      call gr4_give('Y',nhist,logv)
      call gr_exec('CLEAR')
      call gr_exec('LIMITS')
      call gr_exec('BOX')
      call gr_exec('HISTO')
      logv = a+b*hist(:,2)+c*hist(:,2)**2
      call gr4_give('Y',nhist,logv)
      call gr_exec('CONNECT')
      read(5,*) mloc
    endif
  enddo
  !
  ! Correct for the Offset
  amed = amed+aoff
  if (rms.ne.0.0 .and. sigma.gt.rms) then
    write(chain,'(A,1PG10.2,A,1PG10.2)')  'Expected noise ',rms, &
      & ' is smaller than measured noise ',sigma
    call message_colour(4)
    call map_message(seve%w,rname,chain)
    call message_colour(-1)
  endif
  !
  ! If there is a noise correction, apply it
  sigma = sigma*noise_ratio
  !
  ! Now clip the Spectrum where it deviates by more than 
  ! CLIP_VALUE sigma
  if (debug) Print *,'Clipping around median ',amed,' by ',clip*sigma
  do jc=1,nchan
    if (abs(data(jc)-bval).le.eval) then
      data(jc) = bval
    else if (abs(data(jc)-amed).gt.clip*sigma) then
      data(jc) = bval
    endif
  enddo
  !
end subroutine clip_lineregions
!
subroutine guess_lineregions(data,nchan,bval,eval,mylines,nb)
  use gildas_def
  ! @ public
  integer(kind=index_length), intent(in) :: nchan   ! Data size
  real, intent(inout) :: data(nchan)                ! Blanked data 
  real, intent(in) :: bval, eval                    ! Blanking values to be used
  integer, intent(inout) :: mylines(nchan)          ! Line channel list
  integer, intent(inout) :: nb                      ! Number of line channels
  !
  integer :: jc,jb,lb
  !
  do jc=1,nchan
    if (data(jc).eq.bval) then
      jb = 0
      do lb=1,nb
        if (mylines(lb).eq.jc) then
          jb = lb
          exit
        endif
      enddo
      if (jb.eq.0) then
        nb = nb+1
        mylines(nb) = jc
      endif
    endif
  enddo
end subroutine guess_lineregions
!
subroutine comp_r4_rms_blank (x,n,out,vblank4,eblank4)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Support routine for command
  !   COMPUTE OutVar RMS InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !---------------------------------------------------------------------
  real*4,                    intent(in)  :: x(*)  ! Data values to compute
  integer(kind=size_length), intent(in)  :: n     ! Number of data values
  real*4,                    intent(out) :: out   ! Output scalar value
  real*4,                    intent(in) :: vblank4, eblank4
  ! Local
  integer(kind=size_length) :: i,count
  real*4 :: s0,s1
  !
  !!Print *,'N ',n,' Bval ',vblank4,eblank4
  out = vblank4
  if (n.lt.1) return
  out = 0.0
  !
  s0 = 0.
  s1 = 0.
  count = 0
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.ge.0) then
        if (abs(x(i)-vblank4).gt.eblank4) then
          s0 = s0+x(i)
          count = count+1
        endif
      else
        s0 = s0+x(i)
        count = count+1
      endif
    endif
  enddo
  if (count.gt.0) then
    s0 = s0/dble(count)
  else
    out = vblank4 ! lastchanceretval
    return
  endif
  !
  ! Note philosophique: Count is the same in the 2 loops
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        s1 = s1 + (x(i)-s0)**2
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          s1 = s1 + (x(i)-s0)**2
        endif
      endif
    endif
  enddo
  s1 = s1/dble(count)
  out = sqrt (s1)
end subroutine comp_r4_rms_blank
!
subroutine clip_expand(mylines,nc,nb)
  use gildas_def
  use gkernel_interfaces
  !
  ! @ private
  !   Expand the list of bad channels by continuity 
  !   to account for line widths
  integer(kind=index_length), intent(in) :: nc ! Number of channels
  integer, intent(inout) :: nb          ! Number of bad channels
  integer, intent(inout) :: mylines(nc) ! List of bad channels
  !
  integer :: ier, nrange, iwide, ib, lb
  integer, allocatable :: istart(:), iend(:)
  logical :: error
  !
  error = .false.
  allocate(istart(nb),iend(nb),stat=ier)
  if (ier.ne.0) return
  call gi4_trie (mylines,istart,nb,error)
  if (error) return
  !
  ! Define the number of ranges
  nrange = 1
  istart(1) = mylines(1)
  iend(1) = mylines(1)
  iwide = 1
  do ib = 2,nb
    if ((mylines(ib)-iend(nrange)).gt.iwide) then  
      ! A gap wider than the current range
      nrange = nrange+1
      istart(nrange) = mylines(ib)
      iend(nrange) = mylines(ib)
      iwide = 1
    else
      iend(nrange) = mylines(ib)
      iwide = max(1,(iend(nrange)-istart(nrange)+1)/2)
    endif
  enddo
  !
  ! Extend the ranges by doubling or adding 16 channels to
  ! their width to account for typical line widths, but 
  ! ignore single channels in this process
  nb = 0
  do ib=1,nrange
    iwide = min((iend(ib)-istart(ib))/2,8)
    istart(ib) = max(1,istart(ib)-iwide)
    iend(ib) = min(nc,iend(ib)+iwide)
    !
    do lb=istart(ib),iend(ib) 
      nb = nb+1
      mylines(nb) = lb
    enddo
  enddo
end subroutine clip_expand
!
subroutine median_filter(temp,nchan,bval,eval,amed,amin,amax)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, only : comp_r4_rms_blank 
  ! @ public
  integer(kind=index_length), intent(in) :: nchan
  real, intent(inout) :: temp(nchan)
  real, intent(in) :: bval
  real, intent(in) :: eval
  real, intent(out) :: amed
  real, intent(out) :: amin
  real, intent(out) :: amax
  !
  integer(kind=index_length) :: nmin,nmax
  real :: arms
  logical :: error
  !
  error = .false.
  call gr4_median(temp,nchan,bval,eval,amed,error)
  if (error) return  ! No valid data
  temp = temp-amed   ! Remove the median
  call gr4_extrema (nchan,temp,bval,eval,amin,amax,nmin,nmax)
  !!call gr4_minmax (nchan,temp,bval,eval,amin,amax,nmin,nmax)
  if (amin.eq.amax) return ! 
  amax = min(-amin,amax)
  amin = -amax 
  where(temp.lt.amin .or. temp.gt.amax) temp = bval
  call comp_r4_rms_blank (temp,nchan,arms,bval,eval)
  ! 
  where(abs(temp).gt.3*arms) temp = bval
end subroutine median_filter
!
!
subroutine channel_to_edges(clist,nc,edges,nl)
  use image_def
  ! @ private
  integer, intent(in) :: nc         ! Number of selected channels
  integer, intent(in) :: clist(nc)          ! Channel numbers
  integer, intent(out) :: edges(2,nc)  ! Start and End channels 
  integer, intent(out) :: nl        ! Number of ranges found
  !
  integer i,istart,iend
  !
  if (nc.lt.2) then
    nl = 1
    edges(1,1) = clist(1)
    edges(2,1) = clist(1) 
  else 
    istart = clist(1)
    iend = clist(1)
    nl = 1
    do i=2,nc
      if (clist(i)-iend.gt.1) then
        edges(1,nl) = istart
        edges(2,nl) = iend
        nl = nl+1
        istart = clist(i)
        iend = istart
      else
        iend = clist(i)
      endif
    enddo
    iend = clist(nc)
    edges(1,nl) = istart
    edges(2,nl) = iend
  endif
end subroutine channel_to_edges

subroutine uvstat_map(task,freq,map,uvmax,uvmin,print)
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! Estimate (and Display) the MAP parameters which will be used for
  ! UV_MAP, MX or UV_RESTORE
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: task ! Input task name (UV_MAP or MX)
  type (uvmap_par), intent(inout) :: map  ! Map parameters
  real(8), intent(inout) :: freq          ! Observing frequency
  real(4), intent(in) :: uvmax, uvmin     ! Min & Max UV in m
  logical, optional :: print              ! Printout results
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  real, parameter :: pixel_per_beam=5.0
  character(len=80) :: chain
  real :: hppb, diam, uvmi, uvma
  logical do_print
  !
  do_print = present(print)
  !
  freq = gdf_uv_frequency(huv,huv%gil%ref(1))
  if (do_print) then
    write(chain,'(A,F12.6,A)') "Observed rest frequency       ",freq*1d-3," GHz"
    call map_message(seve%i,task,chain)
  endif
  !
  ! Primary beam
  if (huv%gil%majo.ne.0) then
    hppb = huv%gil%majo
  else
    diam = 0.
    if (huv%gil%nteles.ne.0) then
      diam = huv%gil%teles(1)%diam
    endif
    if (diam.eq.0) diam = 15.0
    hppb = 63.0*pi/180.0/3600.0*(12.0/diam)*(100.e3/freq) ! [rad] Primary beam size
  endif
  hppb = hppb*180*3600/pi
  if (do_print) then
    write(chain,'(A,F12.1,A)') "Half power primary beam       ",hppb," arcsec"
    call map_message(seve%i,task,chain)
  endif
  !
  ! say "   Phase center RA and Dec       "'&1%int%cent%sex[1]'" "'&1%int%cent%sex[2]'
  !
  uvma = uvmax/(freq*f_to_k)
  uvmi = uvmin/(freq*f_to_k)
  if (do_print) then
    write(chain,100) huv%gil%dim(2),huv%gil%nchan
    call map_message(seve%i,task,chain)
    write(chain,101) uvmi,uvma,' meters'
    call map_message(seve%i,task,chain)
    write(chain,101) uvmin*1e-3/2.0/pi,uvmax*1e-3/2.0/pi,' kiloWavelength'
    call map_message(seve%i,task,chain)
  endif
  !
  ! Now get MAP_CELL and MAP_SIZE
  map%xycell(1) = 0.01*nint(360.0*3600.0*100.0/uvmax/pixel_per_beam)
  if (map%xycell(1).le.0.02) map%xycell(1) =   &
         &        0.002*nint(360.0*3600.0*500.0/uvmax/pixel_per_beam)
  map%xycell(2) = map%xycell(1)  ! In ", rounded to 0.02 or 0.002"
  !
  ! Get a wide enough field of view...
  !
  map%size = 0
  if (map%field(1).ne.0) then
    if (map%field(2).eq.0) map%field(2) = map%field(1)
  else
    ! The factor 2 on the primary beam size is to go down to 6.25 % level by default
    map%field(1) = 2*hppb
    ! The factor 2 on uvmax/uvmin is to allow all scales down to uvmin
    map%field(2) = 2*pixel_per_beam*uvmax/uvmin * map%xycell(1)
    ! The Min is to avoid going to very large images when uvmin is close to 0
    map%field = min(map%field(1),map%field(2))
  endif
  !
  map%size = map%field/map%xycell !
  !
  ! Round to power of two : perhaps not the best option here.
  ! Could become too small or uselessly too large, and be compensated by a different
  ! cell size choice.
  !
  map%size =   2**nint(log(real(map%size))/log(2.0))
  !
  if (do_print) then
    write(chain,'(A,F12.1,a,F12.1,A)') 'Field of view / Largest Scale ',map%field(1),' x ',map%field(2),' "'
    call map_message(seve%i,task,chain)
    write(chain,'(A,F11.1,A,F11.1,A)') 'Image size ',map%size(1)*map%xycell(1),' x ',map%size(2)*map%xycell(2),'" '
    call map_message(seve%i,task,chain)
    !
    write(chain,103) map%size
    call map_message(seve%i,task,chain)
    write(chain,104) map%xycell
    call map_message(seve%i,task,chain)
    !
  endif
  !
100 format('Found ',i12,' Visibilities, ',i4,' channels')
101 format('Baselines ',f9.1,' - ',f9.1,a)
103 format('Recommended map size is   ',i4,' by ',i4)
104 format('Recommended pixel size is ',f8.3,' by ',f8.3,'"')
end subroutine uvstat_map
!

subroutine howto_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command HOW_TO
  !   HOW_TO Keywords...
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='HOW_TO'
  integer, parameter :: mkeys=10
  integer :: nkeys, lkeys(mkeys), ikey
  character(len=20) :: ckeys(mkeys),string
  character(len=120) :: ligne
  character(len=256) :: file
  integer, save :: luntem=0
  integer :: ier, i, j, ifound, lt
  logical :: found, used
  !
  integer, parameter :: nuse=11
  character(len=8) :: useless(nuse)
  data useless /'?','a','all','at','do','i','it','my','some','the','to'/
  !
  error = .true.
  nkeys = sic_narg(0)
  if (nkeys.le.0) then
    call map_message(seve%e,rname,'Missing keywords')
    return
  endif
  !
  if (nkeys.gt.mkeys) then
    call map_message(seve%e,rname,'Too many keywords')
    return
  endif
  !
  ikey = 0
  do i=1,nkeys
    call sic_ch(line,0,i,string,lt,.true.,error)
    if (error) return
    if (nkeys.eq.1 .and. string.eq.'?') then
      ikey = 1
      exit
    endif
    !
    used = .true.
    do j=1,nuse
      if (string.eq.useless(j)) then
        used = .false.
        exit
      endif
    enddo
    if (used) then
      ikey = ikey+1
      ckeys(ikey) = string
      if (string(lt:lt).eq.'*') then
        lkeys(ikey) = lt-1
        ckeys(ikey)(lt:) = ' '
      else
        lkeys(ikey) = lt+1
      endif
    endif
  enddo
  nkeys = ikey
  !
  ! Open file (in production, will use a rewind(luntem) statement)
  if (luntem.eq.0) then
    ier = sic_getlun(luntem)
    if (ier.ne.1) return
  else    
    close(unit=luntem)
  endif
  call sic_parse_file('imager-howto','gag_pro:','.hlp',file)    
  ier = sic_open(luntem,file,'old',.true.)
  !
  ! Special case HOWTO ?
  if (nkeys.eq.1 .and. string.eq.'?') then
    do 
      read(luntem,'(A)',iostat=ier) ligne
      if (ier.ne.0)  exit
      !
      if (ligne(1:1).eq.'1') then
        read(luntem,'(A)',iostat=ier) ligne
        write(*,'(A)') trim(ligne)
      endif
    enddo
    error = .false.
    return
  endif
  !
  ! Scan for Keywords
  found = .false.
  ifound = 0
  !
  do 
    read(luntem,'(A)',iostat=ier) ligne
    if (ier.ne.0)  exit
    !
    if (ligne(1:1).eq.'1') then
      if (ifound.eq.nkeys) return ! Every keyword found
      ! We check 1 more character in ligne, which should be blank
      ! for correct match
      ifound = 0  ! Nothing found so far
      found = .false.
      do i=1,nkeys
        lt = lkeys(i)
        if (index(ligne,ckeys(i)(1:lt)).ne.0) then
          error = .false.
          ifound = ifound+1
        endif
      enddo
      found = ifound.eq.nkeys
      !!Print *,ifound,nkeys,trim(ligne)
      !
    else if (found) then
      write(*,'(A)') trim(ligne)
    endif
  enddo
  if (found) return
  !
  ! Second chance: list relevant HOWTOs
  write(*,'(A)') 'No result for '//trim(line)
  ifound = 0
  rewind(luntem)
  do 
    read(luntem,'(A)',iostat=ier) ligne
    if (ier.ne.0)  exit
    !
    if (ligne(1:1).eq.'1') then
      if (ifound.eq.nkeys) return ! Every keyword has been found
      ! We check 1 more character in ligne, which should be blank
      ! for correct match
      found = .false.
      do i=1,nkeys
        lt = lkeys(i)
        if (index(ligne,ckeys(i)(1:lt)).ne.0) then
          if (ifound.eq.0) write(*,'(A)') 'Relevant information '
          write(*,'(A)') ligne(3:len_trim(ligne))
          error = .false.
          ifound = ifound+1
        endif
      enddo
    endif
  enddo
end subroutine howto_comm

program grfont
  use gkernel_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! Construction du jeu de caracteres de GREG a partir de celui de HERSHEY
  !
  ! Organisation :
  !	2 Qualites de caracteres
  !		1 FAST		2 DUPLEX
  !	3 Jeux de caracteres par qualite
  !		1 ROMAIN	2 GREC		3 SCRIPT
  ! 	95 Caracteres par jeu
  !
  ! Addressage base sur le code ASCII du caractere
  !
  ! INDEX = ICHAR(caractere) - ICHAR(' ') + 1 + 100*(NJEU-1) + 300*(NQUAL-1)
  !---------------------------------------------------------------------
  ! Local
  integer :: j
  integer :: icode,nl
  character(len=filename_length) :: command,file
  !
  ! Get command line from the shell calling sequence
  icode = sic_get_foreign(command,nl)
  if (icode.ne.1) call sysexi(icode)
  !
  if (nl.ne.0) then
    ! Check for a blank (e.g. multiple arguments)
    do j = 1,lenc(command)
      if (command(j:j).eq.' ') then
        print *,'F-HERSHEY, Multiple arguments in shell command line'
        call sysexi(fatale)
      endif
    enddo
    ! Parse input pattern
    call sic_parsef(command,file,' ','.bin')
  else
    file = 'gag-font.bin'
  endif
  !
  call hershey2gag(file)
  !
end program grfont

subroutine sub_alma_bis (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam,l_list,   &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam,c_list,   &
     &    error,tcc)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_alma_bis
  use clean_def
  use image_def
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout)  :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout)  :: l_hclean
  type (gildas), intent(inout)  :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout)  :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)
  integer, intent(in) :: c_list(:)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_weight(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_weight(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cct(:,:)
  real, allocatable :: w_resid(:,:)
  !
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc,kx,ky
  integer ip, ier, ix, iy
  real l_max, c_max
  logical do_fft, ok
  character(len=80) chain
  character(len=2) ans
  integer nker,mker
  parameter (mker=12)
  real smooth
  real, allocatable :: kernel(:,:)
  real noise,value,scale,fhat,long,compact
  !
  error = .false.
  do_fft = .true.
  print *,'Into SUB_ALMA_BIS '
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),stat=ier)
  allocate (r_work(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  allocate (w_fft(max(nx,ny)),stat=ier)
  allocate (w_comp(nc),stat=ier)
  !
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_weight=> l_method%weight(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d
  c_weight=> c_method%weight(:,:,1)
  !
  ! Relative noise contributions
  long = l_hdirty%gil%noise**2
  compact = c_hdirty%gil%noise**2
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  if (smooth.eq.0) then
    nker = 4
    smooth = 3.0               ! Test
  elseif  (smooth.lt.4) then
    nker = 8
  else
    nker = mker
  endif
  allocate(kernel(nker,nker),stat=ier)
  call init_kernel(kernel,nker,nker,smooth)
  !
  noise = sqrt(compact/long)
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
    print *,'Starting loop ',iplane
    l_method%flux = 0.0
    c_method%flux = 0.0
    l_method%n_iter= 0
    c_method%n_iter= 0
    !
    l_method%iplane = iplane
    c_method%iplane = iplane
    call beam_plane(l_method,l_hbeam,l_hdirty)
    ibeam = l_method%ibeam
    !
    ! Local aliases
    l_dirty => l_hdirty%r3d(:,:,iplane)
    l_resid => l_hresid%r3d(:,:,iplane)
    l_clean => l_hclean%r3d(:,:,iplane)
    l_beam  => l_hbeam%r3d(:,:,ibeam)
    !
    c_dirty => c_hdirty%r3d(:,:,iplane)
    c_resid => c_hresid%r3d(:,:,iplane)
    c_clean => c_hclean%r3d(:,:,iplane)
    !
    ! Initialize to Dirty map
    l_resid = l_dirty
    c_resid = c_dirty
    !
    ! Prepare beam parameters
    call get_clean (l_method, l_hbeam, l_beam, error)
    if (error) return
    call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
        &        l_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    !
    call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
        &        c_tfbeam,w_work,w_fft,fhat,error)
    if (error) return
    call mrc_plot(c_weight,mx,my,1,'Weight')
    print *,'Beam gains ',l_method%bgain,c_method%bgain
    l_method%bgain = sqrt(l_method%bgain*c_method%bgain)
    l_resid = l_resid * l_weight
    c_resid = c_resid * c_weight
    !
    ! Performs decomposition into components:
    ! Only one major cycle per iteration, with a limited number
    ! of components ?
    !
    l_method%ngoal = 1000
    !
    ! Locate the maximum of the Compact & Normal images
    l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
    c_max = imaxlst (c_method,c_list,c_resid,mx,my,ix,iy)
    ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
    do while (ok)
      !
      ! Plot for debug
      if (l_method%pcycle) then
        call mrc_plot(c_resid,mx,my,2,'Compact')
        call mrc_plot(l_resid,nx,ny,3,'Long')
      endif
      !
      ! NOISE is the Noise RATIO (mean value over the beams)
      !
      if (l_max.gt.c_max/noise .or.   &
         &        l_method%n_iter.gt.l_method%m_iter-nker**2) then
        print *,'LONG baselines ',l_max,c_max/noise,noise
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Find components in LONG baseline image
        call one_cycle90 (l_method,l_hclean,   &   !
            &          l_clean,   &   ! Final CLEAN image
            &          l_dbeam,   &   ! Dirty beams
            &          l_resid,nx,ny,   & ! Residual and size
            &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
            &          w_comp, nc,         &  ! Component storage + Size
            &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
            &          l_method%patch(1),l_method%patch(2),   &
            &          l_method%bgain,l_method%box,   &
            &          w_fft,   &     ! Work space for FFTs
            &          tcc,   &       ! Component table
            &          l_list, l_method%nlist,   & ! Search list
            &          np,   &        ! Number of fields
            &          l_dprim,   &   ! Primary beams
            &          l_weight,   &  ! Weight
            &          l_max)
        !
        ! Define component type
        tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
        ! Remove from COMPACT baselines
        call remove_incompact(c_method,c_resid,mx,my,   &
            &          c_tfbeam, w_fft,mp,c_dprim,c_weight,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
        ! Define number of iterations
        c_method%n_iter = l_method%n_iter
        c_method%flux = l_method%flux
      else
        print *,'COMPACT baselines ',l_max,c_max/noise,noise
        if (l_method%qcycle) then
          call sic_wpr('WAIT ? ',ans)
        endif
        !
        ! Define the corresponding component list AND value
        call expand_kernel(c_method,mx,my,ix,iy,c_max,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny,   &
            &          kernel, nker)
        !
        ! Remove List in Compact Baselines
        call remove_incompact(c_method,c_resid,mx,my,   &
            &          c_tfbeam, w_fft,mp,c_dprim,c_weight,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
        !
        ! Remove List in Long Baselines
        call remove_inlong(l_method,l_resid,nx,ny,   &
            &          l_tfbeam, w_fft,np,l_dprim,l_weight,   &
            &          tcc,c_method%n_iter+1,l_method%n_iter)
        !
        ! Define number of components
        c_method%n_iter = l_method%n_iter
        l_method%flux = c_method%flux
      endif
      ! Stop if done
      l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
      c_max = imaxlst (c_method,c_list,c_resid,mx,my,ix,iy)
      ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
      if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
      if (sic_ctrlc()) ok = .false.
    enddo
    !
    ! Add clean components and residuals to produce clean map
    ! Note that the Kernel is still scaled in the same way as before
    if (l_method%n_iter.ne.0) then
      call alma_make (l_method, l_hclean, tcc)
    else
      l_clean = 0
    endif
    !
    ! Which residual should be added ?...
    ! We don't want to add noise, but to combine it properly...
    ! We may need to go to the full combined gridding business here...
    l_clean = l_clean + l_resid * l_weight * long
    c_clean = c_resid * c_weight * compact
    call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
    where (l_weight.lt.l_method%trunca)
      r_work = 0
    end where
    !!         L_CLEAN = L_CLEAN + R_WORK
  enddo
end subroutine sub_alma_bis
!
function imaxlst (method,list,resid,nx,ny,ix,jy)
  use clean_def
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for ALMA deconvolution
  !--------------------------------------------------------------
  real imaxlst  ! intent(out)
  type (clean_par), intent(in) :: method
  integer, intent(in) :: nx,ny
  integer, intent(out) :: ix,jy
  integer, intent(in) :: list(:)
  real, intent(in) :: resid(nx,ny)
  !
  real maxc, minc, maxabs
  integer i,imin,imax,jmin,jmax
  !
  call maxlst (resid,nx,ny,list,method%nlist,   &
       &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
    ix = imax
    jy = jmax
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
    ix = imin
    jy = jmin
  else
    maxabs=abs(maxc)
    ix = imax
    jy = jmax
  endif
  imaxlst = maxabs
end function imaxlst
!
subroutine remove_incompact(method,resid,nx,ny,tfbeam,wfft,   &
     &    np,primary,weight,tcc,first,last,mx,my)
  use gkernel_interfaces, only : fourt
  use clean_def
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Remove components in "compact" array
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  !
  integer, intent(in) ::  np,nx,ny,mx,my,first,last
  real, intent(inout) ::  resid(nx,ny)
  real, intent(inout) ::  tfbeam(nx,ny,np)     ! T.F. du beam  Complex ?
  real, intent(in) :: primary(np,nx,ny)
  real, intent(in) :: weight(nx,ny)
  type(cct_par), intent(inout) :: tcc(last)
  real, intent(inout) :: wfft(*)
  !
  complex, allocatable :: icomp(:,:), ocomp(:,:)
  real, allocatable :: clean(:,:), prim(:,:), sky(:,:)
  real, allocatable :: ricomp(:,:),rocomp(:,:)
  real wtrun,val,fact
  integer i,j,k,ndim,nn(2),ip,ix,iy,ier
  character(len=2) ans
  !
  wtrun = method%trunca
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  allocate (ocomp(nx,ny),stat=ier)
  allocate (icomp(mx,my),stat=ier)
  allocate (clean(nx,ny),stat=ier)
  allocate (ricomp(mx,my),stat=ier)
  allocate (rocomp(nx,ny),stat=ier)
  allocate (sky(nx,ny),stat=ier)
  allocate (prim(nx,ny),stat=ier)
  !
  fact = float(mx*my)/float(nx*ny)
  !
  ! Optimized by using CLEAN to store sum of components before multiplying
  ! by the weights to subtract from the Residuals
  clean = 0.0
  ricomp = 0.0
  do k=first,last
    ix = tcc(k)%ix
    iy = tcc(k)%iy
    val = tcc(k)%value * fact
    ricomp(ix,iy) = ricomp(ix,iy) + val
  enddo
  !
  ! Add compression
  call compress(mx,my,ricomp,icomp,nx,ny,rocomp,ocomp,wfft)
  sky = rocomp
  if (method%pcycle) then
    call mrc_plot(weight,nx,ny,1,'Weight')
    call mrc_plot(resid,nx,ny,2,'Resid')
    call mrc_plot(sky,nx,ny,3,'Sky')
    if (method%qcycle) call sic_wpr('Continue',ans)
  endif
  !
  ! Loop on the fields
  do ip=np,1,-1
    prim = primary(ip,:,:)
    if (method%pcycle) call mrc_plot(prim,nx,ny,1,'Primary')
    !
    ! Multiply by Complete Primary beam...
    rocomp = sky*prim
    !
    ! Convolve with dirty beam
    ocomp = cmplx(rocomp,0.0)
    call fourt(ocomp,nn,ndim,-1,0,wfft)
    rocomp = tfbeam(:,:,ip)
    ocomp = ocomp*rocomp
    call fourt(ocomp,nn,ndim,1,1,wfft)
    rocomp = real(ocomp)
    !
    ! Multiply by Truncated Primary beam now
    where (prim.lt.wtrun)
      prim = 0
    end where
    rocomp = rocomp*prim
    if (method%pcycle) call mrc_plot(rocomp,nx,ny,3,'Comp...')
    clean = clean + rocomp
  enddo
  if (method%pcycle) then
    if (method%qcycle) call sic_wpr('Continue',ans)
    call mrc_plot(clean,nx,ny,3,'Clean')
    call mrc_plot(resid,nx,ny,1,'Residu')
  endif
  resid = resid - clean*weight
end subroutine remove_incompact
!
subroutine remove_inlong(method,resid,nx,ny,tfbeam,wfft,   &
     &    np,primary,weight,tcc,first,last)
  use gkernel_interfaces, only : fourt
  use clean_def
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Remove components in "long baseline" array
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  !
  integer, intent(in) ::  np,nx,ny,first,last
  real, intent(inout) ::  resid(nx,ny)
  real, intent(inout) ::  tfbeam(nx,ny,np)     ! T.F. du beam  Complex ?
  real, intent(in) :: primary(np,nx,ny)
  real, intent(in) :: weight(nx,ny)
  type(cct_par), intent(inout) :: tcc(last)
  real, intent(inout) :: wfft(*)
  !
  complex, allocatable :: icomp(:,:), ocomp(:,:)
  real, allocatable :: clean(:,:), prim(:,:), sky(:,:)
  real, allocatable :: ricomp(:,:),rocomp(:,:)
  real wtrun,val,fact
  integer i,j,k,ndim,nn(2),ip,ix,iy,ier
  integer jx,jy,xfact,yfact,firstx,lastx,firsty,lasty
  logical comp
  character(len=2) ans
  !
  wtrun = method%trunca
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  allocate (ocomp(nx,ny),stat=ier)
  allocate (clean(nx,ny),stat=ier)
  allocate (rocomp(nx,ny),stat=ier)
  allocate (sky(nx,ny),stat=ier)
  allocate (prim(nx,ny),stat=ier)
  !
  ! Optimized by using CLEAN to store sum of components before multiplying
  ! by the weights to subtract from the Residuals
  clean = 0.0
  rocomp = 0.0
  do k=first,last
    ix = tcc(k)%ix
    iy = tcc(k)%iy
    val = tcc(k)%value
    rocomp(ix,iy) = rocomp(ix,iy) + val
  enddo
  sky = rocomp
  if (method%pcycle) then
    call mrc_plot(weight,nx,ny,1,'Weight')
    call mrc_plot(resid,nx,ny,2,'Resid')
    call mrc_plot(sky,nx,ny,3,'Sky')
    if (method%qcycle) call sic_wpr('Continue',ans)
  endif
  !
  ! Loop on the fields
  do ip=np,1,-1
    prim = primary(ip,:,:)
    if (method%pcycle) call mrc_plot(prim,nx,ny,1,'Primary')
    !
    ! Multiply by Complete Primary beam...
    rocomp = sky*prim
    !
    ! Convolve with dirty beam
    ocomp = cmplx(rocomp,0.0)
    call fourt(ocomp,nn,ndim,-1,0,wfft)
    rocomp = tfbeam(:,:,ip)
    ocomp = ocomp*rocomp
    call fourt(ocomp,nn,ndim,1,1,wfft)
    rocomp = real(ocomp)
    !
    ! Multiply by Truncated Primary beam now
    where (prim.lt.wtrun)
      prim = 0
    end where
    rocomp = rocomp*prim
    if (method%pcycle) call mrc_plot(rocomp,nx,ny,3,'Comp...')
    clean = clean + rocomp
  enddo
  if (method%pcycle) then
    if (method%qcycle) call sic_wpr('Continue',ans)
    call mrc_plot(clean,nx,ny,3,'Clean')
    call mrc_plot(resid,nx,ny,1,'Residu')
  endif
  resid = resid - clean*weight
end subroutine remove_inlong
!
subroutine expand_kernel(c_method,mx,my,ix,iy,c_max,   &
     &    tcc,first,last,nx,ny,kernel,nker)
  use clean_def
  ! @ private
  type (clean_par), intent(inout) :: c_method
  integer, intent(in) :: nx,ny
  integer, intent(in) :: mx,my
  integer, intent(in) :: ix,iy
  integer, intent(in) :: nker
  integer, intent(in) :: first
  integer, intent(inout) :: last
  real, intent(in) :: kernel(nker,nker)
  real, intent(in) :: c_max
  type (cct_par), intent(inout) :: tcc(*)
  !
  integer lk, i,j,lx,ly,xfact,yfact,nc
  real value
  !
  last = first+nker*nker-1
  !
  value = c_max * c_method%gain * c_method%weight(ix,iy,1)
  xfact = nx/mx
  yfact = ny/my
  !
  lx = xfact*(ix-1) + xfact/2
  ly = yfact*(iy-1) + yfact/2
  lk = (nker+1)/2
  nc = first
  !
  do j=1,nker
    do i=1,nker
      tcc(nc)%ix = lx-lk+i
      tcc(nc)%iy = ly-lk+j
      tcc(nc)%value = value*kernel(i,j)
      tcc(nc)%type = 0
      !!            print *,nc,tcc(nc)
      c_method%flux = c_method%flux + tcc(nc)%value
      if (c_method%pflux) then
         call draw(dble(nc),dble(c_method%flux))
         call gr_out
      endif
      nc = nc+1
    enddo
  enddo
  !
end subroutine expand_kernel
!
subroutine alma_make (method, l_hclean, tcc)
  use gkernel_interfaces, only : fourt
  use clean_def
  use image_def
  ! @ private
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: l_hclean
  type (cct_par), intent(in) :: tcc(method%n_iter)
  !
  real(8), parameter :: pi=3.141592653589793d0
  integer nx,ny,nc,ix,iy,ic,imax,ndim,nn(2),ier, iplane
  real xinc, yinc, fact, val
  real, pointer :: l_clean(:,:)
  real, allocatable :: wfft(:)
  complex, allocatable :: fcomp(:,:)
  !
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  iplane = method%iplane
  l_clean => l_hclean%r3d(:,:,iplane)
  !
  allocate (wfft(2*max(nx,ny)),stat=ier)
  allocate (fcomp(nx,ny),stat=ier)
  xinc = l_hclean%gil%convert(3,1)
  yinc = l_hclean%gil%convert(3,2)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  !
  ! Add the Long Baseline components
  l_clean = 0.0
  do ic=1,method%n_iter
    ix = tcc(ic)%ix
    iy = tcc(ic)%iy
    val = tcc(ic)%value
    l_clean(ix,iy) = l_clean(ix,iy) + val
  enddo
  !
  ! Convolve by Gaussian
  fcomp = cmplx(l_clean,0.0)
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fact = method%major*method%minor*pi/(4.0*log(2.0))   &
       &    /abs(xinc*yinc)/(nx*ny)
  call mulgau(fcomp,nx,ny,   &
       &    method%major,method%minor,method%angle,   &
       &    fact,xinc,yinc)
  call fourt(fcomp,nn,ndim,1,1,wfft)
  l_clean(:,:) = real(fcomp)
end subroutine alma_make

subroutine statistic (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>statistic
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use clean_support
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !     Support for command
  !   STATISTIC Image [Edge] [/WHOLE] [NOISE Variable]
  !
  !     Compute Statistics on internal image, and optionally
  !   return the noise level in the specified Variable.
  !   Image is the name of one of the internal images (DIRTY, CLEAN,
  !   RESIDUAL, SKY, etc...)
  ! 
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_whole=2
  integer, parameter :: o_noise=1
  !
  type (gildas), pointer :: hstat
  real, pointer :: dstat(:,:,:)
  integer ier, plane, na, nx, ny
  character(len=12) argum,stype
  logical do_whole, do_mask
  real valmin, valmax, mean, rms, noise, beam, flux, sec, lambda, jyperk
  integer imin, imax, jmin, jmax, n_sup, n_off, box(4), ntype, n
  character(len=4) :: rname = 'STAT'
  character(len=9) :: prefix
  character(len=3) :: fixpre
  character(len=64) :: var
  real :: scale, uscale, edge
  real, save :: stat_noise = 0.0
  !
  ! Save DO_MASK
  do_mask = user_method%do_mask
  !
  ! Type of image (default = last_shown)
  !
  argum = last_shown
  call sic_ke (line,0,1,argum,na,.false.,error)
  call sic_ambigs ('STATISTIC',argum,stype,ntype,vtype,mtype,error)
  if (error) return
  !
  ! Plane
  if (sic_present(0,2)) then
    call sic_i4(line,0,2,plane,.false.,error)
    if (error) return
  else
    call sic_get_inte ('FIRST',plane,error)
  endif
  if (plane.eq.0) plane = 1
  !
  ! Allocate memory
  if (stype.eq.'CLEAN') then
    if (.not.allocated(dclean)) then
      call map_message(seve%e,rname,'No Clean image')
      error = .true.
      return
    endif
    hstat => hclean
    dstat => dclean
  elseif (stype.eq.'DIRTY') then
    if (.not.allocated(ddirty)) then
      call map_message(seve%e,rname,'No Dirty image')
      error = .true.
      return
    endif
    hstat => hdirty
    dstat => ddirty
  elseif (stype.eq.'RESIDUAL') then
    if (.not.allocated(dresid)) then
      call map_message(seve%e,rname,'No Residual image')
      error = .true.
      return
    endif
    hstat => hresid
    dstat => dresid
  elseif (stype.eq.'SKY') then
    if (.not.allocated(dsky)) then
      call map_message(seve%e,rname,'No Sky image')
      error = .true.
      return
    endif
    hstat => hsky
    dstat => dsky
  else
    call map_message(seve%e,rname,'Unkown image type')
    error = .true.
    return
  endif
  !
  ! Local support
  nx = hstat%gil%dim(1)
  ny = hstat%gil%dim(2)
  !
  if (sic_present(o_whole,0)) then
    !    1) /WHOLE option
    !  - set all the support to .true. (ie compute stat on the whole image)
    do_whole = .true.
  elseif  (do_mask) then
    !  - Re-evaluate the Mask and List
    if (.not.allocated(d_mask)) then
      allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Error getting support memory')
        error = .true.
        return
      endif
    endif
    method%do_mask = .true.
    method%nlist = 0
    do_whole = .false.
    !!Print *,' DO_Mask ',do_mask,' Method Mask ',method%nlist
    !!Print *,' MASK ',hmask%loca%size
  else
    ! Re-use current List
    do_whole = (method%nlist.eq.0) 
    !!Print *,' DO_Whole ',do_whole,' Method list ',method%nlist
    !!Print *,' MASK ',hmask%loca%size
  endif
  !
  ! Avoid edges
  !! box = [nx/16,ny/16,15*nx/16,15*ny/16]
  edge = 1./16.
  call sic_r4(line,0,2,edge,.false.,error)
  box(1) = nint(nx*edge)
  box(2) = nint(ny*edge)
  box(3) = nx-box(1)+1
  box(4) = ny-box(2)+1
  !
  if (do_whole) then
    call map_message(seve%i,rname,'Using the whole image')
    if (sic_present(o_whole,1)) box = [1,1,nx,ny]
  else
    ! Re-compute the Mask from current Mask, Support or Box
    ! Default Box from BLC & TRC
    call check_box(nx,ny,method%blc,method%trc)
    method%box = (/method%blc(1),method%blc(2),method%trc(1),method%trc(2)/)
    ! call check_area(method,hstat,.true.)
    ! Print *,'Checking Mask ',method%do_mask
    ! Mask evaluation from List
    call check_mask(method,hstat)
    !!Print *,'Method list ',method%nlist, ' Box ',method%box
    box(1) = min(box(1),method%box(1))
    box(2) = min(box(2),method%box(2))
    box(3) = max(box(3),method%box(3))
    box(4) = max(box(4),method%box(4))
    !!Print *,'Support Type ',support_type,' Mask ',support_mask,' Poly ',support_poly
    if (support_type.eq.support_mask) then
      call map_message(seve%i,rname,'Using current Mask')
    else if (support_type.eq.support_poly) then
      call map_message(seve%i,rname,'Using current Support')
    else
      call map_message(seve%i,rname,'Using default Box')
    endif
  endif
  !
  ! Compute stat
  if (do_whole) then
    call compute_stat(nx,ny,dstat(:,:,plane),box,   &
       &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise, &
       &    n_sup,n_off,hstat%gil%bval,hstat%gil%eval)
  else
    call compute_stat(nx,ny,dstat(:,:,plane),box,   &
       &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise, &
       &    n_sup,n_off,hstat%gil%bval,hstat%gil%eval,        &
       &    d_mask)
  endif
  !
  call sic_delvariable ('STAT_NOISE',.false.,error)
  stat_noise = noise
  call sic_def_real ('STAT_NOISE',stat_noise,0,0,.false.,error)  
  !
  if (sic_present(o_noise,0)) then
    ! /NOISE option
    call sic_ke(line,o_noise,1,var,n,.true.,error)
    if (error) return
    call sic_let_real(var,noise,error)
  else
    write(6,101) 'Found ',n_sup,' pixels on, ',n_off,' off source'
    !
    ! Find the appropriate unit (Jy, mJy or microJy)
    if (noise.lt.1e-5) then
      scale = 1e6
      prefix = ' microJy'
    else if (noise.lt.0.01) then
      scale = 1e3
      prefix = ' mJy'
    else
      scale = 1.0
      prefix = ' Jy'
    endif
    !
    ! If CLEAN or SKY image, compute total flux
    if (stype.eq.'CLEAN' .or. stype.eq.'SKY') then
      beam = pi*hstat%gil%majo*hstat%gil%mino/4./log(2.0)
      beam = beam/abs(hstat%gil%convert(3,1)*hstat%gil%convert(3,2))
      sec = 180.*3600./pi
      lambda = 2.99792458e8/hstat%gil%freq*1e-6
      jyperk = 2.0*1.38e3*   &
       &      pi*hstat%gil%majo*hstat%gil%mino/4./log(2.0)   &
       &      /lambda**2.
      if (jyperk*scale.gt.1e3) then
        uscale = 1e-3
        fixpre = 'mK'
      else
        uscale = 1
        fixpre = ' K'
      endif
      !
      write(6,1002) ' Map minimum at (',imin,jmin,') : ',valmin*scale, &
        prefix,valmin/jyperk*uscale,fixpre
      write(6,1002) ' Map maximum at (',imax,jmax,') : ',valmax*scale, &
        prefix,valmax/jyperk*uscale,fixpre
      !
      write(6,1003) ' RMS:       On-source:            ', rms*scale, &
        & trim(prefix)//'/beam',rms/jyperk*uscale,fixpre
      write(6,1003) ' RMS:      Off-source:            ', noise*scale, &
        trim(prefix)//'/beam', noise/jyperk*uscale,fixpre
      write(6,1003) ' RMS:         Thermal:            ', hstat%gil%noise*scale, &
        & trim(prefix)//'/beam', hstat%gil%noise/jyperk*uscale,fixpre
      !
      write(6,'(A,F8.1,A,F8.1)') ' Dynamic range: ',valmax/noise,  &
        & ' -- ',-3.0*valmax/valmin
      flux = (mean*n_sup)/beam
      write(6,104) 'Total flux in CLEAN map: ',flux*scale,trim(prefix)
      write(6,105) ' Tb scale for CLEAN map: 1 '//fixpre//' = ',   &
       &      jyperk*uscale*scale,trim(prefix)//'/beam'
      write(6,106) 'Clean Beam is ',   &
       &      hstat%gil%majo*sec,' x ',hstat%gil%mino*sec,   &
       &      ' sec at PA = ',hstat%gil%posa*180/pi,' deg'
      call sic_delvariable ('CLEANFLUX',.false.,error)
      call sic_def_real ('CLEANFLUX',flux,0,0,.false.,error)
      !
      ! Set the CLEAN rms to the Off source noise.
      hstat%gil%rms = noise
    else
      write(6,1002) ' Map minimum at (',imin,jmin,') : ',valmin*scale, prefix
      write(6,1002) ' Map maximum at (',imax,jmax,') : ',valmax*scale, prefix
      write(6,1003) ' RMS:       On-source:            ', rms*scale,trim(prefix)
      write(6,1003) ' RMS:      Off-source:            ', noise*scale,trim(prefix)
      write(6,1003) ' RMS:         Thermal:            ', hstat%gil%noise*scale,trim(prefix)
    endif
  endif
  !
  !
  101   format (1x,a,i8,a,i8,a)
  104   format (1x,a,f9.3,a)
  105   format (1x,a,f8.3,a)
  106   format (1x,a,f7.3,a,f7.3,a,f5.0,a)
  1002  format (a,i6,',',i6,a,f10.3,a,f10.3,a)
  1003  format (A,0PF10.3,A,0PF10.3,A) 
  !
end subroutine statistic
!
subroutine compute_stat(nx,ny,amap,box, &
     &    valmin,imin,jmin,valmax,imax,jmax,mean,rms,noise,np,nn, &
     &    bval,eval, &
     &    support)
  !--------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING
  !    Statistics on image
  !--------------------------------------------------------------
  integer, intent(out) :: np, nn
  integer, intent(in) :: nx,ny
  real, intent(in) :: amap(nx,ny)
  integer, intent(out) :: imin, jmin, imax, jmax
  integer, intent(in) ::  box(4)
  real, intent(out) :: valmin, valmax, mean, rms, noise
  real, intent(in) :: bval, eval
  logical, intent(in), optional :: support(nx,ny)
  !
  integer i,j,nb
  real val, mean2
  !
  valmin = 1e30                ! ??
  valmax = -1e30
  mean = 0.
  mean2 = 0.
  noise = 0.
  nn = 0
  np = 0
  nb = 0
  !
  if (eval.lt.0.) then
    if (present(support)) then
      do i = box(1),box(3)
        do j = box(2),box(4)
          val = amap(i,j)
          if (support(i,j)) then
            np  = np+1
            mean = mean+val
            mean2 = mean2+val*val
            if (valmax.lt.val) then
              valmax = val
              imax = i
              jmax = j
            endif
            if (valmin.gt.val) then
              valmin= val
              imin = i
              jmin = j
            endif
          else
            nn = nn+1
            noise = noise+val*val
          endif
        enddo
      enddo
    else
      do i = box(1),box(3)
        do j = box(2),box(4)
          val = amap(i,j)
          mean = mean+val
          mean2 = mean2+val*val
          if (valmax.lt.val) then
            valmax = val
            imax = i
            jmax = j
          endif
          if (valmin.gt.val) then
            valmin= val
            imin = i
            jmin = j
          endif
        enddo
      enddo
      np  = (box(4)-box(2)+1)*(box(3)-box(1)+1)
    endif
  else
    ! With Blanking
    if (present(support)) then
      do i = box(1),box(3)
        do j = box(2),box(4)
          val = amap(i,j)
          if (support(i,j)) then
            if (abs(val-bval).gt.eval) then
              np  = np+1
              mean = mean+val
              mean2 = mean2+val*val
              if (valmax.lt.val) then
                valmax = val
                imax = i
                jmax = j
              endif
              if (valmin.gt.val) then
                valmin= val
                imin = i
                jmin = j
              endif
            else
              nb = nb+1
            endif ! Blanking
          else
            if (abs(val-bval).gt.eval) then
              nn = nn+1
              noise = noise+val*val
            else
              nb = nb+1
            endif
          endif ! Support
        enddo
      enddo
    else
      do i = box(1),box(3)
        do j = box(2),box(4)
          val = amap(i,j)
          if (abs(val-bval).gt.eval) then
            mean = mean+val
            mean2 = mean2+val*val
            if (valmax.lt.val) then
              valmax = val
              imax = i
              jmax = j
            endif
            if (valmin.gt.val) then
              valmin= val
              imin = i
              jmin = j
            endif
            np = np+1
          else
            nb = nb+1
          endif
        enddo
      enddo
    endif
  endif
  !
  mean = mean/np
  mean2 = mean2/np
  rms = sqrt(mean2-mean*mean)
  if (nn.ne.0) then
    noise = sqrt(noise/nn)
  else
    noise = rms
  endif
end subroutine compute_stat

subroutine moments_comm(line,error)
  use gkernel_interfaces
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command
  !       MOMENT [Area Peak Velocity Width] 
  !         [/METHOD Mean Peak Parabolic]
  !         [/RANGE Min Max TYPE] [/THRESHOLD Min]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MOMENTS'
  !
  call sic_delvariable ('M_AREA',.false.,error)
  call sic_delvariable ('M_PEAK',.false.,error)
  call sic_delvariable ('M_VELO',.false.,error)
  call sic_delvariable ('M_WIDTH',.false.,error)
  error = .false.
  !
  if (hsky%loca%size.ne.0) then
    call map_message(seve%i,rname,'Using SKY cube')
    hsky%r3d => dsky
    call sub_moments(hsky,line,error)
  else if (hclean%loca%size.ne.0) then
    call map_message(seve%i,rname,'Using CLEAN cube')
    hclean%r3d => dclean
    call sub_moments(hclean,line,error)
  else
    call map_message(seve%e,rname,'No CLEAN or SKY brightness cube')
    error = .true.
  endif
end subroutine moments_comm
!
subroutine sub_moments(horigin,line,error)
  use gkernel_interfaces
  use clean_arrays
  use moment_arrays
  use gbl_message
  use imager_interfaces
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command
  !       MOMENT [Area Peak Velocity Width] 
  !         [/METHOD Mean Peak Parabolic]
  !         [/RANGE Min Max TYPE] [/THRESHOLD Min]
  !
  !	A dedicated routine to compute the moment of an input data cube.
  !	Input: a LMV cube
  !	Output: any or all of 4 images
  !           1) the integrated intensity map
  !           2) the Peak brightness
  !           3) The mean velocity
  !           4) The line width
  !	Method:
  !     AREA      Integrated intensity in Velocity range
  !
  !     PEAK      Peak intensity in Velocity range
  !     VELOCITY  Velocity of peak  
  !     WIDTH     2nd moment: line width, using the Velocity
  !               assigned 
  ! The peak intensity is obtained either as a per-channel basis,
  ! or a parabolic fit around the maximum. The Velocity is obtained
  ! in a similar way, or intensity weighted.
  !     
  !       For each spectrum, make a gate in velocity and clip based on
  !       intensity. Sum up weighted velocity and mean intensity.
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: horigin ! Input image, CLEAN or SKY
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MOMENTS'
  real(8), parameter :: pi=3.14159265358979323846d0
  ! Local
  integer, parameter :: o_mask=1
  integer, parameter :: o_method=2
  integer, parameter :: o_range=3
  integer, parameter :: o_seuil=4
  !
  character(len=12) :: cmeth,ch,new_unit
  integer :: nc(2)
  real(8) :: drange(2), freq, href
  character(len=12) :: csort
  integer(kind=4) :: isort
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort),mysort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !  
  character(len=80) :: chain
  real(kind=4) :: seuil,dv,vfirst,vlast
  integer(kind=4) :: ier,n
  integer(kind=index_length) :: nv,nx,ny,i,j,iplane
  integer(kind=size_length) :: nxy
  real(kind=4), allocatable :: ipb(:)
  real(kind=4), pointer :: odata(:,:,:)
  real :: lambda, jyperk, sigma
  logical :: do_mask
  type(gildas) :: hin
  !
  if (allocated(dmean)) then
    deallocate(dmean,dpeak,dvelo,dwidth,stat=ier)
  endif
  !
  do_mask = sic_present(o_mask,0)
  if (do_mask) then
    if (.not.allocated(dmask)) then
      call map_message(seve%e,rname,'No mask allocated for the /MASK option')
      error = .true.
    else if (hin%gil%dim(1).ne.hmask%gil%dim(1) .or. &
      & hin%gil%dim(2).ne.hmask%gil%dim(2)) then
      call map_message(seve%e,rname,'MASK and image do not match')
      error = .true.
    endif
    if (error) return
  endif    
  !
  ! Compute the channel range
  if (sic_present(o_range,0)) then
    ! /RANGE (for flexibility)
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,n,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs(rname//' /RANGE',csort,mysort,isort,types,msort,error)
    if (error)  return
  else
    ! Default is FIRST and LAST channels
    mysort = 'CHANNEL'
    drange = 0.d0
    call sic_get_dble('FIRST',drange(1),error)
    call sic_get_dble('LAST',drange(2),error)
  endif
  call out_range(rname,mysort,drange,nc,horigin,error)
  if (error) return
  !
  ! Get the threshold. Default is 3 sigma
  sigma = max(horigin%gil%noise,horigin%gil%rms)
  if (sic_present(o_seuil,0)) then
    call sic_r4(line,o_seuil,1,seuil,.false.,error)
    if (error) return
    ch = 'SIGMA'
    call sic_ke(line,o_seuil,2,ch,n,.false.,error)
    if (ch.eq.'SIGMA') then
      if (sigma.ne.0) then
        seuil = seuil*sigma
      else
        call map_message(seve%e,rname,'Noise statistic not available, specify /THRESHOLD value FLUX')
        error = .true.
        return
      endif
    else if (ch.ne.'FLUX') then
      call map_message(seve%e,rname,'Invalid threshold unit '//ch)
      error = .true.
      return
    endif
  else
    if (sigma.ne.0) then
      seuil = 3*sigma
    else
      call map_message(seve%e,rname,'Noise statistic not available, specify /THRESHOLD value FLUX')
      error = .true.
      return
    endif
  endif
  !
  ! Change to Velocity representation
  call gildas_null(hin)
  call gdf_copy_header(horigin,hin,error)
  new_unit = 'VELOCITY'
  call gdf_modify(hin,hin%gil%voff,hin%gil%freq,new_unit,error)
  if (error) return
  !
  ! Get the method
  cmeth = 'MEAN'
  call sic_ke(line,o_method,1,cmeth,n,.false.,error)
  if (error) return
  select case (cmeth)
  case ('MEAN','PEAK','PARABOLA') 
    call map_message(seve%i,rname,'Using method '//cmeth)
  case default
    call map_message(seve%e,rname,'Invalid method '//cmeth)
    error = .true.
    return
  end select
  !
  nx = hin%gil%dim(1)
  ny = hin%gil%dim(2)
  nv = hin%gil%dim(3)
  !
  !
  ! Modify the requested part of the PEAK Header
  call gildas_null(hpeak)
  call gdf_copy_header(hin,hpeak,error)
  hpeak%gil%dim(3) = 1
  hpeak%char%code(3) = 'UNKNOWN'
  hpeak%gil%convert(:,3) = 1.d0
  hpeak%gil%extr_words = def_extr_words
  hpeak%gil%blan_words = 2
  ! Convert to Brightness ??
  ! hpeak%char%unit = 'K' ! and JyperK factor 
  hpeak%gil%faxi = 0
  hpeak%gil%bval = 0
  hpeak%gil%eval = 0
  hpeak%loca%size = nx*ny
  !
  ! Modify the requested part of the MEAN Header
  call gildas_null(hmean)
  call gdf_copy_header(hpeak,hmean,error)
  if (hin%char%code(3).eq.'VELOCITY') then
    hmean%char%unit = trim(hin%char%unit)//'.km/s'
  elseif (hin%char%code(3).eq.'FREQUENCY') then
    hmean%char%unit = trim(hin%char%unit)//'.MHz'
  else
    hmean%char%unit = 'UNKNOWN'
  endif
  !
  ! As above for VELOCITY image
  call gildas_null(hvelo)
  call gdf_copy_header(hpeak,hvelo,error)
  if (hin%char%code(3).eq.'VELOCITY') then
    hvelo%char%unit = 'km/s'
  elseif (hin%char%code(3).eq.'FREQUENCY') then
    hvelo%char%unit = 'MHz'
  else
    hvelo%char%unit = 'UNKNOWN'
  endif
  !
  ! As above for line width
  call gildas_null(hwidth)
  call gdf_copy_header(hvelo,hwidth,error)
  !
  ! Do some useful job
  nxy = hmean%gil%dim(1)*hmean%gil%dim(2)
  allocate (dmean(nx,ny), dvelo(nx,ny), dpeak(nx,ny),  &
            dwidth(nx,ny), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  dmean = 0.
  dvelo = 0.
  dwidth = 0.
  dpeak = 0.
  !
  dv = abs(hin%gil%inc(3))
  !
  ! Loop in valid range
  write(chain,*) 'Channel range ',nc(1),nc(2)
  call map_message(seve%i,rname,chain)
  if (hin%gil%inc(3).gt.0) then
    vfirst = (nc(1)-0.5-hin%gil%ref(3))*hin%gil%inc(3)+hin%gil%val(3)
    vlast  = (nc(2)+0.5-hin%gil%ref(3))*hin%gil%inc(3)+hin%gil%val(3)
  else
    vlast = (nc(2)-0.5-hin%gil%ref(3))*hin%gil%inc(3)+hin%gil%val(3)
    vfirst  = (nc(1)+0.5-hin%gil%ref(3))*hin%gil%inc(3)+hin%gil%val(3)
  endif
  write(chain,*) 'Velocity range ',vfirst,vlast
  call map_message(seve%i,rname,chain)
  !
  ! Only copy when needed
  if (do_mask) then
    ! And only copy what is needed
    nv = nc(2)-nc(1)+1
    allocate(odata(nx,ny,nv), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do i=nc(1),nc(2)
      j = i-nc(1)+1
      ! Find out the mask plane
      freq = (i-hin%gil%ref(3))*hin%gil%fres + hin%gil%freq
      iplane = nint((freq-hmask%gil%freq)/hmask%gil%fres + hmask%gil%ref(3))
      iplane = min(max(1,iplane),hmask%gil%dim(3)) ! Just  in case
      odata(:,:,j) = horigin%r3d(:,:,i) 
      where (dmask(:,:,iplane).eq.0) odata(:,:,j) = 0.
    enddo
    nc(1) = 1
    nc(2) = nv
    href = hin%gil%ref(3)-nc(1)+1   ! Shift reference pixel
  else
    odata => horigin%r3d
    href = hin%gil%ref(3)
  endif
  !
  ! Set the velocity scale
  allocate(ipb(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif 
  call set_velo(nv,ipb,href,hin%gil%val(3),hin%gil%inc(3))
  !
  ! Compute the moments
  call compute_moments(cmeth,odata,nx*ny,nv,dmean,dvelo, &
    & dwidth,dpeak, ipb,nc(1),nc(2), seuil, &
    & hin%gil%bval,hin%gil%eval)
  ! Scale intensity map
  dmean = dmean * dv
  ! Scale line width to equivalent Gaussian profile
  dv = sqrt(8.0*alog(2.0))
  dwidth = dwidth * dv
  !
  ! Scale the Peak brightness to Kelvin
  lambda = 2.99792458e8/hpeak%gil%freq*1e-6
  jyperk = 2.0*1.38e3*   &
   &      pi*hpeak%gil%majo*hpeak%gil%mino/4./log(2.0)   &
   &      /lambda**2.
  dpeak = dpeak/jyperk
  hpeak%char%unit = 'K'
  hpeak%gil%noise = hpeak%gil%noise/jyperk
  hpeak%gil%rms = hpeak%gil%rms/jyperk
  !
  ! Define the SIC variables
  hmean%loca%addr = locwrd(dmean)
  call gdf_get_extrema (hmean,error)
  hpeak%loca%addr = locwrd(dpeak)
  call gdf_get_extrema (hpeak,error)
  hvelo%loca%addr = locwrd(dvelo)
  call gdf_get_extrema (hvelo,error)
  hwidth%loca%addr = locwrd(dwidth)
  call gdf_get_extrema (hwidth,error)
  call sic_mapgildas ('M_AREA',hmean,error,dmean)
  call sic_mapgildas ('M_PEAK',hpeak,error,dpeak)
  call sic_mapgildas ('M_VELO',hvelo,error,dvelo)
  call sic_mapgildas ('M_WIDTH',hwidth,error,dwidth)
  !
  ! return  with some acknowledgement message
  call message_colour(2)
  call map_message(seve%i,rname,'Successful completion')
  call message_colour(-1)
  if (do_mask) deallocate(odata)
end subroutine sub_moments
!
subroutine compute_moments(method,a,nxy,nv,a0,a1,a2,a3,v, &
  & ivmin,ivmax,s,bval,eval)
  use gildas_def
  character(len=*), intent(in) :: method
  integer(kind=size_length),  intent(in)  :: nxy
  integer(kind=index_length), intent(in)  :: nv
  real(kind=4),               intent(in)  :: a(nxy,nv)
  real(kind=4),               intent(out) :: a0(nxy)  ! 0th moment
  real(kind=4),               intent(out) :: a1(nxy)  ! 1st moment
  real(kind=4),               intent(out) :: a2(nxy)  ! 2nd moment
  real(kind=4),               intent(out) :: a3(nxy)  ! Peak value
  real(kind=4),               intent(in)  :: v(nv)    ! Velocities
  integer(kind=4), intent(in)  :: ivmin
  integer(kind=4), intent(in)  :: ivmax
  real(kind=4),               intent(in)  :: s
  real(kind=4),               intent(in)  :: bval,eval
  ! Local
  integer(kind=size_length) :: i
  integer(kind=index_length) :: k
  integer :: kloc(1)
  real(kind=4) :: a12, aa, bb, cc
  real, allocatable :: spectrum(:)
  integer :: ier, jvmin, jvmax
  !
  if (method.eq.'MEAN') then
    if (eval.lt.0.) then
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s) then
            a0(i) = a0(i) + a(i,k)
            a1(i) = a1(i) + v(k)*a(i,k)
            a2(i) = a2(i) + v(k)*v(k)*a(i,k)
            a3(i) = max(a3(i),a(i,k))
          endif
        enddo
      enddo
    else
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s .and. abs(a(i,k)-bval).gt.eval) then
            a0(i) = a0(i) + a(i,k)
            a1(i) = a1(i) + v(k)*a(i,k)
            a2(i) = a2(i) + v(k)*v(k)*a(i,k)
            a3(i) = max(a3(i),a(i,k))
          endif
        enddo
      enddo
    endif
    !
    do i=1,nxy
      if (a0(i).ne.0.0) then
        a1(i) = a1(i)/a0(i)
        a2(i) = a2(i)/a0(i)
        a12 = a1(i)*a1(i)
        if (a12.gt.a2(i)) then
          a2(i) = 0.0
        else
          a2(i) = sqrt(a2(i) - a12)
        endif
      else
        a1(i) = 0.0
        a2(i) = 0.0
      endif
    enddo
  else if (method.eq.'PEAK') then
    if (eval.lt.0.) then
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s) then
            a0(i) = a0(i) + a(i,k)
            a3(i) = max(a3(i),a(i,k))
            if (a3(i).eq.a(i,k)) a1(i) = v(k)
          endif
        enddo
      enddo
      !
      ! Second pass for Width
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s) then
            a2(i) = a2(i) + (v(k)-a1(i))**2 * a(i,k)
          endif
        enddo
      enddo      
    else
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s .and. abs(a(i,k)-bval).gt.eval) then
            a0(i) = a0(i) + a(i,k)
            a3(i) = max(a3(i),a(i,k))
            if (a3(i).eq.a(i,k)) a1(i) = v(k)
          endif
        enddo
      enddo
      do k=ivmin,ivmax
        do i=1,nxy
          if (a(i,k).ge.s .and. abs(a(i,k)-bval).gt.eval) then
            a2(i) = a2(i) + (v(k)-a1(i))**2 * a(i,k)
          endif
        enddo
      enddo
    endif
    !
    do i=1,nxy
      if (a0(i).ne.0.0) then
        a2(i) = sqrt(a2(i)/a0(i))
      else
        a1(i) = 0.0
        a2(i) = 0.0
      endif
    enddo
  else if (method.eq.'PARABOLA') then
    !
    ! Do it in non-optimal memory order
    allocate (spectrum(nv),stat=ier)
    jvmin = max(2,ivmin)
    jvmax = min(nv-1,ivmax)
    !
    if (eval.lt.0.) then
      do i=1,nxy
        spectrum(:) = a(i,1:nv) 
        kloc = maxloc(spectrum(jvmin:jvmax)) 
        k = kloc(1) + jvmin-1
        ! aa*v2 + bb*v + cc
        call parabola_3pt(v(k-1:k+1),spectrum(k-1:k+1),aa,bb,cc) 
        a1(i) = -bb/(2*aa)
        if (a1(i).lt.v(1) .or. a1(i).gt.v(nv) ) then
          a1(i) = v(k)
          a3(i) = spectrum(k)
        else
          a3(i) = (aa*a1(i) + bb)*a1(i) + cc
        endif
        do k=jvmin,jvmax
          if (spectrum(k).ge.s) then
            a0(i) = a0(i) + spectrum(k)
            a2(i) = a2(i) + (v(k)-a1(i))**2 * spectrum(k)
          endif
        enddo
      enddo
    else
      do i=1,nxy
        spectrum(:) = a(i,1:nv) 
        where (abs(spectrum-bval).le.eval) spectrum = 0
        !
        kloc = maxloc(spectrum(jvmin:jvmax)) 
        k = kloc(1) + jvmin-1
        ! aa*v2 + bb*v + cc
        call parabola_3pt(v(k-1:k+1),spectrum(k-1:k+1),aa,bb,cc) 
        a1(i) = -bb/(2*aa)
        if (a1(i).lt.v(1) .or. a1(i).gt.v(nv) ) then
          a1(i) = v(k)
          a3(i) = spectrum(k)
        else
          a3(i) = (aa*a1(i) + bb)*a1(i) + cc
        endif
        do k=jvmin,jvmax
          if (spectrum(k).ge.s) then
            a0(i) = a0(i) + spectrum(k)
            a2(i) = a2(i) + (v(k)-a1(i))**2 * spectrum(k)
          endif
        enddo
      enddo
    endif
    !
    ! Normalize
    do i=1,nxy
      if (a0(i).ne.0.0) then
        a2(i) = sqrt(a2(i)/a0(i))
      else
        a1(i) = 0.0
        a2(i) = 0.0
        a3(i) = 0.0
      endif
    enddo
  endif
end subroutine compute_moments
!
subroutine set_velo(nv,av,ref,val,inc)
  use gildas_def
  integer(kind=index_length), intent(in)  :: nv
  real(kind=4),               intent(out) :: av(nv)
  real(kind=8),               intent(in)  :: ref,val,inc
  ! Local
  integer(kind=index_length) :: iv
  do iv=1,nv
    av(iv) = (iv-ref)*inc+val
  enddo
end subroutine set_velo
!
subroutine parabola_3pt(x,y,aa,bb,cc) 
  !----------------------------------------------------------------------
  !	Solve for Y = aa*x^2 + bb*x + cc with 3 points input data
  !----------------------------------------------------------------------
  real, intent(in) :: x(3)
  real, intent(in) :: y(3)
  real, intent(out) :: cc,bb,aa
  !
  aa = (y(3)-y(2))*(x(2)-x(1))-(y(2)-y(1))*(x(3)-x(2))
  bb = (x(2)-x(1))*(x(3)*x(3)-x(2)*x(2))-(x(2)*x(2)-x(1)*x(1))*(x(3)-x(2))
  aa = aa/bb
  bb = (y(2)-y(1))-aa*(x(2)*x(2)-x(1)*x(1))
  bb = bb/(x(2)-x(1))
  cc = y(1)-aa*x(1)*x(1)-bb*x(1)
end subroutine parabola_3pt

subroutine mrtindex_variable_entry(struct,head,ro,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Map a Sic structure on an entry
  !---------------------------------------------------------------------
  character(len=*),      intent(in)    :: struct  ! Structure name
  type(mrtindex_header_t), intent(in)    :: head    !
  logical,               intent(in)    :: ro      ! Read-Only?
  logical,               intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  !
  userreq = .false.
  !
  call sic_delvariable(struct,userreq,error)
  call sic_defstructure(struct,.true.,error)
  if (error)  return
  !
  call mrtindex_variable_entry_key(struct,head%key,ro,error)
  if (error)  return
  call mrtindex_variable_entry_prim(struct,head%pri,ro,error)
  if (error)  return
  call mrtindex_variable_entry_calib(struct,head%cal,ro,error)
  if (error)  return
  call mrtindex_variable_entry_science(struct,head%sci,ro,error)
  if (error)  return
  !
end subroutine mrtindex_variable_entry
!
subroutine mrtindex_variable_entry_key(struct,key,ro,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_key
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: struct  ! Structure name
  type(mrtindex_key_t), intent(in)    :: key     !
  logical,            intent(in)    :: ro      ! Read-Only?
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  integer(kind=index_length) :: dims(sic_maxdims)
  !
  userreq = .false.
  str = trim(struct)//'%KEY'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_inte (trim(str)//'%VERSION',     key%version,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%TELESCOPE',   key%telescope,   0,0,   ro,error)
  call sic_def_char (trim(str)//'%PROJID',      key%projid,             ro,error)
  call sic_def_char (trim(str)//'%SOURCE',      key%source,             ro,error)
  call sic_def_inte (trim(str)//'%DOBS',        key%dobs,        0,0,   ro,error)
  call sic_def_dble (trim(str)//'%UT',          key%ut,          0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LST',         key%lst,         0,0,   ro,error)
  call sic_def_real (trim(str)//'%AZ',          key%az,          0,0,   ro,error)
  call sic_def_real (trim(str)//'%EL',          key%el,          0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LON',         key%lon,         0,0,   ro,error)
  call sic_def_dble (trim(str)//'%LAT',         key%lat,         0,0,   ro,error)
  call sic_def_inte (trim(str)//'%SYSTEM',      key%system,      0,0,   ro,error)
  call sic_def_real (trim(str)//'%EQUINOX',     key%equinox,     0,0,   ro,error)
  dims(1) = mrtcal_indx_mfrontend
  call sic_def_charn(trim(str)//'%FRONTEND',    key%frontend,    1,dims,ro,error)
  call sic_def_inte (trim(str)//'%SCAN',        key%scan,        0,0,   ro,error)
  call sic_def_inte (trim(str)//'%BACKEND',     key%backend,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%OBSTYPE',     key%obstype,     0,0,   ro,error)
  call sic_def_inte (trim(str)//'%SWITCHMODE',  key%switchmode,  0,0,   ro,error)
  call sic_def_inte (trim(str)//'%POLARIMETRY', key%polstatus,   0,0,   ro,error)
  call sic_def_inte (trim(str)//'%FILSTATUS',   key%filstatus,   0,0,   ro,error)
  call sic_def_inte (trim(str)//'%CALSTATUS',   key%calstatus,   0,0,   ro,error)
  call sic_def_char (trim(str)//'%FILENAME',    key%filename,           ro,error)
  !
end subroutine mrtindex_variable_entry_key
!
subroutine mrtindex_variable_entry_prim(struct,prim,ro,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_prim
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: struct  ! Structure name
  type(sec_primary_t), intent(in)    :: prim    !
  logical,             intent(in)    :: ro      ! Read-Only?
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  !
  userreq = .false.
  str = trim(struct)//'%PRI'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_real(trim(str)//'%IMBFVERS',prim%imbfvers,0,0,ro,error)
  !
end subroutine mrtindex_variable_entry_prim
!
subroutine mrtindex_variable_entry_calib(struct,calib,ro,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_calib
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: struct  ! Structure name
  type(sec_calib_t), intent(in)    :: calib   !
  logical,           intent(in)    :: ro      ! Read-Only?
  logical,           intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  integer(kind=index_length) :: dims(sic_maxdims)
  !
  userreq = .false.
  str = trim(struct)//'%CAL'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_inte(trim(str)//'%NFREQ',calib%nfreq,0,0,ro,error)
  if (calib%nfreq.le.0)  return
  !
  dims(1) = calib%nset
  call sic_def_charn(trim(str)//'%FRONTEND',calib%frontend,1,dims,ro,error)
  !
  dims(1) = calib%nfreq
  dims(2) = calib%nset
  dims(3) = calib%npix
  call sic_def_dble(trim(str)//'%FREQ',calib%freq,3,dims,ro,error)
  call sic_def_real(trim(str)//'%TSYS',calib%atsys,3,dims,ro,error)
  call sic_def_real(trim(str)//'%ZTAU',calib%ztau,3,dims,ro,error)
  !
end subroutine mrtindex_variable_entry_calib
!
subroutine mrtindex_variable_entry_science(struct,sci,ro,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_variable_entry_science
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),    intent(in)    :: struct  ! Structure name
  type(sec_science_t), intent(in)    :: sci     !
  logical,             intent(in)    :: ro      ! Read-Only?
  logical,             intent(inout) :: error   ! Logical error flag
  ! Local
  logical :: userreq
  character(len=32) :: str
  !
  userreq = .false.
  str = trim(struct)//'%SCI'
  !
  call sic_delvariable(str,userreq,error)
  call sic_defstructure(str,.true.,error)
  if (error)  return
  !
  call sic_def_inte(trim(str)//'%CALDOBS',sci%caldobs,0,0,ro,error)
  call sic_def_inte(trim(str)//'%CALSCAN',sci%calscan,0,0,ro,error)
  call sic_def_inte(trim(str)//'%CALBACK',sci%calback,0,0,ro,error)
  call sic_def_inte(trim(str)//'%CALVERS',sci%calvers,0,0,ro,error)
  !
end subroutine mrtindex_variable_entry_science

subroutine uv_truncate_comm(line,error)
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_truncate_comm
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !
  ! Truncate a UV Table, by removing baselines out of
  ! a given range (Min and Max)
  !
  ! UV_TRUNCATE Max [Min]
  !
  ! Works on the "current" UV data set: Uses UVS or UVR as needed.
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_TRUNCATE'
  !
  character(len=80) :: mess
  real(4) :: mymax, mymin, rmin, rmax, length
  integer :: iv, kv, ier
  integer :: nu, nv
  type (gildas) :: hcuv
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  integer, allocatable :: point(:)
  !
  call sic_r4(line,0,1,mymax,.true.,error)
  if (error) return
  !
  mymin = 0.
  call sic_r4(line,0,2,mymin,.false.,error)
  if (error) return
  !
  ! The UV table is available in HUV%
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi ! %dim(2)
  !
  ! Read the Baseline length information
  allocate (point(nv), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  rmin = mymin**2
  rmax = mymax**2
  !
  kv = 0
  do iv = 1, nv
    length = duv(1,iv)**2 + duv(2,iv)**2
    if (length.ge.rmin .and. length.le.rmax) then
      kv = kv+1
      point(kv) = iv
    endif
  enddo
  !
  ! Prepare header and allocate buffers
  call gildas_null(hcuv,type='UVT')
  call gdf_copy_header(huv,hcuv,error)
  hcuv%gil%dim(2) = kv
  hcuv%gil%nvisi = kv
  nullify (duv_previous, duv_next)
  call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
  if (error) return
  !
  ! Now do the job
  do iv = 1,kv
    duv_next(:,iv) = duv(:,point(iv))
  enddo
  !
  ! Finalize the UV Table
  write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
    & huv%gil%nvisi,' before)'
  call map_message(seve%i,rname,mess)
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Copy back to UV data set
  call gdf_copy_header(hcuv,huv,error)
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_truncate_comm
!

!
subroutine uv_calibrate(line,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_calibrate
  use gbl_message
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for 
  !     CALIBRATE\APPLY [Mode [Gain]] [/FLAG]
  ! 
  ! Apply gains from the GAIN data set to the UV data set.
  ! If no available solution, keep the data as it was.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  ! Global
  character(len=*), parameter :: rname='CALIBRATE'
  real(8), parameter :: pi=3.141592653589793d0
  integer, parameter :: o_flag=1
  ! Local
  character(len=80) :: mess
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real(8), allocatable :: itimg(:), it(:)
  integer, allocatable :: flagged(:)
  integer, allocatable :: idxg(:), idx(:)
  integer(4) ::  n, nvis, ncol, nvg, ndc, ier
  real(8) :: phase_gain, ampli_gain
  real(8) :: fdata, fgain ! Reference frequencies for Gain and UV
  real(4) :: gain
  logical :: do_flag
  integer, parameter :: mmode=3
  character(len=12) :: smode(mmode), mode, argum
  character(len=32) :: chain
  data smode /'AMPLITUDE','DELAY','PHASE'/
  !
  error = .false.
  !
  if (hbgain%loca%size.eq.0) then
    call map_message(seve%e,rname,'Gain table is not defined')
    error = .true.
    return
  endif
  !
  do_flag = sic_present(o_flag,0)
  !
  gain = 1.0
  if (sic_present(0,1)) then
    call sic_ke(line,0,1,argum,n,.true.,error)
    call sic_r4(line,0,2,gain,.false.,error)
    if (error) return
  else
    call sic_get_char('SELF_MODE',argum,n,error)
  endif    
  call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
  if (error) return
  !
  if (gain.le.0. .or. gain.gt.1.0) then
    call map_message(seve%e,rname,trim(mode)//' gain out of range [0,1]')
    error = .true.
    return
  endif
  write(chain,*) gain
  call map_message(seve%i,rname,'Applying '//trim(mode)// &
    & ' calibration with gain '//trim(chain))
  !
  select case(mode)
  case ('AMPLITUDE') 
    ampli_gain = gain
    phase_gain = 0.0
  case ('PHASE')
    phase_gain = gain
    ampli_gain = 0.0
  case ('DELAY')
    fgain = gdf_uv_frequency(hbgain)
    fdata = gdf_uv_frequency(huv)
    write(mess,'(A,F10.1,A,F10.1,A)') 'Frequencies : Data ',fdata,',  Gain table ',fgain,' MHz'
    call map_message(seve%i,rname,mess)  
    phase_gain = gain * fdata/fgain
    write(mess,'(A,F6.3)',iostat=ier) 'Phase gain is ',phase_gain
    call map_message(seve%i,rname,mess)  
    ampli_gain = 0.0
  end select
  !
  ! Now do the job
  nvis = huv%gil%nvisi ! not %dim(2)
  ncol = huv%gil%dim(1)
  ndc =  huv%gil%nchan
  !
  nullify (duv_previous, duv_next)  
  call uv_find_buffers (rname,ncol,nvis,duv_previous, duv_next,error)
  if (error) return
  !
  nvg = hbgain%gil%dim(2)
  !
  ! Get a bunch of memory ...
  allocate (it(nvis), idx(nvis), flagged(nvis), stat=ier)
  if (ier.ne.0) then
    error = .true.
    call map_message(seve%e,rname,'Visibility work array allocation error')
    return
  endif
  allocate (itimg(nvg), idxg(nvg), stat=ier)
  if (ier.ne.0) then
    error = .true.
    call map_message(seve%e,rname,'Gain work array allocation error')
    return
  endif
  !
  call sub_uvcal(ncol,nvis, duv_previous, ndc, duv_next, &
     &    idx, it, do_flag, flagged, nvg, duvbg, idxg, itimg,  &
     &    ampli_gain,phase_gain,error)
    !Print *,'Done do_cal ',self%blc(2),self%trc(2),self%gil%dim(2),error
  if (error) return
  !
  call uv_clean_buffers (duv_previous, duv_next,error)
  !
  ! Self Calibration affects Weights
  call uv_new_data (.true.)
  !! do_weig = .true.
end subroutine uv_calibrate
!
subroutine sub_uvcal(ncol,nvis,data,ndc,cal, &
     &    index,times,do_flag,flagged,nvg,gain,indg,timesg,   &
     &    ampli_gain,phase_gain,error)
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !      Support routine for command APPLY
  !
  !   Apply phase and/or amplitude calibration to
  !   the "raw" UV data.   Phase and Amplitudes are stored in
  !   the "gain" UV table, and usually come from a previous
  !   use of Task uv_gain.    This subroutine allows to apply the
  !   corrections to a spectral line table, whatever the way the gains
  !   were computed before.
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol            ! Visibility size
  integer, intent(in) :: nvis            ! Number of visibilities
  real, intent(in) :: data(ncol,nvis)    ! Visibility array
  integer, intent(in) :: ndc             ! Number of channels
  real, intent(out) :: cal(ncol,nvis)    ! Calibrated visibilities
  integer, intent(in) :: index(nvis)     ! Visibility Index
  real(8), intent(inout) :: times(nvis)  ! Visibility Time stamp
  logical, intent(in) :: do_flag           ! Flag data with no solution
  integer, intent(inout) :: flagged(nvis)  ! Flag work array
  integer, intent(in) :: nvg             ! Number of gains
  real, intent(in) :: gain(10,nvg)       ! Gain array
  integer, intent(out) :: indg(nvg)      ! Index in gains
  real(8), intent(out) :: timesg(nvg)    ! Gain time stamp
  real(8), intent(in) :: ampli_gain      ! Amplitude gain
  real(8), intent(in) :: phase_gain      ! Phase gain
  logical, intent(out) :: error          ! Error flag
  !
  character(len=*), parameter :: rname='CALIBRATE'
  integer, parameter :: mant=256  ! ALMA maximum, after renumbering
  ! Local
  integer :: iv, jv, k, ivg, jvg, ia, ja, kv, isev
  complex :: zdata, zgain(mant,mant), zcal, zg
  real :: wg
  real(8) :: t, tg, tgold
  real(8) :: ampli, phase
  real(8) :: time_step = 1.0d0
  character(len=80) :: mess
  !
  !---------------------------------------------------------------------
  !
  ! Get the chronological order, for both input tables:
  do iv=1, nvis
    times(iv) = data(4,iv)*86400.d0+data(5,iv)
  enddo
  call gr8_trie (times,index,nvis,error)
  if (error) then
    call map_message(seve%e,rname,'Error sorting UV Table')
    return
  endif
  !
  do ivg=1, nvg
    timesg(ivg) = gain(4,ivg)*86400.d0+gain(5,ivg)
  enddo
  call gr8_trie (timesg,indg,nvg,error)
  if (error) then
    call map_message(seve%e,rname,'Error sorting Gain Table')
    return
  endif
  !
  iv = 1
  jv = index(iv)
  ivg = 1
  tgold = timesg(ivg)
  zgain = 0.0
  !
  ! The loop is done on calibration times, so
  ! there is no guarantee that a given data visibility is treated.
  !
  ! To handle this, we set a counter for each visibility, to
  ! check whether it has indeed been affected...
  !
  flagged(1:nvis) = 1
  jvg = indg(1) ! To suppress compiler warning
  !
  do ivg = 1, nvg+1
    if (ivg.le.nvg) then
      jvg = indg(ivg)
      tg = timesg(ivg)
    else
      ! Last one, force a dummy time change
      tg = tgold+1e20
    endif
    !         type *, 'ivg, jvg, tg, tgold'
    !         type *, ivg, jvg, tg, tgold
    if (tg.ne.tgold) then
      !
      ! Time change, apply calibration
      t = times(iv)
      jv = index(iv)
      do while (t-tgold.le.time_step)
        !               type *, 'iv,jv,t'
        !               type *, iv,jv,t
        cal(:,jv) = data(:,jv)    ! Copy visibility
        if (t.ge.tgold-time_step) then
          ia = nint(cal(6,jv))
          ja = nint(cal(7,jv))
          !                  type *, ia, ja, zgain(ia,ja)
          if (zgain(ia,ja).ne.0) then
            flagged(jv) = 0 
            zg = zgain(ia,ja)
            wg = abs(zg)**2
            do k=8, 3*ndc+7, 3
              zdata = cmplx(data(k,jv),data(k+1,jv))
              zcal = zdata/zg
              cal(k,jv) = real(zcal)
              cal(k+1,jv) = aimag(zcal)
              cal(k+2,jv) = data(k+2,jv)*wg
            enddo
          endif
        endif
        iv = iv+1
        if (iv.gt.nvis) exit
        t = times(iv)
        jv = index(iv)
        ! print *, iv, jv, t-tgold
      enddo
      if (iv.gt.nvis) exit
      tgold = tg
      zgain = 0.0
    endif
    !
    ! Always fill the baseline gain array (even if new time !)
    ia = nint(gain(6,jvg))
    ja = nint(gain(7,jvg))
    zgain(ia,ja) = 0.0       ! Although already done just above
    !
    ! Sign of weight gain(10,jvg) indicates if there is a solution
    if (gain(10,ivg).gt.0) then
      ampli = sqrt(gain(8,jvg)**2+gain(9,jvg)**2)
      phase = atan2(gain(9,jvg),gain(8,jvg))
      if (ampli.ne.0) then
        !
        ! Correct (a fraction of) the phase
        phase = phase_gain*phase
        zg = cmplx(cos(phase),sin(phase))
        !
        ampli = 1d0-ampli_gain+ampli*ampli_gain
        zg = ampli*zg
        !
        ! Fill both baseline directions...
        zgain(ia,ja) = zg
        zgain(ja,ia) = conjg(zg)
      endif
    endif
    !            type *, ia, ja, zGAIN(IA,JA)
  enddo
  !
  kv = sum(flagged)
  if (do_flag) then
    do iv = 1,nvis
      if (flagged(iv).ne.0) then
        !! Print *,'Visi ',iv,' not calibrated'
        cal(8:3*ndc+7,iv) = 0.0
      endif
    enddo
  endif
  !
  if (kv.eq.0) then
    write(mess,'(A,I0,A)') 'Calibrated all ',nvis-kv,' visibilities'
    isev = seve%i
  else if (do_flag) then
    write(mess,'(A,I0,A,I0,A)') 'Calibrated ',nvis-kv,', flagged ',kv, &
      & ' visibilities'
    isev = seve%w
  else
    write(mess,'(A,I0,A,I0,A)') 'Calibrated ',nvis-kv,', kept ',kv, &
      & ' visibilities'
    isev = seve%w
  endif
  call map_message(isev,rname,mess)
end subroutine sub_uvcal

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_calib_types
  use gildas_def
  use gkernel_types
  use class_types
  use chopper_definitions
  use imbfits_parameters
  use imbfits_types
  use mrtindex_types
  use mrtindex_parse_types
  !
  type mjd_t
     real(kind=8) :: beg=0d0 ! Time at beginning
     real(kind=8) :: end=0d0 ! Time at end
     real(kind=8) :: med=0d0 ! Median time
  end type mjd_t
  type elev_corr_t
     real(kind=8) :: el      = 0.0 ! Elevation
     real(kind=4) :: airmass = 0.0 ! Airmass
  end type elev_corr_t
  !
  type mrtcal_classuser_t
    integer(kind=4) :: obstype    ! [Code] Observation type
    real(kind=4)    :: noise=-1.  ! [Int. unit] Theoretical noise (rms) from calibration
    real(kind=4)    :: backeff    ! [---------] Backend efficiency
    real(kind=4)    :: airmass    ! [---------] Airmass
    real(kind=4)    :: expatau    ! [---------] exp( airmass * tauzen )
  end type mrtcal_classuser_t
  !
  type chunk_t
    ! Miscelleanous information which is not directly/easily available in the Class sections
    integer(kind=4)  :: id       = 0   ! Identifier (equal to the PART in the IMBFITS)
    real(kind=8)     :: mjd      = 0   ! Date + Time (useful for interpolation around midnight...)
    integer(kind=4)  :: ifront   = 0   ! Line number in IMBFITS frontend table
    character(len=8) :: frontend = ''  ! Frontend abbreviation (as found in the Class telescope name)
    ! Class sections
    type(class_general_t)    :: gen         ! General
    type(class_position_t)   :: pos         ! Position
    type(class_spectro_t)    :: spe         ! Spectroscopic axis description
    type(class_calib_t)      :: cal         ! Calibration
    type(class_switch_t)     :: swi         ! Switching
    type(class_res_t)        :: res         ! Resolution
    type(mrtcal_classuser_t) :: user        ! Mrtcal User Section
    ! Arrays
    integer(kind=4)          :: nchan = 0   ! Number of channels
    real(kind=4)             :: cont1 = 0.0 ! Continuum associated to data1
    real(kind=4), pointer    :: data1(:) => null()  ! [ nchan ] 1D Values
    real(kind=4), pointer    :: dataw(:) => null()  ! [ nchan ] Associated weights
    integer(kind=4)          :: allocated=code_pointer_null ! Allocated or just associated?
  end type chunk_t
  type chunkset_t
    integer(kind=4)        :: n   ! Number of chunks in this set
    type(chunk_t), pointer :: chunks(:) => null() ! [ n ] The chunks
    integer(kind=4)        :: allocated=code_pointer_null ! Allocated or just associated?
  end type chunkset_t
  type chunkset_2d_t
     type(mjd_t)       :: mjd      ! MJD beginning, end, and median
     type(elev_corr_t) :: corr     ! Elevation correction
     integer(kind=4)   :: isub = 0 ! Associated subscan number
     integer(kind=4)   :: npix = 0 ! Number of pixels
     integer(kind=4)   :: nset = 0 ! Number of chunksets
     type(chunkset_t), pointer :: chunkset(:,:) => null()  ! [ nset x npix ] Data array
     integer(kind=4)  :: allocated=code_pointer_null ! Allocated or just associated?
  end type chunkset_2d_t
  integer(kind=4), parameter :: ckind_time=0   ! Time dumps
  integer(kind=4), parameter :: ckind_calib=1  ! Calibration products
  integer(kind=4), parameter :: ckind_onoff=2  ! ON-OFF differences
  type chunkset_3d_t
     integer(kind=4)   :: kind = ckind_time  ! Kind of 3rd dimension
     type(mjd_t)       :: mjd        ! MJD beginning, end, and median
     type(elev_corr_t) :: corr       ! Elevation correction
     integer(kind=4)   :: isub  = 0  ! Associated subscan number
     integer(kind=4)   :: ntime = 0  ! Number of 'time' rows read
     integer(kind=4)   :: npix  = 0  ! Number of pixels
     integer(kind=4)   :: nset  = 0  ! Number of chunksets mapping Nchan in first dimension of DATA block: databuf%imbf%val(:,ipix,itime)
     type(chunkset_t), pointer :: chunkset(:,:,:) => null()  ! [ nset x npix x ntimes] Chunksets mapping the DATA block
  end type chunkset_3d_t
  !
  type calib_backend_t
     ! Input 
     type(mrtindex_header_t) :: head
     integer(kind=4) :: nset = 0
     integer(kind=4) :: npix = 0
     integer(kind=4) :: nspec   ! Number of CLASS spectra produced by this scan
     type(imbfits_back_chunks_t) :: chunksetlist ! List of chunksets
     ! Standard calibration
     type(chunkset_2d_t) :: sky
     type(chunkset_2d_t) :: hot
     type(chunkset_2d_t) :: cold
     type(chunkset_2d_t) :: trec
     type(chunkset_2d_t) :: tcal
     type(chunkset_2d_t) :: atsys ! System temperature attenuated by the atmosphere = Tsys * exp(-airmass*ztau)
     type(chunkset_2d_t) :: tsys
     type(chunkset_2d_t) :: water
     type(chunkset_2d_t) :: ztau  ! Zenith opacity
     type(chunkset_2d_t) :: flag
     type(chopper_t), pointer :: chopperset(:,:) => null()
     ! Polarimetry calibration
     logical :: polar = .false.
     type(chunkset_2d_t) :: grid
     type(chunkset_2d_t) :: amppha
     type(chunkset_2d_t) :: sincos
  end type calib_backend_t
  !
  type calib_scan_t
     ! Provides an array of all possible backends. Use the backend identifier code
     ! as array index.
     integer(kind=4) :: n = 0 ! Sized with the number of backends available in Mrtcal
     type(calib_backend_t), pointer :: val(:) => null() ! Calibration parameters
  end type calib_scan_t
  !
  type calib_t
     type(user_calib_t)      :: user ! User request
     type(mrtindex_optimize_t) :: idx  ! Backend index
     type(calib_scan_t)      :: scan ! Scan calibration parameters
  end type calib_t
  !
  type on_stack_t
     type(chunkset_2d_t) :: curr    ! Current on spectra
  end type on_stack_t
  !
  type off_stack_t
     type(chunkset_2d_t), pointer :: prev=>null() ! Off spectra before current on
     type(chunkset_2d_t), pointer :: curr=>null() ! Off spectra interpolated at current on time
     type(chunkset_2d_t), pointer :: next=>null() ! Off spectra after current on
     type(chunkset_2d_t) :: stack(2) ! off spectra
     type(chunkset_2d_t) :: slope  ! Linear interpolation slope
     type(chunkset_2d_t) :: offset ! Linear interpolation offset
     type(chunkset_2d_t) :: interp ! Linear interpolation result
  end type off_stack_t
  !
  type subscan_list_t
     integer(kind=4) :: nsub = 0 ! Number of subscan in list
     integer(kind=4), pointer :: isub(:)  => null() ! Subscan number
     real(kind=8),    pointer :: mjd(:)   => null() ! Date and time
     real(kind=8),    pointer :: time(:)  => null() ! Declarative integration time
     logical,         pointer :: empty(:) => null() ! Is the subscan empty (0 data dumps)?
     type(eclass_char_t)  :: scanning ! Tracked or OTF
     type(eclass_2dble_t) :: onoff
     integer(kind=4) :: tracked = 0
     integer(kind=4) :: otf = 0
     integer(kind=4) :: on  = 0
     integer(kind=4) :: off = 0
  end type subscan_list_t
  !
  type switch_desc_t
     integer(kind=4) :: noffset = 0 ! Number of offsets (1 for FSW, 2 for WSW or PSW)
     integer(kind=4) :: nfront  = 0 ! Number of frontends
     real(kind=4), pointer :: wei(:)   => null() !           nfront phase weights
     real(kind=8), pointer :: off(:,:) => null() ! noffset x nfront phase offsets
  end type switch_desc_t
  !
  type switch_cycle_t
     integer(kind=4) :: mode = switchmode_unk
     integer(kind=4) :: ion  =  0 ! Index of ON  phase
     integer(kind=4) :: ioff =  0 ! Index of OFF phase
     integer(kind=4) :: ndump = 0 ! Number of dumps in dumpcycle
     integer(kind=4) :: npha =  0 ! Number of phases in switch cycle
     integer(kind=4) :: ndata = 0 ! Number of filled elements in the data array
     integer(kind=4) :: ndesc = 0 ! Number of filled elements in the desc array
     type(chunkset_2d_t), pointer :: data(:) => null() ! Data
     type(switch_desc_t), pointer :: desc(:) => null() ! Description
  end type switch_cycle_t
  !
  type switch_book_t
     logical         :: found = .false. ! Is current cycle OK?
     integer(kind=4) :: nphase  = 0     ! Number of mandatory phases in cycle
     integer(kind=4) :: ncycle  = 0     ! Number of dumps in complete cycles
     integer(kind=4) :: ndump   = 0     ! Number of dumps in current subscan
     integer(kind=4) :: norphan = 0     ! Number of dumps that do not belong to a complete cycle
     integer(kind=4) :: idump   = 0     ! Where do we stand in the dump stream?
     integer(kind=4) :: ifirst  = 0     ! First dump of current cycle
     integer(kind=4) :: izero   = 0     ! Index of last dump before on-track signal
  end type switch_book_t
  !
  type switch_t
     type(switch_cycle_t) :: cycle
     type(switch_book_t)  :: book
  end type switch_t
  !
  type science_backend_t
     logical :: cumulinit = .true.    ! Shall we initialize the accumulated spectrum?
     type(mrtindex_header_t) :: head
     type(imbfits_back_chunks_t) :: chunksetlist ! List of chunksets
     type(subscan_list_t)  :: list    ! List of subscan properties
     type(switch_t)        :: switch  ! Switching properties
     type(on_stack_t)      :: on      ! Current on  stack
     type(off_stack_t)     :: off     ! Current off stack
     type(chunkset_3d_t)   :: diff    ! Current on-off
     type(chunkset_3d_t)   :: cumul   ! Current accumulated spectrum
     type(chunkset_2d_t)   :: tscale  ! Current temperature scale
     type(chunkset_2d_t)   :: expatau ! Current exp(airmass*tau)
     integer(kind=4)       :: nspec   ! Number of CLASS spectra produced by this scan
  end type science_backend_t
  !
  type science_scan_t
     integer(kind=4) :: n = 0 ! Number of backends to be calibrated
     type(science_backend_t), pointer :: val(:) => null() ! Calibrated results
  end type science_scan_t
  !
  type science_t
     type(user_calib_t)      :: user ! User request
     type(mrtindex_optimize_t) :: idx  ! Backend index
     type(science_scan_t)    :: scan ! Scan being calibrated
  end type science_t
  !
end module mrtcal_calib_types
!
module mrtcal_sicidx
  !---------------------------------------------------------------------
  ! Support module for
  !  Sic structure  IDX%USER%
  !  Command        VARIABLE USER /INDEX
  !---------------------------------------------------------------------
  !
  type mrtcal_classuser_arr_t
    integer(kind=4), allocatable :: obstype(:)  ! Observation type
    real(kind=4),    allocatable :: noise(:)    ! Theoretical noise (rms) from calibration
    real(kind=4),    allocatable :: backeff(:)  ! Backend efficiency
    real(kind=4),    allocatable :: airmass(:)  ! Airmass
    real(kind=4),    allocatable :: expatau(:)  ! exp( airmass * tauzen )
  end type mrtcal_classuser_arr_t
  !
  ! Support variable for command "SET VARIABLE Section /INDEX"
  type(mrtcal_classuser_arr_t), save :: idxuser
  !
end module mrtcal_sicidx
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! The use of UV buffers in Mapping
!
! Mapping has three virtual UV buffers, named
! "UVI" (Initial), "UVS" (Sorted) and "UVR" (Resampled).
! UVR and UVS are used indifferently, depending on which one is
! available, rather than using UVS only for sorting and UVR only
! for Resampling. Only one of those two is allocated at any time
! (except temporarily when using one as input and the other as output).
!
! UVR and UVS may point to UVI, as sorting is not always needed.
!
! Command READ uses UVI, and nullifies or deallocate UVR and UVS.
!
! Commands UV_MAP, UV_CONT, UV_TIME, UV_RESIDUAL, UV_COMPRESS
! and UV_RESAMPLE use the UVR and UVS buffers.
!   A little tricky logic allows to select UVS or UVR
! for the output, depending on which one is busy as input,
! allocating on demand as needed.
!
! Through the use of a pointer, "UV" (actually a header
! HUV and a pointer to the data DUV), the so-called "current UV data"
! points towards one of them, depending on the last issued commands.
!
! Other commands like UV_BASELINE, UV_FILTER, UV_REWEIGHT or UV_FLAG
! work on the "current UV data". UV_FLAG is partially reversible.
!
! Finally, UV_SORT does not affect the "current UV data", but produces
! a transposed copy of it (which thus cannot be written by WRITE UV),
! called UVT.
!
! The whole thing is a little complex and perhaps should be changed.
!
! In addition to the buffer use, the code must account for the
! weight computation optimization.
!
! NOTE: In an earlier version, commands UV_COMPRESS and UV_RESAMPLE 
! only worked with UVI as input. This makes little sense, as a 
! combination of UV_TIME - UV_COMPRESS did not give the same as 
! UV_COMPRESS - UV_TIME for example. The only "nice" feature of 
! this behaviour was to allow the spectral resampling to start 
! from the full resolution data.
!
! The original data can always be recovered through a READ, which
! is optimized by proper caching if no modification has been done
! to the data.
!-----------------------------------------------------------------------
subroutine uv_select_buffer(rname,nu,nv,error)
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use mapping_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !
  !   Select the next available UV buffer (UVR or UVS) for
  ! commands using them.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  ! Caller's name
  integer, intent(in) :: nu              ! Visibility size
  integer, intent(in) :: nv              ! Number of visibilities
  logical, intent(out) :: error          ! Error flag
  !
  integer :: ier
  !
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVS')
      return
    endif
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else if (associated(duvr)) then
      deallocate (duvr)     ! Free the old one
    endif
    duv => duvs             ! Point to new one
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVR')
      return
    endif
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else if (associated(duvs)) then
      deallocate (duvs)      ! Free the old one
    endif
    duv => duvr               ! Point to new one
  endif
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+1
  error = .false.
end subroutine uv_select_buffer
!
subroutine uv_reset_buffer(rname)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Reset pointers to UV datasets (back to UVI). Deallocate
  ! UVR or UVS if needed, as well as the "transposed" buffer UVT
  !---------------------------------------------------------------------
  character(len=*) :: rname
  !
  logical error
  !
  ! What happens no compressed data is defined ?
  ! well we have to set the same pointers DUV and DUVR as in READ...
  !
  if (allocated(duvt)) deallocate (duvt)        ! UV data not plotted
  uv_plotted = .false.
  !
  if (.not.allocated(duvi)) then
    call map_message(seve%w,rname,'No UV data (DUVI not allocated)')
    return
  endif
  !
  ! Find out which one DUVI is pointing about
  if (associated(duvr,duvi)) then
    !!Print *,'DUVR was pointing towards DUVI'
    nullify(duvr)
  else if (associated(duvr)) then
    !!Print *,'DUVR was allocated '
    deallocate (duvr)     ! Free the old one
  else
    !!Print *,'DUVR not allocated '
  endif
  if (associated(duvs,duvi)) then
    !!Print *,'DUVS was pointing towards DUVI'
    nullify(duvs)
  else if (associated(duvs)) then
    !!Print *,'DUVS was allocated '
    deallocate (duvs)     ! Free the old one
  else
    !!Print *,'DUVS not allocated '
  endif
  !
  call gdf_copy_header(huvi,huv, error)
  !
  duvr => duvi     ! As in READ
  !
  ! This means we were already pointing to the previous UV data set
  if (associated(duv,duvi)) return
  !
  ! Here we point back...
  if (optimize(code_save_uv)%change.gt.1) then
    optimize(code_save_uv)%change = optimize(code_save_uv)%change - 1
    call map_message(seve%i,rname,'Returning to previous UV data set')
  else
    optimize(code_save_uv)%change = 0
    call map_message(seve%i,rname,'Returning to original UV data set')
  endif
  duv => duvi
  do_weig = .true. ! Recompute weight
  call sic_delvariable ('UV',.false.,error)
  call sic_delvariable ('UVS',.false.,error)
  !
end subroutine uv_reset_buffer
!
subroutine uv_dump_buffers(rname)
  use clean_def
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Dump the allocation status of the UV buffers. (Debugging only)
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  ! Caller's name
  !
  integer(kind=index_length) :: udim(2)
  logical :: error
  !
  if (associated(duvr)) then
    if (associated(duvr,duvi)) then
      call map_message(seve%w,rname,'DUVR associated to DUVI')
    else
      call map_message(seve%w,rname,'DUVR allocated')
    endif
    !
    ! Redefine SIC variables
    udim(1) = ubound(duvr,1)
    udim(2) = ubound(duvr,2)
    call sic_delvariable ('UVR',.false.,error)
    call sic_def_real ('UVR',duvr,2,udim,.false.,error)
  else
    call map_message(seve%w,rname,'no DUVR ...')
  endif
  !
  if (associated(duvs)) then
    if (associated(duvs,duvi)) then
      call map_message(seve%w,rname,'DUVS associated to DUVI')
    else
      call map_message(seve%w,rname,'DUVS allocated')
    endif
    ! Redefine SIC variables
    udim(1) = ubound(duvs,1)
    udim(2) = ubound(duvs,2)
    call sic_delvariable ('UVS',.false.,error)
    call sic_def_real ('UVS',duvs,2,udim,.false.,error)
  else
    call map_message(seve%w,rname,'no DUVS ...')
  endif
  !
  if (allocated(duvt)) call map_message(seve%w,rname,'Transposed buffer allocated.')
  !
  if (associated(duv,duvi)) then
    call map_message(seve%w,rname,'DUV associated to DUVI')
  else if (associated(duv,duvr)) then
    call map_message(seve%w,rname,'DUV associated to DUVR')
  else if (associated(duv,duvs)) then
    call map_message(seve%w,rname,'DUV associated to DUVS')
  else if (associated(duv)) then
    call map_message(seve%w,rname,'DUV is not associated to ???')
  else
    call map_message(seve%w,rname,'DUV is undefined')
  endif

end subroutine uv_dump_buffers
!
subroutine uv_free_buffers
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  ! MAPPING
  !   Deallocate all UV buffers.
  !---------------------------------------------------------------------
  integer ier
  !
  ! Free the previous zone
  !!Print *,'Into free_uvdata '
  if (associated(duvr)) then
    if (associated(duvr,duvi)) then
      nullify(duvr)
      !!print *,'Nullify duvr'
    else
      !!print *,'Deallocate duvr'
      deallocate(duvr,stat=ier)
    endif
  endif
  if (associated(duvs)) then
    if (associated(duvs,duvi)) then
      !!print *,'Nullify duvs'
      nullify(duvs)
    else
      !!print *,'Deallocate duvs'
      deallocate(duvs,stat=ier)
    endif
  endif
  if (allocated(duvi)) deallocate(duvi,stat=ier)
  if (allocated(duvt)) deallocate(duvt,stat=ier)
  !!Print *,'Done free_uvdata'
end subroutine uv_free_buffers
!
subroutine uv_find_buffers (rname,nu,nv,duv_previous, duv_next,error)
  use clean_arrays
  use gbl_message
  use mapping_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING
  !   Find the next available UV buffer (UVR or UVS).
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  ! Caller's name
  integer, intent(in) :: nu   ! Size of a visiblity
  integer, intent(in) :: nv   ! Number of visibilities
  real, pointer, intent(out) :: duv_previous(:,:)
  real, pointer, intent(out) :: duv_next(:,:)
  logical, intent(out) :: error
  !
  integer :: ier
  !
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVS')
      return
    endif
    call map_message(seve%d,rname,'Storing in DUVS')
    duv_previous => duvr
    duv_next => duvs
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVR')
      return
    endif
    call map_message(seve%d,rname,'Storing in DUVR')
    duv_previous => duvs
    duv_next => duvr
  endif
  error = .false.
end subroutine uv_find_buffers
!
subroutine uv_clean_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING
  !   Take care of freeing the unused UV buffer, and set UV to point to
  ! the new one.
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:)
  real, pointer, intent(inout) :: duv_next(:,:)
  logical, intent(in) :: error
  !
  if (associated(duv_previous,duvr)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free the old one
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_previous,duvs)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free the old one
    endif
    duv => duvr             ! Point to new one
  endif
end subroutine uv_clean_buffers

subroutine uv_discard_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! MAPPING
  !   Take care of freeing the last used UV buffer, and reset 
  !   UV to point to the previous one.
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:)
  real, pointer, intent(inout) :: duv_next(:,:)
  logical, intent(in) :: error
  !
  if (associated(duv_next,duvr)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free it 
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_next,duvs)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free it
    endif
    duv => duvr             ! Point to new one
  endif
end subroutine uv_discard_buffers

subroutine uv_model_comm(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_default
  use imager_interfaces, except_this => uv_model_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !     MODEL [/MINVAL Value [Unit]]
  !
  ! Dispatch to adequate routine to   
  !  - Compute the MODEL UV data set from the current CCT table
  ! or
  !  - Compute the MODEL UV data set from the current UV_FIT results
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  if (last_resid.eq.'CCT') then
    call cct_fast_uvmodel(line,error)
  else
    call uvfit_residual_model(line,'MODEL',error)
  endif
end subroutine uv_model_comm
!
subroutine cct_fast_uvmodel(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use imager_interfaces, except_this => cct_fast_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !     MODEL [/MINVAL Value [Unit]]
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  ! Local
  integer :: nclean ! Number of clean components retained
  logical :: large
  !
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: dmap(:,:,:)
  real, allocatable :: work(:)
  integer :: if,nf,nx,ny,mx,my,kx,ky,nt,nv,mt, ier
  real :: cpu0, cpu1
  real :: rx, ry, factor, fmin
  real(8) :: xinc, yinc, freq, area, jyperk
  character(len=8) :: chain
  integer :: nc, narg
  !
  nclean = 0
  call sic_i4(line,0,1,nclean,.false.,error)
  if (error) return
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'DUV is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is the current UV Data (perhaps we should
  ! extract only one channel ?)
  !     huv & duv
  !
  ! Input CCT is the current CCT Data (it should match the UV data)
  !
  ! Compact it into an image
  ! This depends on the CCT type, and is done in a subroutine
  !    First, define the sampling and image size 
  call cct_def_image (hcct,mx,my,nf,freq,xinc,yinc,error)
  if (error) return
  if (nf.ne.1) then
    call map_message(seve%e,rname,'More than 1 channel')
    error = .true.
    return
  endif
  !
  !    Then do the job
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    goto 999
  endif
  call cct_set_image (hcct,dcct,mx,my,nclean,xinc,yinc,nf,dmap,error)
  !
  ! Retrieve minimum value
  narg = sic_narg(1)  ! /MINVAL option
  if (narg.ge.0) then
    call sic_r4(line,1,1,fmin,.true.,error)
    if (error) return
    !
    if (narg.gt.1) then
      call sic_ch(line,1,2,chain,nc,.true.,error)
      if (error) return
      if (chain(1:nc).eq.'sigma') then
        fmin = fmin * max(hclean%gil%noise,hclean%gil%rms)
      elseif (chain(1:nc).eq.'mJy') then
        fmin = 1e-3*fmin
      elseif (chain(1:nc).eq.'K') then
        area = 8*log(2.0)*pi*hclean%gil%majo*hclean%gil%mino
        jyperk = 1.38e3*area/(299792458d0/freq*1d-6)**2
        fmin = fmin * jyperk 
      elseif (chain(1:nc).eq.'Jy') then
        fmin = fmin
      else
        call map_message(seve%e,rname,'Unrecognized unit '//chain(1:nc))
        error = .true.
        return
      endif
    endif
    where (dmap.lt.fmin)  dmap = 0.
  endif
  !
  !! pixel_area = abs(xinc*yinc)   ! in radian
  !
  !
  ! Define the image size
  !
  if (large) then
    rx = log(float(mx))/log(2.0)
    kx = nint(rx)
    if (kx.lt.rx) kx = kx+1
    nx = 2**kx
    ry = log(float(my))/log(2.0)
    ky = nint(ry)
    if (ky.lt.ry) ky = ky+1
    ny = 2**ky
    kx = max(nx,ny)
    kx = min(4*kx,4096)
    kx = max(mx,kx)
    kx = max(my,kx)
    nx = kx
    ny = kx
    call gag_cpu(cpu1)
  else
    nx = mx
    ny = my
  endif
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT space allocation error')
    goto 999
  endif
  !
  ! See UV_RESTORE also...
  if (nx.eq.mx .and. ny.eq.my) then
    fft(:,:,:) = cmplx(dmap,0.0)
  else
    do if = 1,nf
      call plunge_real (dmap(:,:,if),mx,my,fft(:,:,if),nx,ny)
    enddo
  endif
  ! Free map
  deallocate (dmap,stat=ier)
  allocate (work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT work allocation error')
    goto 999
  endif
  !
  ! Compute the FFT
  !!Print *,'NX NY NF ', nx,ny,nf
  call do_fft(nx,ny,nf,fft,work)
  call gag_cpu(cpu1)
  !
  call gildas_null(huvm, type = 'UVT')
  call gdf_copy_header(huv,huvm,error) ! Will work in all cases
  !
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  !! lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  !! factor = 2*1.38e3/lambda**2*pixel_area
  !! print *,'Factor ',factor,pixel_area
  !! if (factor.eq.0.0) factor = 1.0
  !
  ! We are in Jy, so this is simple
  factor = 1.0
  !
  huvm%gil%dim(1) = 7+3*nf
  huvm%gil%ref(1)  = 1.0
  !
  if (allocated(duvm)) deallocate(duvm)
  allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    goto 999
  endif
  nt = huvm%gil%dim(1)
  nv = huvm%gil%dim(2)
  mt = huv%gil%dim(1)
  !!Print *,'NT NV MT ',nt,nv,mt
  !!Print *,'DUV ',ubound(duv,1), ubound(duv,2)
  !!Print *,'DUVM ',ubound(duvm,1), ubound(duvm,2)
  !
  ! At this stage, we could extract the relevant channel
  call copyuv (nt,nv,duvm,mt,duv)
  !
  ! OK, compute the model
  call do_uvmodel(duvm, nt, nv,   &
       &    fft,nx,ny,nf,freq,xinc,yinc,factor)
  !
  call gag_cpu(cpu1)
  error = .false.
  return
  !
999 error = .true.
  return
end subroutine cct_fast_uvmodel
!<FF>
subroutine do_uvmodel (visi,nc,nv,a,nx,ny,nf,   &
     &    freq,xinc,yinc,factor)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  ! CAUTION
  !     Frequency (and hence Lambda/D) is assumed constant 
  !---------------------------------------------------------------------
  !
  integer, intent(in) :: nc                     ! Size of visibility
  integer, intent(in) :: nv                     ! Number of visibilities
  real, intent(inout) :: visi(nc,nv)            ! Visibilities
  integer, intent(in) :: nx                     ! X Size of image
  integer, intent(in) :: ny                     ! Y Size of image
  integer, intent(in) :: nf                     ! Number of frequencies
  complex, intent(in) :: a(nx,ny,nf)            ! Clean Component Image
  real(8), intent(in) :: freq                   ! Reference frequency
  real(8), intent(in) :: xinc                   ! X Pixel increment
  real(8), intent(in) :: yinc                   ! Y Pixel increment
  real, intent(in) :: factor                    ! Flux scale factor
  ! Local
  real(kind=8), parameter :: clight=299792458d0
  real(kind=8) :: kwx,kwy,stepx,stepy,lambda,bfin(2),xr,yr
  complex(kind=8) :: aplus,amoin,azero,afin
  integer :: i,if,ia,ja
  logical :: inside
  equivalence (afin,bfin)
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ia = int(kwx)
    ja = int(kwy)
    inside = (ia.gt.1 .and. ia.lt.nx) .and.   &
        &      (ja.gt.1 .and. ja.lt.ny)
    if (inside) then
      xr = kwx - ia
      yr = kwy - ja
      do if=1,nf
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
            &          - 2.d0*a(ia,ja+1,if) )*xr   &
            &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
            &          + a(ia,ja+1,if)
        azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
            &          - 2.d0*a(ia,ja,if) )*xr   &
            &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
            &          + a(ia,ja,if)
        amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
            &          - 2.d0*a(ia,ja-1,if) )*xr   &
            &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
            &          + a(ia,ja-1,if)
        ! Then Y (or X)
        afin = ( (aplus+amoin-2.d0*azero)   &
            &          *yr + aplus-amoin )*yr*0.5d0 + azero
        !
        visi(5+3*if,i) =  bfin(1)*factor
        ! There was a - sign in the precedent version
        visi(6+3*if,i) =  bfin(2)*factor
      enddo
    else
      print *,'Error Visi ',i,ia,nx,ja,ny
    endif
  enddo
end subroutine do_uvmodel
!<FF>
subroutine do_fft (nx,ny,nf,fft,work)
  integer, intent(in)  :: nx                     !
  integer, intent(in)  :: ny                     !
  integer, intent(in)  :: nf                     !
  complex, intent(inout) :: fft(nx,ny,nf)
  real, intent(inout)  :: work(2*max(nx,ny))
  ! Local
  integer :: if,dim(2)
  !
  ! Loop on channels
  dim(1) = nx
  dim(2) = ny
  do if = 1, nf
    call fourt(fft(:,:,if),dim,2,1,1,work)
    call recent(nx,ny,fft(:,:,if))
  enddo
end subroutine do_fft
!<FF>
subroutine copyuv (nco,nv,out,nci,in)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !
  ! Copy structure of UV data, but not the (Real,Imag) columns
  !---------------------------------------------------------------------
  integer, intent(in)  :: nco                    ! Size of output visi.
  integer, intent(in)  :: nv                     ! Number of visibilities
  real, intent(out)  :: out(nco,nv)              ! Output Visibilities
  integer, intent(in) :: nci                     ! Size of input visi.
  real, intent(in)  :: in(nci,nv)                ! Input visibilities
  ! Local
  integer :: i,j
  ! This does not handle extra columns
  do i=1,nv
    do j=1,7
      out(j,i) = in(j,i)
    enddo
    do j=8,nco,3
      out(j,i) = 0
      out(j+1,i) = 0
      out(j+2,i) = in(10,i)
    enddo
  enddo
end subroutine copyuv
!
subroutine cct_def_image (hima,mx,my,nf,freq,xinc,yinc,error)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  ! Define Image size from CCT information.
  ! Supports both layouts of CCT tables.
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hima
  integer, intent(out) :: mx,my,nf
  real(8), intent(out) :: freq
  real(8), intent(out) :: xinc,yinc
  logical, intent(out) :: error
  !
  error = .false.
  if (hima%char%code(3).eq.'COMPONENT') then
    call gagout('I-UV_FCCT,  Clean Components from IMAGER')
    nf = hima%gil%dim(2)  ! Number of channels
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(3)-1)*2
    yinc = hima%gil%inc(3)
    ! Define observing frequency
    freq = hima%gil%freq + hima%gil%fres*((nf+1)*0.5-hima%gil%ref(2))
  else
    call gagout('I-UV_FCCT,  Clean Components from Task CLEAN')
    nf = hima%gil%dim(3)
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(2)-1)*2
    yinc = hima%gil%inc(2)
    freq = hima%gil%freq + hima%gil%fres*((nf+1)*0.5-hima%gil%ref(3))
  endif
end subroutine cct_def_image
!
subroutine cct_set_image (hcct,clean,mx,my,mc,xinc,yinc,nf,image,error)
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  ! Fill an Image from the list of Clean Components 
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hcct
  real clean(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  integer, intent(in) :: mx,my,nf
  integer, intent(in) :: mc
  real(8), intent(in) :: xinc,yinc
  real, intent(out) :: image(mx,my,nf)
  logical, intent(out) :: error
  !
  integer lc,nc,kc
  integer ic,jf
  integer ix,iy
  character(len=80) :: mess
  !
  image = 0
  if (hcct%char%code(3).eq.'COMPONENT') then
    lc = hcct%gil%dim(1)
    nc = hcct%gil%dim(2)  ! Number of channels
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    if (mc.eq.0) then
      kc = hcct%gil%dim(3)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(3))
    endif
    !
    do jf = 1,nf
      do ic = 1,kc
        if (clean(3,jf,ic).ne.0) then
          ix = nint(clean(1,jf,ic)/xinc)+mx/2+1
          iy = nint(clean(2,jf,ic)/yinc)+my/2+1
          image(ix,iy,jf) = image(ix,iy,jf) + clean(3,jf,ic)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  else
    lc = hcct%gil%dim(1)
    if (mc.eq.0) then
      kc = hcct%gil%dim(2)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(2))
    endif
    nc = hcct%gil%dim(3)
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    do jf = 1,nf
      do ic = 1,kc
        if (clean(1,ic,jf).ne.0) then
          ix = nint(clean(2,ic,jf))
          iy = nint(clean(3,ic,jf))
          image(ix,iy,jf) = image(ix,iy,jf) + clean(1,ic,jf)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  endif
end subroutine cct_set_image
!

subroutine uv_radial(line,rname,error)
  use clean_def
  use clean_arrays
  use clean_types
  use gkernel_types
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_radial
  !---------------------------------------------------------------------------
  ! Imager / Mapping
  !
  ! @ private
  !
  ! Support for commands
  !   UV_DEPROJECT X0 Y0 ROTA INCLI 
  ! and
  !   UV_RADIAL X0 Y0 ROTA INCLI [/SAMPLING QSTEP [Unit [QMIN QMAX]] [/ZERO]
  ! and
  !   UV_CIRCLE X0 Y0 ROTA INCLI [/SAMPLING QSTEP [Unit [QMIN QMAX]] [/ZERO]
  ! 
  !   Deproject from inclination effects and Compute the radial 
  !   profile of visibilities (or azimutal average of)
  !   using the specified values of X0, Y0, ROTA and INCLI
  !
  ! This combines
  !  - a u,v shift to X0,Y0
  !  - a rotation of the u,v coordinates by ROTA
  !  - a compression of the v axis by cos(INCLI)
  !  - a circular averaging
  !  - an azimutal spreading of the circularly averaged values
  !
  ! which were available in tasks UV_SHIFT, a script and UV_CIRCLE in an
  ! rather unconvenient way (see sg_create_circular.map script)
  !
  !---------------------------------------------------------------------------
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: rname
  logical, intent(out) :: error
  !
  integer, parameter :: o_zero=2
  integer, parameter :: o_sample=1
  !
  character(len=8) :: qunit
  real(4) :: rpos(2),cs(2)
  real(8) :: o_pang, freq
  type(gildas), save :: hou  ! Deprojected Visibilities, then Circular ones
  type(gildas), save :: hci  ! Circular average
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  type(projection_t) :: proj
  integer :: nvisi
  real :: ang, pos(2),cosi
  integer :: i, eff_dim, ier, mq, nq, n
  integer :: nvs, nvi, kvi, nu, nv
  integer, allocatable :: array(:),flag(:)
  real, allocatable :: q(:), meter(:)
  real :: qstep, qmax, qmin, diam, daz, az, x1, x2, xd, klambda
  integer :: iaz,naz,iv,kv,iw,istart
  real, allocatable :: caz(:), saz(:), avisi(:)
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  call sic_delvariable('UVRADIAL',.false.,error)
  error = .false.
  !
  !
  call gildas_null(hou,'UVT')
  call gdf_copy_header (huv,hou,error)
  !
  pos = 0
  ang = 0
  cosi = 1.0
  call sic_r4(line,0,1,pos(1),.false.,error)
  if (error) return
  call sic_r4(line,0,2,pos(2),.false.,error)
  if (error) return
  call sic_r4(line,0,3,ang,.false.,error)
  if (error) return
  !
  ! To bring the desired PA of the axis to the North, 
  ! we must counter-rotate the data.
  ang = -ang
  call sic_r4(line,0,4,cosi,.false.,error)
  if (error) return
  cosi = cos(cosi*pi/180.0)
  !
  ! Modify header 
  ! 1) Get new center. Offsets are relative to this one
  o_pang = hou%gil%pang
  call gwcs_projec(hou%gil%a0,hou%gil%d0,hou%gil%pang,hou%gil%ptyp,proj,error)
  call rel_to_abs (proj,dble(pos(1)),dble(pos(2)),hou%gil%a0,hou%gil%d0,1)
  ! 2) Set new Projection
  hou%gil%pang = ang*pi/180.0d0
  hou%gil%posi_words = 12
  hou%gil%proj_words = 9
  !
  ! Compute observing frequency, and new phase center in wavelengths
  ! need uv_frequency call here...
  freq = hou%gil%val(1)+hou%gil%fres*(hou%gil%val(1)/hou%gil%freq) &
          * (hou%gil%nchan+1)*0.5d0
  rpos(1) = - freq * f_to_k * pos(1)
  rpos(2) = - freq * f_to_k * pos(2)
  cs(1)  =  cos(hou%gil%pang-o_pang)
  cs(2)  = -sin(hou%gil%pang-o_pang)
  !
  nvisi = huv%gil%nvisi
  huv%r2d => duv
  !
  select case(rname)
  case ('UV_DEPROJECT') 
    nullify (duv_previous, duv_next)
    nu = huv%gil%dim(1)
    kv = nvisi
    call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
    if (error) return
    hou%r2d => duv_next
    !
    call shift_and_squeeze_uv(huv,hou,nvisi,rpos,cs,cosi)
    !
    call gdf_copy_header(hou,huv,error)
  case ('UV_RADIAL','UV_CIRCLE')
    !
    allocate (hou%r2d(hou%gil%dim(1),hou%gil%dim(2)), stat=ier)
    call shift_and_squeeze_uv(huv,hou,nvisi,rpos,cs,cosi)
    !
    ! Now define the circular average
    call gildas_null(hci,'UVT')
    call gdf_copy_header(huv,hci,error)
    !
    nvs = hou%gil%dim(1)
    nvi = hou%gil%dim(2)
    !
    ! Default sampling 1/2 of dish diameter
    diam = 0.
    if (huv%gil%nteles.ne.0) then
      diam = huv%gil%teles(1)%diam
    endif
    if (diam.eq.0) diam = 15.0  ! For NOEMA
    qstep = diam/2.0
    call uvgmax(huv,duv,qmax,qmin)
    !
    if (sic_present(o_sample,0)) then
      call sic_r4(line,o_sample,1,qstep,.true.,error)
      if (error) return
      qunit = 'METER'
      call sic_ke(line,o_sample,2,qunit,n,.false.,error)
      if (error) return   
      if (qunit.eq.'KWAVE') then
        klambda = 1.D3*299792.458d-3/huv%gil%freq
      else if (qunit.eq.'METER' .or. qunit.eq.'M') then
        klambda = 1.0
      else
        call map_message(seve%e,rname,'Unit must be Meter or kWave')
        error = .true.
        return
      endif
      qmin = qmin/klambda
      qmax = qmax/klambda
      call sic_r4(line,o_sample,3,qmin,.false.,error)
      if (error) return
      call sic_r4(line,o_sample,4,qmax,.false.,error)
      if (error) return
      qstep = qstep*klambda 
      qmin = qmin*klambda
      qmax = qmax*klambda
    endif
    !
    hci%gil%dim(2) = nint((qmax-qmin)/qstep)
    kvi = hci%gil%dim(2)
    mq = hci%gil%dim(2)+1
    allocate (q(mq), meter(mq), flag(mq), array(mq), stat=ier)
    !
    do i=1, mq
      q(i) = qmin+(i-1)*qstep
    enddo
    !
    ! Extrapolate the 0 visibility if possible ?
    if (sic_present(o_zero,0)) then
      istart = 2
    else
      istart = 1
    endif
    !
    ! Find actual size
    call uv_steps (hou%r2d,nvs,nvi, &
       &    q,kvi,eff_dim, array,meter,flag,mq)
    hci%gil%ndim = 2
    hci%gil%dim(2) = eff_dim+istart-1
    hci%gil%dim(3) = 1
    hci%gil%dim(4) = 1
    allocate (hci%r2d(hci%gil%dim(1),hci%gil%dim(2)),stat=ier)
    !
    hci%r2d = 0.0
    nq = eff_dim
    call uv_circle_average (nvs,nvi,hci%gil%nchan,hou%r2d,   &
       &    nq,hci%r2d(:,istart:nq),q,eff_dim,   &
       &    array,meter,mq)
    !
    if (istart.eq.2) then
      ! Extrapolate the 0 visibility if possible ?
      !
      ! Test: 0-centered parabola going through points 2 and 4
      x1 = hci%r2d(1,2)**2
      x2 = hci%r2d(1,4)**2
      xd = x2-x1
      x1 = x1/xd
      x2 = x2/xd
      hci%r2d(:,1) = 0
      do i=1,huv%gil%nchan
        hci%r2d(5+3*i,1) = x2*hci%r2d(5+3*i,2) - x1*hci%r2d(5+3*i,4)
        hci%r2d(7+3*i,1) = 0.25*hci%r2d(7+3*i,2)
      enddo
      Print *,'Zero spacing ',hci%r2d(:,1)
    endif
    hci%r2d(6,:) = 1  ! Fake antenna numbers
    hci%r2d(7,:) = 2  !
    !
    ! Do not forget to reset the number of visibilities & Size
    hci%gil%nvisi = eff_dim
    hci%gil%dim(2) = eff_dim
    !
    call sic_mapgildas('UVRADIAL',hci,error,hci%r2d)
    !
    if (rname.eq.'UV_CIRCLE') then
      nu = hci%gil%dim(1) 
      nv = hci%gil%nvisi
      nullify (duv_previous, duv_next)
      call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
      if (error) return
      !
      do iv = 1,nv
        duv_next(:,iv) = hci%r2d(:,iv)
      enddo
      hci%gil%basemax = hci%r2d(1,nv)
      hci%gil%basemin = hci%r2d(1,1)  
      call gdf_copy_header(hci,huv,error)
    else
      ! Now spread it over Azimut ...
      !
      ! Number of Azimut and Azimut step (half circle only...)
      naz = pi*qmax/qstep
      daz = pi/naz
      hou%gil%nvisi = hci%gil%nvisi * naz
      hou%gil%dim(2) = hou%gil%nvisi
      nu = hci%gil%dim(1) 
      nv = hou%gil%nvisi
      !
      nullify (duv_previous, duv_next)
      call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
      if (error) return
      allocate(caz(naz),saz(naz),avisi(hou%gil%dim(1)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      do iaz = 1,naz
        az = (iaz-1)*daz
        caz(iaz) = cos(az)
        saz(iaz) = -sin(az)
      enddo
      !
      kv = 0
      do iv=1,nq
        avisi = hci%r2d(:,iv)
        do iw=1,huv%gil%nchan
          avisi(6+3*iw) = 0.0 ! Set the imaginary part to Zero  
          avisi(7+3*iw) = avisi(7+3*iw)/naz  ! Spread the weight evenly         
        enddo
        do iaz=1,naz
          kv = kv+1
          duv_next(:,kv) = avisi
          duv_next(1,kv) = avisi(1)*caz(iaz)
          duv_next(2,kv) = avisi(1)*saz(iaz)
        enddo
      enddo
      hou%gil%basemax = qmax
      hou%gil%basemin = qmin  
      call gdf_copy_header(hou,huv,error)
    endif
  case default
    call map_message(seve%e,rname,'Not implemented')
    error = .true.
    return
  end select 
  !
  ! Point back to UV data set
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_radial
!
!<FF>
subroutine parabola(x,y,a,b,c) 
  !----------------------------------------------------------------------
  !	Solve for Y = a + b*x() + c*x()^2
  !----------------------------------------------------------------------
  real, intent(in) :: x(3)
  real, intent(in) :: y(3)
  real, intent(out) :: a,b,c
  !
  c = (y(3)-y(2))*(x(2)-x(1))-(y(2)-y(1))*(x(3)-x(2))
  b = (x(2)-x(1))*(x(3)*x(3)-x(2)*x(2))-(x(2)*x(2)-x(1)*x(1))*(x(3)-x(2))
  c = c/b
  b = (y(2)-y(1))-c*(x(2)*x(2)-x(1)*x(1))
  b = b/(x(2)-x(1))
  a = y(1)-c*x(1)*x(1)-b*x(1)
end subroutine parabola
!
subroutine uv_steps(visx, n1, nvx, q, nq, eff_dim,   &
     &    array,meter,flag,nsize)
  !------------------------------------------------------------------
  ! IMAGER
  !   @ public 
  !
  !------------------------------------------------------------------
  integer, intent(in) :: n1              ! Size of a visibility
  integer, intent(in) :: nvx             ! Number of a visibilities
  real, intent(in) :: visx(n1,nvx)       ! Visibilities
  integer, intent(in) :: nq              ! Number of radii
  real, intent(in) :: q(nq+1)            ! Radii
  integer, intent(out) :: eff_dim        ! Actual size of radial array
  integer, intent(in) :: nsize           ! Size of radial array
  integer, intent(out) :: array(nsize)   ! Cell value
  real, intent(inout) :: meter(nsize)    ! Cell position
  integer, intent(out) :: flag(nsize)    ! Is there any data ?

  ! Local
  integer :: iq, iv, i
  real :: qq
  !
  flag = 0
  !
  do iv=1, nvx
    qq = sqrt(visx(1,iv)**2+visx(2,iv)**2)
    iq = int( (qq-q(1))/(q(2)-q(1))+1. )
    if (iq.gt.0 .and. iq.le.nq+1) then
      flag(iq) = 1
    endif
  enddo
  !
  eff_dim = 0
  do i=1,nsize
    if (flag(i).ne.0) then
      eff_dim = eff_dim+1
      meter(eff_dim) = (3*q(1)-q(2))/2+(q(2)-q(1))*i
    endif
    array(i) = eff_dim
  enddo
end subroutine uv_steps
!
subroutine uv_circle_average(n1, nvx, nc, visx, nq, visy, q, eff_dim,   &
     &    array, meter, nsize)
  !------------------------------------------------------------------
  ! IMAGER
  !   @ public 
  !
  !------------------------------------------------------------------
  integer, intent(in) :: n1              ! Size of a visibility
  integer, intent(in) :: nvx             ! Number of a visibilities
  integer, intent(in) :: nc              ! Number of channels
  real, intent(in) :: visx(n1,nvx)       ! Visibilities
  integer, intent(in) :: nq              ! Number of radii
  real, intent(in) :: q(nq+1)            ! Radii
  integer, intent(in) :: eff_dim         ! Actual size of radial array
  real, intent(out) :: visy(n1, eff_dim) ! Output visibilities        !
  integer, intent(in) :: nsize           ! Size of radial array
  integer, intent(in) :: array(nsize)    ! Cell value
  real, intent(inout) :: meter(nsize)    ! Cell position
  ! Local
  integer :: iq, iv, ic, i, ip, ier
  real :: w, qq
  real, allocatable :: true(:)
  !
  visy = 0.0
  allocate (true(nsize),stat=ier)
  if (ier.ne.0) stop
  !
  true = 0
  ic = (nc+1)/2
  !
  do iv = 1, nvx
    qq = sqrt(visx(1,iv)**2+visx(2,iv)**2)
    iq = int( (qq-q(1))/(q(2)-q(1))+1. )
    if (iq.gt.0 .and. iq.le.nq+1) then
      ip = array(iq)
      w = visx(3*ic+7,iv)
      if (w.gt.0) then
        true(ip) = true(ip)+w*qq
      endif
      do i=1, nc
        w = visx(3*i+7,iv)
        if (w.gt.0) then
          visy(3*i+5,ip)=visy(3*i+5,ip)+visx(3*i+5,iv)*w
          visy(3*i+6,ip)=visy(3*i+6,ip)+visx(3*i+6,iv)*w
          visy(3*i+7,ip)=visy(3*i+7,ip)+w
        endif
      enddo
    endif
  enddo
  !
  do iq = 1, eff_dim
    w = visy(3*ic+7,iq)
    if (w.ne.0) then
      visy(1,iq) = true(iq)/w
    else
      visy(1,iq) = meter(iq)
    endif
    do i=1, nc
      w = visy(3*i+7,iq)
      if (w.gt.0) then
        visy(3*i+5,iq)=visy(3*i+5,iq)/w
        visy(3*i+6,iq)=visy(3*i+6,iq)/w
      endif
    enddo
  enddo
  deallocate (true)
end subroutine uv_circle_average
!
subroutine shift_and_squeeze_uv(hin,hou,nvisi,xy,cs,cosi)
  use image_def
  !------------------------------------------------------------------
  ! IMAGER
  !   @ public 
  !
  ! Apply a Phase shift to the data (in the previous frame)
  ! then rotate the frame (u,v) coordinates.
  !------------------------------------------------------------------
  type(gildas), intent(in)  :: hin    ! Input UV data 
  type(gildas), intent(inout) :: hou  ! Output UV data
  integer, intent(in) :: nvisi        ! Number of visibilities
  real, intent(in) :: xy(2)  ! Phase Shift
  real, intent(in) :: cs(2)  ! Cos/Sin of Rotation
  real, intent(in) :: cosi   ! Cos of inclination
  !
  integer(kind=index_length) :: i
  integer :: ix, iu, iv
  real phi, sphi, cphi, u, v, reel, imag
  !
  iu = hin%gil%column_pointer(code_uvt_u)
  iv = hin%gil%column_pointer(code_uvt_v)
  !
  if (xy(1).eq.0. .and. xy(2).eq.0.) then
    do i = 1,nvisi
      hou%r2d(:,i) = hin%r2d(:,i)
      u = hin%r2d(iu,i)
      v = hin%r2d(iv,i)
      hou%r2d(iu,i) = cs(1)*u - cs(2)*v
      hou%r2d(iv,i) = cosi * (cs(2)*u + cs(1)*v)
    enddo
  else
    do i = 1,nvisi
      hou%r2d(1:hou%gil%nlead,i) = hin%r2d(1:hin%gil%nlead,i)
      u = hin%r2d(iu,i)
      v = hin%r2d(iv,i)
      hou%r2d(iu,i) = cs(1)*u - cs(2)*v
      hou%r2d(iv,i) = cs(2)*u + cs(1)*v
      phi = xy(1)*u + xy(2)*v
      cphi = cos(phi)
      sphi = sin(phi)
      do ix=hou%gil%fcol,hou%gil%lcol,hou%gil%natom
        reel = hin%r2d(ix,i) * cphi - hin%r2d(ix+1,i) * sphi
        imag = hin%r2d(ix,i) * sphi + hin%r2d(ix+1,i) * cphi
        hou%r2d(ix,i) = reel
        hou%r2d(ix+1,i) = imag
        hou%r2d(ix+2,i) = hin%r2d(ix+2,i)
      enddo
      ! Deproject the Y axis, i.e. shorten the V axis
      hou%r2d(iv,i) = cosi * hou%r2d(iv,i)
    enddo
  endif
end subroutine shift_and_squeeze_uv

subroutine sicsay (line,nline,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sicsay
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Support routine for command SAY
  !       SAY 'Expression' "String" 'Character_variable' ...
  !  [opt 1]     /FORMAT  a10 i2 f5.2 ...
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  integer                         :: nline  !
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='SAY'
  ! Note: ARGUM must have at least a length equal to TEXTLENGTH parameter
  ! in 'gwidget.h' .
  character(len=1024) :: argum,chain,string
  integer :: nleft,nchara,nfirst,nremain,iarg,narg,curwidth,lstring
  integer(kind=address_length) :: ia,ja
  character(len=message_length) :: mess
  logical :: noadvance
  !
  if (siclun.eq.0) then
    curwidth = sic_ttyncol()
  else
    curwidth = len(chain)
  endif
  !
  noadvance = sic_present(2,0)
  !
  ! /FORMAT Option
  if (sic_present(1,0)) then
    narg = sic_narg(0)
    nfirst = 1
    do iarg=1,narg
      !
      call say_format_arg(line,iarg,iarg,string,lstring,error)
      if (error) return
      !
      argum(nfirst:) = string(:lstring)
      nfirst = nfirst+lstring
    enddo
    !
    ! Check for widget creation
    if (lxwindow) then
      if (nfirst.eq.1) then
        call xgag_separator (noptscr)
      else
        ia = locstr(argum)
        ja = bytpnt(ia,membyt)
        call xgag_show (membyt(ja),nfirst-1,noptscr)
      endif
    else
      if (siclun.ne.0) then
        if (noadvance) then
          if (nfirst.gt.1) write(siclun,101,advance='NO') argum(1:nfirst-1)
        else
          write(siclun,101) argum(1:nfirst-1)
        endif
      else
        write(6,100) argum(1:nfirst-1)
      endif
    endif
  else
    !
    ! Automatic format
    if (lxwindow) then
      curwidth = len(chain)
    endif
    nleft = curwidth           ! Pas 0
    nfirst = 0
    narg = sic_narg(0)
    do iarg=1,narg
      call sic_ch (line,0,iarg,argum,nchara,.true.,error)
      if (error) then
        write(mess,'(A,I0)')  'Could not read argument #',iarg
        call sic_message(seve%e,rname,mess)
        return
      endif
      if (nchara.le.nleft) then
        chain (nfirst+1:) = argum(1:nchara)
        nleft = nleft-nchara-1
        nfirst = nfirst+nchara+1
      else
        if (nfirst.gt.0) then
          if (siclun.ne.0) then
            write(siclun,101) chain(1:nfirst-1)  ! Drop last blank
          else
            write(6,100) chain(1:nfirst-1)  ! Drop last blank
          endif
        endif
        nfirst = 0
        nremain = nchara
        do while (nfirst.lt.nchara)
          if (nremain.le.curwidth) then
            chain = argum(nfirst+1:nchara)
            nleft = curwidth-nremain-1
            nfirst = nchara+2
          else
            !
            if (lxwindow) then
              argum(nfirst+curwidth+1:nfirst+curwidth+1) = char(0)
              ia = locstr(argum)
              ja = bytpnt(ia,membyt)+nfirst
              call xgag_show (membyt(ja),curwidth,noptscr)
            else
              if (siclun.ne.0) then
                write(siclun,101) argum(nfirst+1:nfirst+curwidth)
              else
                write(6,100) argum(nfirst+1:nfirst+curwidth)
              endif
              nfirst = nfirst+curwidth
              nremain = nremain-curwidth
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Check for widget creation
    if (nfirst.gt.0) then
      if (lxwindow) then
        nfirst = len_trim(argum)
        if (nfirst.gt.0) then
          nfirst = nfirst+1
          argum(nfirst:nfirst) = char(0)
          ia = locstr(argum)
          ja = bytpnt(ia,membyt)
          call xgag_show (membyt(ja),nfirst,noptscr)
        else
          call xgag_separator(noptscr)
        endif
      else
        if (siclun.ne.0) then
          write(siclun,101) chain(1:nfirst-1)  ! Drop last blank
        else
          write(6,100) chain(1:nfirst-1)  ! Drop last blank
        endif
      endif
    elseif (lxwindow) then
      call xgag_separator(noptscr)
    endif
  endif
  !
100 format(20(a))
101 format(a)
end subroutine sicsay
!
subroutine sicmsg(line)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sicmsg
  use sic_interactions
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  ! Local
  integer :: nl,nt,n1,tt_width
  !
  if (sic_quiet) return
  !
  tt_width = sic_ttyncol()
  nl = len_trim(line)
  n1 = 1
  nt = nl
  do while (n1.le.nl)
    if (nt.le.tt_width) then
      write(6,100) line(n1:nl)
      return
    else
      write(6,100) line(n1:n1+tt_width-1)
      n1 = n1+tt_width
      nt = nt-tt_width
    endif
  enddo
  !
100 format(20(a))
end subroutine sicmsg
!
subroutine say_format_arg(line,iarg,iform,fmtd_string,lstring,error)
  use sic_dependencies_interfaces
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_interactions
  use sic_interfaces, except_this=>say_format_arg
  use sic_types
  !---------------------------------------------------------------------
  ! @private
  ! From input line, format the iarg-th argument of the command
  ! according to the iform-th format of the option /FORMAT. Formatted
  ! string is returned in fmtd_string, and its usefull length is lstring.
  ! Warnings!
  !  1) /FORMAT option must be the 1st option of the calling command
  !  2) In return, fmtd_string(1:lstring) != fmtd_string
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line         ! Line to analyze
  integer,          intent(in)    :: iarg         ! The arg number to analyze
  integer,          intent(in)    :: iform        ! The format number to be used
  character(len=*), intent(out)   :: fmtd_string  ! Output string
  integer,          intent(out)   :: lstring      ! Output string usefull length
  logical,          intent(inout) :: error        ! Error status
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='/FORMAT'
  character(len=512) :: forma,arg
  integer :: lforma,larg,arg_start,arg_end,ier
  integer(kind=size_length) :: nelem
  integer(kind=address_length) :: ia
  type(sic_descriptor_t) :: adesc
  logical :: found
  ! Arguments
  logical :: l
  integer(kind=8) :: n
  real(kind=8) :: r
  !
  fmtd_string = ''
  lstring = 0
  !
  ! Get the desired format
  call sic_ke(line,1,iform,forma(2:),lforma,.true.,error)
  if (error) return
  forma(1:1) =  '('
  !
  ! A "?" will always be appended. It allows to keep the desired length of
  ! string variables even if they are ended with blanks, e.g.
  ! SIC> SAY "Hello   "  1  /FORMAT A8 F4.2
  ! will preserve the 3 blanks. This terminating "?" is dropped off before
  ! returning the current routine.
  forma(lforma+2:lforma+4) = ',A)'
  lforma = lforma+4
  !
  ! Character strings
  if (forma(2:2).eq.'A') then  ! Format (A...)
    ! NB: character arrays not supported
    call sic_ch(line,0,iarg,arg,larg,.true.,error)
    ! Check if argument is a plain variable name
    arg_start = sic_start(0,iarg)
    arg_end   = sic_end(0,iarg)
    if (arg(1:larg).eq.line(arg_start:arg_end)) then
      call sic_descriptor(arg,adesc,found)
      if (found) then
        call destoc(adesc%type,adesc%addr,arg)
        larg = len_trim(arg)
      endif
    endif
    write(fmtd_string,forma(1:lforma),iostat=ier) arg(1:larg),'?'
  !
  ! Something not character
  else
    !
    ! Test for arrays
    call sic_ch(line,0,iarg,arg,larg,.true.,error)
    call sic_descriptor(arg,adesc,found)
    if (found) then
      ! Ok, a variable is found
      nelem = desc_nelem(adesc)
    else
      nelem = 1
    endif
    !
    ! This is an array
    if (nelem.gt.1) then
      ia = gag_pointer(adesc%addr,memory)
      lforma=lforma-2  ! Do not use the terminating "?" mechanism
      forma(lforma:lforma) =')'
      if (adesc%type.eq.fmt_r4) then
        call say_array_r4(memory(ia),nelem,forma(1:lforma),siclun,error)
      elseif (adesc%type.eq.fmt_r8) then
        call say_array_r8(memory(ia),nelem,forma(1:lforma),siclun,error)
      elseif (adesc%type.eq.fmt_i4) then
        call say_array_i4(memory(ia),nelem,forma(1:lforma),siclun,error)
      elseif (adesc%type.eq.fmt_i8) then
        call say_array_i8(memory(ia),nelem,forma(1:lforma),siclun,error)
      elseif (adesc%type.eq.fmt_l) then
        call say_array_l4(memory(ia),nelem,forma(1:lforma),siclun,error)
      else
        call sic_message(seve%e,rname,  &
          'Array printout not supported for that type')
        error = .true.
      endif
      return
    endif
    !
    ! Simple scalars
    if (index(forma,'I').ne.0) then
      call sic_i8 (line,0,iarg,n,.true.,error)
      if (.not.error) write(fmtd_string,forma(1:lforma),iostat=ier) n,'?'
    elseif (index(forma,'L').ne.0) then
      call sic_l4 (line,0,iarg,l,.true.,error)
      if (.not.error) write(fmtd_string,forma(1:lforma),iostat=ier) l,'?'
    else
      call sic_r8 (line,0,iarg,r,.true.,error)
      if (.not.error) write(fmtd_string,forma(1:lforma),iostat=ier) r,'?'
    endif
    !
    if (error) then
      call sic_message(seve%e,rname,'Format/Variable type mismatch')
      return
    endif
  endif
  !
  ! Format error
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Invalid format '//forma(2:lforma-5))
    error  = .true.
    return
  endif
  !
  ! Drop the last "?"
  lstring = len_trim(fmtd_string)-1
  !
end subroutine say_format_arg
!
subroutine say_array_r4 (array,na,form,lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: na   !
  real(4) :: array(na)              !
  character(len=*) :: form          !
  integer :: lun                    !
  logical :: error                  !
  ! Local
  integer :: mylun,ier
  !
  mylun = lun
  if (lun.eq.0) mylun = 6
  if (form.ne.'(*)') then
    write(mylun,form,iostat=ier) array
  else
    write(mylun,*,iostat=ier) array
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY ',ier)
    error = .true.
  else
    error = .false.
  endif
end subroutine say_array_r4
!
subroutine say_array_r8 (array,na,form,lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: na   !
  real(8) :: array(na)              !
  character(len=*) :: form          !
  integer :: lun                    !
  logical :: error                  !
  ! Local
  integer :: mylun,ier
  !
  mylun = lun
  if (lun.eq.0) mylun = 6
  if (form.ne.'(*)') then
    write(mylun,form,iostat=ier) array
  else
    write(mylun,*,iostat=ier) array
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY ',ier)
    error = .true.
  else
    error = .false.
  endif
end subroutine say_array_r8
!
subroutine say_array_i4 (array,na,form,lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: na   !
  integer(4) :: array(na)           !
  character(len=*) :: form          !
  integer :: lun                    !
  logical :: error                  !
  ! Local
  integer :: mylun,ier
  !
  mylun = lun
  if (lun.eq.0) mylun = 6
  if (form.ne.'(*)') then
    write(mylun,form,iostat=ier) array
  else
    write(mylun,*,iostat=ier) array
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY ',ier)
    error = .true.
  else
    error = .false.
  endif
end subroutine say_array_i4
!
subroutine say_array_i8 (array,na,form,lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: na   !
  integer(8) :: array(na)           !
  character(len=*) :: form          !
  integer :: lun                    !
  logical :: error                  !
  ! Local
  integer :: mylun,ier
  !
  mylun = lun
  if (lun.eq.0) mylun = 6
  if (form.ne.'(*)') then
    write(mylun,form,iostat=ier) array
  else
    write(mylun,*,iostat=ier) array
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY ',ier)
    error = .true.
  else
    error = .false.
  endif
end subroutine say_array_i8
!
subroutine say_array_l4(array,na,form,lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: na   ! Number of elements in array
  logical,          intent(in)    :: array(na)  ! Array which will be displayed
  character(len=*), intent(in)    :: form       ! Format to be used
  integer,          intent(in)    :: lun        ! Send output to this logical unit
  logical,          intent(inout) :: error      ! Error flag
  ! Local
  integer :: mylun,ier
  !
  mylun = lun
  if (lun.eq.0) mylun = 6
  if (form.ne.'(*)') then
    write(mylun,form,iostat=ier) array
  else
    write(mylun,*,iostat=ier) array
  endif
  !
  if (ier.ne.0) then
    write (*,'(A)') form
    call putios('E-SAY ',ier)
    error = .true.
  endif
end subroutine say_array_l4

subroutine display_buffer(comm,line,error)
  use gkernel_interfaces
  use mapping_interfaces, only : display_buffer_sub, map_message
  use clean_arrays
  use clean_def
  use clean_types
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for command
  !     SHOW Name
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: comm  ! Command (SHOW or VIEW)
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  ! Local variables
  integer ntype,nc
  character argu*12,dtype*12
  !
  ! Parse input line
  call sic_ke(line,0,1,argu,nc,.true.,error)
  if (error) return
  if (argu.eq.'?') argu = ' '
  call sic_ambigs(comm,argu,dtype,ntype,vtype,mtype,error)
  if (error) return
  !
  ! Special case for FIELDS
  if (dtype.eq.'FIELDS') then
    if (hprim%loca%size.eq.0 .or. comm.eq.'SHOW') then
      if (themap%nfields.eq.0) then
        call map_message(seve%e,comm,'No Mosaic loaded')
        error = .true.
      else
        call exec_program('@ p_plot_fields.map FIELDS')
      endif
      return
    endif
  endif
  !
  ! Display the buffer
  call display_buffer_sub(comm,ntype,line,error)
  if (sic_lire().eq.0) call sic_insert(line)
  !
end subroutine display_buffer
!
subroutine display_buffer_sub(comm,ntype,line,error)
  use gkernel_interfaces
  use mapping_interfaces, only : display_uv, buffer_copy
  use clean_types
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for command
  !     SHOW Name
  !
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: comm
  integer, intent(in)  :: ntype ! Buffer type
  logical, intent(out) :: error ! Logical error flag
  character(len=*), intent(in) :: line
  !
  character(len=40) :: argu1,argu2,chain,c_more
  integer :: nc
  logical :: do_dirty
  character(len=12) :: xtype,ytype
  !
  ! Load into SIC buffer
  if (comm.eq.'SHOW' .and. ntype.eq.1) then
    call sic_get_char('XTYPE',xtype,nc,error)
    call sic_get_char('YTYPE',ytype,nc,error)
    call buffer_copy('UV','W',w_plot,error)
    call sic_let_char('XTYPE','u',error)
    call sic_let_char('YTYPE','v',error)
    chain = 'UV'
    call display_uv (chain,error)
    call sic_let_char('XTYPE',xtype,error)
    call sic_let_char('YTYPE',ytype,error)
    return
  endif
  !
  call buffer_copy(vtype(ntype),'W',w_plot,error)
  if (error) return
  ! Plot SIC buffer with adequate plotting procedure
  if (comm.eq.'SHOW' .or. comm.eq.'UV_FLAG') then
    if (vtype(ntype).eq.'UV') then
       argu1 = ' '
       call sic_ch(line,0,2,argu1,nc,.false.,error)
       argu2 = ' '
       call sic_ch(line,0,3,argu2,nc,.false.,error)
       chain = vtype(ntype)//' '//trim(argu1)//' '//trim(argu2)
       call display_uv(chain,error)
    else if (vtype(ntype).eq.'CCT') then
       argu1 = ' '
       call sic_ch(line,0,2,argu1,nc,.false.,error)
       call exec_program('@ p_cct_w.map w '//argu1)
    else
       c_more = ' '
       call sic_get_logi('DO_DIRTY',do_dirty,error)
       if (do_dirty) then
         call buffer_copy('BEAM','BPLOT',b_plot,error)
         c_more = 'BPLOT'
       endif
       !
       argu1 = ' '
       call sic_ch(line,0,2,argu1,nc,.false.,error)
       argu2 = ' '
       call sic_ch(line,0,3,argu2,nc,.false.,error)
       chain = vtype(ntype)//' W '//trim(c_more)//' '//trim(argu1)//' '//trim(argu2)
       call exec_program('@ p_plot_w.map '//chain)
    endif
  else if (comm.eq.'VIEW') then
    if (vtype(ntype).eq.'UV') then
       continue
    else if (vtype(ntype).eq.'CCT') then
       argu1 = ' '
       call sic_ch(line,0,2,argu1,nc,.false.,error)
       argu2 = ' '
       call sic_ch(line,0,3,argu2,nc,.false.,error)
       chain = vtype(ntype)//' W '//trim(argu1)//' '//trim(argu2)
       call exec_program('@ p_cct_vue.map '//chain)
    else
       argu1 = ' '
       call sic_ch(line,0,2,argu1,nc,.false.,error)
       argu2 = ' '
       call sic_ch(line,0,3,argu2,nc,.false.,error)
       chain = vtype(ntype)//' W '//trim(argu1)//' '//trim(argu2)
       call exec_program('@ p_view_w.map '//chain)
    endif
  endif
  !
end subroutine display_buffer_sub
!
subroutine load_buffer(line,error)
  use gkernel_interfaces
  use mapping_interfaces, only : buffer_copy
  use clean_types
  use clean_default
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for command
  !     LOAD Name
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  ! Local variables
  integer :: ntype,nc
  character(len=12) :: argu, d_type
  !
  ! Parse input line
  call sic_ke(line,0,1,argu,nc,.true.,error)
  if (error) return
  if (argu.eq.'?') argu = ' '
  call sic_ambigs('LOAD',argu,d_type,ntype,vtype,mtype,error)
  if (error) return
  ! Load into SIC buffer
  call buffer_copy(d_type,'W',w_plot,error)
  if (error) return
  !
end subroutine load_buffer
!
subroutine buffer_copy(atype,namew,gw,error)
  use image_def
  use gkernel_interfaces
  use mapping_interfaces, only : map_message
  use clean_def
  use gbl_message
  use clean_arrays
  use clean_types
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING support routine for commands
  !     LOAD and SHOW Name
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: atype
  character(len=*), intent(in) :: namew
  type(gildas), intent(inout) :: gw
  logical, intent(out) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LOAD'
  integer(kind=address_length) :: ipw
  integer(kind=index_length) :: dim(4)
  !
  ! Read header
  gw%loca%size = 0
  select case (atype)
  case ('UV')
    call gdf_copy_header(huv,gw,error)
    gw%loca%addr = locwrd(duv)
  case ('BEAM')
    call gdf_copy_header(hbeam,gw,error)
    gw%loca%addr = locwrd(dbeam)
  case ('DIRTY')
    call gdf_copy_header(hdirty,gw,error)
    gw%loca%addr = locwrd(ddirty)
  case ('CLEAN')
    call gdf_copy_header(hclean,gw,error)
    gw%loca%addr = locwrd(dclean)
  case ('MASK')
    call gdf_copy_header(hmask,gw,error)
    gw%loca%addr = locwrd(dmask)
  case ('RESIDUAL')
    call gdf_copy_header(hresid,gw,error)
    gw%loca%addr = locwrd(dresid)
  case ('CCT')
    call gdf_copy_header(hcct,gw,error)
    gw%loca%addr = locwrd(dcct)
  case ('SKY')
    call gdf_copy_header(hsky,gw,error)
    gw%loca%addr = locwrd(dsky)
  case ('FIELDS','PRIMARY')
    call create_fields(error)
    if (.not.error) then
      call gdf_copy_header(hfields,gw,error)
      gw%loca%addr = locwrd(dfields)
    endif
  case default
    call map_message(seve%e,rname,'Unsupported type '//atype)
    error = .true.
    return
  end select
  !
  ! Pass table address to SIC buffer
  if (gw%loca%size.eq.0) then
    call map_message(seve%e,rname,'Image not defined '//atype)
    error =.true.
    return
  endif
  call sic_delvariable(namew,.false.,error)
  ipw = gag_pointer(gw%loca%addr,memory)
  !
  if (atype.eq.'BEAM') then
    ! Squeeze degenerate dimensions for Beams
    if (gw%gil%dim(3).eq.1) then
      gw%gil%dim(3) = max(1,gw%gil%dim(4))
      gw%gil%dim(4) = 1
      gw%gil%ndim = 3
    endif
  endif
  dim(1:4) = gw%gil%dim(1:4)
  call sic_def_real_addr(namew,memory(ipw),gw%gil%ndim,dim,.true.,error)
  !
end subroutine buffer_copy
!
subroutine create_fields(error)
  use gkernel_interfaces
  use clean_arrays
  use clean_types
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING internalroutine for command
  !     Create the FIELDS array (transposed version of the PRIMARY array)
  !----------------------------------------------------------------------
  logical, intent(out) :: error
  ! Local variables
  !
  character(len=4) :: code
  integer(kind=index_length) :: nfirst,nsecon,nmiddl,nelems,nlast,iblock(5)
  integer :: ier
  !
  if (hprim%loca%size.eq.0) then
    error = .true.
    return
  endif
  error = .false.
  !
  ! If it is allocated, it should be the right one, but play safe...
  if (allocated(dfields)) then
    if (hfields%loca%size.eq.hprim%loca%size) return
    deallocate(dfields)
  endif
  call gildas_null(hfields)
  !
  code = '231'
  call gdf_transpose_header(hprim,hfields,code,error)
  ! Determine chunk sizes from code and dimensions.
  call transpose_getblock(hprim%gil%dim,gdf_maxdims,code,iblock,error)
  if (error) return
  !
  ! With only one beam per frequency so far
  if (.not.allocated(dfields)) then
    allocate(dfields(hprim%gil%dim(2),hprim%gil%dim(3),hprim%gil%dim(1),hprim%gil%dim(4)),stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
  endif
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  call trans4all(dfields,dprim,nelems,nfirst,nmiddl,nsecon,nlast)
  !
  ! Set Type of First Axis
  hfields%gil%inc(3) = 1.0
  hfields%char%code(3) = 'FIELD'
end subroutine create_fields

!
subroutine uv_sort (error,sorted,shift,new,uvmax,uvmin)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_sort
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Sort the input UV table
  !----------------------------------------------------------------------
  logical, intent(inout) :: sorted      ! Is table sorted ?
  logical, intent(inout) :: shift       ! Do we shift phase center ?
  logical, intent(out) :: error
  real(kind=8), intent(inout) :: new(3) ! New phase center and PA
  real, intent(out) :: uvmin            ! Min baseline
  real, intent(out) :: uvmax            ! Max baseline
  !
  ! Global variables:
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  real(kind=8) freq, off(3)
  real pos(2), cs(2)
  integer nu,nv,ier
  real, pointer :: duv_previous(:,:)
  real, pointer :: duv_next(:,:)
  !
  ! The UV table is available in HUV%
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,'UV_MAP','No UV data loaded')
    error = .true.
    return
  endif
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  !
  ! Correct for new phase center if required
  if (shift) then
    if (huv%gil%ptyp.eq.p_none) then
      call map_message(seve%w,'SHIFT','No previous phase center info')
      huv%gil%a0 = huv%gil%ra
      huv%gil%d0 = huv%gil%dec
      huv%gil%pang = 0.d0
      huv%gil%ptyp = p_azimuthal
    elseif (huv%gil%ptyp.ne.p_azimuthal) then
      call map_message(seve%w,'SHIFT','Previous projection type not SIN')
      huv%gil%ptyp = p_azimuthal
    endif
    call uv_shift (new,huv%gil%a0,huv%gil%d0,huv%gil%pang,   &
        &      off,shift)
    huv%gil%posi_words = def_posi_words
    huv%gil%proj_words = def_proj_words
  endif
  if (shift) then
    sorted = .false.
  else
    call check_order (duv,nu,nv,sorted)
  endif
  !
  ! Get center frequency
  freq = gdf_uv_frequency(huv,huv%gil%ref(1))
  !
  ! If already sorted, use it
  if (sorted) then
    call map_message(seve%i,'UVSORT','UV table is already sorted')
    !
    ! Compute UVMAX
    call uvgmax (huv,duv,uvmax,uvmin)
    !
    ! Else, create another copy
  else
    call map_message(seve%i,'UVSORT','Sorting UV table...')
    !
    ! Compute observing frequency, and new phase center in wavelengths
    if (shift) then
      huv%gil%a0 = new(1)
      huv%gil%d0 = new(2)
      huv%gil%pang = new(3)
      cs(1)  =  cos(off(3))
      cs(2)  = -sin(off(3))
      ! Note that the new phase center is counter-rotated because rotations
      ! are applied before phase shift.
      pos(1) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
      pos(2) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
    else
      pos(1) = 0.0
      pos(2) = 0.0
      cs(1) = 1.0
      cs(2) = 0.0
    endif
    !
    !$ call uv_dump_buffers('UV_SORT')
    !
    ! OK, rotate, shift, sort and copy...
    nullify (duv_previous, duv_next)
    call uv_find_buffers ('UV_SORT',nu,nv, duv_previous, duv_next, error)
    if (error) return
    call uvsort_uv (nu,nv,huv%gil%ntrail,duv_previous,duv_next,   &
         &        pos,cs,uvmax,uvmin,error)
    huv%gil%basemax = uvmax
    huv%gil%basemin = uvmin
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
  endif
  !
  ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
  uvmax = uvmax*freq*f_to_k
  uvmin = uvmin*freq*f_to_k
  error = .false.
end subroutine uv_sort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the IMAGER package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imager_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !
  type(gpack_info_t), intent(out) :: pack
  !
  external :: imager_pack_init
  external :: imager_pack_on_exit
  !
  pack%name='imager'
  pack%ext = '.ima'
  pack%depend(1:1) = (/ locwrd(greg_pack_set) /)
  pack%init=locwrd(imager_pack_init)
  pack%on_exit=locwrd(imager_pack_on_exit)
  pack%authors="S.Guilloteau"
  !
end subroutine imager_pack_set
!
subroutine imager_pack_init(gpack_id,error)
  use gkernel_interfaces
  use sic_def
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  ! Local
  integer(kind=4) :: ier
  !
  !
  ! Local language
  call init_clean
  !
  ! One time initialization
  call map_message_set_id(gpack_id)  ! Set library id
  !
  ! Procedure extensions
  call exec_program('SIC'//backslash//'SIC EXTENSION .ima .greg ')
  ! Language priorities
  call exec_program('SIC'//backslash//'SIC PRIORITY 1 ADVANCED CLEAN')
  !
  ! Specific initializations
  !
  ! IMAGER ad-hoc patch: override symbol from kernel/etc/gag.dico.gbl.src
  ! which sets 'gag_help_clean' pointing to Mapping one.
  ier = sic_setlog('gag_help_clean','gag_doc:hlp/imager-help-clean.hlp')
  if (ier.eq.0) then
    error=.true.
    return
  endif
  ier = sic_setlog('gag_html_clean:','gag_doc:html/imager-html/')

  ier = sic_setlog('gag_help_advanced','gag_doc:hlp/imager-help-news.hlp')
  ier = sic_setlog('gag_html_advanced:','gag_doc:html/imager-html/')

  ier = sic_setlog('gag_help_calibrate','gag_doc:hlp/imager-help-calib.hlp')
  ier = sic_setlog('gag_html_calibrate:','gag_doc:html/imager-html/')
end subroutine imager_pack_init
!
subroutine imager_pack_on_exit(error)
  !----------------------------------------------------------------------
  !
  !----------------------------------------------------------------------
  logical :: error
  !
  call save_result(error)
  !
end subroutine imager_pack_on_exit
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine read_image (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>read_image
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !   READ Type File [/COMPACT] [/NOTRAIL] [/RANGE Start End Type]
  !   [/FREQUENCY RestFreqMHz] and (obsolete) /PLANE
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  ! Local
  integer, parameter :: o_compact=1
  integer, parameter :: o_freq=2
  integer, parameter :: o_plane=3
  integer, parameter :: o_range=4
  integer, parameter :: o_trail=5
  !
  integer ntype,nn,isort
  character(len=12) argu,atype
  character(len=filename_length) :: name
  logical compact,lexist,do_freq
  character(len=filename_length) :: file
  real(8) :: drange(2), freq
  character(len=12) :: csort
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort),mysort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  call sic_ke (line,0,1,argu,nn,.true.,error)
  if (error) return
  !
  if ((argu.eq.'?').and.(sic_narg(0).eq.1)) then
    call sic_ambigs ('READ',argu,atype,ntype,vtype,mtype,error)
    error = .false.
    return
  endif
  !
  call sic_ch (line,0,2,name,nn,.true.,error)
  if (error) return
  !
  if (argu.eq.'UV') argu = 'UV_DATA'
  !
  ! Default settings
  drange = 0
  mysort = 'NONE'
  !
  ! /PLANE (for compatibility)
  if (sic_present(o_plane,0)) then
    call sic_r8 (line,o_plane,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_plane,2,drange(2),.true.,error)
    if (error) return
    mysort = 'CHANNEL'
  endif
  !
  ! /RANGE (for flexibility)
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs('READ',csort,mysort,isort,types,msort,error)
    if (error)  return
  endif
  !
  ! /FREQUENCY Option
  do_freq = sic_present(o_freq,0)
  if (do_freq) then
    call sic_r8(line,o_freq,1,freq,.true.,error)
    if (error) return
  endif
  !
  ! /COMPACT
  compact = sic_present(o_compact,0)
  !
  if (argu.eq.'*') then
    !
    ! Find all files of relevant extension, and load them
    do ntype = 1, mtype
      lexist = sic_findfile(name,file,' ',etype(ntype))
      if (lexist) then
        call map_message(seve%i,'READ','Loading '//vtype(ntype)//trim(file))
        if (ntype.eq.1 .or. ntype.eq.mtype) then
          csort = 'NONE'
        else
          csort = mysort
        endif
        if (do_freq) then
          call sub_read_image (name,ntype,drange,csort,compact,error,freq)
        else
          call sub_read_image (name,ntype,drange,csort,compact,error)
        endif
        call check_view(1,atype)  ! Force VIEW re-computation for these
      endif
    enddo
  else
    call sic_ambigs ('READ',argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    if (do_freq) then
      call sub_read_image (name,ntype,drange,mysort,compact,error,freq)
    else
      call sub_read_image (name,ntype,drange,mysort,compact,error)
    endif
    call check_view(1,atype)  ! Force VIEW re-computation for these
  endif
  !
end subroutine read_image
!
subroutine sub_read_image (name,ntype,drange,crange,compact,error, freq)
  use gkernel_interfaces
  use imager_interfaces, only : map_read
  use clean_def
  use clean_arrays
  use clean_types
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Support routine for command
  !   READ Type File [/COMPACT] [/FREQUENCY RestFreqMHz] [/RANGE Start End Type]
  !   [/NOTRAIL] and obsolescent [/PLANE]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name    ! Name of file
  integer, intent(in) :: ntype            ! Type of data
  real(8), intent(in) :: drange(2)        ! Range to be read
  character(len=*), intent(in) :: crange  ! Type of range
  logical, intent(in) :: compact          ! ACA buffer flag
  logical, intent(inout) :: error
  real(8), intent(in), optional :: freq   ! Desired rest frequency
  !
  type (gildas) :: head
  integer :: nc(2)
  logical :: nochange, attempt, err
  real(4) :: velo
  !
  !!Print *,'Planes read ',nc
  !
  call gildas_null(head)
  call sic_parse_file(name,' ',etype(ntype),head%file)
  !
  head%blc = 0
  head%trc = 0
  !
  ! Read Header
  call gdf_read_header (head,error)
  if (error) return
  !
  ! Shift it to the requested Rest Frequency if needed
  if (present(freq)) then
    velo = head%gil%voff
    call gdf_modify(head,velo,freq,error=error)
    if (error) return
  endif
  !
  call out_range('READ',crange,drange,nc,head,error)
  if (error) return
  !
  ! Check if anything changed
  if (.not.compact) then
    ! We must check if the corresponding buffer is still allocated !...
    select case(vtype(ntype))
    case ('CCT')
      attempt = hcct%loca%size.ne.0
    case ('RESIDUAL')
      attempt = hresid%loca%size.ne.0
    case ('CLEAN')
      attempt = hclean%loca%size.ne.0
    case default
      attempt = .true.
    end select
    if (attempt) then
      call sub_modified(ntype,head%file,optimize(ntype),nc,nochange)
      if (nochange) return
    endif
  endif
  !
  ! Read Data as required
  call map_read(head,vtype(ntype),nc,compact,error)
  !
  ! Indicate Buffer has been read
  optimize(ntype)%change = 0
  !
  ! Free image slot 
  err = .false.
  call gdf_close_image (head,err)
  if (err) error = .true.
  !
end subroutine sub_read_image
!
subroutine sub_modified(atype,file,opti,nc,nochange)
  use gkernel_interfaces
  use gkernel_types
  use clean_types
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_uvgildas
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Check if the file of type "atype" needs to be read again.
  !---------------------------------------------------------------------
  integer, intent(in) :: atype          ! Code of type of file
  character(len=*), intent(in) :: file  ! Filename
  type(readop_t), intent(inout) :: opti ! Status of corresponding buffer
  integer, intent(in) :: nc(2)          ! Range to be read
  logical, intent(out) :: nochange      ! Change status
  !
  logical :: error
  character(len=36) :: mess, trail
  integer :: msev
  !
  nochange = .false.           ! By default
  !
  opti%modif%modif = .true.    ! In case of error
  call gag_filmodif(file,opti%modif,error)
  if (.not.opti%modif%modif) then
    if (nc(1).eq.opti%lastnc(1) .and. nc(2).eq.opti%lastnc(2)) then
      mess = 'File not modified and same range  -- '
      msev = seve%w
      nochange = .true.
    else
      mess = 'File not modified, different range - '
      msev = seve%i
    endif
  else
    opti%lastnc = nc
    return
  endif
  opti%lastnc = nc
  !
  ! The buffers may however have been manipulated in Mapping
  if (optimize(atype)%change.gt.1) then
    nochange = .false.
    trail = ' Buffer changed -- Reloaded '
    msev = seve%i
  else if (optimize(atype)%change.eq.1 .and. nochange) then
    !
    ! Is there a buffer to be Reset
    if (atype.eq.code_save_uv) then
      call uv_reset_buffer('READ')
      call map_uvgildas('UV',huv,error,duvi) 
    endif
    optimize(atype)%change = 0
    trail = ' Reset from Buffer'
  else if (nochange) then
    trail = ' not reloaded '
  else
    trail = ' reloaded '
  endif
  !
  call map_message(msev,'READ',mess//trail)
  ! No Read / Write optimization
  ! RW_Optimize is an integer, so that we may distinguish
  ! optimization based on "atype"
  if (rw_optimize.eq.0 .and. nochange) then
    call map_message(seve%w,'READ','Reading enforced by user')
    nochange = .false.
  endif
  !
end subroutine sub_modified
!
subroutine map_read (head,out,nc,compact,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>map_read
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use uvfit_data
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !  Read some type of input data.
  !------------------------------------------------------------------
  type (gildas), intent(inout) :: head ! Header of data
  character(len=*), intent(in) :: out  ! Desired data
  integer, intent(in) :: nc(2)         ! Channel range
  logical, intent(in) :: compact       ! Put in ACA space ?
  logical, intent(out) :: error
  !
  type (gildas) :: htmp
  character(len=80) chain
  integer i, ier, nchan, local_nc(2), blc
  character(len=4) :: rname = 'READ'
  integer, parameter :: o_trail=5
  logical :: subset
  !
  real, allocatable :: tmp_data(:,:)
  integer :: ram_need
  character(len=132) :: mess
  !
  error = .false.
  !
  if (.not.compact) then
    select case (out)
    case ('BEAM')
      ! Beam is a 4-D array of dimension Nx Ny Np Nb
      ! where Nb is the number of "beam frequencies"
      ! and Np the number of pointing centers
      call gdf_copy_header(head, hbeam, error)
      hbeam%loca = head%loca
      save_data(code_save_beam) = .false.
      call sic_delvariable ('BEAM',.false.,error)
      if (allocated(dbeam)) deallocate(dbeam,stat=ier)
      hbeam%gil%dim(3) = max(1,hbeam%gil%dim(3))
      hbeam%gil%dim(4) = max(1,hbeam%gil%dim(4))
      allocate(dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2),   &
       &        hbeam%gil%dim(3),hbeam%gil%dim(4)),stat=ier)
      call gdf_read_data(hbeam,dbeam,error)
      if (error) return
      !
      ! One should check here the beam order:
      ! input beams can also be
      !   Nx Ny Nb
      ! or
      !   NX Ny Np
      ! depending on GILDAS  version used for creation
      call sic_mapgildas('BEAM',hbeam,error,dbeam)
      ! Special case for UV data
    case ('UV_DATA')
      !
      if (head%char%type(1:9).ne.'GILDAS_UV') then
        call map_message(seve%e,'READ','Input file is not a UV data set')
        error = .true.
        return
      endif
      !
      ! Free the previous zone
      call uv_free_buffers
      save_data(code_save_uv) = .false.
      !
      call gildas_null (huv, type= 'UVT')
      call gildas_null (htmp, type= 'UVT')
      call gdf_copy_header(head, htmp, error)
      ! Check appropriate order
      if (htmp%char%code(1).eq."RANDOM") then
        call map_message(seve%w,rname,'UV data is transposed')
        call gdf_transpose_header (htmp, huv, '21', error)
        subset = .true.
      else
        call gdf_copy_header(htmp, huv, error)
        subset = .false.
      endif
      if (error)  return
      htmp%loca = head%loca
      huv%loca = head%loca   ! Why : to get the image slot !...
      !
      call sic_delvariable ('UV',.false.,error)
      call sic_delvariable ('UVS',.false.,error)
      !
      ! Extract desired channels
      nchan = huv%gil%nchan
      local_nc = nc
      ier = gdf_range (local_nc, nchan)
      nchan = local_nc(2)-local_nc(1)+1
      huv%gil%ref(1) = huv%gil%ref(1)-local_nc(1)+1
      huv%gil%dim(1) = huv%gil%nlead+huv%gil%natom*huv%gil%nstokes*nchan
      if (huv%gil%ntrail.gt.0) then
        if (sic_present(o_trail,0)) then    ! /NOTRAIL option
          do i=1,code_uvt_last
            if (huv%gil%column_pointer(i).gt.huv%gil%dim(1)) then
              call map_message(seve%w,rname,'Found column '//uv_column_name(i))
              huv%gil%column_size(i) = 0
              huv%gil%column_pointer(i) = 0
            endif
          enddo
          huv%gil%ntrail = 0
        endif
        ! use them according to user selection
        huv%gil%dim(1) = huv%gil%dim(1) + huv%gil%ntrail
      endif
      huv%gil%nchan = nchan
      !
      call sic_get_inte('SIC%RAMSIZE',sys_ramsize,error)
      ram_need = (huv%gil%dim(1)*huv%gil%dim(2))/(512*512)   ! Size of RAM requested
      if (ram_need.gt.sys_ramsize) then
        write(mess,'(A,F8.1,A,F8.1,A)') 'Data size (',1d-3*ram_need, &
          & 'GB) exceeds available RAM (',1d-3*sys_ramsize,' GB)'
        call map_message(seve%e,rname,mess)
        error = .true.
        return
      else if (ram_need.gt.sys_ramsize/2) then
        write(mess,'(A,F8.1,A,F8.1,A)') 'Data size (',1d-3*ram_need, &
          & 'GB) exceeds half of available RAM (',1d-3*sys_ramsize,' GB)'
        call map_message(seve%w,rname,mess)
      endif
      !
      allocate(duvi(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
      call gdf_read_uvdataset(htmp,huv,local_nc,duvi,error)
      if (error) then
        deallocate(duvi,stat=ier)
        return
      endif
      ! Erase undefined part of visibility data
      if (huv%gil%nvisi.lt.huv%gil%dim(2)) then
        duvi(:,huv%gil%nvisi+1:huv%gil%dim(2)) = 0.
      endif
      !
      duv => duvi              ! Point on original data
      duvr => duvi             ! Point on original data
      !
      ! Check the type and number of fields
      call check_uvdata_type(huv,duv,themap,error)
      if (error) return
      call map_uvgildas('UV',huv,error,duvi) 
      call gildas_null (huvi, type = 'UVT')
      call gdf_copy_header(huv,huvi, error)
      !
      do_weig = .true.
      !
      ! Unload the PRIMARY array if defined
      call sic_delvariable ('PRIMARY',.false.,error)
      if (allocated(dprim)) deallocate(dprim,stat=ier)
      hprim%loca%size = 0
      !
      ! Delete the BEAM_RANGES array if any
      call sic_delvariable ('BEAM_RANGES',.false.,error)
      !
      ! Delete the SELF array if defined
      call sic_delvariable ('UVSELF',.false.,error)
      if (allocated(duvself)) deallocate(duvself,stat=ier)
      hself%loca%size = 0
      ! Delete the CONTINUUM array if defined
      call sic_delvariable ('UVCONT',.false.,error)
      if (allocated(duvc)) deallocate(duvc,stat=ier)
      huvc%loca%size = 0
    case ('MODEL')
      !
      ! Free the previous zone
      call sic_delvariable ('UVM',.false.,error)
      if (allocated(duvm)) then
        deallocate(duvm,stat=ier)
      endif
      !
      call gildas_null (huvm, type= 'UVT')
      call gildas_null (htmp, type= 'UVT')
      call gdf_copy_header(head, htmp, error)
      ! Check appropriate order
      if (htmp%char%code(1).eq."RANDOM") then
        call map_message(seve%w,rname,'UV data is transposed')
        call gdf_transpose_header (htmp, huvm, '21', error)
      else
        call gdf_copy_header(htmp, huvm, error)
      endif
      if (error)  return
      htmp%loca = head%loca
      huvm%loca = head%loca   ! Why ?  See above !
      !
      ! Extract desired channels
      nchan = huvm%gil%nchan
      local_nc = nc
      ier = gdf_range (local_nc, nchan)
      nchan = local_nc(2)-local_nc(1)+1
      huvm%gil%ref(1) = huvm%gil%ref(1)-local_nc(1)+1
      huvm%gil%dim(1) = huvm%gil%nlead+huvm%gil%natom*nchan
      allocate(duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
      call gdf_read_uvdataset(htmp,huvm,local_nc,duvm,error)
      if (error) return
      !
      huvm%loca%size = huvm%gil%dim(1)*huvm%gil%dim(2)
      call sic_def_real ('UVM',duvm,huvm%gil%ndim,   &
       &        huvm%gil%dim,.true.,error)
      !
    case ('CGAINS')
      !
      ! Free the previous zone
      call sic_delvariable ('CGAINS',.false.,error)
      if (allocated(duvbg)) then
        deallocate(duvbg,stat=ier)
      endif
      !
      call gildas_null (hbgain, type= 'UVT')
      call gildas_null (htmp, type= 'UVT')
      call gdf_copy_header(head, htmp, error)
      ! Check appropriate order
      if (htmp%char%code(1).eq."RANDOM") then
        call map_message(seve%w,rname,'Gain data is transposed')
        call gdf_transpose_header (htmp, hbgain, '21', error)
      else
        call gdf_copy_header(htmp, hbgain, error)
      endif
      if (error)  return
      htmp%loca = head%loca
      hbgain%loca = head%loca   ! Why ? See above !
      !
      ! Extract 1 channel
      local_nc = 1
      nchan = 1
      hbgain%gil%ref(1) = hbgain%gil%ref(1)-local_nc(1)+1
      hbgain%gil%dim(1) = hbgain%gil%nlead+hbgain%gil%natom*nchan
      hbgain%gil%nchan = 1
      ! Trim trailing column
      if (hbgain%gil%ntrail.gt.0) then
        do i=1,code_uvt_last
          if (hbgain%gil%column_pointer(i).gt.hbgain%gil%dim(1)) then
            call map_message(seve%w,rname,'Found column '//uv_column_name(i))
            hbgain%gil%column_size(i) = 0
            hbgain%gil%column_pointer(i) = 0
          endif
        enddo
        hbgain%gil%ntrail = 0
      endif
      !
      allocate(duvbg(hbgain%gil%dim(1),hbgain%gil%dim(2)),stat=ier)
      call gdf_read_uvdataset(htmp,hbgain,local_nc,duvbg,error)
      if (error) return
      !
      hbgain%loca%size = hbgain%gil%dim(1)*hbgain%gil%dim(2)
      call sic_mapgildas ('CGAINS',hbgain,error,duvbg)
      !
    case ('DIRTY')
      save_data(code_save_dirty) = .false.
      call sic_delvariable ('DIRTY',.false.,error)
      if (allocated(ddirty)) deallocate(ddirty,stat=ier)
      !
      ! Specify the subset
      error = map_range(nc,head,hdirty)
      if (error) return
      !
      allocate(ddirty(hdirty%gil%dim(1),hdirty%gil%dim(2),   &
       &        hdirty%gil%dim(3)),stat=ier)
      call gdf_read_data(head,ddirty,error)
      if (error) return
      !
      call sic_mapgildas('DIRTY',hdirty,error,ddirty)
      user_method%do_mask = .true.
      !
      ! Define Min Max
      d_max = hdirty%gil%rmax
      if (hdirty%gil%rmin.eq.0) then
        d_min = -0.03*hdirty%gil%rmax
      else
        d_min = hdirty%gil%rmin
      endif
      !
    case ('RESIDUAL')
      save_data(code_save_resid) = .false.
      call sic_delvariable ('RESIDUAL',.false.,error)
      if (allocated(dresid)) deallocate(dresid,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hresid)
      if (error) return
      allocate(dresid(hresid%gil%dim(1),hresid%gil%dim(2),   &
       &        hresid%gil%dim(3)),stat=ier)
      call gdf_read_data(head,dresid,error)
      if (error) return
      call sic_mapgildas('RESIDUAL',hresid,error,dresid)
      user_method%do_mask = .true.
      !
    case ('CLEAN')
      save_data(code_save_clean) = .false.
      call sic_delvariable ('CLEAN',.false.,error)
      if (allocated(dclean)) deallocate(dclean,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hclean)
      if (error) return
      allocate(dclean(hclean%gil%dim(1),hclean%gil%dim(2),   &
       &        hclean%gil%dim(3)),stat=ier)
      call gdf_read_data(head,dclean,error)
      if (error) return
      call sic_mapgildas ('CLEAN',hclean,error,dclean)
      !
    case ('SKY')
      save_data(code_save_sky) = .false.
      call sic_delvariable ('SKY',.false.,error)
      if (allocated(dsky)) deallocate(dsky,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hsky)
      if (error) return
      allocate(dsky(hsky%gil%dim(1),hsky%gil%dim(2),   &
       &        hsky%gil%dim(3)),stat=ier)
      call gdf_read_data(head,dsky,error)
      if (error) return
      call sic_mapgildas ('SKY',hsky,error,dsky)
      !
    case ('MASK')
      save_data(code_save_mask) = .false.
      call sic_delvariable ('MASK',.false.,error)
      if (allocated(dmask)) deallocate(dmask,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hmask)
      if (error) return
      allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
       &        stat=ier)
      call gdf_read_data(head,dmask,error) 
      if (error) return
      call sic_mapgildas ('MASK',hmask,error,dmask)
      user_method%do_mask = .true.
      !
    case ('PRIMARY')
      !
      ! Primary is a 4-D array of dimension Np Nx Ny Nb
      ! where Nb is the number of "beam frequencies"
      ! and Np the number of pointing centers
      !
      ! /RANGE option not effective here
      !
      call gdf_copy_header(head, hprim, error)
      hprim%loca = head%loca
      save_data(code_save_primary) = .false.
      call sic_delvariable ('PRIMARY',.false.,error)
      if (allocated(dprim)) deallocate(dprim,stat=ier)
      hprim%gil%dim(4) = max(1,hprim%gil%dim(4))
      allocate(dprim(hprim%gil%dim(1),hprim%gil%dim(2),   &
       &        hprim%gil%dim(3),hprim%gil%dim(4)),stat=ier)
      call gdf_read_data(hprim,dprim,error)
      if (error) return
      call sic_mapgildas('PRIMARY',hprim,error,dprim)
      !
      ! Old GILDAS primary beams had only one Frequency channel
      !
      ! Switch to mosaic mode
      user_method%trunca = hprim%gil%inc(1)  ! Truncation of beam
      user_method%search = user_method%trunca
      user_method%restor = user_method%trunca
      call map_message(seve%i,rname,'Primary Beam read, setting MOSAIC')
      call sub_mosaic('ON',error)
      if (error) return
    case ('CCT')
      call gdf_copy_header(head, hcct, error)
      hcct%loca = head%loca
      save_data(code_save_cct) = .false.
      call sic_delvariable ('CCT',.false.,error)
      if (allocated(dcct)) deallocate(dcct,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hcct)
      if (error) return
      allocate(dcct(hcct%gil%dim(1),hcct%gil%dim(2),   &
       &        hcct%gil%dim(3)),stat=ier)
      call gdf_read_data(head,dcct,error)
      if (error) return
      call sic_mapgildas ('CCT',hcct,error,dcct)
      !
    case ('SINGLEDISH')
      save_data(code_save_single) = .false.
      call sic_delvariable ('SINGLE',.false.,error)
      call sic_delvariable ('SHORT',.false.,error)
      if (associated(hshort%r3d,dsingle)) then
        nullify(hshort%r3d)
      else if (associated(hshort%r3d)) then
        deallocate(hshort%r3d,stat=ier)
      endif
      if (allocated(dsingle)) deallocate(dsingle,stat=ier)
      !
      ! Find out what type of data it is
      if (head%gil%xaxi*head%gil%yaxi.eq.2) then
        ! This is an image
        if (head%gil%ndim.eq.2) then
          ! Extend 2-D images as a data cube
          head%gil%ndim = 3
          head%gil%dim(3) = 1
        endif
      else
        ! This must be a Class Table
        if (head%gil%ndim.ne.2) then
          call map_message(seve%e,rname,'Unrecognized SINGLEDISH data')
          error = .true.
          return
        endif
      endif
      ! Hereafter ndim=2 will say it is a Table
      !  
      ! Specify the subset if possible
      if (head%gil%ndim.eq.2) then        
        call map_message(seve%w,rname,'SINGLEDISH table -- range under test')
        error = tab_range(nc,head,hsingle,subset)
        if (error) return
        hsingle%gil%dim(3) = 1
      else if (head%gil%ndim.eq.3) then        
        error = map_range(nc,head,hsingle)
        if (error) return
      else
        call map_message(seve%e,rname,'SINGLEDISH data must have rank 2 or 3')
        error = .true.
        return
      endif
      !
      allocate(dsingle(hsingle%gil%dim(1),hsingle%gil%dim(2),   &
       &        hsingle%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'SINGLEDISH data allocation error')
        error = .true.
        return
      endif
      !      
      if (hsingle%gil%ndim.eq.2) then     
        ! The section to be read is not-contiguous...
        ! Read the smallest contiguous section for simplicity,
        ! i.e. up to the last selected channel
        allocate(tmp_data(head%trc(1),head%gil%dim(2)),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'SINGLEDISH temporary data allocation error')
          error = .true.
          return
        endif
        blc = head%blc(1)
        head%blc(1) = 1
        call gdf_read_data(head,tmp_data,error)
        !
        ! Put in place
        dsingle(1:3,:,1) = tmp_data(1:3,:)  ! Extra columns
        dsingle(4:,:,1) = tmp_data(blc:,:)  ! Real data
        deallocate(tmp_data)
      else
        call gdf_read_data(head,dsingle,error)
      endif
      if (error) return
      !
      call sic_mapgildas('SINGLE',hsingle,error,dsingle)
      if (hsingle%gil%ndim.eq.3) then     
        call gildas_null(hshort)
        call gdf_copy_header(hsingle,hshort,error)
        call sic_mapgildas('SHORT',hshort,error,dsingle)
        hshort%r3d => dsingle
      endif
    case ('UV_FIT')
!      save_data(code_save_mask) = .false.
      call sic_delvariable ('UV_FIT',.false.,error)
      if (allocated(duvfit)) deallocate(duvfit,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,huvfit)
      if (error) return
      allocate(duvfit(huvfit%gil%dim(1),huvfit%gil%dim(2)), & 
       &        stat=ier)
      call gdf_read_data(head,duvfit,error) 
      if (error) return
      call sic_mapgildas ('UV_FIT',huvfit,error,duvfit)
      !
    case default
      chain = 'Unsupported operation '//out
      call map_message(seve%e,rname,chain)
      error = .true.
    end select
    !
    ! Compact Array data
  else
    ! 4-D not yet done...
    !
    select case (out)
    case ('BEAM')
      call gdf_copy_header(head, c_hbeam, error)
      c_hbeam%loca = head%loca
      save_data(code_save_beam) = .false.
      call sic_delvariable ('C_BEAM',.false.,error)
      if (allocated(c_dbeam)) deallocate(c_dbeam,stat=ier)
      allocate(c_dbeam(c_hbeam%gil%dim(1),c_hbeam%gil%dim(2),   &
           &        c_hbeam%gil%dim(3)),stat=ier)
      call gdf_read_data(c_hbeam,c_dbeam,error)
      if (error) return
      c_hbeam%gil%dim(3) = max(1,c_hbeam%gil%dim(3))
      call sic_def_real ('C_BEAM',c_dbeam,c_hbeam%gil%ndim,   &
           &        c_hbeam%gil%dim,.true.,error)
    case ('DIRTY')
      call gdf_copy_header(head, c_hdirty, error)
      c_hdirty%loca = head%loca
      save_data(code_save_dirty) = .false.
      call sic_delvariable ('C_DIRTY',.false.,error)
      if (allocated(c_ddirty)) deallocate(c_ddirty,stat=ier)
      allocate(c_ddirty(c_hdirty%gil%dim(1),c_hdirty%gil%dim(2),   &
           &        c_hdirty%gil%dim(3)),stat=ier)
      call gdf_read_data(c_hdirty,c_ddirty,error)
      if (error) return
      call sic_def_real ('C_DIRTY',c_ddirty,c_hdirty%gil%ndim,   &
           &        c_hdirty%gil%dim,.true.,error)
      cuse_method%do_mask = .true.
      !
    case ('RESIDUAL')
      call gdf_copy_header(head, c_hresid, error)
      c_hresid%loca = head%loca
      save_data(code_save_resid) = .false.
      call sic_delvariable ('C_RESIDUAL',.false.,error)
      if (allocated(c_dresid)) deallocate(c_dresid,stat=ier)
      allocate(c_dresid(c_hresid%gil%dim(1),c_hresid%gil%dim(2),   &
           &        c_hresid%gil%dim(3)),stat=ier)
      call gdf_read_data(c_hresid,c_dresid,error)
      if (error) return
      call sic_def_real ('C_RESIDUAL',c_dresid,c_hresid%gil%ndim,   &
           &        c_hresid%gil%dim,.true.,error)
      cuse_method%do_mask = .true.
      !
    case ('PRIMARY')
      call gdf_copy_header(head, c_hprim, error)
      c_hprim%loca = head%loca
      call sic_delvariable ('C_PRIMARY',.false.,error)
      if (allocated(c_dprim)) deallocate(c_dprim,stat=ier)
      allocate(c_dprim(c_hprim%gil%dim(1),c_hprim%gil%dim(2),   &
           &        c_hprim%gil%dim(3)),stat=ier)
      call gdf_read_data(c_hprim,c_dprim,error)
      if (error) return
      call sic_def_real ('C_PRIMARY',c_dprim,c_hprim%gil%ndim,   &
           &        c_hprim%gil%dim,.true.,error)
      !
      ! Switch to mosaic mode
      cuse_method%trunca = c_hprim%gil%inc(1)  ! Truncation of beam
      cuse_method%search = cuse_method%trunca
      cuse_method%mosaic = .true.
    case default
      chain = 'Unsupported operation '//out
      call map_message(seve%e,rname,chain)
      error = .true.
    end select
  endif
end subroutine map_read
!
function map_range (nc,hin,hou)
  use image_def
  use gkernel_interfaces, only : gdf_range
  !---------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Define channel range and set output Map header
  ! accordingly.
  !---------------------------------------------------
  logical :: map_range ! intent(out)
  integer, intent(in) :: nc(2)         ! Input channel range
  type (gildas), intent(inout) :: hin     ! Input header
  type (gildas), intent(inout) :: hou     ! Output header
  !
  integer :: local_nc(2), hdim, faxi, rank
  !
  map_range = .false.
  !
  ! Trim header to 3
  rank = 3
  call gdf_trim_header(hin,rank,map_range)
  if (map_range) return
  !
  ! Copy header
  call gdf_copy_header(hin, hou, map_range)
  if (map_range) return
  hou%loca = hin%loca
  !
  ! Verif Frequency axsi
  faxi = hin%gil%faxi
  !
  if (faxi.eq.0) then
    ! NO Frequency axis -- map_range must called with default value
    map_range = any(nc.ne.1) 
  else
    !
    ! Frequency axis: Find out the actual range
    local_nc = nc
    map_range = gdf_range(local_nc,hin%gil%dim(faxi)).ne.0
    if (map_range) return
    hdim = local_nc(2) - local_nc(1) + 1
    !
    ! Set the input header subset range
    hin%blc(faxi) = local_nc(1)
    hin%trc(faxi) = local_nc(2)
    !
    ! Set the output header reference channel and number of channels
    hou%gil%ref(faxi) = hou%gil%ref(faxi)+1-max(hin%blc(faxi),1)
    hou%gil%dim(faxi) = hdim
    !
    ! Correct the data size
    hou%loca%size = hin%loca%size*hou%gil%dim(faxi)/hin%gil%dim(faxi)
  endif
end function map_range
!
subroutine out_range(rname,atype,drange,nc,head,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Utility routine to define a channel range from a
  !   Velocity, Frequency or Channel range
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  ! Caller name
  character(len=*), intent(in) :: atype  ! Type of range
  real(8), intent(in) :: drange(2)     ! Input range
  integer, intent(out) :: nc(2)          ! Ouput channel number
  type(gildas), intent(in) :: head       ! Reference GILDAS data frame
  logical, intent(out) :: error          ! Error flag
  !
  real(8) :: frange(2)
  integer :: itype, nn, ier, nchan
  character(len=80) :: chain
  integer(kind=4), parameter :: mtype=4
  character(len=12) :: types(mtype),mytype,ctype
  data types /'CHANNEL','VELOCITY','FREQUENCY','NONE'/
  !
  ctype = atype
  call sic_upper(ctype)
  error = .false.
  call sic_ambigs(rname,ctype,mytype,itype,types,mtype,error)
  if (error)  return
  !
  if (abs(head%gil%type_gdf).eq.code_gdf_uvt) then
    nchan = head%gil%nchan
  else if (head%gil%faxi.ne.0) then
    nchan = head%gil%dim(head%gil%faxi)
  else if (head%gil%ndim.eq.2) then
    call map_message(seve%w,rname,'Dataset is 2-D only') 
    nchan = 1
  else  
    if (mytype.ne.'NONE') call map_message(seve%w,rname, &
      & 'No Frequency axis, /RANGE option ignored.')
    nc = 1
    return
  endif
  !
  if (mytype.eq.'CHANNEL') then
    nc = nint(drange)
  else if (mytype.eq.'VELOCITY') then
    if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
      ! UV data case
      frange = (drange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else if  (head%gil%faxi.eq.0) then  !
      call map_message(seve%e,rname,'No Velocity/Frequency Axis')
      error = .true.
      return
    else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
      frange = -(drange-head%gil%voff)*head%gil%freq/299792.458d0+head%gil%freq
      frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
      frange = (drange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else
      call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
      error = .true.
      return
    endif
    !
    nc = nint(frange)
    if (nc(1).gt.nc(2)) then
      nn = nc(2)
      nc(2) = nc(1)
      nc(1) = nn
    endif
    if (nc(1).gt.nchan .or. nc(2).lt.1) then
      write(chain,'(A,I8,A,I8,A,I8,A)') 'Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
      call map_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    nc = max(1,min(nc,nchan))
  else if (mytype.eq.'FREQUENCY') then
    ! The current code is only valid for UV Tables.
    ! See as above for the VELOCITY case
    ! drange = nc - head%gil%ref(head%gil%faxi) ) * head%gil%vres + head%gil%voff
    if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
      ! UV data case is always the same...
      frange = (drange - head%gil%freq) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%gil%faxi.eq.0) then  !
      call map_message(seve%e,rname,'No Velocity/Frequency Axis')
      error = .true.
      return
    else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
      frange = (drange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
      frange = -(drange-head%gil%freq)/head%gil%freq*299792.458d0 + head%gil%voff
      frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else
      call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
      error = .true.
      return
    endif
    !
    nc = nint(frange)
    if (nc(1).gt.nc(2)) then
      nn = nc(2)
      nc(2) = nc(1)
      nc(1) = nn
    endif
    if (nc(1).gt.nchan .or. nc(2).lt.1) then
      write(chain,'(A,I8,A,I8,A,I8,A)') 'Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
      call map_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    nc = max(1,min(nc,nchan))
  else if (mytype.eq.'NONE') then
    nc = [1,nchan]
  else
    call map_message(seve%f,rname,"Type of value '"//trim(mytype)//"' not supported")
    error = .true.
    return
  endif
  !
  ier = gdf_range (nc, nchan)
  if (ier.ne.0) error = .true.
  !
end subroutine out_range
!
subroutine check_uvdata_type(huv,duv,map,error)
  use image_def
  use clean_def
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, only : mosaic_getfields, map_message, get_bsize
  !-------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !     Internal routine
  ! Check number and types of fields
  !-------------------------------------------------------
  type(gildas), intent(inout) :: huv
  real, intent(inout) :: duv(:,:)
  type(uvmap_par), intent(inout) :: map
  logical, intent(inout) :: error
  !
  type(projection_t) :: uv_proj
  integer :: np, nv
  integer :: loff, moff, xoff, yoff, lid, nf, i, ier
  character(len=12) :: chain
  real :: value
  !
  map%nfields = 0
  call sic_delvariable('FIELDS',.false.,error)
  error = .false.
  huv%loca%size = huv%gil%dim(1)*huv%gil%dim(2)
  if (huv%gil%ntrail.eq.0) return
  !
  np = huv%gil%dim(1)
  nv = huv%gil%nvisi
  !
  loff = huv%gil%column_pointer(code_uvt_loff)
  moff = huv%gil%column_pointer(code_uvt_moff)
  !
  xoff = huv%gil%column_pointer(code_uvt_xoff)
  yoff = huv%gil%column_pointer(code_uvt_yoff)
  !
  lid  = huv%gil%column_pointer(code_uvt_id)
  !
  if (lid.ne.0 .and. (loff.eq.0.or.moff.eq.0)) then
    value = duv(lid,1)
    if (any(duv(lid,:).ne.value)) then 
      nf = maxval(duv(lid,:))
      write(chain,'(I12)') nf
      call map_message(seve%e,'READ','Mosaic of '//adjustl(trim(chain))//' fields with only Source ID column')
      call map_message(seve%i,'READ','Use task UV_UPDATE_FIELDS to specify field coordinates')
      huv%loca%size = 0 ! Set UV as undefined
      error = .true.
      return
    else
      map%nfields = 0
      call map_message(seve%w,'READ','Degenerate mosaic of 1 field with Source ID column')
    endif    
  else if (loff.ne.0 .or. moff.ne.0) then
    call mosaic_getfields (duv,np,nv,loff,moff,nf,map%offxy)
    if (nf.gt.1) then
      map%nfields = -nf
      write(chain,'(I12)') nf
      call map_message(seve%i,'READ','Raw mosaic of '//adjustl(trim(chain))//' fields')
    else
      map%nfields = 0
      call map_message(seve%w,'READ','Degenerate raw mosaic of 1 field')
    endif
  else if (xoff.ne.0 .or. yoff.ne.0) then
    call mosaic_getfields (duv,np,nv,xoff,yoff,nf,map%offxy)
    if (nf.gt.1) then
      map%nfields = nf
      write(chain,'(I12)') nf
      call map_message(seve%i,'READ','Phase shifted mosaic of '//adjustl(trim(chain))//' fields')
    else
      map%nfields = 0
      call map_message(seve%w,'READ','Degenerate phase shifted mosaic of 1 field')
    endif
  endif
  !
  if (map%nfields.eq.0) return
  !
  ! Convention for Rotated UV data is still pending for Mosaics
  if (huv%gil%pang.ne.0.) then
    call map_message(seve%e,'READ','Rotated UV data not yet supported for Mosaics (no convention defined by IRAM)')
    huv%loca%size = 0 ! Set UV as undefined
    error = .true.
    return
  endif
  !
  if (huv%gil%nteles.le.0) then
    call map_message(seve%w,'READ','No Telescope section in data') 
    call map_message(seve%r,'READ', &
      &   '         Use command "SPECIFY TELESCOPE Name" to add one') 
  endif
  ! 
  call get_bsize(huv,'READ',' ',map%bsize,error)  ! Compute the primary beams
  !
  ! Compute the Pointing Centers
  call gwcs_projec(huv%gil%a0, huv%gil%d0, huv%gil%pang, huv%gil%ptyp, uv_proj, error)
  allocate(map%centers(2,abs(map%nfields)),stat=ier)
  !
  do i=1,abs(map%nfields)
    call rel_to_abs(uv_proj, dble(map%offxy(1,i)), dble(map%offxy(2,i)), &
      & map%centers(1,i), map%centers(2,i), 1)
  enddo
  !
  call define_fields(map,error)
end subroutine check_uvdata_type
!
subroutine define_fields(map,error)  
  use image_def
  use clean_def
  use gkernel_interfaces
  !
  type(uvmap_par), intent(in) :: map
  logical, intent(inout) :: error
  !
  integer(kind=index_length) :: dim(2)
  !
  call sic_defstructure('FIELDS',.true.,error)
  call sic_def_inte('FIELDS%N',map%nfields,0,dim,.false.,error)
  dim(1:2) = [2,abs(map%nfields)]
  call sic_def_real('FIELDS%OFFSETS',map%offxy,2,dim,.false.,error) 
  call sic_def_real('FIELDS%PRIMARY',map%bsize,0,dim,.false.,error)
  call sic_def_dble('FIELDS%CENTERS',map%centers,2,dim,.false.,error) 
end subroutine define_fields
!
function tab_range (nc,hin,hou,subset)
  use image_def
  use gkernel_interfaces, only : gdf_range
  !---------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Define channel range and set output Table header
  ! accordingly. Valid for a CLASS Table of Spectra
  !---------------------------------------------------
  logical :: tab_range ! intent(out)
  integer, intent(in) :: nc(2)         ! Input channel range
  type (gildas), intent(inout) :: hin     ! Input header
  type (gildas), intent(inout) :: hou     ! Output header
  logical, intent(out) :: subset
  !
  integer local_nc(2), hdim, faxi
  integer(kind=index_length) :: fdim
  !
  subset = .false.
  ! Copy header
  call gdf_copy_header(hin, hou, tab_range)
  if (tab_range) return
  hou%loca = hin%loca
  !
  ! Find out the actual range
  faxi = hin%gil%faxi
  local_nc = nc
  fdim = hin%gil%dim(faxi)-3
  tab_range = gdf_range(local_nc,fdim).ne.0
  if (tab_range) return
  hdim = local_nc(2) - local_nc(1) + 1 + 3 ! Allow 3 additional columns
  !
  ! Set the input header subset range
  local_nc = local_nc+3                    ! Shift by the 3 columns
  hin%blc(faxi) = local_nc(1)
  hin%trc(faxi) = local_nc(2)
  !
  ! Set the output header reference channel and number of channels
  hou%gil%ref(faxi) = hou%gil%ref(faxi)+1-max(hin%blc(faxi)-3,1)
  hou%gil%dim(faxi) = hdim
  !
  ! Correct the data size
  hou%loca%size = hin%loca%size*hou%gil%dim(faxi)/hin%gil%dim(faxi)
end function tab_range
!
subroutine check_view(n,argu)
  ! @ public-mandatory
  integer, intent(in) :: n
  character(len=*), intent(in) :: argu(n)
  !
  logical :: error
  character(len=12) :: previous
  integer :: i,nn
  !
  ! Do not use commands here, only direct SIC routines
  call sic_get_char('VIEW%PREVIOUS',previous,nn,error)
  do i=1,n
    if (previous.eq.argu(i)) then    
      call sic_let_char('VIEW%PREVIOUS','outdated',error)
    endif
  enddo
end subroutine check_view
!

subroutine uv_extract_main(line, error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_extract_main
  use gbl_message
  use clean_arrays
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  ! Command line interaction for UV_EXTRACT command
  !----------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out)            :: error ! Error flag
  !
  character(len=*), parameter  :: rname='UV_EXTRACT'
  integer, parameter           :: opt_rang=1 ! option for range
  integer, parameter           :: opt_freq=2 ! option for frequency
  integer, parameter           :: opt_widt=3 ! option for width
  integer, parameter           :: nunits =3
  character(len=10)            :: units(3)
  data units/'CHANNEL','FREQUENCY','VELOCITY'/
  !
  real(kind=4)      :: range(2)         ! Range of channels, velocities or frequencies
  integer           :: chlength         ! Argument length
  integer           :: centralchannel   ! Central channel in case of /frequency usage
  real(kind=8)      :: frequency        ! Frequency around which to extract signal
  real(kind=4)      :: width            ! Width to extract around frequency in unit
  integer           :: channels(2)      ! Limits for the new UV table in channels
  character(len=10) :: unitin           ! Input unit
  character(len=10) :: unit             ! Treated unit
  integer           :: dummy            ! dummy integer for one off operations
  !
  ! Initialization
  !
  width = 1
  unitin = 'CHANNEL'
  !
  ! Interface
  !
  if (huv%loca%size.eq.0) then
     call map_message(seve%e,rname,'No UV data loaded')
     error = .true.
     return
  endif
  if (sic_present(opt_freq,0).and.sic_present(opt_rang,0)) then
     call map_message(seve%e,rname,"Options /FREQUENCY and /RANGE are mutually exclusive.")
     error = .true.
     return
  else if (sic_present(opt_freq,0)) then
     call sic_r8(line, opt_freq, 1, frequency, .true., error)
     if (sic_present(opt_widt,0)) then
        call sic_r4(line, opt_widt, 1, width, .true., error)
        call sic_ke(line, opt_widt, 2, unitin, chlength, .false., error)
     endif
     call sic_ambigs (rname,unitin,unit,chlength,units,nunits,error)
     if (error) return
     !
     ! Transform frequency + width to range
     !
     call uv_spectral_frequency_sel(frequency, width, unit, channels, error)
  else if (sic_present(opt_rang,0)) then
     call sic_r4(line, opt_rang, 1, range(1), .true., error)
     call sic_r4(line, opt_rang, 2, range(2), .true., error)
     call sic_ke(line, opt_rang, 3, unitin, chlength, .false., error)
     call sic_ambigs (rname,unitin,unit,chlength,units,nunits,error)
     if (error) return
     !
     ! Go from range to channels
     !
     call uv_spectral_range_sel(range, unit, channels, error)
  else
     call map_message(seve%e,rname,"Options /RANGE OR /FREQUENCY must be present.")
     error = .true.
     return
  endif
  !
  call uv_extract_sub(channels, error)
end subroutine uv_extract_main
!
subroutine uv_extract_sub(channels, error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_extract_sub
  use clean_def
  use clean_types
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !    Support routine for command UV_extract
  !    Extract a range of channels from a UV table
  !----------------------------------------------------------
  integer, intent(in)         :: channels(2) ! Limits for the new UV table in channels
  logical, intent(inout)      :: error       ! Error flag
  !
  character(len=*), parameter :: rname='UV_EXTRACT'
  !
  integer                     :: nchan             ! Number of channels of new UV table  
  type(gildas)                :: tempuv            ! Temporary UV buffer to store cropped UV table
  real, pointer               :: duv_previous(:,:) ! original UV buffer pointer
  real, pointer               :: duv_next(:,:)     ! Destiny UV buffer pointer
  integer                     :: ier               ! Integer error flag
  ! the following two variable have to be Kind 4 for compatibility with buffer initiliazation
  integer(kind=4)             :: nvisi             ! Number of Vibilities
  integer(kind=4)             :: ncols             ! Number of columns in output
  integer(kind=index_length)  :: lastc             ! Last channel to be copied
  integer(kind=index_length)  :: ivisi             ! Index for loop over visibilities
  integer(kind=index_length)  :: firstcolin        ! First column of extractable data in UV buffer
  integer(kind=index_length)  :: lastcolin         ! Last column of extractable data in UV buffer
  integer(kind=index_length)  :: firstcolout       ! First column of data in temporary UV buffer
  integer(kind=index_length)  :: lastcolout        ! Last column of data in temporary UV buffer
  integer(kind=4)             :: icol              ! Index to loop through columns
  !
  nchan = channels(2)-channels(1)+1  
  !
  ! Create, fill header and allocate internal UV buffer for data manipulation
  !
  call gildas_null(tempuv, type= 'UVT')
  call gdf_copy_header(huv, tempuv, error)
  if (error) then
     call map_message(seve%e,rname,"Failed to copy header from buffer UV table into temporary buffer")
     return
  endif
  !
  ! Fixing header
  !
  tempuv%gil%nchan = nchan
  tempuv%gil%ref(1) = huv%gil%ref(1)-channels(1)+1
  tempuv%gil%fcol = tempuv%gil%nlead+1
  tempuv%gil%lcol = tempuv%gil%nlead + tempuv%gil%natom*tempuv%gil%nchan
  tempuv%gil%dim(1) = tempuv%gil%lcol + tempuv%gil%ntrail
  ncols = tempuv%gil%dim(1)
  nvisi = tempuv%gil%dim(2)
  !
  ! Shift the trailing columns of the output table by the right amount
  do icol=1,code_uvt_last
    if (huv%gil%column_pointer(icol).gt.huv%gil%lcol) then
      !!Print *,'Shifting ',l,' by ',-huvin%gil%lcol+huvou%gil%lcol
      tempuv%gil%column_pointer(icol) = &
        huv%gil%column_pointer(icol) - (huv%gil%lcol-tempuv%gil%lcol)
    endif
  enddo
  !
  ! Define initial points for copy
  !
  if (channels(1).ge.1.and.channels(1).le.huv%gil%nchan) then
     firstcolin = huv%gil%nlead+(channels(1)-1)*huv%gil%natom+1
     firstcolout = tempuv%gil%nlead+1
  else if (channels(1).lt.1) then
     firstcolin = huv%gil%nlead+1
     firstcolout = tempuv%gil%nlead+(abs(channels(1))+1)*huv%gil%natom+1
     if (firstcolout.gt.(tempuv%gil%dim(1)-tempuv%gil%ntrail)) then
        firstcolin = -1 ! this means nothing to copy
     endif
  else if (channels(1).gt.huv%gil%nchan) then
     firstcolin = -1 ! this means nothing to copy
  endif
  !
  ! Define final points for copy
  !
  if (channels(2).ge.1.and.channels(2).le.huv%gil%nchan) then
     lastcolin = huv%gil%nlead+channels(2)*huv%gil%natom
     lastcolout = tempuv%gil%nlead+tempuv%gil%nchan*tempuv%gil%natom
  else if (channels(2).lt.0) then
     firstcolin = -1 ! this means nothing to copy
  else if (channels(2).gt.huv%gil%nchan) then
     lastcolin = huv%gil%dim(1)-tempuv%gil%ntrail
     lastc = nchan-huv%gil%nchan ! last copy channel
     lastcolout = tempuv%gil%nlead+(lastc+huv%gil%nchan)*tempuv%gil%natom
  endif
  !
  ! Define previous and destiny buffers
  !
  nullify (duv_previous, duv_next)
  call uv_find_buffers (rname,ncols,nvisi,duv_previous, duv_next,error)
  if (error) then
     call map_message(seve%e,rname,'Cannot set buffer pointers')
     return
  endif
  ! Zero out output UV table to simplify copy operations
  duv_next(:,:) = 0.0
  !
  ! Now copy only the wanted channels to the temporary buffer, parallelizable on the visibilities
  !   
  !$OMP PARALLEL &
  !$OMP DEFAULT(none) &
  !$OMP SHARED(huv, duv_previous, duv_next, tempuv, firstcolin, lastcolin, firstcolout, lastcolout, nvisi) &
  !$OMP PRIVATE(ivisi)
  !$OMP DO
  do ivisi=1, nvisi
     ! Copy first columns
     duv_next(1:huv%gil%nlead,ivisi) = duv_previous(1:huv%gil%nlead,ivisi)
     ! Copy data, if there is any data to copy
     if (firstcolin.ne.-1) duv_next(firstcolout:lastcolout,ivisi) = duv_previous(firstcolin:lastcolin,ivisi)
     ! Copy trailing columns if any
     if (tempuv%gil%ntrail.gt.0) then
        duv_next(tempuv%gil%dim(1)-tempuv%gil%ntrail+1:tempuv%gil%dim(1),ivisi) =   &
             &     duv_previous(huv%gil%dim(1)-huv%gil%ntrail+1:huv%gil%dim(1),ivisi)  
     endif
  end do
  !$OMP END DO
  !$OMP END PARALLEL  
  !
  ! Now Copy header from tempuv to huv, and handle buffers
  !
  call gdf_copy_header(tempuv, huv, error)
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  ! Redefine SIC variables 
  call sic_delvariable ('UV',.false.,error)
  call sic_mapgildas ('UV',huv,error,duv) 
end subroutine uv_extract_sub

module gtemplate_interfaces_none
  interface
    subroutine gtemplate_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine gtemplate_pack_set
  end interface
  !
  interface
    subroutine gtemplate_pack_init(gpack_id,error)
      !----------------------------------------------------------------------
      ! 
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine gtemplate_pack_init
  end interface
  !
  interface
    subroutine gtemplate_pack_clean(error)
      !----------------------------------------------------------------------
      ! Called at end of session. Might clean here for example global buffers
      ! allocated during the session
      !----------------------------------------------------------------------
      logical :: error
    end subroutine gtemplate_pack_clean
  end interface
  !
  interface
    subroutine gtemplate_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gtemplate_message_set_id
  end interface
  !
  interface
    subroutine gtemplate_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gtemplate_message
  end interface
  !
  interface
    subroutine gtemplate_load
      !---------------------------------------------------------------------
      ! Define and load languages of the package.
      !---------------------------------------------------------------------
      ! Global
    end subroutine gtemplate_load
  end interface
  !
  interface
    subroutine gtemplate_run(line,comm,error)
      !---------------------------------------------------------------------
      ! Support routine for the language GTEMPLATE.
      ! This routine is able to call the routines associated to each
      ! command of the language GTEMPLATE
      !---------------------------------------------------------------------
      use gbl_message
      character(len=*),  intent(in)    :: line   ! Command line to send to support routines
      character(len=12), intent(in)    :: comm   ! Command resolved by the SIC interpreter
      logical,           intent(inout) :: error  ! Logical error flag
    end subroutine gtemplate_run
  end interface
  !
  interface
    function gtemplate_error()
      !---------------------------------------------------------------------
      ! Support routine for the error status of the library. Does nothing
      ! here.
      !---------------------------------------------------------------------
      logical :: gtemplate_error
    end function gtemplate_error
  end interface
  !
  interface
    subroutine gtemplate_void(line,error)
      !---------------------------------------------------------------------
      ! Does nothing more than returning asap
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gtemplate_void
  end interface
  !
  interface
    subroutine gtemplate_dummy(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Support routine for command DUMMY
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gtemplate_dummy
  end interface
  !
end module gtemplate_interfaces_none

!
subroutine map_parameters(task,map,freq,uvmax,uvmin,error,print)
  use gkernel_interfaces
  use mapping_interfaces, only: map_message, primary_beam
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! Prepare the MAP parameters for UV_MAP, MX or UV_RESTORE
  ! Reads this from SIC variables
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: task ! Input task name (UV_MAP or MX)
  type (uvmap_par), intent(inout) :: map  ! Map parameters
  real(8), intent(inout) :: freq          ! Observing frequency
  real(4), intent(in) :: uvmax, uvmin     ! Min & Max UV in m
  logical, intent(inout) :: error
  logical, optional :: print
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  real(4), parameter :: pixel_per_beam=5.0
  real(4) :: map_range(2)  ! Range of offsets
  character(len=80) :: chain
  character(len=12) :: prefix
  real :: uvmi, uvma, xp, xm, diam, hppb, rsize, bsize
  integer :: i, ms, k, np, isize
  type (uvmap_par), save :: last_map
  logical :: do_print
  integer :: osize(2)
  logical, parameter :: fromressection=.true.
  !
  do_print = present(print)
  !
  ! For UV_STAT, reset all parameters to Zero
  if (task.eq.'UV_STAT') then
    map%size = 0
    map%field = 0
    map%xycell = 0
  endif
  !
  freq = gdf_uv_frequency(huv)
  if (do_print) then                                            
    write(chain,'(A,F12.6,A)') "Observed rest frequency       ", &
      & freq*1d-3," GHz"
    call map_message(seve%i,task,chain)
  endif
  !
  uvma = uvmax/(freq*f_to_k)
  uvmi = uvmin/(freq*f_to_k)
  if (do_print) then
    write(chain,100) huv%gil%dim(2),huv%gil%nchan
    call map_message(seve%i,task,chain)
    write(chain,101) uvmi,uvma,' meters'
    call map_message(seve%i,task,chain)
    write(chain,101) uvmin*1e-3/2.0/pi,uvmax*1e-3/2.0/pi,' kiloWavelength'
    call map_message(seve%i,task,chain)
  endif
  !
  ! Get beam size (in radians)
  bsize = primary_beam(task,huv,fromressection)
  !
  if (bsize.eq.0) then
    !
    ! Default to IRAM Plateau de Bure case
    hppb = 63.0*(12.0/15.0)*(100.e3/freq) ! ["] Primary beam size
    write(chain,'(A,F12.1,A)') "Half power primary beam defaulted to ", &
      & hppb," arcsec"
    call map_message(seve%w,task,chain)                         
    bsize = hppb*pi/3600.0/180.0
  else if (do_print .or. map%size(1).eq.0) then                                           
    write(chain,'(A,F12.1,A)') "Half power primary beam       ", &
      & bsize*180*3600/pi," arcsec"
    call map_message(seve%i,task,chain)                         
  endif
  hppb = bsize*3600.*180./pi                                                        
  !
  ! Only 2 out of the 3 MAP_FIELD, MAP_SIZE and MAP_CELL
  !   can be non-zero. This should be tested in some way
  !
  if (map%xycell(1)*map%size(1)*map%field(1).ne.0) then
    if (abs(map%field(1)-map%size(1)*map%xycell(1)).gt.0.01*map%field(1)) then
      call map_message(seve%w,task,'User specified MAP_FIELD, MAP_SIZE and MAP_CELL do not match')
    else
      call map_message(seve%w,task,'MAP_FIELD, MAP_SIZE and MAP_CELL specified by user')    
    endif
  endif
  !
  ! Now get MAP_CELL and MAP_SIZE if Zero.
  if (map%xycell(1).eq.0) then
    if (map%size(1)*map%field(1).eq.0) then
      map%xycell(1) = 0.01*nint(360.0*3600.0*100.0/uvmax/pixel_per_beam)
      if (map%xycell(1).le.0.02) then
        map%xycell(1) =   &
             &        0.002*nint(360.0*3600.0*500.0/uvmax/pixel_per_beam)
      endif
      map%xycell(2) = map%xycell(1)  ! In ", rounded to 0.02 or 0.002"
    else
      map%xycell(1) = map%field(1)/map%size(1)
      map%xycell(2) = map%xycell(1)
    endif
  endif
  !
  ! Get MAP_SIZE if non Zero
  if (map%size(1).ne.0) then
    if (map%size(2).eq.0) map%size(2) = map%size(1)
    if (map%field(1).eq.0) map%field = map%size * map%xycell
  endif
  !
  ! Get a wide enough field of view (in ")
  if (map%field(1).ne.0) then
    if (map%field(2).eq.0) map%field(2) = map%field(1)
  else
    !
    if (map%nfields.ne.0) then
      ! The factor 2.5 on the primary beam size is to go down 
      ! low enough by default
      map%field = 2.5*hppb
      ! Enlarge the field of view by the Offset range
      np = abs(map%nfields)
      xm = minval(map%offxy(1,1:np))
      xp = maxval(map%offxy(1,1:np))
      map_range(1) = xp-xm
      xm = minval(map%offxy(2,1:np))
      xp = maxval(map%offxy(2,1:np))
      map_range(2) = xp-xm
      map_range = map_range*180*3600/pi
      !
      map%field = map%field + map_range
    else
      ! The factor 2 on the primary beam size is to go down to 6.25 % level by default
      map%field(1) = 2*hppb
      ! Map Field = 1.13*Lambda/Dmin - but round to 1.3
      if (uvmin.ne.0) then
        map%field(2) = 2.6*360*3600/uvmin ! " In arcsec
      else
        map%field(2) = map%field(1)
      endif
      ! The Min is to avoid going to very large images when uvmin is close to 0
      ! e.g. when short or Zero spacings have been added
      map%field = min(map%field(1),map%field(2))    
    endif
  endif
  !
  if (map%size(1).eq.0) then
    !
    map%size = map%field/map%xycell !
    !
    ! map%size =   2**nint(log(real(map%size))/log(2.0))
    call gi4_round_forfft(map%size(1),osize(1),error,map_rounding,map_power)
    call gi4_round_forfft(map%size(1),osize(2),error,map_rounding,map_power)
    map%size = osize
  else if ( (mod(map%size(1),2).ne.0) .or. (mod(map%size(2),2).ne.0) ) then
    call map_message(seve%e,task,'Number of pixels (MAP_SIZE) must be even')
    error = .true.
  endif
  !
  if (task.eq.'UV_STAT') then
    prefix = 'Recommended '
  else
    if (error) return
    prefix = 'Current '
  endif
  write(chain,'(A,A,F12.1,a,F12.1,A)') prefix,'Field of view / Largest Scale ' &
    & ,map%field(1),' x ',map%field(2),' "'
  call map_message(seve%i,task,chain)
  write(chain,'(A,A,F11.1,A,F11.1,A)') prefix,'Image size ', &
    & map%size(1)*map%xycell(1),' x ',map%size(2)*map%xycell(2),'" '
  call map_message(seve%i,task,chain)
  !
  write(chain,'(A,A,I0,A,I0,A)') prefix,'Map size ', &
    & map%size(1),' x ',map%size(2)
  call map_message(seve%i,task,chain)
  write(chain,'(A,A,F8.3,A,F8.3,A)') prefix,'Pixel size ', &
    & map%xycell(1),' x ',map%xycell(2),' "'
  call map_message(seve%i,task,chain)
  !
  ! Do NOT adjust the Field while keeping the Cell size 
  !     map%field = map%size * map%xycell
  ! it is useless or incorrect...
  !
  if (task.eq.'UV_STAT') return
  ! This part is only for UV_MAP / UV_MOSAIC, not for UV_STAT
  !
  ! Check whether Weights have to be recomputed
  if (map%mode.ne.last_map%mode) do_weig = .true.
  if (map%mode.ne.'NATURAL ') then
    if (map%uniform(1).ne.last_map%uniform(1)) do_weig = .true.
    if (map%uniform(2).ne.last_map%uniform(2)) do_weig = .true.
  endif
  if (map%ctype.ne.last_map%ctype) do_weig = .true.
  do i=1,4
    if (map%taper(i).ne.last_map%taper(i)) do_weig = .true.
  enddo
  last_map = map
  !
  ! Subroutine DOWEI uses map%uniform = 0.0 for Natural Weighting
  if (map%mode.eq.'NATURAL ') map%uniform(1) = 0
  !
100 format('Found ',i12,' Visibilities, ',i4,' channels')
101 format('Baselines ',f9.1,' - ',f9.1,a)
103 format('Map size is   ',i4,' by ',i4)
104 format('Pixel size is ',f8.3,' by ',f8.3,'"')
end subroutine map_parameters
!
subroutine uv_stat_comm(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_stat_comm
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for command UV_STAT
  !       Analyse a UV data set to define approximate beam size,
  !       field of view, expected "best beam", etc...
  ! Input :
  !     a precessed UV table
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !     a beam image ?
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  integer, parameter :: mt=100
  integer datelist(mt)
  !
  type (uvmap_par), save :: amap  ! To get the New variable names
  !
  integer i
  integer ndates
  character(len=8) mode, argum
  character(len=4) :: wei
  real, allocatable :: beams(:,:), fft(:)
  real uv_taper(3),map_cell(2),uniform(2),uvmax,uvmin,uvm
  real start,step,taper
  integer map_size(2),wcol,ctype,n,mcol(2),ier,nu,nv,noff
  integer(kind=index_length) :: dim(4)
  logical sorted, shift
  real(kind=8) :: freq, new(3)
  real(kind=4) :: map_field(2)
  real(4), save :: bmax, bmin
  logical, save :: first = .true.
  real, save :: result(10,8)
  logical :: print
  character(len=message_length) :: chain
  character(len=7) :: rname = 'UV_STAT'
  integer, parameter :: mmode=8
  character(len=8) :: smode(mmode)
  data smode /'ADVISE','ALL','BEAM','CELL','HEADER','SETUP','TAPER','WEIGHT'/
  !
  if (sic_present(0,1)) then
    call sic_ke(line,0,1,argum,n,.false.,error)
    if (error) return
    call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
    if (error) return
  else
    mode = 'ALL'
  endif
  !
  freq = gdf_uv_frequency(huv)
  !
  select case (mode)
  case ('CELL','TAPER','WEIGHT')
    !
    start = 0.0
    call sic_r4(line,0,2,start,.false.,error)
    start = abs(start)
    step = 0.0
    call sic_r4(line,0,3,step,.false.,error)
    step = abs(step)
    !
    ctype = 1
    ! That is no longer correct -
!    call sic_get_real('UV_TAPER[1]',uv_taper(1),error)
!    if (error) return
!    call sic_get_real('UV_TAPER[2]',uv_taper(2),error)
!    call sic_get_real('UV_TAPER[3]',uv_taper(3),error)
!    call sic_get_real('UV_CELL[1]',uniform(1),error)
!    call sic_get_real('UV_CELL[2]',uniform(2),error)
!    call get_weightmode(rname,wei,error)
    !
    ! Must do like UV_MAP now
    call map_prepare(rname,amap,error)
    uniform(:) = amap%uniform(:)
    uv_taper(:) = amap%taper(1:3) 
! Unclear ...
!    call sic_get_inte('WCOL',wcol,error)
! This were useless anyway...
!    call sic_get_inte('MCOL[1]',mcol(1),error)
!    call sic_get_inte('MCOL[2]',mcol(2),error)
!    !
    if (error) return
    !
    ! First sort the input UV Table, leaving UV Table in UV_*
    shift = .false.
    call uv_sort (error,sorted,shift,new,uvmax,uvmin)
    if (error) return
  case ('ADVISE','ALL','HEADER','SETUP','BEAM')
    ! For HEADERS, do the minimum work for speed...
    ! The UV table is available in HUV%
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    call uvgmax (huv,duv,uvmax,uvmin)
    ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
    uvmax = uvmax*freq*f_to_k
    uvmin = uvmin*freq*f_to_k
    error = .false.
  end select
  !
  ! New code: For the time being, this is somewhat inconsistent
  ! with the use of uv_sort which uses a different frequency
  !
  bmax = uvmax/(freq*f_to_k)
  bmin = uvmin/(freq*f_to_k)
  if (first) then
!    call sic_defstructure('UVSTAT',.true.,error)
!    call sic_def_real('UVSTAT%BMAX',bmax,0,dim,.false.,error)
!    call sic_def_real('UVSTAT%BMIN',bmin,0,dim,.false.,error)
    call sic_def_real('UV_BMAX',bmax,0,dim,.false.,error)
    call sic_def_real('UV_BMIN',bmin,0,dim,.false.,error)
    first = .false.
  endif
  !
  ! That's all for HEADER
  select case (mode)
  case ('BEAM') 
    call map_beamsize(huv,duv,bmax,error)
  case ('HEADER')
    call gdf_print_header(huv)
    call uv_listheader(huv,duv,mt,datelist,ndates,freq)
    call uv_printoffset('HEADER',themap)
  case ('ADVISE')
    call map_copy_par(default_map,themap)
    call map_parameters(rname,themap,freq,uvmax,uvmin,error,print)
    error = .false.
  case ('ALL')
    call gdf_print_header(huv)
    call uv_listheader(huv,duv,mt,datelist,ndates,freq)
    call uv_printoffset('HEADER',themap)
    call map_copy_par(default_map,themap)
    call map_parameters(rname,themap,freq,uvmax,uvmin,error,print)
  case ('SETUP')
    call map_copy_par(default_map,themap)
    call map_parameters(rname,themap,freq,uvmax,uvmin,error,print)
    if (error) return
    call map_copy_par(themap,default_map) ! Copy Back ...
    error = .false.
  case default
    !
    ! back to usual code
    uvm = uvmax/(freq*f_to_k)
    !
    if (mode.eq.'TAPER') then
      if (step.eq.0.) step = sqrt(2.0)
      if (start.eq.0.) start = 10*nint(uvm/160.0)
      taper = 16*start
!      if (wei.eq.'NATU') then
!        uniform(1) = 0.
!        uniform(2) = 0.
!     endif
    else
      taper = sqrt(uv_taper(1)*uv_taper(2))
      if (taper.ne.0) then
        taper = min(taper,uvm)
      else
        taper = uvm
      endif
    endif
    !
    ! Define MAP_CELL and MAP_SIZE
    taper = uvm*freq*f_to_k
    map_cell(1) = 0.02*nint(180.0*3600.0*50.0/taper/4.0)
    if (map_cell(1).le.0.02) then
      map_cell(1) = 0.002*nint(180.0*3600.0*500.0/taper/4.0)
    endif
    map_cell(2) = map_cell(1)    ! In ", rounded to 0.01"
    if (mode.eq.'TAPER') then
      map_size(1) = 256
      map_size(2) = 256
    else
      map_size(1) = 64
      map_size(2) = 64
    endif
    !
    write(chain,102) uvm,uvmax*1e-3/2.0/pi
    call map_message(seve%i,rname,chain)
    write(chain,103) map_size
    call map_message(seve%i,rname,chain)
    write(chain,104) map_cell
    call map_message(seve%i,rname,chain)
    !
    ! Redefine some parameters
    map_cell(1) = map_cell(1)*pi/180.0/3600.0   ! In radians
    map_cell(2) = map_cell(2)*pi/180.0/3600.0
    !
    ! Process sorted UV Table according to the type of beam produced
    n = 2*max(map_size(1),map_size(2))
    allocate (beams(map_size(1),map_size(2)),fft(n),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation failure')
      error = .true.
      return
    endif
    call uniform_beam (' ',uv_taper,   &
       &    map_size,map_cell,uniform,wcol,mcol,fft,   &
       &    error,mode,beams,1,start,step,uvm,result,huv,duv)
    deallocate (beams,fft)
    !
    call sic_delvariable('BEAM_SHAPE',.false.,error)
    dim(1) = 10
    dim(2) =  8
    call sic_def_real('BEAM_SHAPE',result,2,dim,.true.,error)
    error = .false.
  end select
  !
  102   format('Maximum baseline is   ',f8.1,' m,  ',f8.1,' kWavelength')
  103   format('Map size is   ',i4,' by ',i4)
  104   format('Pixel size is ',f6.3,' by ',f5.3,'"')
end subroutine uv_stat_comm
!
subroutine uv_printoffset(rname,map)
  use clean_def
  use gbl_message
  use mapping_interfaces, only : map_message
  ! @ private
  character(len=*), intent(in) :: rname
  type(uvmap_par), intent(in) :: map
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(4), parameter :: rad_to_sec = 180.0*3600.0/pi
  integer :: n,j
  character(len=60) :: chain
  !
  if (map%nfields.eq.0) return
  !
  n = abs(map%nfields)
  if (map%nfields.lt.0) then
    write(chain,'(I5,A)') n, ' Phase offsets in mosaic'
  else
    write(chain,'(I5,A)') n, ' Pointing offsets in mosaic'
  endif
  call map_message(seve%i,rname,chain)
  do j=1,n-1,2
    write(*,'(2(A,F12.4,A,F12.4,A))') &
    &   '(',map%offxy(1,j)*rad_to_sec,' ,',map%offxy(2,j)*rad_to_sec,' )', &
    &   '(',map%offxy(1,j+1)*rad_to_sec,' ,',map%offxy(2,j+1)*rad_to_sec,' )'
  enddo
  if (mod(n,2).ne.0)     write(*,'(A,F12.2,A,F12.2,A)') &
    &   '(',map%offxy(1,n)*rad_to_sec,' ,',map%offxy(2,n)*rad_to_sec,' )'
end subroutine uv_printoffset
!
!
subroutine map_beamsize(huv,duv,uvmax,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  !
  ! @ public
  !     Get the natural synthesized beam size
  !
  type(gildas), intent(in) :: huv   ! UV Header
  real, intent(in) :: duv(:,:)      ! UV data
  real, intent(in) :: uvmax         ! Maximum UV value
  logical, intent(out) :: error     ! Error flag
  !
  character(len=*), parameter :: rname='MAP_BEAMSIZE'
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Customized values
  real(4) :: pixel_per_beam=4.0     ! A good compromise
  integer, parameter :: nsize=128   ! Large enough for most cases
  real, save :: abeam(nsize,nsize), work(2*nsize)
  ! FFT arrays
  complex :: ipft(nsize*nsize), ipf(nsize*nsize)
  integer :: lx,ly,lw, nu,nv, nx,ny, ix_patch, iy_patch
  integer :: ndim, nn(2)
  real :: uvcell, map_cell, thre, rtmp
  real(kind=8) :: convert(6)
  real :: major_axis, minor_axis, pos_angle 
  !
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi
  lx = nsize  ! Grid size
  ly = nsize
  nx = nsize  ! Map size
  ny = nsize
  !
  ! Compute FFT's
  lw = max(10,7 + 3*(2*huv%gil%nchan/3))   ! Weight channel
  !
  ! Make sure all baselines are accounted for
  ! and beam is properly sampled
  uvcell = 2.0*uvmax/(lx-2)  * pixel_per_beam  
  !
  call doqfft (nu,nv,   &      ! Size of visibility array
     &    duv,          &      ! Visibilities
     &    1,2,lw,       &      ! U, V pointers
     &    lx,ly,        &      ! Cube size
     &    ipft,         &      ! FFT cube
     &    uvcell)              ! U and V grid coordinates
  !
  ! Make beam, not normalized
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ipf,nn,ndim,-1,1)
  call extracs(1,nx,ny,1,ipft,ipf,lx,ly)
  call fourt  (ipf,nn,ndim,-1,1,work)
  call cmtore (ipf,abeam,nx,ny)
  !
  ! Normalize beam - no grid correction needed here
  rtmp = abeam(nx/2+1,ny/2+1)
  abeam = abeam/rtmp
  !
  ! Define MAP_CELL
  rtmp = uvmax*huv%gil%freq*f_to_k
  map_cell = 0.002*nint(180.0*3600.0*500.0/rtmp/pixel_per_beam)
  map_cell = map_cell*pi/180.0/3600.0
  convert = (/dble(nx/2+1),0.d0,-dble(map_cell),   &
     &    dble(ny/2+1),0.d0,dble(map_cell)/)
  !
  ! Get Fitting Threshold 
  rtmp  = minval(abeam(:,:)) 
  thre = max(min(abs(-1.5*rtmp),0.7),0.3)
  !
  ! Fit beam
  ix_patch = nx/2
  iy_patch = ny/2
  major_axis = 0.
  minor_axis = 0.
  pos_angle  = 0.
  call fibeam (rname,abeam,nx,ny,   &
   &      ix_patch,iy_patch,thre,   &
   &      major_axis,minor_axis,pos_angle,   &
   &      convert,error)
  !
  if (sic_present(0,2)) then
    call gr_exec('CLEAR')
    call gr4_rgive(nx,ny,convert,abeam)
    call gr_exec('LIMITS /RG')
    call gr_exec('SET BOX SQUARE')
    call gr_exec('PLOT')
    call gr_exec('BOX /UNIT SEC')
    call gr_exec('WEDGE')
  endif
end subroutine map_beamsize

module clean_arrays
  use clean_def
  use image_def
  !
  ! Static variables first, allocatable next.
  !
  type (uvmap_par), save :: themap      ! UV_MAP parameters
  type (clean_par), target :: method, user_method ! CLEAN parameters
  type (gildas), save, target :: hbeam  ! Synthesized beam Header
  type (gildas), save, target :: hdirty ! Dirty image Header
  type (gildas), save, target :: hclean ! Clean image Header
  type (gildas), save, target :: hresid ! Residual image Header
  type (gildas), save, target :: hatten ! Field weights header
  type (gildas), save, target :: hprim  ! Primary beams Header
  type (gildas), save :: hfields        ! Fields Header
  type (gildas), save, target :: hcct   ! Clean component table Header
  type (gildas), save, target :: hmask  ! Mask Header
  type (gildas), save, target :: hsky   ! Sky brightness image Header
  !
  ! Self-calibration headers
  type (gildas), save :: hraw           ! Raw (non self-calibrated) UV header
  type (gildas), save :: hself          ! Self-calibrated UV header
  type (gildas), save :: hagain         ! Antenna-based gain Header
  type (gildas), save :: hbgain         ! Baseline-based gain Header
  !
  ! Short spacings
  type (gildas), save :: hsingle        ! Single Dish Cube or Table
  type (gildas), save :: hshort         ! Short spacing Cube 
  !
  ! These are UV data
  type (gildas), save, target :: huvi   ! Initial UV data Header
  type (gildas), save, target :: huv    ! Current UV data Header 
  type (gildas), save, target :: huvt   ! Transposed UV data Header
  type (gildas), save, target :: huvc   ! Continuum UV data Header
  type (gildas), save :: huvm           ! Model UV data Header
  !
  ! For the Multi-Primary beams Mosaic deconvolution
  ! C_ stands for "Compact Array"
  type (clean_par), target :: c_method, cuse_method
  type (gildas), save :: c_hbeam, c_hdirty, c_hresid, c_hclean
  type (gildas), save :: c_hprim
  !
  real, allocatable, save :: g_weight(:)  ! UV weights
  real, allocatable, save :: g_v(:)       ! V values
  logical, save :: do_weig                ! Optimization of weight computing
  !
  ! Imaging and deconvolution arrays
  real, allocatable, target, save :: dbeam(:,:,:,:)   ! 4-D
  real, allocatable, target, save :: ddirty(:,:,:)    ! Dirty 3-D 
  real, allocatable, target, save :: dclean(:,:,:)    ! Clean 3-D
  real, allocatable, target, save :: dresid(:,:,:)    ! Residual 3-D
  real, allocatable, target, save :: dprim(:,:,:,:)   ! Primary beam 4-D
  real, allocatable, target, save :: datten(:,:,:)    ! Mosaic weights 3-D
  real, allocatable, target, save :: dsky(:,:,:)      ! Primary beam corrected 3-D
  real, allocatable, target, save :: dfields(:,:,:,:) ! Mosaic fields 4-D
  !
  ! Deconvolution arrays
  real, allocatable, target, save :: dmask(:,:,:)     ! Input 3-D 0, #0 mask
  integer, allocatable, target, save :: d_list(:)     ! List of selected pixels
  logical, allocatable, target, save :: d_mask(:,:)   ! Logical mask for pixel selection
  real, allocatable, target, save :: dcct(:,:,:)      ! Clean component values
  type (cct_par), allocatable, save :: tcc(:)         ! Clean component list
  !
  ! These are UV data-like arrays
  real, pointer :: duv(:,:)                        ! Current UV data
  real, allocatable, target, save :: duvi(:,:)     ! Original UV data
  real, pointer :: duvr(:,:)                       ! "Resampled" UV data
  real, pointer :: duvs(:,:)                       ! "Sorted" UV data
  real, allocatable, target, save :: duvc(:,:)     ! Sorted or Unsorted Continuum UV data
  real, allocatable, target, save :: duvt(:,:)     ! Time-Baseline sorted UV data, for UV_FLAG
  real, allocatable, target, save :: duvm(:,:)     ! Model UV data
  real, allocatable, target, save :: duvbg(:,:)    ! Baseline Gains (UV data like)
  real, allocatable, target, save :: duvraw(:,:)   ! Raw UV data for Self calibration
  real, allocatable, target, save :: duvself(:,:)  ! Self calibrated UV data
  real, allocatable, target, save :: dagain(:,:)   ! Antenna based gain
  !
  ! Short spacing data array
  real, allocatable, target, save :: dsingle(:,:,:)   ! Short spacing data (Table or Cube)
  !! real, allocatable, target, save :: dshort(:,:,:)    ! Short spacing 3-D cube
  ! The above one is actually accessible by hshort%r3d only
  !
  ! For the Multi-Primary beams Mosaic deconvolution
  ! C_ stands for "Compact Array"
  real, allocatable, target, save :: c_dbeam(:,:,:)
  real, allocatable, target, save :: c_ddirty(:,:,:)
  real, allocatable, target, save :: c_dclean(:,:,:)
  real, allocatable, target, save :: c_dresid(:,:,:)
  real, allocatable, target, save :: c_dprim(:,:,:)
  logical, allocatable, target, save :: c_mask(:,:)
  integer, allocatable, target, save :: c_list(:)
  real, allocatable, target, save :: c_atten(:,:,:)  ! 3-D
  !
  integer :: niter_listsize=0
  integer, allocatable :: niter_list(:)
  integer :: ares_listsize=0
  real, allocatable :: ares_list(:)
  ! List of selected fields in UV_MAP (used for UV_RESTORE and
  ! also for SHOW FIELDS)
  integer :: selected_fieldsize=0
  integer, allocatable :: selected_fields(:)
end module clean_arrays
!
module moment_arrays
  use image_def
  ! Moment Images
  type(gildas), save :: hpeak, hmean, hvelo, hwidth
  real, allocatable, target, save :: dmean(:,:), dpeak(:,:), dvelo(:,:), dwidth(:,:)
  ! Flux spectra
  integer, target, save :: flux_nf=0
  integer, target, save :: flux_nc=0
  real(4), target, save, allocatable :: flux_velo(:)
  real(8), target, save, allocatable :: flux_freq(:)
  real(4), target, save, allocatable :: flux_values(:,:)
end module moment_arrays
!
module uvsplit_mod
  ! Module for the UV_SPLIT command
  use image_def
  !
  integer, parameter :: opt_chan=1
  integer, parameter :: opt_file=2
  integer, parameter :: opt_freq=3
  integer, parameter :: opt_range=4
  integer, parameter :: opt_velo=5
  integer, parameter :: opt_width=6
  integer, parameter :: opt_zero=7
  !
  character(len=filename_length) :: in_file
  character(len=filename_length) :: ou_file
  !
  type(gildas) :: hiuv
  type(gildas) :: houv
  type(gildas) :: hfuv
  integer :: nblock        ! Blocking factor
  integer :: ncompr        ! Channel compression factor
  logical :: use_file      ! /FILE option
  real :: edge_drop=0.05   ! Fraction of bandwidth dropped at edges for continuum
  !
end module uvsplit_mod
!
module clean_support
  use gkernel_types
  ! CLEAN\SUPPORT polygon, mapped on SUPPORT%
  type(polygon_t), save :: supportpol
  integer, save :: support_type  
  integer, parameter :: support_mask = 1 
  integer, parameter :: support_poly = -1
  integer, parameter :: support_none = 0
  character(len=varname_length), parameter :: supportvar='SUPPORT'
end module clean_support
!
module clean_types
  use gkernel_types
  integer mtype
  parameter(mtype=25)
  character(len=12) :: vtype(1:mtype) = (/ &
  &  'COVERAGE    ',  &
  &  'UV_DATA     ',  &
  &  'BEAM        ',  &
  &  'DIRTY       ',  &
  &  'CLEAN       ',  &
  &  'PRIMARY     ',  &
  &  'RESIDUAL    ',  &
  &  'MASK        ',  &
  &  'SUPPORT     ',  &
  &  'CCT         ',  &
  &  'MODEL       ',  &
  &  'SKY         ',  &
  &  'FIELDS      ',  &
  &  'CGAINS      ',  &
  &  'SELFCAL     ',  &
  &  'SHORT       ',  &
  &  'SINGLEDISH  ',  &
  &  'NOISE       ',  &
  &  'SNR         ',  &     ! NOISE and SNR are special, just for SHOW NOISE  
  &  'MOMENTS     ',  &     ! special, just for SHOW MOMENTS
  &  'COMPOSITE   ',  &     ! special, Moments + Flux on one plot
  &  'FLUX        ',  &     ! special, for SHOW FLUX and WRITE FLUX    
  &  'SOURCES     ',  &     ! special, for SHOW SOURCES
  &  'SPECTRA     ',  &     ! special, for SHOW SPECTRA 
  &  'UV_FIT      ' /)
  !
  character(len=12) :: etype(1:mtype) = (/ &
  & '.uvt        ',  &
  & '.uvt        ',  &
  & '.beam       ',  &
  & '.lmv        ',  &
  & '.lmv-clean  ',  &
  & '.lobe       ',  &
  & '.lmv-res    ',  &
  & '.msk        ',  &
  & '.pol        ',  &
  & '.cct        ',  &
  & '.uvt        ',  &
  & '.lmv-sky    ',  &
  & '.fields     ',  &
  & '.uvt        ',  &      
  & '.tab        ',  &
  & '.lmv-sky    ',  &
  & '.tab        ',  &
  & '            ',  &
  & '            ',  &
  & '            ',  &
  & '            ',  &
  & '.tab        ',  &
  & '            ',  &
  & '            ',  &
  & '.uvfit      '  /)       
  !
  integer, parameter :: mbuffer=27
  character(len=12) :: cbuffer(1:mbuffer) = (/ &
  &  'AGAINS      ',  &
  &  'BEAM        ',  &
  &  'CCT         ',  &
  &  'CGAINS      ',  &
  &  'CLEAN       ',  &
  &  'CLIPPED     ',  &  
  &  'CONTINUUM   ',  &
  &  'DIRTY       ',  &
  &  'EXTRACTED   ',  &
  &  'MASK        ',  &
  &  'M_AREA      ',  &
  &  'M_PEAK      ',  &
  &  'M_VELO      ',  &
  &  'M_WIDTH     ',  &
!  &  'MODEL       ',  &
  &  'PRIMARY     ',  &
  &  'RESIDUAL    ',  &
  &  'WEIGHT      ',  &
  &  'FIELDS      ',  &
  &  'SHORT       ',  &
  &  'SINGLE      ',  &
  &  'SKY         ',  &
  &  'SLICE       ',  &
  &  'SPECTRUM    ',  &
  &  'UV          ',  &
  &  'UV_FIT      ',  &
  &  'UVCONT      ',  &
  &  'UVRADIAL    '  /)  
  character(len=36) :: sbuffer(1:mbuffer) = (/ &
!     123456789 12345678 123456789 12
  &  'Self-Cal Antenna Gains             ',  &
  &  'Synthesized Dirty Beam             ',  &
  &  'Clean Component Table              ',  &
  &  'Self-Calibration Complex Gains     ',  &
  &  'Clean-ed data cube                 ',  &
  &  'Clipped Spectrum from UV_PREVIEW   ',  &  
  &  'Continuum image from MAP_CONTINUUM ',  &
  &  'Dirty Image                        ',  &
  &  'Image extracted by EXTRACT         ',  &
  &  'Current Mask                       ',  &
  &  'Integrated Area from MOMENTS       ',  &
  &  'Peak flux from MOMENTS             ',  &
  &  'Mean Velocity from MOMENTS         ',  &
  &  'Line Width from MOMENTS            ',  &
!  &  'MODEL       ',  &
  &  'Primary Beam                       ',  &
  &  'Residual UV table                  ',  &  
  &  'Mosaic Weight Image                ',  &
  &  'Mosaic Fields                      ',  &
  &  'Short Spacing Image                ',  &
  &  'Single-Dish Data                   ',  &
  &  'Sky Brightness (PB corrected)      ',  &
  &  'Image extracted by SLICE           ',  &
  &  'Initial Spectrum from UV_PREVIEW   ',  &
  &  'UV data                            ',  &
  &  'UV Fit results binary table        ',  &
  &  'Continuum UV data                  ',  &
  &  'Azimutally averaged UV data        '  /)  
  
  character(len=12) ctype
  !
  integer, parameter :: code_save_uv=2
  integer, parameter :: code_save_beam=3
  integer, parameter :: code_save_dirty=4
  integer, parameter :: code_save_clean=5
  integer, parameter :: code_save_primary=6
  integer, parameter :: code_save_resid=7
  integer, parameter :: code_save_mask=8
  integer, parameter :: code_save_support=9
  integer, parameter :: code_save_cct=10
  integer, parameter :: code_save_model=11
  integer, parameter :: code_save_sky=12
  integer, parameter :: code_save_fields=13
  integer, parameter :: code_save_gains=14
  integer, parameter :: code_save_short=15
  integer, parameter :: code_save_single=16
  logical :: save_data(mtype)
  !
  ! Read / Write optimization
  type readop_t
    type(mfile_t) :: modif
    integer :: lastnc(2) = 0
    integer :: change = 0
  end type
  !
  type (readop_t), save :: optimize(mtype)
  !
  integer :: rw_optimize
end module clean_types
!
module clean_default
  use clean_def
  !
  real d_min,d_max                   ! min max of dirty image
  real major_sec
  real minor_sec
  !
  type (uvmap_par), save :: default_map, old_map, save_map
  !
  ! OPEN-MP control parameters
  logical, save :: omp_compiled = .false.
  logical, save :: omp_uvmap = .false.
  integer, save :: omp_grid = 0
  logical, save :: omp_restore_fast = .true.
  logical, save :: omp_uvmap_lock = .false.
  integer, save :: omp_single_beam = 0
  logical, save :: omp_debug = .false.
  !
  ! Parameter to select the imaging tool version. Non zero means old
  ! non-optimized code.
  integer, save :: map_version = 0
  !
  ! Parameters for determining image size
  integer, save :: map_power = 2           ! Max exponent of powers of 3 and 5
  real, save :: map_rounding = 0.05        ! Tolerance for rounding to floor
  !
  logical, save :: MappingError = .false.  ! Error status from scripts
  !
  character(len=16), save :: last_shown    ! CLEAN or DIRTY
  character(len=16), save :: last_resid    ! CCT or UV_FIT
  logical, save :: view_do_loop            ! Interactive mode for VIEW
  !
  integer, save :: sys_ramsize             ! RAM size in MBytes
  !
  real(4), save :: recmap_field(2)
  integer, save :: recmap_size(2)
  real(4), save :: recmap_xycell(2)
  real(4), save :: recmap_uvcell
end module clean_default

module uvfit_data
  ! Support module for command UV_FIT
  use image_def
  integer, parameter :: mpar=70         ! Max number of parameters
  integer, parameter :: mf=10           ! Max number of functions
  integer, parameter :: mpin=7          ! Max number of parameters per function
  real(kind=8) :: pars(mpar)            ! Parameter values
  real(kind=8) :: sw
  real, allocatable :: uvriw(:,:)       ! Work space for visibilities
  integer :: nf                         ! number of functions
  integer :: ifunc(mf)                  ! Function codes
  integer :: npfunc(mf)                 ! number of parameters per function
  logical :: savef(mf)                  ! Subtract function
  integer :: npuvfit                    ! number of points
  integer :: npar                       ! Number of parameters
  integer :: nstart(mpar)               ! Number of starts per parameter
  !
  real(kind=4) :: uvf_results(mpin,mf)  ! Results for each function
  real(kind=4) :: uvf_errors(mpin,mf)   ! Errors 
  !
  type (gildas) :: huvfit               ! Table of fitted parameters
  real, allocatable :: duvfit(:,:)      ! UV_FIT results
end module uvfit_data
!

!
!     Id: pako-package.f90,v 1.2.4 2013-12-01 Hans Ungerechts
!     Id: pako-package.f90,v 1.2.4 2013-04-19 Hans Ungerechts
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the PAKO package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine pako_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !
  type(gpack_info_t), intent(out) :: pack
  !
  External :: pako_pack_init
  External :: pako_pack_clean
  !
  pack%name='pako'
  pack%ext='.pako'
  pack%depend(1:2) = (/ locwrd(sic_pack_set), locwrd(greg_pack_set) /) ! List here dependencies
  pack%init=locwrd(pako_pack_init)
  pack%clean=locwrd(pako_pack_clean)
  pack%authors="Hans Ungerechts"
  !
End Subroutine pako_pack_set
!
Subroutine pako_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! 
  !----------------------------------------------------------------------
  Integer :: gpack_id
  Logical :: error
  ! Global
  Integer :: sic_setlog
  ! Local
  Integer :: ier
  !
  Call pako_message_set_id(gpack_id)
  !
  ! Specific variables
  ier = sic_setlog('gag_help_pako','gag_doc:hlp/pako-help-pako.hlp')
  If (ier.Eq.0) Then
    error=.True.
    Return
  Endif
  !
  ! Load local language
  Call pako_load
  !
  ! Specific initializations
  !
End Subroutine pako_pack_init
!
Subroutine pako_pack_clean(error)
  !----------------------------------------------------------------------
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  Logical :: error
  !
  Character*80 shellCommand
  Integer :: SYSTEM
  Integer :: ier2
  !
  !D   Write (6,*) " --> pako_pack_clean"
  !
  shellCommand = "rm -f .pakoLock"
  ier2 = system(shellCommand)                                                    !  !!  TBD: handle error
  !
End Subroutine pako_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program p_matchspectrum
  use gkernel_interfaces
  use image_def
  use gbl_message
  !$ use omp_lib
  !
  ! Compute Frequency Cross-Correlation spectrum
  ! of two UV tables
  !
  character(len=256) csmo,cuv,cspec 
  logical error
  type (gildas) :: hsmo,huv,hspec
  character(len=*), parameter :: rname='UV_MATCHSPECTRUM'
  integer :: iv, ic, ier
  !
  ! New
  real(kind=8) :: ininc, inref, inval
  real :: pix1,pixn,w
  integer(kind=index_length) :: ipix1,ipixn
  integer(kind=index_length) :: nchan
  real, allocatable :: ospec(:), ipr(:,:)
  integer, allocatable :: ipi(:,:)
  !
  call gildas_open
  call gildas_char('UVDATA$',cuv)
  call gildas_char('SMOOTH$',csmo)
  call gildas_char('SPECTRUM$',cspec)
  call gildas_close
  !
  call gildas_null(hsmo,type='UVT')
  call gildas_null(hspec) 
  call gildas_null(huv,type='UVT')
  !
  call sic_parse_file(cspec,' ','.tab',hspec%file)
  call sic_parse_file(cuv,' ','.uvt',huv%file)
  !
  call gdf_read_header(hspec,error)
  call gdf_read_header(huv,error)
  !
  nchan = huv%gil%nchan
  !
  call gdf_copy_header(huv,hsmo,error)
  call sic_parse_file(csmo,' ','.uvt',hsmo%file)
  !
  hsmo%gil%nchan = 1
  hsmo%gil%dim(1) = hsmo%gil%nlead + 3 + hsmo%gil%ntrail
  Print *,'Smooth size ',hsmo%gil%dim(1:2)
  call gdf_setuv(hsmo,error)
  !
  ! Shift trailing columns if needed
  if (hsmo%gil%ntrail.ne.0) then
    continue  ! To be done
  endif
  !
  ! Resample input spectrum onto the desired grid
  call gdf_allocate(hspec,error)
  call gdf_read_data(hspec,hspec%r2d,error)
  ! 1 Velocity, 2 Flux, ( 3 Frequency ) ?
  !
  ! Assume regularly spaced spectrum
  ininc = hspec%r2d(2,1)-hspec%r2d(1,1)
  inval = hspec%r2d(1,1)
  inref = 1.d0
  ! Check limits
  !!Print *,'INVAL ',inval,' end ',hspec%r2d(hspec%gil%dim(1),1), &
  !!  & (hspec%gil%dim(1)-inref)*ininc + inval, ' VOFF ',huv%gil%voff
  pix1 = huv%gil%ref(1) + ( inval + (1.d0-inref)  &
      & *ininc - huv%gil%voff ) / huv%gil%vres
  pixn = huv%gil%ref(1) + ( inval + (hspec%gil%dim(1)-inref)  &
      & *ininc - huv%gil%voff ) / huv%gil%vres
  !!Print *,'Pixels ',pix1,pixn
  if (pix1.lt.pixn) then
    ipix1 = int(pix1)
    if (ipix1.ne.pix1) ipix1 = ipix1+1
    ipix1 = max(ipix1,1)
    ipixn = min(int(pixn),nchan) 
  else
    ipixn = min(int(pix1),nchan)
    ipix1 = int(pixn)
    if (ipix1.ne.pixn) ipix1 = ipix1+1
    ipix1 = max(ipix1,1)
  endif
  !
  allocate (ipi(2,huv%gil%nchan), ipr(4,huv%gil%nchan), & 
    & ospec(huv%gil%nchan),stat=ier)
  !
  !!Print *,'Doing all_inter ',ipix1,ipixn,' nchan ',nchan,huv%gil%nchan
  call all_inter(1_8,ipix1,ipixn, &
    & ospec,nchan,dble(huv%gil%vres),huv%gil%ref(3),dble(huv%gil%val(3)), &
    & hspec%r2d(:,2),hspec%gil%dim(3),ininc,inref,inval, ipi, ipr)     
  !!Print *,'Done all_inter '
  !
  call gdf_close_image(hspec,error)
  !
  ! Will be done by Blocks later if needed
  call gdf_allocate(huv,error)
  call gdf_read_data(huv,huv%r2d,error)
  !!Print *,'Data read ',error
  call gdf_allocate(hsmo,error)
  !!Print *,'Smooth allocated ',error
  !  
  ! Normalize the spectrum to integral of 1
  w = sum(ospec)
  ospec = ospec/w
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP &  SHARED(huv,hsmo,ospec,nchan) &
  !$OMP &  PRIVATE(iv,ic,w)
  !
  !$OMP DO
  do iv = 1, huv%gil%nvisi
    ! Sum each channel with the appropriate weight
    hsmo%r2d(1:7,iv) = huv%r2d(1:7,iv)
    !
    do ic = 1,nchan
      if (huv%r2d(7+3*ic,iv).gt.0) then
        hsmo%r2d(8,iv) = hsmo%r2d(8,iv) + huv%r2d(5+3*ic,iv) * ospec(ic)
        hsmo%r2d(9,iv) = hsmo%r2d(9,iv) + huv%r2d(6+3*ic,iv) * ospec(ic)
        hsmo%r2d(10,iv) = hsmo%r2d(10,iv) + huv%r2d(7+3*ic,iv) !! Need to figure out this later
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  call gdf_write_image(hsmo,hsmo%r2d,error)
  !
  contains
!
subroutine all_inter (n,ic1,icn,x,xdim,xinc,xref,xval,y,ydim,yinc,yref,yval,iwork,rwork)
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Performs the linear interpolation/integration
  ! Arguments:
  !	X	R*4(*)	Output spectrum
  !	N	I*4	Map size
  !	XDIM	I*4	Output pixel number
  !	XINC	R*8	Output first axis increment
  !	XREF	R*8	Output first axis reference pixel
  !	XVAL	R*8	Output first axis value at reference pixel
  ! 	Y	R*4(*)	Input spectrum
  !---------------------------------------------------------------------
  integer(kind=index_length) :: n       ! Map size, will be 1 here
  integer(kind=index_length) :: ic1     ! First output channel
  integer(kind=index_length) :: icn     ! Last output channel
  integer(kind=index_length) :: xdim    ! Output dimension
  real :: x(n,xdim)                     ! Output map
  real(8) :: xinc                    !
  real(8) :: xref                    !
  real(8) :: xval                    !
  integer(kind=index_length) :: ydim    ! Input dimension
  real :: y(n,ydim)                     ! Input map
  real(8) :: yinc                    !
  real(8) :: yref                    !
  real(8) :: yval                    !
  integer :: iwork(2,xdim)              ! Work array
  real :: rwork(4,xdim)                 ! Work array
  !	iwork = imin,imax
  !	rwork = rmin_1, rmin, rmax, rmax_1
  !
  integer i,imax,imin, j, k
  real(8) minpix, maxpix, pix, val, expand
  real rmin_1, rmin, rmax_1, rmax, smin, smax
  real scale
  !
  ! Special case: output axis = input axis
  if ((xdim.eq.ydim).and.(xref.eq.yref).and.(xval.eq.yval).and.(xinc.eq.yinc)) then
    x = y
    return
  endif
  !
  x = 0
  !
  expand = abs(xinc/yinc)
  scale  = 1.d0/expand
  do i = ic1, icn
    !
    ! Compute interval
    !
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    maxpix = pix + 0.5d0*expand
    minpix = pix - 0.5d0*expand
    imin = int(minpix+1.0d0)
    imax = int(maxpix)
    iwork(1,i) = imin
    iwork(2,i) = imax
    if (imax.ge.imin) then
      if (imin.gt.1) then
        !
        ! Lower end
        !
        ! YMIN = Y(IMIN-1)*(IMIN-MINPIX)+Y(IMIN)*(MINPIX-IMIN+1)
        !     and
        ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(YMIN+Y(IMIN)) )
        !   
        ! Coefficient de IMIN-1: RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)
        ! Coefficient de IMIN:   RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)
        !
        smin = imin-minpix
        rwork(1,i) = 0.5*smin*smin
        rwork(2,i) = smin-rwork(1,i)
      else
        ! Coefficient de IMIN:      RMIN   = (IMIN-MINPIX)
        ! Coefficient de IMIN-1:    RMIN_1 = 0
        rwork(1,i) = 0.0
        rwork(2,i) = imin-minpix
      endif
      if (imax.lt.ydim) then
        ! Upper end
        smax = maxpix-imax
        rwork(4,i) = 0.5*smax*smax
        rwork(3,i) = smax-rwork(4,i)
      else
        rwork(3,i) = maxpix-imax
        rwork(4,i) = 0.0
      endif
      if (imax.eq.imin) then
        ! Point Case
        rwork(2,i) = rwork(2,i)+rwork(3,i)
        rwork(3,i) = 0.0
      else
        ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate
        ! channels
        rwork(2,i) = rwork(2,i)+0.5
        rwork(3,i) = rwork(3,i)+0.5
      endif
    else
      if (imin.gt.1) then
        rwork(1,i) = (imin-pix)
        rwork(2,i) = (pix+1-imin)
      else
        rwork(1,i) = 0.0
        rwork(2,i) = 1.0
      endif
    endif
  enddo
  !
  ! OK, now do it...
  do i = ic1, icn
    imin = iwork(1,i)
    imax = iwork(2,i)
    rmin_1 = rwork(1,i)
    rmin   = rwork(2,i)
    rmax   = rwork(3,i)
    rmax_1 = rwork(4,i)
    !
    if (imax.ge.imin) then
      ! General Trapezium integration
      if (imin.gt.1) then
        do j=1,n
          x(j,i) = y(j,imin-1)*rmin_1
        enddo
        do j=1,n
          x(j,i) = x(j,i) + y(j,imin)*rmin
        enddo
      else
        do j=1,n
          x(j,i) = y(j,imin)*rmin
        enddo
      endif
      if (imax.gt.imin) then
        do k = imin+1,imax-1
          do j=1,n
            x(j,i) = x(j,i) + y(j,k)
          enddo
        enddo
        do j=1,n
          x(j,i) = x(j,i) + y(j,imax)*rmax
        enddo
      endif
      if (imax.lt.ydim) then
        do j=1,n
          x(j,i) = x(j,i) + y(j,imax+1)*rmax_1
        enddo
      endif
      ! Normalise
      do j=1,n
        x(j,i) = x(j,i)*scale
      enddo
      !
    else
      ! Interpolation
      if (imin.gt.1) then
        do j=1,n
          x(j,i) = y(j,imin-1)*rmin_1
        enddo
        do j=1,n
          x(j,i) = x(j,i) + y(j,imin)*rmin
        enddo
      else
        do j=1,n
          x(j,i) = y(j,imin)
        enddo
      endif
    endif
  enddo
  !
end subroutine all_inter

end program p_matchspectrum

        

!
subroutine one_beam (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax)
  use gkernel_interfaces
  use imager_interfaces, except_this=>one_beam
  use clean_def
  use image_def
  use gbl_message
  use clean_default
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   one single beam for all channels.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image
  ! a VLM cube
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx   ! X size
  integer, intent(in) :: ny   ! Y size
  integer, intent(in) :: nu   ! Size of a visibilities
  integer, intent(in) :: nv   ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout) :: w_mapu(nx)      ! U grid coordinates
  real, intent(inout) :: w_mapv(ny)      ! V grid coordinates
  real, intent(inout) :: w_grid(nx,ny)   ! Gridding space
  real, intent(inout) :: w_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)         ! V values
  logical, intent(inout) :: do_weig
  !
  real, intent(inout) :: wfft(*)     ! Work space
  real, intent(inout) :: cpu0        ! CPU
  real, intent(inout) :: uvmax       ! Maximum baseline
  integer, intent(inout) :: sblock   ! Blocking factor
  integer, intent(inout) :: wcol     ! Weight channel
  integer, intent(inout) :: mcol(2)  ! First and last channel
  logical, intent(inout) :: error
  !
  if (omp_single_beam.eq.0) then
    Print *,'Calling SERIAL one_beam'
    call one_beam_serial (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax)
  else
    Print *,'Calling PARALLEL one_beam'
    call one_beam_para (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax)
  endif
end subroutine one_beam
!
subroutine check_order(visi,np,nv,sorted)
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Check if visibilites are sorted.
  !   Chksuv does a similar job, but using V values and an index.
  !----------------------------------------------------------
  integer, intent(in) :: np       ! Size of a visibility
  integer, intent(in) :: nv       ! Number of visibilities
  real, intent(in) :: visi(np,nv) ! Visibilities
  logical, intent(out) :: sorted
  !
  real vmax
  integer iv
  !
  vmax = visi(2,1)
  do iv=1,nv
    if (visi(2,iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = visi(2,iv)
  enddo
  sorted = .true.
end subroutine check_order
!
subroutine cct_prepare(line,nc,a_method,task,error)
  use gkernel_interfaces
  use imager_interfaces, only : get_i4list_fromsic, get_r4list_fromsic
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !---------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Prepare the Clean Component Table
  !---------------------------------------------------
  character(len=*), intent(in) :: line      ! Command line
  integer, intent(in) :: nc                 ! Number of channels
  type(clean_par), intent(in) :: a_method   ! Input method
  character(len=*), intent(in) :: task      ! Caller name
  logical, intent(out) :: error  !
  ! Local
  integer(kind=4) :: ier,x_iter
  integer, parameter :: opt_iter=4
  integer, parameter :: opt_ares=5
  !
  error = .false.
  x_iter = a_method%m_iter
  !
  ! Use up to nc = hdirty%gil%dim(3)
  if (sic_present(opt_iter,0)) then
    niter_listsize = hdirty%gil%dim(3)
    Print *,'Allocating per plane NITER ',niter_listsize
    if (allocated(niter_list)) deallocate(niter_list)
    allocate(niter_list(niter_listsize),stat=ier)
    call get_i4list_fromsic(task,line,opt_iter,niter_listsize, &
      & niter_list,error)
    if (error) return
    ! 
    x_iter = maxval(niter_list)
  endif
  !
  if (sic_present(opt_ares,0)) then
    ares_listsize = hdirty%gil%dim(3)
    Print *,'Allocating per plane ARES ',ares_listsize
    if (allocated(ares_list)) deallocate(ares_list)
    allocate(ares_list(ares_listsize),stat=ier)
    call get_r4list_fromsic(task,line,opt_ares,ares_listsize, &
      & ares_list,error)
    if (error) return
  endif
  !
  if (a_method%method.eq.'MULTI') x_iter = a_method%ninflate*x_iter
  !print *,'CCT-Prepare, Method ',method%method,m_iter,x_iter
  !print *,'CCT-Prepare, FIRST ',a_method%first,' LAST ',a_method%last
  call sic_delvariable('CCT',.false.,error)
  if (error)  error = .false.  ! Not an error if no such variable
  !
  x_iter = max(1,x_iter)
  call reallocate_cct(3,nc,x_iter,dcct,error)
  if (error)  return
  hcct%loca%size = 3*nc*x_iter
  dcct(:,a_method%first:a_method%last,:) = 0.  ! Nullify the channels to be used
  !
  ! Define the image header
  call gildas_null(hcct)
  call gdf_copy_header (hdirty,hcct,error)
  hcct%gil%ndim = 3
  hcct%char%unit = 'Jy'
  !
  hcct%gil%dim(1) = 3
  ! Keep the same axis description
  hcct%gil%xaxi = 1
  !
  hcct%gil%convert(:,2) = hdirty%gil%convert(:,3)
  hcct%gil%convert(:,3) = hdirty%gil%convert(:,2)
  hcct%gil%dim(2) = hdirty%gil%dim(3)
  hcct%char%code(2) = hdirty%char%code(3)
  hcct%gil%faxi = 2
  hcct%gil%dim(3) = x_iter
  hcct%char%code(3) = 'COMPONENT'
  hcct%gil%yaxi = 3
  !
  ! Initialize BLCs...
  hcct%blc = 0
  hcct%trc = 0
  !
contains
  subroutine reallocate_cct(n1,n2,n3,array,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! (re)allocate the CCT allocatable array.
    ! If only the last dimension is enlarged, the previous contents are
    ! kept. Otherwise, the data is initialized to 0.
    !-------------------------------------------------------------------
    integer(kind=4),           intent(in)    :: n1,n2,n3      ! New dimensions
    real(kind=4), allocatable, intent(inout) :: array(:,:,:)  !
    logical,                   intent(inout) :: error         !
    ! Local
    character(len=message_length) :: mess
    logical :: keep
    integer(kind=4) :: ier,oldn1,oldn2,oldn3
    real(kind=4), allocatable :: tmp(:,:,:)
    !
    if (n1.le.0 .or. n2.le.0 .or. n3.le.0) then
      write(mess,'(A,3(I0,A))')  &
        'CCT size can not be zero nor negative (got n1 x n2 x n3 = ',  &
        n1,'x',n2,'x',n3,')'
      call map_message(seve%e,task,mess)
      error = .true.
      return
    endif
    !
    keep = .false.
    if (allocated(array)) then
      oldn1 = ubound(array,1)
      oldn2 = ubound(array,2)
      oldn3 = ubound(array,3)
      if (oldn1.eq.n1 .and.  &  ! Strict equality
          oldn2.eq.n2 .and.  &  ! Strict equality
          oldn3.ge.n3) then     ! Greater or equal
        write(mess,'(a,i0,a,i0,a,i0)')  &
          'Re-using current CCT table of size ',oldn1,' x ',oldn2,' x ',oldn3
        call map_message(seve%i,task,mess)
        return
      endif
      !
      write(mess,'(a,i0,a,i0,a,i0,a)')  &
        'Current CCT table has size ',oldn1,' x ',oldn2,' x ',oldn3,', increasing'
      call map_message(seve%i,task,mess)
      if (oldn1.eq.n1 .and.  &  ! Strict equality
          oldn2.eq.n2) then     ! Strict equality
        ! The 2 first dimensions are not modified, only the third is enlarged.
        ! Data will be kept.
        keep = .true.
        call move_alloc(from=array,to=tmp)
        ! 'array' is now deallocated
      else
        deallocate(array)
      endif
    endif
    !
    ! Allocation
    allocate(array(n1,n2,n3),stat=ier)
    if (failed_allocate(task,'ARRAY',ier,error))  return
    write(mess,'(a,i0,a,i0,a,i0)')  &
      'Allocated new CCT table of size ',n1,' x ',n2,' x ',n3
    call map_message(seve%i,task,mess)
    !
    ! Back copy
    if (keep) then
      array(:,:,1:oldn3) = tmp(:,:,1:oldn3)
      array(:,:,oldn3+1:n3) = 0.
      deallocate(tmp)
    else
      array(:,:,:) = 0.
    endif
    !
  end subroutine reallocate_cct
  !
end subroutine cct_prepare
!
subroutine get_i4list_fromsic(rname,line,opt,nf,list,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use gbl_format
  use imager_interfaces, only : map_message
  !
  ! @ public-mandatory
  !
  ! Return in the allocatable array the content of the 1-D
  ! SIC variable given as argument of Option # opt.
  ! Return the size of the array in NF
  ! If NF is non zero on entry, the size must match and the
  ! array is pre-allocated.
  !
  character(len=*), intent(in) :: rname
  character(len=*), intent(in) :: line
  integer, intent(in) :: opt
  integer, intent(inout) :: nf
  integer, allocatable, intent(inout) :: list(:)
  logical, intent(out) :: error
  !
  character(len=64) :: listname
  logical :: found
  integer(kind=address_length) :: jpd
  type(sic_descriptor_t) :: desc
  integer :: na, ier
  integer, save :: memory(2)
  !
  call sic_ch(line,opt,1,listname,na,.true.,error)
  if (error) return
  call sic_descriptor(listname,desc,found)
  if (.not.found) then
    call sic_i4(line,opt,1,na,.true.,error)
    if (error) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
      return 
    endif
    if (nf.eq.0) then
      nf = 1
      allocate(list(nf),stat=ier)
    else if (nf.ne.1) then
      call map_message(seve%e,rname,'Number of elements mismatch in List')
      error = .true.
    else if (.not.allocated(list)) then
      call map_message(seve%e,rname,'List is not allocated')
      error = .true.
    endif
    if (error) return
    list(1:nf) = na
    return
  else if (desc%type.ne.fmt_i4) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
    error = .true.
    return
  endif
  if (desc%ndim.ne.1) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
    error = .true.
    return
  endif
  if (nf.eq.0) then
    nf = desc%dims(1)
    allocate(list(nf),stat=ier)
  else if (nf.ne.desc%dims(1)) then
    call map_message(seve%e,rname,'Number of elements mismatch in List')
    error = .true.
  else if (.not.allocated(list)) then
    call map_message(seve%e,rname,'List is not allocated')
    error = .true.
  endif
  if (error) return
  !
  jpd = gag_pointer(desc%addr,memory)
  call i4toi4(memory(jpd),list,nf)
end subroutine get_i4list_fromsic
!
subroutine get_r4list_fromsic(rname,line,opt,nf,list,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use gbl_format
  use imager_interfaces, only : map_message
  !
  ! @ public-mandatory
  !
  ! Return in the allocatable array the content of the 1-D
  ! SIC variable given as argument of Option # opt.
  ! Return the size of the array in NF
  ! If NF is non zero on entry, the size must match and the
  ! array is pre-allocated.
  !
  character(len=*), intent(in) :: rname
  character(len=*), intent(in) :: line
  integer, intent(in) :: opt
  integer, intent(inout) :: nf
  real, allocatable, intent(inout) :: list(:)
  logical, intent(out) :: error
  !
  character(len=64) :: listname
  logical :: found
  integer(kind=address_length) :: jpd
  type(sic_descriptor_t) :: desc
  integer :: na, ier
  integer, save :: memory(2)
  !
  call sic_ch(line,opt,1,listname,na,.true.,error)
  if (error) return
  call sic_descriptor(listname,desc,found)
  if (.not.found) then
    call sic_i4(line,opt,1,na,.true.,error)
    if (error) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
      return 
    endif
    if (nf.eq.0) then
      nf = 1
      allocate(list(nf),stat=ier)
    else if (nf.ne.1) then
      call map_message(seve%e,rname,'Number of elements mismatch in List')
      error = .true.
    else if (.not.allocated(list)) then
      call map_message(seve%e,rname,'List is not allocated')
      error = .true.
    endif
    if (error) return
    list(1:nf) = na
    return
  else if (desc%type.ne.fmt_i4) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
    error = .true.
    return
  endif
  if (desc%ndim.ne.1) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
    error = .true.
    return
  endif
  if (nf.eq.0) then
    nf = desc%dims(1)
    allocate(list(nf),stat=ier)
  else if (nf.ne.desc%dims(1)) then
    call map_message(seve%e,rname,'Number of elements mismatch in List')
    error = .true.
  else if (.not.allocated(list)) then
    call map_message(seve%e,rname,'List is not allocated')
    error = .true.
  endif
  if (error) return
  !
  jpd = gag_pointer(desc%addr,memory)
  call r4tor4(memory(jpd),list,nf)
end subroutine get_r4list_fromsic

subroutine astro_planet(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_planet
  use ast_astro
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !	ASTRO Command :
  !	PLANET name|ALL SURFACE lon lat /DRAW /QUIET
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='PLANET'
  character(len=message_length) :: mess
  character(len=3) :: patch
  character(len=12) :: arg2,arg
  character(len=60) :: alpha, delta
  logical :: draw,drawclip, found, surf, visible
  real(kind=8) :: lola(2),eq(2),ho(2),lola_e(2),eqoff(2),vr, vroff, distance
  real(kind=8) :: helio_dist, pl_axes(3), tbright, flux, sunel, eqtopo(2)
  integer(kind=4) :: m_body, na, nd, ip, nc, nf, ieph, k, nkey, mvoc1
  parameter (m_body = 9, mvoc1=2)
  character(len=12) :: body (m_body+1), name, voc1(mvoc1), k1
  character(len=1) :: c_symbol(m_body)
  real(kind=8) :: degrad, secrad, au, tmb, fbeam, size, save_tdt, eqeph(2,3)
  real(kind=8) :: eq1(2),eq2(2),vreph(3),vr1,vr2
  parameter (degrad=pi/180d0,secrad=degrad/3600d0)
  logical :: ephem , dowrite
  real(kind=8) :: dteph(3), dte
  ! 1 hour interval for produced ephemeris
  parameter (dte=1.d0)
  integer(kind=4) :: neph, nch, ier, lun, nchp, nchv
  character(len=40) :: namef, ephfile, d_chain, ch, chp, chv
  character(len=16) :: varname
  integer(kind=4) :: nv
  real(kind=8) :: tmpde, tmpds, tmpmaj, tmpmin, tmppa, tmpsize,beam
  integer(kind=4), parameter :: optdraw=1  ! /DRAW
  integer(kind=4), parameter :: optbeam=4  ! /BEAM
  integer(kind=4), parameter :: optnoclip=5  ! /NOCLIP
  character(len=1) :: drawargs(5)  ! Support for /DRAW arguments
  !
  ! Data must be after all declarations...
  data au/1.49598d8/
  data body/'MOON', 'SUN', 'MERCURY', 'VENUS', 'MARS', 'JUPITER', 'SATURN',  &
            'URANUS', 'NEPTUNE','ALL'/
  data c_symbol /':', '0', '1', '2', '4', '5', '6', '7', '8'/
  data voc1/'CENTER','SURFACE'/
  !
  ! SAVE variables that are mapped to a SIC variable
  save ho, sunel, vr, tbright, flux, tmb, fbeam
  save tmpde, tmpds, tmpmaj, tmpmin, tmppa, tmpsize
  save alpha, delta
  !------------------------------------------------------------------------
  !
  found = .false.
  arg = 'ALL'
  call sic_ke (line,0,1,arg,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,arg,name,nkey,body,m_body+1,error)
  if (error) return
  arg = 'CENTER'
  nc = 6
  call sic_ke (line,0,2,arg,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,arg,k1,nkey,voc1,mvoc1,error)
  if (error) return
  if (k1.eq.'SURFACE') then
    surf = .true.
    call sic_r8 (line,0,3,lola(1),.true.,error)
    if (error) return
    call sic_r8 (line,0,4,lola(2),.true.,error)
    if (error) return
    lola(1) = lola(1)*degrad
    lola(2) = lola(2)*degrad
  else
    surf = .false.
    lola(1) = 0.d0
    lola(2) = 0.d0
  endif
  !
  dowrite = .not.sic_present(3,0)
  !
  ! Set /DRAW type option
  draw = sic_present(optdraw,0)
  if (draw) then
    call astro_draw_parse(rname,line,optdraw,drawargs,error)
    if (error)  return
  endif
  drawclip=.true.
  if (sic_present(optnoclip,0)) then
    if (.not.draw) then
      call astro_message(seve%e,rname,'Option /NOCLIP only valid in combination with /DRAW')
      error=.true.
      return
    endif
    drawclip=.false.
  endif
  !
  ! Ephemeris option
  ephem = sic_present(2,0)
  if (ephem) then
    ier = sic_getlun (lun)
    namef = 'BODY'
    nc = 4
    call sic_ch(line,2,1,namef,nc,.false.,error)
    arg2 = 'APPEND'
    call sic_ke(line,2,2,arg2,nc,.false.,error)
    call sic_parsef(namef,ephfile,' ','.sou')
    ier = sic_getlun (lun)
    nf = lenc(ephfile)
    if (arg2(1:3).eq.'NEW') then
      ier = sic_open(lun,ephfile(1:nf),'NEW',.false.)
    else
      ier = sic_open(lun,ephfile(1:nf),'APPEND',.false.)
    endif
    if (ier.ne.0) goto 98
    neph = 3
    dteph(1) = -dte/24d0
    dteph(2) = dte/24d0
    dteph(3) = 0d0
  else
    neph = 1
    dteph(1) = 0d0
  endif
  !
  ! Get beam size
  beam = 0d0
  if (sic_present(optbeam,0)) then
    ! to replace the default beam (from observatory) by the user's value
    call sic_r8(line,optbeam,1,beam,.true.,error)
    if (error) return
  endif
  call do_tele_beam(primbeam,beam,freq,obsname(1:4))
  !
  ! Loop on possible objects
  save_tdt = jnow_tdt
  do ip = 1, m_body
    if (name .eq. 'ALL' .or. name.eq.body(ip)) then
      do ieph = 1, neph
        jnow_tdt = save_tdt + dteph(ieph)
        call do_astro_planet(ip,surf,lola,eq,eqtopo, ho,sunel,vr,distance,  &
        helio_dist,pl_axes,tbright,freq,flux, visible,lola_e,eqoff,vroff,   &
        primbeam*secrad,tmb,fbeam, size,error)
        ! we use the GEOCENTRIC coordinates here ...
        ! EQEPH(1,IEPH) = EQTOPO(1)
        ! EQEPH(2,IEPH) = EQTOPO(2)
        eqeph(1,ieph) = eq(1)
        eqeph(2,ieph) = eq(2)
        vreph(ieph) = vr
      enddo
      ! Get the first and second derivative
      if (ephem) then
        do k=1,2
          eq1(k) = (eqeph(k,2)-eqeph(k,1))/2d0/dte
          eq2(k) = (eqeph(k,2)+eqeph(k,1)-2*eqeph(k,3))/dte**2
        enddo
        vr1 = (vreph(2)-vreph(1))/2d0/dte
        vr2 = (vreph(2)+vreph(1)-2*vreph(3))/dte**2
      endif
      !
      if (surf) then
        lola_e(1) =mod(540.d0+lola_e(1)/degrad,360.d0)
        lola_e(2) =lola_e(2)/degrad
        write(mess,1001) '_Sub-earth point long,lat=', lola_e,' degrees.'
        call astro_message(seve%r,rname,mess)
        eqoff(1) = eqoff(1)/secrad
        eqoff(2) = eqoff(2)/secrad
        if (visible) then
          write(mess,1001) '_Surface point offsets: ',eqoff,  &
            ' arc sec.; vel. ',vroff,'  km/s; visible.'
        else
          write(mess,1001) '_Surface point offsets: ',eqoff,  &
            ' arc sec.; vel. ',vroff,'  km/s; hidden.'
        endif
        call astro_message(seve%r,rname,mess)
      endif
      !
      if (ephem) then
        call rad2sexa(eq(1),24,alpha,4,left=.true.)
        na = len_trim(alpha)
        call rad2sexa(eq(2),360,delta,3,left=.true.)
        nd = len_trim(delta)
        eq1(1) = eq1(1)/pi*3600*12
        eq1(2) = eq1(2)/pi*3600*180
        eq2(1) = eq2(1)/pi*3600*12
        eq2(2) = eq2(2)/pi*3600*180
        call jdate_to_datetime(jnow_utc,d_chain,error)
        !
        write(ch,'(f20.3)') eq1(1)
        nch = 20
        call sic_blanc(ch,nch)
        alpha = alpha(1:na)//','//ch(1:nch)
        na = na+nch+1
        write(ch,'(f20.3)') eq2(1)
        nch = 20
        call sic_blanc(ch,nch)
        alpha = alpha(1:na)//','//ch(1:nch)
        na = na+nch+1
        !
        write(ch,'(f20.3)') eq1(2)
        nch = 20
        call sic_blanc(ch,nch)
        delta = delta(1:nd)//','//ch(1:nch)
        nd = nd+nch+1
        write(ch,'(f20.3)') eq2(2)
        nch = 20
        call sic_blanc(ch,nch)
        delta = delta(1:nd)//','//ch(1:nch)
        nd = nd+nch+1
        !
        ! Geocentric parallax (horizontal parallax)
        write(chp,'(F20.3)') 8.794/distance*au
        nchp = 20
        ! topocentric coordinates: set parallax to zero (for a test)
        ! CH='0'
        ! NCH = 1
        write(ch(nch:),'(F20.3)') vr
        call sic_blanc(chp,nchp)
        !
        write(chv,'(f20.3)') vr
        nchv = 20
        call sic_blanc(chv,nchv)
        write(ch,'(f20.3)') vr1
        nch = 20
        call sic_blanc(ch,nch)
        chv = chv(1:nchv)//','//ch(1:nch)
        nchv = nchv+1+nch
        if (abs(vr2).gt.0.001) then
          write(ch,'(f20.3)') vr2
          nch = 20
          call sic_blanc(ch,nch)
          chv = chv(1:nchv)//','//ch(1:nch)
          nchv = nchv+1+nch
        endif
        !
        write(lun,1005) body(ip), trim(d_chain), dte*3600.,  &
        alpha(1:na),delta(1:nd), chp(1:nchp), chv(1:nchv)
      else
        call rad2sexa(eq(1),24,alpha,4,left=.true.)
        na = len_trim(alpha)
        call rad2sexa(eq(2),360,delta,3,left=.true.)
        nd = len_trim(delta)
      endif
      ho(1) = ho(1) /degrad
      ho(2) = ho(2) /degrad
      if (dowrite) then
        if (azref.eq.'S') then
          write(mess,1000) body(ip),alpha(1:na), delta(1:nd), ho, sunel, vr
          azimuth = ho(1) * degrad
        else
          write(mess,1000) body(ip),alpha(1:na), delta(1:nd), ho(1)+180.d0,  &
          ho(2), sunel, vr
          azimuth = ho(1) * degrad + pi
        endif
        call astro_message(seve%r,rname,mess)
        if (sunel.lt.slimit) then
          write(mess,1003) body(ip),sunel
          call astro_message(seve%r,rname,mess)
        endif
        if (ip.gt.2) then
          write(mess,1002) distance/au, helio_dist/au, pl_axes(1)/secrad,  &
          pl_axes(2)/secrad, pl_axes(3)/degrad, tbright, freq, flux
          call astro_message(seve%r,rname,mess)
          write(mess,1004) freq, primbeam, tmb, fbeam, size/secrad
          call astro_message(seve%r,rname,mess)
        endif
        call astro_message(seve%r,rname,' ')
        !
        ! Store all output parameters in a SIC structure astro%planet
        !
        varname = 'ASTRO'
        if (.not.sic_varexist(varname)) then
          call sic_defstructure(varname,.true.,error)
          if (error) return
        endif
        varname = 'ASTRO%PLANET'
        if (sic_varexist(varname)) then
          call sic_delvariable(varname,.false.,error)
          if (error) return
        endif
        call sic_defstructure(varname,.true.,error)
        if (error) return
        nv = lenc(varname)
        !
        call sic_def_char(varname(1:nv)//'%NAME',body(ip),.true.,error)
        call sic_def_char(varname(1:nv)//'%RA',alpha(1:na),.true.,error)
        call sic_def_char(varname(1:nv)//'%DEC',delta(1:nd),.true.,error)
        if (azref.eq.'S') then
          call sic_def_dble(varname(1:nv)//'%AZ',ho(1),0,0,.true.,error)
        else
          ho(1) = ho(1)+180.
          call sic_def_dble(varname(1:nv)//'%AZ',ho(1),0,0,.true.,error)
        endif
        call sic_def_dble(varname(1:nv)//'%EL',ho(2),0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%SUND',sunel,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%VEL',vr,0,0,.true.,error)
        tmpde = distance/au
        call sic_def_dble(varname(1:nv)//'%DE',tmpde,0,0,.true.,error)
        tmpds = helio_dist/au
        call sic_def_dble(varname(1:nv)//'%DS',tmpds,0,0,.true.,error)
        tmpmaj= pl_axes(1)/secrad
        call sic_def_dble(varname(1:nv)//'%MAJ',tmpmaj,0,0,.true.,error)
        tmpmin = pl_axes(2)/secrad
        call sic_def_dble(varname(1:nv)//'%MIN',tmpmin,0,0,.true.,error)
        tmppa = pl_axes(3)/degrad
        call sic_def_dble(varname(1:nv)//'%PA',tmppa,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%TB',tbright,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%S',flux,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%FREQ',freq,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%BEAM',primbeam,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%TMB',tmb,0,0,.true.,error)
        call sic_def_dble(varname(1:nv)//'%FLUX',fbeam,0,0,.true.,error)
        tmpsize = size/secrad
        call sic_def_dble(varname(1:nv)//'%SIZE',tmpsize,0,0,.true.,error)
        if (error) return
        !
      endif
      !
      ! SIC global variables
      !
      elevation = ho(2) * degrad
      ra = eq(1)
      if (ra.lt.0d0) ra = ra + 2.0d0*pi
      dec = eq(2)
      source_name = body (ip)
      s_1(1) = ra   ! LAMBDA
      s_1(2) = dec  ! BETA
      velocity = 0  ! VELOCITY (VLSR) - makes no really sense for a planet
      !
      z_axis = 0
      z_axis_type = 'MA'
      if (draw) then
        patch=char(92)//'g'//c_symbol(ip)
        call astro_draw(patch,-1,drawargs,drawclip,error)
      endif
    endif
  enddo
  jnow_tdt = save_tdt
  if (ephem) then
    close(lun)
    call sic_frelun (lun)
  endif
  planet_tmb = tmb
  planet_flux = fbeam
  planet_size(1) = pl_axes(1)
  planet_size(2) = pl_axes(2)
  planet_size(3) = pl_axes(3)
  return
  !
  98    call astro_message(seve%e,'PLANET','Error opening '//ephfile(1:nf))
  call putios ('E-PLANET, ',ier)
  error = .true.
  call sic_frelun (lun)
  return
  !
  1000 format (1x,a,' RA ',a,' Dec ',a,' Az ',f12.5,' El ',f12.5,' Sun.D. ',  &
       f6.1,' Vel. ',f8.3)
  1001 format (a,2f7.2,a,f7.3,a)
  1002 format(' DE=',f5.2,' DS=',f5.2,' Maj=',f6.2,' Min=',f6.2,' PA=',f6.2,  &
       ' TB=',f6.2,' S(',f6.1,')=',f8.2)
  1003 format(1x,a,' is within Sun avoidance (',f6.1,' deg)')
  1004 format(' Frequency ',f6.1,': Beam ',f6.1,'  Tmb ',f8.2,'  Flux ',f9.2,  &
       '  Size ',f6.1)
  1005 format(1x,a,' DAY ',a,1x,f7.0,1x,a,1x,a,' PA ',a,' EA ',a)
end subroutine astro_planet
!
subroutine do_astro_planet(ip,surf,lola,eq,eqtopo,ho,sunel,vr,distance,  &
  helio_dist,pl_axes,tbright,fr,flux, visible,lola_e,eqoff, vroff,pbeam,tmb,  &
  fbeam,size,error)
  use ast_astro
  use ast_constant
  !---------------------------------------------------------------------
  ! @ public
  !	ASTRO Command :
  !	PLANET name|ALL /DRAW
  !---------------------------------------------------------------------
  integer(kind=4) :: ip             !
  logical :: surf                   !
  real(kind=8) :: lola(2)           !
  real(kind=8) :: eq(2)             !
  real(kind=8) :: eqtopo(2)         !
  real(kind=8) :: ho(2)             !
  real(kind=8) :: sunel             !
  real(kind=8) :: vr                !
  real(kind=8) :: distance          !
  real(kind=8) :: helio_dist        !
  real(kind=8) :: pl_axes(3)        !
  real(kind=8) :: tbright           !
  real(kind=8) :: fr                !
  real(kind=8) :: flux              !
  logical :: visible                !
  real(kind=8) :: lola_e(2)         !
  real(kind=8) :: eqoff(2)          !
  real(kind=8) :: vroff             !
  real(kind=8) :: pbeam             !
  real(kind=8) :: tmb               !
  real(kind=8) :: fbeam             !
  real(kind=8) :: size              !
  logical :: error                  !
  ! Local
  real(kind=8) :: sun_distance
  integer(kind=4) :: m_body
  parameter (m_body = 9)
  integer(kind=4) :: vector(m_body), i
  real(kind=8) :: plrad(m_body)
  real(kind=8) :: aratio(m_body)
  real(kind=8) :: temp(m_body)
  real(kind=8) :: etemp(m_body)
  real(kind=8) :: rap(m_body)
  real(kind=8) :: decp(m_body)
  real(kind=8) :: w0(m_body)
  real(kind=8) :: wp(m_body)
  real(kind=8) :: x_0(3), x_2(3), v_0(3), v_2(3), result(6), trfm_32(9), x_3(3)
  real(kind=8) :: au, r3, s_p(2), x_p(3), x_5(3), x_4(3), mat1(9), s_4(2), psi
  real(kind=8) :: the, phi, w1, v_4(3), v_5(3), x_6(3), s_6(2), mat2(9), x, y
  real(kind=8) :: n_2(3), n_3(3), den, y_2(3), norm
  !
  equivalence (result(1), x_0(1)), (result(4),v_0(1))
  real(kind=8) :: jzero                 ! 1994 January 0, 0h tdt.
  parameter (jzero= 2449352.4993381481d0)
  real(kind=8) :: degrad
  parameter (degrad=pi/180d0)
  ! Data
  data au/1.49598d8/
  data vector /1, 2, 3, 3, 3, 3, 3, 3, 3/
  ! Planet properties (order:MOON,SUN,MERCURY,VENUS,MARS,JUPITER,SATURN,URANUS,NEPTUNE)
  ! Planet Radius from Astronomical Almanac 2015 (page E6):
  data plrad /1737.4d0,0.d0,2439.7d0,6051.8d0, 3396.2d0,71492.d0,60268.d0,  &
    25559.d0,24764.d0/    ! in km
  ! Aspect ratio = oblateness=flatening from Ast. Almanac 2015 (page E6):
  data aratio/0d0,0d0,0d0,0d0, 0.005886d0,0.064874d0,0.097962d0, &
    0.022927d0,0.017081d0/ ! aratio=(Feq-Fpol)/Feq)
  ! Pole coordinates from Astronomical Almanac 2015 (page E5):
  data rap/0.d0, 0.d0, 281.00d0, 272.76d0, 317.67d0, 268.06d0, 40.58d0,  &
    257.31d0, 299.43d0/
  data decp /0.d0, 0.d0, 61.41d0, 67.16d0, 52.88d0, 64.50d0, 83.54d0,  &
    -15.18d0, 42.95d0/
  !Argument of prime meridian (Ast. Almanac 1994 (page E87)) -
  ! Go along with jzero defined above
  data w0/0d0, 0d0, 191.04d0, 168.12d0, 166.20d0, 354.77d0, 53.27d0,  &
    277.31d0, 147.30d0/
  data wp/0d0, 0d0, 6.1385025d0, -1.4813675d0, 350.8919830d0, 870.536d0,  &
    810.7939024d0, -501.1600928d0, 536.3128492/
  !
  !Brightness temperatures
  data temp/200.d0,5700.d0,450.d0,350.d0,  &  ! at 100GHz (3.0mm)
    207.d0,170.d0,150.d0,132.d0,125.d0/       ! Avant Marten
  ! 207.D0,170.D0,150.D0,118.D0,119.D0/       ! D'apres A.Marten
  data etemp/0.d0,0.d0,0.d0,-0.35d0, 0.d0,0.d0,0.d0,-0.35d0,-0.35d0/  ! Avant Marten
  !          0.D0,0.D0,0.D0,-0.22D0,-0.20D0/        ! D'apres A.Marten
  !------------------------------------------------------------------------
  ! Code :
  call ephsta(vector(ip), ip, error)
  if (error) return
  !
  ! Get ecliptic J2000 coordinates
  call ephvec(jnow_tdt, 1, result, error)
  !
  ! Get Apparent Horizontal coordinates
  call matvec(x_0, trfm_20, x_2)
  call matvec(v_0, trfm_20, v_2)
  !
  ! Geocentric distance
  distance = dsqrt(x_0(1)**2 + x_0(2)**2 + x_0(3)**2)
  vr = (x_0(1)*v_0(1)+x_0(2)*v_0(2)+x_0(3)*v_0(3))/distance
  ! Heliocentric distance
  helio_dist = dsqrt((xsun_0(1)-x_0(1))**2 +(xsun_0(2)-x_0(2))**2 +  &
  (xsun_0(3)-x_0(3))**2)
  ! Light-time correction
  do i = 1, 3
    x_2(i) = x_2(i) - distance / light * v_2(i)
  enddo
  !
  ! Apparent equatorial coordinates (without parallax)
  call transp(trfm_23, trfm_32)
  call matvec(x_2, trfm_32, x_3)
  call spher(x_3, eq)
  ! half diameter, angle
  if (ip.gt.2) then
    pl_axes(1) = 2d0*plrad(ip)/distance    ! radians,diam
    pl_axes(2) = pl_axes(1)*(1.d0-aratio(ip))
    s_p(1) = rap(ip)*pi/180.d0
    s_p(2) = decp(ip)*pi/180.d0
    call rect(s_p, x_p)
    r3 = dsqrt(x_3(1)**2+x_3(2)**2+x_3(3)**2)
    pl_axes(3) = atan2( -x_3(2)*x_p(1)+x_3(1)*x_p(2), (x_p(3)*  &
    (x_3(1)**2+x_3(2)**2) - x_3(3)*(x_p(1)*x_3(1)+x_p(2)*x_3(2)))/r3)
    pl_axes(3) = mod(pl_axes(3)+2d0*pi,2d0*pi)
    ! Brightness temperature
    if (fr.gt.0) then
      tbright = temp(ip)*(fr/100.)**etemp(ip)
      ! Martian specials
      if (ip.eq.5) then
        tbright = tbright*dsqrt(1.5236*au/helio_dist)
      endif
      ! Flux
      flux = pl_axes(1)*pl_axes(2)*1158.1d0*fr**3 *  &
             (1.d0/(exp(0.04801d0*fr/tbright)-1.d0) -  &
              1.d0/(exp(0.04801d0*fr/2.7d0)-1.d0))
    endif
    if (surf) then
      ! x_5 = planetocentric rectangular coordinates
      ! the angular rotation is degrad*w1/86400. (rad/sec)
      w1 = (w0(ip)+wp(ip) * (jnow_utc-jzero-distance/light/86400.))
      x_5(1) = plrad(ip)*cos(lola(1))*cos(lola(2))
      x_5(2) = -plrad(ip)*sin(lola(1))*cos(lola(2))
      x_5(3) = plrad(ip)*(1.d0-aratio(ip))*sin(lola(2))
      v_5(1) = -x_5(2)*degrad*wp(ip)/86400.
      v_5(2) = x_5(1)*degrad*wp(ip)/86400.
      v_5(3) = 0.
      if (wp(ip).lt.0)  then
        x_5(2) = - x_5(2)
        v_5(2) = - v_5(2)
      endif
      ! x_4 = same, but in equatorial system of date
      psi = pi-w1*degrad
      the = pi/2d0-s_p(2)
      phi = pi/2d0-s_p(1)      !(90d0-rap(ip)) * DEGRAD
      call eulmat (psi,the,phi,mat1)
      call eulmat (-phi,-the,-psi,mat2)
      call matvec (x_5, mat1, x_4)
      call matvec (v_5, mat1, v_4)
      call matvec(x_3,mat2,x_6)
      call spher(x_6,s_6)
      lola_e(1)=-s_6(1)
      lola_e(2)=-s_6(2)
      ! radial velocity:
      vroff = (v_4(1)*x_3(1)+v_4(2)*x_3(2)+v_4(3)*x_3(3)) /sqrt(x_3(1)**2+  &
      x_3(2)**2+x_3(3)**2)
      visible = x_4(1)*x_3(1)+x_4(2)*x_3(2)+x_4(3)*x_3(3).lt.0
      ! position offsets
      do i=1, 3
        x_4(i) = x_4(i)+x_3(i)
      enddo
      call spher(x_4,s_4)
      eqoff(1) = (s_4(1)-eq(1))/cos(eq(2))
      eqoff(2) = (s_4(2)-eq(2))
    endif
    !
  endif
  !
  ! Parallax correction
  x_2(3) = x_2(3) - (radius + altitude)
  !
  ! Apparent equatorial coordinates (with parallax = topocentric)
  call matvec(x_2, trfm_32, x_3)
  call spher(x_3, eqtopo)
  !
  ! Spherical horizontal coordinates
  sunel = sun_distance (x_2)   ! Sun Angular Distance
  !
  call spher(x_2, ho)          ! Back to spherical
  ho(1) = -ho(1)
  do i=1, 2
    ho(i) = mod(ho(i)+3d0*pi,2d0*pi)-pi
  enddo
  !
  if (ip.gt.2) then
    !
    ! Rayleigh Jeans Brightness
    tmb = 6.62d-34/1.38d-23*fr*1e9 *(1.d0/(exp(0.04801d0*fr/tbright)-1.d0)  &
         -1.d0/(exp(0.04801d0*fr/2.7d0)-1.d0))
    ! Primary beam correction
    if (pbeam.ne.0.0d0) then
      x = (pl_axes(1)*pl_axes(2))/(pbeam/sqrt(log(2d0)))**2
      y = (1.0d0-exp(-x))
      fbeam = flux*y/x
      tmb = tmb*y
      size = sqrt(log(2d0)/2.0d0*pl_axes(1)*pl_axes(2)+pbeam**2)
    else
      fbeam = flux
      size = 0d0
    endif
  endif
  !
  ! Compute parallactic angle
  ! parallactic angle
  ! x_3 is the source vector in eq coordinates (3)
  ! n_3 is the normal to the source meridian plane
  ! TRFM_23 goes from (3) to (2)
  ! n_2 is the normal to the source meridian plane, in horiz coords.(2)
  ! x_2 is the source vector in in horiz coords.
  ! y_2 is the intersection of the vertical plane of the source and
  ! the plane of the sky
  den = sqrt(x_3(1)**2+x_3(2)**2)
  n_3(1) = -x_3(2)/den
  n_3(2) = x_3(1)/den
  n_3(3) = 0
  call matvec (n_3, trfm_23, n_2)
  den = sqrt(x_2(1)**2+x_2(2)**2)
  y_2(1) = x_2(1)*x_2(3) / den
  y_2(2) = x_2(2)*x_2(3) / den
  y_2(3) = -den
  norm = sqrt(y_2(1)**2+y_2(2)**2+y_2(3)**2)
  parallactic_angle = pi/2-acos((y_2(1)*n_2(1)+y_2(2)*n_2(2)+y_2(3)*n_2(3))/norm)
end subroutine do_astro_planet

subroutine sub_atmos (ldata_in,data,arg1,monitor,error,scale)
  use gkernel_interfaces
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! Process a scan of data depending on procedure
  !
  ! Arguments
  !     LDATA_IN      Integer Length of data array
  !     DATA(*)       (*)     Data array
  !     ARG1          C*(*)   'C' or 'D' for correlator or detector
  !                           'W'for 22 GHz water vapor radiometer
  !
  ! Call Tree
  !			READ_DATA,
  !	READ_SPEC,	SUB_READ_SPEC,
  !			CLIC_ATMOS,
  !---------------------------------------------------------------------
  include 'clic_parameter.inc'
  integer(kind=data_length) :: ldata_in               !
  real :: data(ldata_in)            !
  character :: arg1                 !
  logical :: monitor                !
  logical :: error                  !
  real :: scale(mnant,mnbb)      !
  ! Global
  include 'clic_clic.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer(kind=address_length) :: kin, k
  integer :: i, ia, mesure, dim(4),ip,ical,ic
  integer :: save_nrec
  logical :: nocal, mon_done
  character(len=160) :: message2, ch
  ! Code:
  do ia = 1, r_nant
    do ip = 1,mnbb
      if (scale(ia,ip).eq.0) then
        scale(ia,ip) = 1.
      endif
    enddo
  enddo
  error = .false.
  if (r_proc.eq.p_pass) return
  !
  ! What are we measuring ?
  mesure = 0
  if (r_scaty.eq.4) then
    call message(8,1,'SUB_ATMOS ','Ambient load')
    mesure = chop
  elseif (r_scaty.eq.7) then
    call message(8,1,'SUB_ATMOS ','Cold load')
    mesure = cold
  else
    mesure = sky
  endif
  nocal = .false.
  !
  ! Compute auto correlation in C_L, C_C
  ! and save corresponding total powers in s_lev for further scaling
  ! Buffers extended for polarisation
  !
  kin = r_ndump*r_ldump + 1
  call decode_header (data(kin))
  ! Not for Stability (P_STAB)
  if (r_proc.eq.p_cal .or. r_proc.eq.p_sky) then
    ! Reset only buffers remeasured (for polarimetric observations)
    do ia=1,r_nant
      do ical=1,r_nbb
        ic = r_mapbb(ical)
        ip = r_mappol(ia,ical)
        integ(ia,r_nrec,ic,ip,mesure) = 0
      enddo
    enddo
    k = kin + r_ldpar
    k = k + r_ldatc
    call do_autol (mesure,data(k), error)
    call cal_levels(arg1,mesure)
    do ia=1, r_nant
      do ical = 1, r_nbb
         ic = r_mapbb(ical)
         ip = r_mappol(ia,ical)
         s_lev(ia,r_nrec,ic,ip,mesure) = c_lev(ia,r_nrec,ic,ip,mesure)
         if (mesure.eq.1) then
           if (s_lev(ia,r_nrec,ic,ip,1).ne.0) then
             scale(ia,ic) = (r_tchop(ic,ia)+   &
               r_trec(ic,ia)) / s_lev(ia,r_nrec,ic,ip,1)
           endif
         endif
      enddo
    enddo
    !
    ! this is done to check for correlator setup changes (-> Check_atmos)
    !
    call r4tor4(r_lband,h_line(1,r_nrec),mlineset) 
    call r4tor4(r_nant,h_inter(1,r_nrec),minterc) 
  else
    call cal_levels(arg1,mesure)
  endif
  do ia = 1,r_nant
    do ic = 1,mnbb
      r_totscale(ic,ia) = scale(ia,ic)
    enddo
  enddo
  !
  ! on SKY, compute TSYS and atmospheric parameters.
  !    compute phase correction only if calibration.
  !
  if ((mesure.ne.cold).and.(mesure.ne.chop)) then
    call do_tsys(r_proc.eq.p_cal, error)
  endif
  !
  ! - Sky Autocorrelation Scan
  !
  if (r_proc.eq.p_onoff) then
    call check_atmos (nocal)
    if (nocal) return
    call load_atmos
    !
    ! Calibrate
    !
    do i=1, r_ndump
      kin = (i-1)*r_ldump + 1
      call decode_header (data(kin))
      k = kin + r_ldpar
      call do_auto_atmosc (data(k), error, i)  ! Get spectrum
      call encode_header (data(kin))
    enddo
    kin = r_ndump*r_ldump + 1
    call decode_header (data(kin))
    k = kin + r_ldpar
    k = k + r_ldatc
    call do_auto_atmosl (data(k), error, 1)    ! Get spectrum
    call encode_header (data(kin))
  !
  ! - Sky Correlation Scan
  elseif (r_proc.eq.p_source .or. r_proc.eq.p_delay   &
    .or. r_proc.eq.p_gain .or. r_proc.eq.p_focus   &
    .or. r_proc.eq.p_point.or. r_proc.eq.p_holog   &
    .or. r_proc.eq.p_five .or. r_proc.eq.p_flux   &
    .or. r_proc.eq.p_vlbi .or. r_proc.eq.p_vlbg   &
    .or. r_proc.eq.p_otf) then
    ! Load Atmospheric Parameters
    call check_atmos (nocal)
    if (nocal) return
    call load_atmos
    !
    ! Calibrate
    !
    do i = 1, r_ndump          ! Next record
      kin = (i-1)*r_ldump + 1
      call decode_header (data(kin))
      k = kin + r_ldpar
      call do_atmosc (data(k), error, i)   ! Get spectrum
      do ia = 1, r_nant
        do ical=1, r_nbb
          ic = r_mapbb(ical)
          dh_aflag(ia) = ior(dh_aflag(ia),sky_flags(ia,ic))
          r_dmaflag(ia) = dh_aflag(ia)
        enddo
      enddo
      call encode_header (data(kin))
    enddo
    kin = r_ldump*r_ndump + 1
    call decode_header (data(kin))
    k = kin + r_ldpar
    call do_atmosc (data(k), error, 0) ! Get spectrum
    k = k + r_ldatc
    call do_atmosl (data(k), error, 1) ! Get spectrum
    call encode_header (data(kin))
    !
    ! Corrected data if present
    if (r_ndatl.gt.1) then
      kin = r_ldump*r_ndump + r_ldpar+r_ldatc+r_ldatl+1
      call decode_header (data(kin))
      k = kin + r_ldpar
      call do_atmosc (data(k), error, 0)   ! Get spectrum
      k = k + r_ldatc
      call do_atmosl (data(k), error, 0)   ! Get spectrum
      call encode_header (data(kin))
    endif
  endif
  r_lfour = .true.
  r_presec(modify_sec) = .true.
  return
end subroutine sub_atmos
!
subroutine do_tsys (monitor, error)
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Compute TSYS from a sky measurement in r_csky.
  !---------------------------------------------------------------------
  logical :: monitor                !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: ia, ip, ical, ic
  logical :: again
  !-----------------------------------------------------------------------
  !
  ! Get current values of cold, chop sky.
  !
  if (r_nbb.le.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
  endif
  do ia=1, r_nant
! Fill the data format with appropriate calibration buffer
    do ical = 1, r_nbb
      ic = r_mapbb(ical)
      ip = r_mappol(ia,ical)
      r_cchop(ic, ia) = c_lev(ia, r_nrec, ic, ip, chop)
      r_ccold(ic, ia) = c_lev(ia, r_nrec, ic, ip, cold)
      r_csky (ic, ia) = c_lev(ia, r_nrec, ic, ip, sky)
    enddo
  enddo
  !
  ! Do calibration
  !
  call do_calib (error)        ! compute TSYS
  if (error) print *,"erreur do_calib"
  if (error) return
  !
  ! do h2o monitor
  !
  if (new_receivers) return !! TBA adapt monitor section
  !
  if (monitor .and. r_presec(atmon_sec)) then
    again = mon_scan.eq.r_scan
    if (again) then
      call r4tor4(h_mon(1,3-r_nrec),r_nrec_mon,matmon)
    else
      !
      ! Get current values of cold, chop sky for monitor.
      !
      do ia=1, r_nant
        r_cchop_mon(ia) = c_lev(ia,2,1,1,chop) !! TBA
        r_ccold_mon(ia) = c_lev(ia,2,1,1,cold) !! TBA
        r_csky_mon(ia)  = c_lev(ia,2,1,1,sky)  !! TBA
      enddo
      mon_scan = r_scan
    endif
    call do_monitor(again, error)
    call r4tor4(r_nrec_mon,h_mon(1,r_nrec),matmon)
  else
    call r4tor4(h_mon(1,r_nrec),r_nrec_mon,matmon)
  endif
end subroutine do_tsys
!
subroutine do_calib (error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! Processes a CAL scan. Autocorrelations on ambient choppper and
  ! Sky have been read in by READ_AUTO.
  ! The chopper standard program is called for each antenna,
  ! in the mode selected in OBS.
  ! The autocorrelation gains are stored in C_C and C_L arrays.
  ! do_test : test the linearity correlator versus total power.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  ! Local
  integer :: ia, ntrec, ilevel, ip, iunit, ic, ical
  real*4 :: awater, tcals, tcali, prec_water
  real*4 :: fmin(mnbb), fmax(mnbb), fs(mnbb), fi(mnbb)
  real*4 :: fcen(mnbb), fif
  logical :: first(mnbb)
  character(len=160) :: ch
  integer :: mode_au,mode_tr
  character(len=2) :: chcode
  !------------------------------------------------------------------------
  ! Code:
  call chtoby('AU  ',mode_au,4)
  call chtoby('TR  ',mode_tr,4)
  ! message level
  ilevel = 0
  if (r_proc.eq.p_cal) ilevel = 6
  ! 
  if (r_nbb.eq.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! Force input values if desired
  do ia = 1, r_nant
    do ip = 1, mnbb
      !
      ! Reset flags !!
      sky_flags(ia,ip) = 0
      !
      ! Water
      if (atm_mode(ia).eq.'AUTO') then
        if (atm_water.eq.0) then
          r_h2omm(ip,ia) =  prec_water(r_tamb,r_humid)
        elseif (atm_water.gt.0) then
          r_h2omm(ip,ia) = atm_water
        endif
        r_cmode(ip,ia) = mode_au
      elseif (atm_mode(ia).eq.'TREC') then
        if (atm_trec(ia).gt.0) then
          r_trec(ip,ia) = atm_trec(ia)
        endif
        r_cmode(ip,ia) = mode_tr
      endif
      !
      ! Gain Image
      ! we should be able to specify ATM_GIM this for polarization...
      if (atm_gim(ia).gt.0) then
        r_gim(ip,ia) = atm_gim(ia) !! TBA yes we should
      endif
    enddo
  enddo
  ! Compute calibration entries IF1 center frequencies
  first = .true.
  do iunit = 1, r_lband
    ic = r_bb(iunit)
    fif = r_flo2(iunit)+r_band2(iunit)*(r_flo2bis(iunit)+r_band2bis(iunit) &
           *r_lfcen(iunit))
    if (first(ic)) then
      fmin(ic) = fif
      fmax(ic) = fif
      first(ic) = .false.
    else
      fmin(ic) = min(fmin(ic),fif) 
      fmax(ic) = max(fmax(ic),fif) 
    endif
  enddo
  do ical = 1, r_nbb
    ic = r_mapbb(ical)
    fcen(ic) = (fmin(ic)+fmax(ic))/2.
    fs(ic)  = (r_flo1+r_sb(ical)*fcen(ic))/1000.
    fi(ic)  = (r_flo1-r_sb(ical)*fcen(ic))/1000.
  enddo 
  r_qual = 1
  !
  ! TREC antennas
  ntrec = 0
  awater = 0
  do ia=1, r_nant
    do ical = 1, r_nbb
      ic = r_mapbb(ical)
      ip = r_mappol(ia,ical)
      if (r_cmode(ic,ia).eq.mode_tr) then
        error = .false.
        call chopper (ic,ia, fs(ic), fi(ic), tcals, tcali, error)
        if (error) then
          integ(ia, r_nrec, ic, ip, chop) = 0
        !                  RETURN
        endif
        write(ch,1000) r_kant(ia), ic, chcode(r_cmode(ic,ia)),   &
          r_h2omm(ic,ia),r_trec(ic,ia), r_tsyss(ic,ia),   &
          r_tsysi(ic,ia)
1000    format('A',i0,1x,'Cal.Unit ',i1,1x,a2,' H2O=',f6.2,' Tr=',f6.2,   &
          ' Ts(S,I)=',2f8.1)
        call message(ilevel,1,'DO_CALIB  ',ch(1:lenc(ch)))
        awater = awater+r_h2omm(ic,ia)
        ntrec = ntrec+1
        !     New version
        if ((r_cchop(ic,ia)-r_csky(ic,ia)).ne.0) then
          tcals = tcals*r_csky(ic,ia) / (r_cchop(ic,ia)   &
            -r_csky(ip,ia))
          tcali = tcali*r_csky(ic,ia) / (r_cchop(ic,ia)   &
            -r_csky(ic,ia))
        else
!          error = .true.
!          return
          tcals = 1.
          tcali = 1.
          print *,"Calibration error Ant. ",ia," input ",ical
        endif
        !     End new version
      endif
    enddo
  enddo
  if (ntrec.gt.0) awater = awater / ntrec
  !
  ! Then other modes
  do ia = 1, r_nant
    do ical = 1, r_nbb
      ic = r_mapbb(ical)
      ip = r_mappol(ia,ical)
      if (r_cmode(ic,ia).eq.mode_au) then
        if (ntrec.gt.0) r_h2omm(ic,ia) = awater
      endif
      if (r_cmode(ic,ia).ne.mode_tr) then
        error = .false.
        call chopper (ic,ia, fs(ic), fi(ic), tcals, tcali, error)
        if (error) then
          integ(ia,r_nrec,ic,ip,chop) = 0
        endif
        write(ch,1000) r_kant(ia), ic, chcode(r_cmode(ic,ia)),   &
          r_h2omm(ic,ia),r_trec(ic,ia), r_tsyss(ic,ia),   &
          r_tsysi(ic,ia)
        call message(ilevel,1,'DO_CALIB  ',ch(1:lenc(ch)))
        tcals = tcals*r_csky(ic,ia) / (r_cchop(ic,ia)   &
          -r_csky(ic,ia))
        tcali = tcali*r_csky(ic,ia) / (r_cchop(ic,ia)   &
          -r_csky(ic,ia))
      endif
    enddo
    !
  enddo
  !
  do ical =1, r_nbb
    ic = r_mapbb(ical)
    write(ch,1001) ic, (r_kant(ia), r_h2omm(ic,ia), ia=1,r_nant   &
      )
1001 format(' H2O Cal.Unit',i1,12(' A',i0,':',f6.1))
    call message(ilevel,1,'DO_CALIB  ',ch(1:lenc(ch)))
    write(ch,1002) ic, (r_kant(ia),  r_tsyss(ic,ia), ia=1   &
      ,r_nant)
1002 format('TSYS Cal.Unit',i1,12(' A',i0,':',f6.0))
    call message(ilevel,1,'DO_CALIB  ',ch(1:lenc(ch)))
  enddo
  !
  return
end subroutine do_calib
!
subroutine do_test(error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_buffers
  !---------------------------------------------------------------------
  ! check subbands for low gain after a sky measurement.
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Local
  integer :: ia, nfl, ic, i, is, i1, ifl(10), ip, ical
  real*4 :: test
  character(len=80) :: ch
  !-----------------------------------------------------------------------
  !
  ! NOT CALLED ANYMORE ....
  !
  ! Flag subbands with low gain
  do ia=1, r_nant
    nfl = 0
    do ic = 1, r_nband
      ical = r_bb(ic)
      ip = r_lpolentry(ia,ic)
      test = c_c(ic,ia,r_nrec,ip,chop)/c_c(ic,ia,r_nrec,ip,sky)   &
        / (r_cchop(ip,ia)/r_csky(ip,ia))
      !     This will cause the calibration to be declared invalid
      if (test .lt. 0.2) then
        sky_flags(ia,ip) =   &
          ior(sky_flags(ia,ip),ishft(1,ic-1))
        write (ch,'(a,i2.2,a,i0,a,i1,a)') 'Subband C',ic,   &
          ' (Ant ',ia,' Pol',ip,') has low gain'
        call message(8,3,'DO_TEST   ',ch(1:lenc(ch)))
        nfl = nfl + 1
        sky_flags(ia,ip) =   &
          ior(sky_flags(ia,ip),ishft(1,ic-1))
        error = .true.
      !     Here we get a flag, but we may go on.
      elseif (test .lt. 0.7 .or. test.gt.1.3) then
        sky_flags(ia,ip) =   &
          ior(sky_flags(ia,ip),ishft(1,ic-1))
        write (ch,'(a,i2.2,a,i0,a,i1,a)') 'Subband C',ic,   &
          ' (Ant ',ia,' Pol',ip,   &
          ') has a linearity problem'
        call message(8,2,'DO_TEST   ',ch(1:lenc(ch)))
        nfl = nfl + 1
        sky_flags(ia,ip) =   &
          ior(sky_flags(ia,ip),ishft(1,ic-1))
        ifl(nfl) = ic
      endif
    enddo
    if (nfl.gt.0) then
      write(ch,'(I2,A,I2,A,20(1X,A))')   &
        nfl,' subbands flagged for antenna ',ia,':',   &
        (csub(ifl(i)),i=1, nfl)
      call message(8,3,'DO_TEST   ',ch(1:lenc(ch)))
    endif
    !     Patch line channels close to LO3's (2 on each side)
    do is=1, r_lband
      ip = r_lpolentry(ia,is)
      i1 = nint(r_lcench(is)-0.5)+r_lich(is)
      if (r_lfres(is).gt.0.1) then
        do i=i1-1, i1
          c_l(i,ia,r_nrec,ip,sky) =   &
            (i-i1+3)*c_l(i1-2,ia,r_nrec,ip,sky)   &
            -(i-i1+2)*c_l(i1-3,ia,r_nrec,ip,sky)
        enddo
        do i=i1+1, i1+2
          c_l(i,ia,r_nrec,ip,sky) =   &
            -(i-i1-4)*c_l(i1+3,ia,r_nrec,ip,sky)   &
            +(i-i1-3)*c_l(i1+4,ia,r_nrec,ip,sky)
        enddo
      endif
    enddo
  enddo
  !
  return
end subroutine do_test
!
subroutine do_atmosc (data, error, ido)
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Process temporal data: apply atmospheric calibration
  ! Input
  !     DATA    COMPLEX(*)
  !     ERROR   LOGICAL      error return
  !     IDO     INTEGER     1 to update the datamodifier section
  !                     (do it only once for the cont and once for the line).
  !---------------------------------------------------------------------
  complex :: data(*)                !
  logical :: error                  !
  integer :: ido                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: k
  integer :: ib, ia, ja, is, ip, ic, ical, jp
  real :: tcalu, tcall, t1, t2, norm, dd, scale
  integer :: ffffff
  data ffffff/z'FFFFFF'/
  !------------------------------------------------------------------------
  ! Code:
  !
  if (r_nbb.le.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
    endif
  ! Get antenna subband Flags from last autocorrelation or calibration
  ! flags may be an issue (how do we specify one polar is down?)
  do ia = 1, r_nant
    do ical = 1, r_nbb
      ip = r_mapbb(ical)
      dh_aflag(ia) = ior(dh_aflag(ia),   &
        iand(sky_flags(ia,ip),ffffff))
      r_dmaflag(ia) = dh_aflag(ia)
      !
      !     New way: use the ratio Tsys / TPower ;
      if (r_sb(ical).eq.1) then
        tcal(ip,1,ia) = r_tsyss(ip,ia)
        tcal(ip,2,ia) = r_tsysi(ip,ia)
      else
        tcal(ip,1,ia) = r_tsysi(ip,ia)
        tcal(ip,2,ia) = r_tsyss(ip,ia)
      endif
      !
      t1 = tcal(ip,1,ia)
      t2 = tcal(ip,2,ia)
      if (r_lfour) then        ! cal done previously
        tcal(ip,1,ia) = t1/dh_atfac(ip,1,ia)
        tcal(ip,2,ia) = t2/dh_atfac(ip,2,ia)
      endif
      dh_atfac(ip,1,ia) = t1
      dh_atfac(ip,2,ia) = t2
      r_dmatfac(ip,1,ia) = t1
      r_dmatfac(ip,2,ia) = t2
    enddo
  enddo
  !
  ! Continuum
  k = 1
  do ib=1, r_nbas
    ia = r_iant(ib)
    ja = r_jant(ib)
    ! nothing to do on flagged DATA
    if ((iand(dh_bflag(ib),ishft(1,31)).eq.0)   &
      .and. (iand(dh_aflag(ia),ishft(1,31)).eq.0)   &
      .and. (iand(dh_aflag(ja),ishft(1,31)).eq.0)) then
      do is = 1, r_nband
        ic = r_bb(is)
        ip = r_lpolentry(ia,is)
        jp = r_lpolentry(ja,is)
        if (r_csky(ic,ia)*r_csky(ic,ja).ne.0) then
          scale = sqrt( s_lev(ia,r_nrec,ic,ip,sky)/r_csky(ic,ia)   &
            * s_lev(ja,r_nrec,ic,jp,sky)/r_csky(ic,ja))
        else
          scale = 1.
        endif
        tcalu = sqrt( abs(tcal(ic,1,ia)*tcal(ic,1,ja)) )   &
          * scale
        tcall = sqrt( abs(tcal(ic,2,ia)*tcal(ic,2,ja)) )   &
          * scale
        dd = abs(data(k))
        if (dd.gt.1e8) then
          dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
        else
          if (r_nsb.eq.2.or.r_sb(is).eq.1) then
            data(k) = data(k) * tcalu
          else
            data(k) = data(k) * tcall
          endif
        endif
        if (r_nsb.eq.2) then
          dd = abs(data(k+r_nband))
          if (dd.gt.1e8) then
            dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
          else
            data(k+r_nband) = data(k+r_nband) * tcall
          endif
        endif
        if (ido.eq.1) then
          r_dmcamp(1,ib,is) = r_dmcamp(1,ib,is)   &
            * tcalu
          r_dmcamp(2,ib,is) = r_dmcamp(2,ib,is)   &
            * tcall
        endif
        if (.not.r_lfour .and. c_c(is,ia,r_nrec,ip,sky).ne.0   &
          .and. c_c(is,ja,r_nrec,jp,sky).ne.0) then
          norm = sqrt(abs(c_c(is,ia,r_nrec,ip,sky)   &
            *c_c(is,ja,r_nrec,jp,sky)))
          if (norm.gt.1e8 .or. norm.lt.1e-8) then
            dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
          else
            data(k) = data(k) / norm
            if (r_nsb.eq.2) data(k+r_nband) = data(k+r_nband) / norm
          endif
        endif
        k = k + 1
      enddo
      if (r_nsb.eq.2) k = k + r_nband
    else
      k = k+r_nsb*r_nband
    endif
  enddo
  do ia = 1, r_nant
    do ip = 1, mnbb
      dh_aflag(ia) = ior(dh_aflag(ia),sky_flags(ia,ip))
      r_dmaflag(ia) = dh_aflag(ia)
    enddo
  enddo
  return
end subroutine do_atmosc
!
subroutine do_atmosl (data, error, ido)
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Process spectral data, after unclipping and fourier transform:
  !     apply atmospheric calibration.
  ! Input
  !     DATA     COMPLEX(*)
  !     ERROR   OGICAL      error return
  !     IDO     INTEGER     1 to update the datamodifier section
  !                     (do it only once for the cont and once for the line
  !---------------------------------------------------------------------
  complex :: data(*)                !
  logical :: error                  !
  integer :: ido                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: k
  integer :: ich, ib, ia, ja, is, icc,ip,jp,ic
  real :: tcalu, tcall, norm, dd, scale
  !------------------------------------------------------------------------
  ! Code:
  if (r_nbb.le.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! Apply to spectral data
  k = 1
  do ib=1, r_nbas
    icc = 1
    ia = r_iant(ib)
    ja = r_jant(ib)
    ! nothing to do on flagged data
    if ((iand(dh_bflag(ib),ishft(1,31)).eq.0)   &
      .and. (iand(dh_aflag(ia),ishft(1,31)).eq.0)   &
      .and. (iand(dh_aflag(ja),ishft(1,31)).eq.0)) then
      do is = 1, r_lband
        ic = r_bb(is)
        ip = r_lpolentry(ia,is)
        jp = r_lpolentry(ja,is)
        if (r_csky(ic,ia)*r_csky(ic,ja).ne.0) then
          scale = sqrt( s_lev(ia,r_nrec,ic,ip,sky)/r_csky(ic,ia)   &
            * s_lev(ja,r_nrec,ic,jp,sky)/r_csky(ic,ja))
        else
          write(6,*) 'ia, ja, r_csky(ic,ia), r_csky(ic,ja)'
          write(6,*) ia, ja, r_csky(ic,ia), r_csky(ic,ja)
          scale = 1.
        endif
        tcalu = sqrt( abs(tcal(ic,1,ia)*tcal(ic,1,ja)) )   &
          *scale
        tcall = sqrt( abs(tcal(ic,2,ia)*tcal(ic,2,ja)) )   &
          *scale
        if (ido.eq.1) then
          r_dmlamp(1,ib,is) = r_dmlamp(1,ib,is)   &
            * tcalu
          r_dmlamp(2,ib,is) = r_dmlamp(2,ib,is)   &
            * tcall
        endif
        do ich = 1, r_lnch(is)
          dd = abs(data(k))
          if (dd.gt.1e8 )  then
            dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
          else
            if (r_lnsb.eq.2.or.r_sb(is).eq.1) then
              data(k) = data(k) * tcalu
            else
              data(k) = data(k) * tcall
            endif
          endif
          if (r_lnsb.eq.2) then
            dd = abs(data(k+r_lntch))
            if (dd.gt.1e8 ) then
              dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
            else
              data(k+r_lntch) = data(k+r_lntch) * tcall
            endif
          endif
          if (.not.r_lfour .and. c_l(icc,ia,r_nrec,ip,sky).ne.0   &
            .and. c_l(icc,ja,r_nrec,jp,sky).ne.0) then
            if (is.gt.r_nbb.and.mod(ich,1024).eq.1) then
              norm = sqrt(abs(c_l(icc+1,ia,r_nrec,ip,sky)   &
                *c_l(icc+1,ja,r_nrec,jp,sky)))
            elseif (is.gt.r_nbb.and.mod(ich,1024).eq.513) then
              norm = sqrt(abs((c_l(icc+1,ia,r_nrec,ip,sky)   &
                 +c_l(icc-1,ia,r_nrec,ip,sky))                &
                *(c_l(icc+1,ja,r_nrec,jp,sky)                &
                 +c_l(icc-1,ja,r_nrec,jp,sky))/4.))
            else
              norm = sqrt(abs(c_l(icc,ia,r_nrec,ip,sky)   &
                *c_l(icc,ja,r_nrec,jp,sky)))
            endif
            if (norm.gt.1e8 .or. norm.lt.1e-8) then
              dh_bflag(ib) = ior(dh_bflag(ib),ishft(1,31))
            else
              data(k) = data(k) / norm
              if (r_lnsb.eq.2) data(k+r_lntch) = data(k+r_lntch) / norm
            endif
          endif
          k = k + 1
          icc = icc +1
        enddo
      enddo
      if (r_lnsb.gt.1) k = k + r_lntch
    else
      k = k + r_lnsb*r_lntch
    endif
  enddo
  !
  do ia = 1, r_nant
    do ip = 1, mnbb
      dh_aflag(ia) = ior(dh_aflag(ia),sky_flags(ia,ip))
      r_dmaflag(ia) = dh_aflag(ia)
    enddo
  enddo
  return
end subroutine do_atmosl
!
subroutine do_auto_atmosc (data, error, ido)
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Process temporal data from a sky autocorrelation spectrum
  ! Input
  !     DATA    REAL(*)
  !     ERROR   LOGICAL      error return
  !     IDO     INTEGER     1 to update the datamodifier section
  !                     (do it only once for the cont and once for the line).
  !---------------------------------------------------------------------
  real :: data(*)                   !
  logical :: error                  !
  integer :: ido                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: k
  integer :: ia, is, ip,ical,ic
  real :: t, scale
  !------------------------------------------------------------------------
  ! Code:
  if (r_nbb.le.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! Get calibration factor
  do ia=1, r_nant
    do ical = 1, r_nbb
      ic = r_mapbb(ical)
      ip = r_mappol(ia,ical)
      !
      ! New way: use the ratio Tsys / TPower ;
      if (r_csky(ic,ia).ne.0) then
        scale = s_lev(ia,r_nrec,ic,ip,sky)/r_csky(ic,ia)
      else
        write(6,*) 'ia, r_csky(ia) : ',ia, r_csky(ic,ia)
        scale = 1.
      endif
      tcal(ic,1,ia) = r_tsyss(ic,ia)
      !
      t = tcal(ic,1,ia)
      if (r_lfour) then
        if (dh_atfac(ic,1,ia).ne.0) then
          tcal(ic,1,ia) = t/dh_atfac(ic,1,ia)
        else
          write(6,*) 'ia, ic, DH_ATFAC(ic,,1,IA) : ',   &
            ia, ic, dh_atfac(ic,1,ia)
        endif
      endif
      dh_atfac(ic,1,ia) = t
      r_dmatfac(ic,1,ia) = t
    enddo
  enddo
  !
  ! Apply to temporal data
  k = 1
  do ia = 1, r_nant
    ! nothing to do on flagged data
    if (iand(dh_aflag(ia),ishft(1,31)).eq.0) then
      do is = 1, r_nband
        ic = r_bb(is)
        ip = r_lpolentry(ia,is)
        if (ido.eq.1) then
          r_dmcamp(1,ia,is) =   &
            r_dmcamp(1,ia,is)*tcal(ic,1,ia)*scale
        endif
        data(k) = data(k) * tcal(ic,1,ia)
        if (.not.r_lfour .and. c_c(is,ia,r_nrec,ip,sky).ne.0)   &
          then
          data(k) = data(k) / c_c(is,ia,r_nrec,ip,sky)
        endif
        k = k + 1
      enddo
    endif
  enddo
end subroutine do_auto_atmosc
!

subroutine do_auto_atmosl (data, error, ido)
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Process a sky autocorrelation spectrum, after unclipping and fourier
  !     transform: apply atmospheric calibration.
  ! Input
  !     DATA     REAL(*)
  !     ERROR   LOGICAL      error return
  !     IDO     INTEGER     1 to update the datamodifier section
  !                     (do it only once for the cont and once for the line).
  !---------------------------------------------------------------------
  real :: data(*)                   !
  logical :: error                  !
  integer :: ido                    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  ! Local
  integer(kind=data_length) :: k
  integer ::  ia, is, ic, ip,icc, ical
  real :: scale
  !------------------------------------------------------------------------
  !     Code:
  if (r_nbb.le.0) then
      print *,"No unit connected to any IF"
      error = .true.
      return
  endif
  !
  ! Apply to spectrum
  k = 1
  do ia = 1, r_nant
    icc = 1
    ! nothing to do on flagged data
    if (iand(dh_aflag(ia),ishft(1,31)).eq.0) then
      do is = 1, r_lband
        ical = r_bb(is)
        ip = r_lpolentry(ia,is)
        if (r_csky(ical,ia).ne.0) then
          scale = s_lev(ia,r_nrec,ical,ip,sky)/r_csky(ical,ia)
        else
          scale = 1.
        endif
        if (ido.eq.1) then
          r_dmlamp(1,ia,is) = r_dmlamp(1,ia,is)   &
            *tcal(ical,1,ia)*scale
        endif
        do ic = 1, r_lnch(is)
          data(k) = data(k)*tcal(ical,1,ia)*scale
          if (.not.r_lfour .and. c_l(icc,ia,r_nrec,ip,sky).ne.0) then
            data(k) = data(k) / c_l(icc,ia,r_nrec,ip,sky)
          endif
          k = k + 1
          icc = icc +1
        enddo
      enddo
    endif
  enddo
  return
end subroutine do_auto_atmosl
!
subroutine do_autol  (mes, data, error)
  use gkernel_interfaces
  use gildas_def
  use classic_params
  use clic_buffers
  !---------------------------------------------------------------------
  ! CLIC
  !     Read in auto correlation function
  !     Increment the C_L and C_C buffers for the specified cal phase "mes".
  ! Input
  !     mes      I           Calibration phase
  !     DATA     REAL(*)     The data.
  !---------------------------------------------------------------------
  integer :: mes                    !
  real :: data(*)                   !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_proc_par.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  real :: calli(mlch)
  real :: c1, c2, cs, cc
  integer(kind=data_length) :: k
  integer :: ia, ic, nc, n1, n2, is, n3, n4, kk, ip, ical
  character(len=80) :: ch
  !------------------------------------------------------------------------
  ! Code:
  ! Increment autocorrelation buffers
  k = 1
  do ia=1, r_nant
    !
    ! First spectra
    do ic =1, r_lntch
      c2 = dh_integ
      call pol_chan(ip,ical,ic,error)
      if (error) return
      c1 = integ(ia,r_nrec,ical,ip,mes)
      !
      cs = c1+c2
      c1 = c1/cs
      c2 = c2/cs
      calli(ic) = data(k)
      if (calli(ic).eq.0) then
2000    format(a,i4,a,i4,a)
        write (ch,2000) 'autocorrelation channel ',ic,' / ',   &
          r_lntch,' is zero'
!        call message(8,1,'DO_AUTOL  ',ch(1:lenc(ch)))
      endif
      k = k + 1
      c_l(ic,ia,r_nrec,ip,mes) =   &
        c1 * c_l(ic,ia,r_nrec,ip,mes) + c2 * calli(ic)
    enddo
    ! Ne doit pas etre ici         CC = 0
    ! Ne doit pas etre ici         NC = 0
    kk = 0
    !
    ! Then continuum
    do is = 1, r_lband
      !
      ! With polarisation, not factorized anymore
      ical = r_bb(is)
      ip = r_lpolentry(ia,is)
      c1 = integ(ia,r_nrec,ical,ip,mes)
      c2 = dh_integ
      cs = c1+c2
      c1 = c1/cs
      c2 = c2/cs
      !
      cc = 0.0                 ! Doit etre ici 09-Jan-1996
      nc = 0                   ! Doit etre ici 09-Jan-1996
      !
      ! avoid center and edges ...
      n1 = nint(r_lnch(is)*0.1)
      n2 = r_lnch(is)/2-1
      n3 = r_lnch(is)/2+2
      n4 = nint(r_lnch(is)*0.9)
      do ic=1, r_lnch(is)
        kk = kk + 1
        if ((ic.ge.n1 .and. ic.le.n2) .or.   &
          (ic.ge.n3 .and. ic.le.n4)) then
          cc = cc + calli(kk)
          nc = nc + 1
        endif
      enddo
      ip = r_lpolentry(ia,is)
      c_c(is,ia,r_nrec,ip,mes) =   &
        c1*c_c(is,ia,r_nrec,ip,mes) + c2*cc/nc
    enddo
    !
    ! ... and sets buffer integration times now
    do ic = 1, r_nbb
      ical = r_mapbb(ic)
      ip = r_mappol(ia,ic)
      ! Sky is polarisation dependent
      if (mes.eq.sky) then
        integ(ia,r_nrec,ical,ip,mes) = integ(ia,r_nrec,ical,ip,mes) &
           + dh_integ
      else
        ! Temp fix. We need cali for each pol each tweak
        do ip = 1, m_pol_rec
          integ(ia,r_nrec,ical,ip,mes) = integ(ia,r_nrec,ical,ip,mes) &
             + dh_integ
        enddo
      endif
    enddo
  enddo
  return
end subroutine do_autol
!
subroutine protect_double(ldata_in,data)
  use classic_api
  !---------------------------------------------------------------------
  ! --- protect total power from occasional doubled values
  !---------------------------------------------------------------------
  integer :: ldata_in               !
  real :: data(ldata_in)            !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: i, ia, kin, nav2, k, ip
  real :: tt(300,m_pol_rec,mnant),ttav, ttav2, ttt(m_pol_rec,mnant)
  !-----------------------------------------------------------------------
  do i=1, r_ndump
    kin = (i-1)*r_ldump+1
    call decode_header(data(kin))
    do ia=1, r_nant
      do ip=1, r_npol_rec
        if (r_npol_rec.eq.1) then
          k = r_lpolentry(1,1) ! To be patched when mixed unit
        else
          k = ip
        endif
        tt(i,k,ia) = dh_total(k,ia)
      enddo
    enddo
  enddo
  do ia=1, r_nant
    do ip=1, r_npol_rec
      if (r_npol_rec.eq.1) then
        k = r_lpolentry(1,1)   ! To be patched when mixed unit
      else
        k= ip
      endif
      ttav = 0
      do i=1, r_ndump
        ttav = ttav + tt(i,k,ia)
      enddo
      ttav = ttav/r_ndump
      nav2 = 0
      ttav2 = 0
      do i=1, r_ndump
        if (tt(i,k,ia)/ttav.lt.1.5 .and. tt(i,k,ia).gt.0.75) then
          ttav2 = ttav2 + tt(i,k,ia)
          nav2 = nav2 + 1
        endif
      enddo
      ttav2 = ttav2/nav2
      ttt(k,ia) = ttav2
    enddo
  enddo
  kin = r_ndump*r_ldump + 1
  call decode_header (data(kin))
  do ia=1, r_nant
    dh_total(k,ia) = ttt(k,ia)
  enddo
  call encode_header (data(kin))
end subroutine protect_double
!
function n_input(error)
  use gildas_def
  use classic_api
  !---------------------------------------------------------------------
  ! Determines the number of correlator entries connected to any unit
  !---------------------------------------------------------------------
  integer :: n_input                !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  ! Local
  logical :: first
  integer :: i, nbc, savenbc
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  first = .true.
  n_input = 0
  !
  do i = 1,r_lband
    nbc = 0
    if (r_lpolmode(i).ne.1) then
      n_input = 2 ! Polarization requires TWO inputs..
      return
    endif
    if (r_iunit(i).lt.9) then
       nbc = r_bb(i)
    endif
    if (first) then
      if (nbc.ne.0) then
        n_input = 1
        savenbc = nbc
        first = .false.
      endif
    endif
    if (nbc.ne.savenbc.and.nbc.ne.0) then
      n_input = 2
      return
    endif
  enddo
  return
end function n_input

      SUBROUTINE RUN_ORBIT (LINE, COMM, ERROR)
C----------------------------------------------------------------------
C	Commands for  orbit language
C
C	Context :
C
C	READ
C       VISU /VELOCITY
C       VISU /ORBIT
C       FIT
C       ADJUST
C       SAVE
C       LIST/DATA
C       LIST/EPHEM
C       GLIESE
C----------------------------------------------------------------------
      LOGICAL ERROR
      CHARACTER*(*) LINE, COMM
*
      if (comm.eq.'READ') then
         call read(line,error)
      elseif (comm.eq.'VISU') then
         call plot(line,error)
      elseif (comm.eq.'FIT') then
         call fit(line,error)
      elseif (comm.eq.'ADJUST') then
         call adjust(line,error)
      elseif (comm.eq.'SAVE') then
         call save(line,error)
      elseif (comm.eq.'LIST') then
         call orbit_list(line,error)
      elseif (comm.eq.'GLIESE') then
         call glinsert(line,error)
      elseif(comm.eq.'FIX') then
         call fix(line,error)
      elseif(comm.eq.'CURSOR') then
         call cursor(line,error)
      elseif(comm.eq.'PERIODOGRAM') then
         call PERIODOGRAM(line,error)
      elseif(comm.eq.'IGNORE') then
         call IGNORE(line,error)
      elseif(comm.eq.'USE') then
         call USE(line,error)
      elseif(comm.eq.'OPTIMISE') then
         call ORBIT_OPTIMISE(line,error)
      else
         WRITE(6,*) 'F-ORBIT, Unknown command ',comm
         goto 99
      endif
      return
*
 99   error = .true.
      return
      end
C<FF>
      SUBROUTINE EXEC_ORBIT(BUFFER)
      LOGICAL ERROR
      CHARACTER*(*) BUFFER
      CHARACTER LINE*255, COMM*12, LANG*12
      INTEGER STATUS, OCODE
*
      LINE = BUFFER
      STATUS = -1
      GOTO 10
*
      ENTRY PLAY_ORBIT(BUFFER)
      LINE = BUFFER
      STATUS = 2
      GOTO 10
*
      ENTRY ENTER_ORBIT
      STATUS = 1
      GOTO 10
*
* Return Ocode -1 : End of subroutine mode
*        Ocode  1 : End of interactive mode
 10   CALL SIC_RUN (LINE,LANG,COMM,ERROR,STATUS,OCODE)
      IF (OCODE.EQ.-1) RETURN
      IF (OCODE.EQ.1) RETURN
      STATUS = OCODE
*
      IF (LANG.EQ.'ORBIT') THEN
         CALL RUN_ORBIT (LINE,COMM,ERROR)
      ELSEIF (LANG.EQ.'SIC') THEN
         CALL RUN_SIC(LINE,COMM,ERROR)
      ELSEIF (LANG.EQ.'GREG1') THEN
         CALL RUN_GREG1 (LINE,COMM,ERROR)
      ELSEIF (LANG.EQ.'GREG2') THEN
         CALL RUN_GREG2 (LINE,COMM,ERROR)
      ELSEIF (LANG.EQ.'GTVL') THEN
         CALL RUN_GTVL(LINE,COMM,ERROR)
      ELSE
         WRITE(6,*) 'Unrecognized Language ',LANG
         ERROR = .TRUE.
      ENDIF
      GOTO 10
      RETURN
      END

! ABSTRACT:
!   Simulated annealing is a global optimization method that distinguishes
!   between different local optima. Starting from an initial point, the
!   algorithm takes a step and the function is evaluated. When minimizing a
!   function, any downhill step is accepted and the process repeats from this
!   new point. An uphill step may be accepted. Thus, it can escape from local
!   optima. This uphill decision is made by the Metropolis criteria. As the
!   optimization process proceeds, the length of the steps decline and the
!   algorithm closes in on the global optimum. Since the algorithm makes very
!   few assumptions regarding the function to be optimized, it is quite
!   robust with respect to non-quadratic surfaces. The degree of robustness
!   can be adjusted by the user. In fact, simulated annealing can be used as
!   a local optimizer for difficult functions.
!
!   This implementation of simulated annealing was used in "Global Optimizatio
!   of Statistical Functions with Simulated Annealing," Goffe, Ferrier and
!   Rogers, Journal of Econometrics, vol. 60, no. 1/2, Jan./Feb. 1994, pp.
!   65-100. Briefly, we found it competitive, if not superior, to multiple
!   restarts of conventional optimization routines for difficult optimization
!   problems.
!
!   For more information on this routine, contact its author:
!   Bill Goffe, bgoffe@whale.st.usm.edu
!
!   This version was edited to change name conventions to avoid
!   conflict with user namespace
!
subroutine simann(n,x,max,rt,eps,ns,nt,neps,maxevl,lb,ub,c,iprint,iseed1,  &
  iseed2,t,vm,xopt,fopt,nacc,nfcnev,nobds,ier,fstar,xp,nacp, fcn)
  use sic_interfaces, except_this=>simann
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Version: 3.2
  !  Date: 1/22/94.
  !  Differences compared to Version 2.0:
  !     1. If a trial is out of bounds, a point is randomly selected
  !        from LB(i) to UB(i). Unlike in version 2.0, this trial is
  !        evaluated and is counted in acceptances and rejections.
  !        All corresponding documentation was changed as well.
  !  Differences compared to Version 3.0:
  !     1. If VM(i) > (UB(i) - LB(i)), VM is set to UB(i) - LB(i).
  !        The idea is that if T is high relative to LB & UB, most
  !        points will be accepted, causing VM to rise. But, in this
  !        situation, VM has little meaning; particularly if VM is
  !        larger than the acceptable region. Setting VM to this size
  !        still allows all parts of the allowable region to be selected.
  !  Differences compared to Version 3.1:
  !     1. Test made to see if the initial temperature is positive.
  !     2. WRITE statements prettied up.
  !     3. References to paper updated.
  !
  !  Synopsis:
  !  This routine implements the continuous simulated annealing global
  !  optimization algorithm described in Corana et al.'s article
  !  "Minimizing Multimodal Functions of Continuous Variables with the
  !  "Simulated Annealing" Algorithm" in the September 1987 (vol. 13,
  !  no. 3, pp. 262-280) issue of the ACM Transactions on Mathematical
  !  Software.
  !
  !  A very quick (perhaps too quick) overview of SA:
  !     SA tries to find the global optimum of an N dimensional function.
  !  It moves both up and downhill and as the optimization process
  !  proceeds, it focuses on the most promising area.
  !     To start, it randomly chooses a trial point within the step length
  !  VM (a vector of length N) of the user selected starting point. The
  !  function is evaluated at this trial point and its value is compared
  !  to its value at the initial point.
  !     In a maximization problem, all uphill moves are accepted and the
  !  algorithm continues from that trial point. Downhill moves may be
  !  accepted; the decision is made by the Metropolis criteria. It uses T
  !  (temperature) and the size of the downhill move in a probabilistic
  !  manner. The smaller T and the size of the downhill move are, the more
  !  likely that move will be accepted. If the trial is accepted, the
  !  algorithm moves on from that point. If it is rejected, another point
  !  is chosen instead for a trial evaluation.
  !     Each element of VM periodically adjusted so that half of all
  !  function evaluations in that direction are accepted.
  !     A fall in T is imposed upon the system with the RT variable by
  !  T(i+1) = RT*T(i) where i is the ith iteration. Thus, as T declines,
  !  downhill moves are less likely to be accepted and the percentage of
  !  rejections rise. Given the scheme for the selection for VM, VM falls.
  !  Thus, as T declines, VM falls and SA focuses upon the most promising
  !  area for optimization.
  !
  !  The importance of the parameter T:
  !     The parameter T is crucial in using SA successfully. It influences
  !  VM, the step length over which the algorithm searches for optima. For
  !  a small intial T, the step length may be too small; thus not enough
  !  of the function might be evaluated to find the global optima. The user
  !  should carefully examine VM in the intermediate output (set IPRINT =
  !  1) to make sure that VM is appropriate. The relationship between the
  !  initial temperature and the resulting step length is function
  !  dependent.
  !     To determine the starting temperature that is consistent with
  !  optimizing a function, it is worthwhile to run a trial run first. Set
  !  RT = 1.5 and T = 1.0. With RT > 1.0, the temperature increases and VM
  !  rises as well. Then select the T that produces a large enough VM.
  !
  !  For modifications to the algorithm and many details on its use,
  !  (particularly for econometric applications) see Goffe, Ferrier
  !  and Rogers, "Global Optimization of Statistical Functions with
  !  Simulated Annealing," Journal of Econometrics, vol. 60, no. 1/2,
  !  Jan./Feb. 1994, pp. 65-100.
  !  For more information, contact
  !              Bill Goffe
  !              Department of Economics and International Business
  !              University of Southern Mississippi
  !              Hattiesburg, MS  39506-5072
  !              (601) 266-4484 (office)
  !              (601) 266-4920 (fax)
  !              bgoffe@whale.st.usm.edu (Internet)
  !
  !  As far as possible, the parameters here have the same name as in
  !  the description of the algorithm on pp. 266-8 of Corana et al.
  !
  !  In this description, SP is single precision, DP is real(kind=8) ,
  !  INT is integer, L is logical and (N) denotes an array of length n.
  !  Thus, DP(N) denotes a real(kind=8)  array of length n.
  !
  !  Input Parameters:
  !    Note: The suggested values generally come from Corana et al. To
  !          drastically reduce runtime, see Goffe et al., pp. 90-1 for
  !          suggestions on choosing the appropriate RT and NT.
  !    N - Number of variables in the function to be optimized. (INT)
  !    X - The starting values for the variables of the function to be
  !        optimized. (DP(N))
  !    MAX - Denotes whether the function should be maximized or
  !          minimized. A true value denotes maximization while a false
  !          value denotes minimization. Intermediate output (see IPRINT)
  !          takes this into account. (L)
  !    RT - The temperature reduction factor. The value suggested by
  !         Corana et al. is .85. See Goffe et al. for more advice. (DP)
  !    EPS - Error tolerance for termination. If the final function
  !          values from the last neps temperatures differ from the
  !          corresponding value at the current temperature by less than
  !          EPS and the final function value at the current temperature
  !          differs from the current optimal function value by less than
  !          EPS, execution terminates and IER = 0 is returned. (EP)
  !    NS - Number of cycles. After NS*N function evaluations, each
  !         element of VM is adjusted so that approximately half of
  !         all function evaluations are accepted. The suggested value
  !         is 20. (INT)
  !    NT - Number of iterations before temperature reduction. After
  !         NT*NS*N function evaluations, temperature (T) is changed
  !         by the factor RT. Value suggested by Corana et al. is
  !         MAX(100, 5*N). See Goffe et al. for further advice. (INT)
  !    NEPS - Number of final function values used to decide upon termi-
  !           nation. See EPS. Suggested value is 4. (INT)
  !    MAXEVL - The maximum number of function evaluations. If it is
  !             exceeded, IER = 1. (INT)
  !    LB - The lower bound for the allowable solution variables. (DP(N))
  !    UB - The upper bound for the allowable solution variables. (DP(N))
  !         If the algorithm chooses X(I) .LT. LB(I) or X(I) .GT. UB(I),
  !         I = 1, N, a point is from inside is randomly selected. This
  !         This focuses the algorithm on the region inside UB and LB.
  !         Unless the user wishes to concentrate the search to a par-
  !         ticular region, UB and LB should be set to very large positive
  !         and negative values, respectively. Note that the starting
  !         vector X should be inside this region. Also note that LB and
  !         UB are fixed in position, while VM is centered on the last
  !         accepted trial set of variables that optimizes the function.
  !    C - Vector that controls the step length adjustment. The suggested
  !        value for all elements is 2.0. (DP(N))
  !    IPRINT - controls printing inside SA. (INT)
  !             Values: 0 - Nothing printed.
  !                     1 - Function value for the starting value and
  !                         summary results before each temperature
  !                         reduction. This includes the optimal
  !                         function value found so far, the total
  !                         number of moves (broken up into uphill,
  !                         downhill, accepted and rejected), the
  !                         number of out of bounds trials, the
  !                         number of new optima found at this
  !                         temperature, the current optimal X and
  !                         the step length VM. Note that there are
  !                         N*NS*NT function evalutations before each
  !                         temperature reduction. Finally, notice is
  !                         is also given upon achieveing the termination
  !                         criteria.
  !                     2 - Each new step length (VM), the current optimal
  !                         X (XOPT) and the current trial X (X). This
  !                         gives the user some idea about how far X
  !                         strays from XOPT as well as how VM is adapting
  !                         to the function.
  !                     3 - Each function evaluation, its acceptance or
  !                         rejection and new optima. For many problems,
  !                         this option will likely require a small tree
  !                         if hard copy is used. This option is best
  !                         used to learn about the algorithm. A small
  !                         value for MAXEVL is thus recommended when
  !                         using IPRINT = 3.
  !             Suggested value: 1
  !             Note: For a given value of IPRINT, the lower valued
  !                   options (other than 0) are utilized.
  !    ISEED1 - The first seed for the random number generator RANMAR.
  !             0 .LE. ISEED1 .LE. 31328. (INT)
  !    ISEED2 - The second seed for the random number generator RANMAR.
  !             0 .LE. ISEED2 .LE. 30081. Different values for ISEED1
  !             and ISEED2 will lead to an entirely different sequence
  !             of trial points and decisions on downhill moves (when
  !             maximizing). See Goffe et al. on how this can be used
  !             to test the results of SA. (INT)
  !
  !  Input/Output Parameters:
  !    T - On input, the initial temperature. See Goffe et al. for advice.
  !        On output, the final temperature. (DP)
  !    VM - The step length vector. On input it should encompass the
  !         region of interest given the starting value X. For point
  !         X(I), the next trial point is selected is from X(I) - VM(I)
  !         to  X(I) + VM(I). Since VM is adjusted so that about half
  !         of all points are accepted, the input value is not very
  !         important (i.e. is the value is off, SA adjusts VM to the
  !         correct value). (DP(N))
  !
  !  Output Parameters:
  !    XOPT - The variables that optimize the function. (DP(N))
  !    FOPT - The optimal value of the function. (DP)
  !    NACC - The number of accepted function evaluations. (INT)
  !    NFCNEV - The total number of function evaluations. In a minor
  !             point, note that the first evaluation is not used in the
  !             core of the algorithm; it simply initializes the
  !             algorithm. (INT).
  !    NOBDS - The total number of trial function evaluations that
  !            would have been out of bounds of LB and UB. Note that
  !            a trial point is randomly selected between LB and UB.
  !            (INT)
  !    IER - The error return number. (INT)
  !          Values: 0 - Normal return; termination criteria achieved.
  !                  1 - Number of function evaluations (NFCNEV) is
  !                      greater than the maximum number (MAXEVL).
  !                  2 - The starting value (X) is not inside the
  !                      bounds (LB and UB).
  !                  3 - The initial temperature is not positive.
  !                  99 - Should not be seen; only used internally.
  !
  !  Work arrays that must be dimensioned in the calling routine:
  !       RWK1 (DP(NEPS))  (FSTAR in SA)
  !       RWK2 (DP(N))     (XP    "  " )
  !       IWK  (INT(N))    (NACP  "  " )
  !
  !  Required Functions (included):
  !    EXPREP - Replaces the function EXP to avoid under- and overflows.
  !             It may have to be modified for non IBM-type main-
  !             frames. (DP)
  !    RMARIN - Initializes the random number generator RANMAR.
  !    RANMAR - The actual random number generator. Note that
  !             RMARIN must run first (SA does this). It produces uniform
  !             random numbers on [0,1]. These routines are from
  !             Usenet's comp.lang.fortran. For a reference, see
  !             "Toward a Universal Random Number Generator"
  !             by George Marsaglia and Arif Zaman, Florida State
  !             University Report: FSU-SCRI-87-50 (1987).
  !             It was later modified by F. James and published in
  !             "A Review of Pseudo-random Number Generators." For
  !             further information, contact stuart@ads.com. These
  !             routines are designed to be portable on any machine
  !             with a 24-bit or more mantissa. I have found it produces
  !             identical results on a IBM 3081 and a Cray Y-MP.
  !
  !  Required Subroutines (included):
  !    SIMAN_PRTVEC - Prints vectors.
  !    SIMAN_PRT1 ... SIMAN_PRT10 - Prints intermediate output.
  !    FCN - Function to be optimized. The form is
  !            SUBROUTINE FCN(N,X,F)
  !            INTEGER N
  !            real(kind=8)   X(N), F
  !            ...
  !            function code with F = F(X)
  !            ...
  !            RETURN
  !            END
  !          Note: This is the same form used in the multivariable
  !          minimization algorithms in the IMSL edition 10 library.
  !
  !  Machine Specific Features:
  !    1. EXPREP may have to be modified if used on non-IBM type main-
  !       frames. Watch for under- and overflows in EXPREP.
  !    2. Some FORMAT statements use G25.18; this may be excessive for
  !       some machines.
  !    3. RMARIN and RANMAR are designed to be protable; they should not
  !       cause any problems.
  !  Type all external variables.
  !---------------------------------------------------------------------
  integer ::  n                     !
  real(kind=8) ::   x(*)            !
  logical ::  max                   !
  real(kind=8) ::   rt              !
  real(kind=8) ::   eps             !
  integer ::  ns                    !
  integer ::  nt                    !
  integer ::  neps                  !
  integer ::  maxevl                !
  real(kind=8) ::   lb(*)           !
  real(kind=8) ::   ub(*)           !
  real(kind=8) ::   c(*)            !
  integer ::  iprint                !
  integer ::  iseed1                !
  integer ::  iseed2                !
  real(kind=8) ::   t               !
  real(kind=8) ::   vm(*)           !
  real(kind=8) ::   xopt(*)         !
  real(kind=8) ::   fopt            !
  integer ::  nacc                  !
  integer ::  nfcnev                !
  integer ::  nobds                 !
  integer ::  ier                   !
  real(kind=8) ::   fstar(*)        !
  real(kind=8) ::   xp(*)           !
  integer ::  nacp(*)               !
  external :: fcn                   !
  ! Local
  !  Type all internal variables.
  real(kind=8) ::   f, fp, p, pp, ratio
  integer ::  nup, ndown, nrej, nnew, lnobds, h, i, j, m
  logical ::  quit
  !  Messaging
  character(len=message_length) :: mess
  character(len=6) :: rname = 'ANNEAL'
  !
  !  Initialize the random number generator RANMAR.
  call rmarin(iseed1,iseed2)
  !  Set initial values.
  nacc = 0
  nobds = 0
  nfcnev = 0
  ier = 99
  !
  xopt(1:n) = x(1:n)
  nacp(1:n) = 0
  fstar(1:neps) = 1.0d+20
  !
  !  If the initial temperature is not positive, notify the user and
  !  return to the calling routine.
  if (t .le. 0.0) then
     write(mess,*) 'Annealing temperature is negative ',T
     call sic_message (seve%e,rname,mess)
     ier = 3
     return
  endif
  !  If the initial value is out of bounds, notify the user and return
  !  to the calling routine.
  do i = 1, n
     if ((x(i) .gt. ub(i)) .or. (x(i) .lt. lb(i))) then
        call siman_prt1
        ier = 2
        return
     endif
  enddo
  !  Evaluate the function with input X and return value as F.
  call fcn(n,x,f,ier)
  !  If the function is to be minimized, switch the sign of the function.
  !  Note that all intermediate and final output switches the sign back
  !  to eliminate any possible confusion for the user.
  if (.not. max) f = -f
  nfcnev = nfcnev + 1
  fopt = f
  fstar(1) = f
  if (iprint .ge. 1) call siman_prt2(max,n,x,f)
  !  Start the main loop. Note that it terminates if (i) the algorithm
  !  succesfully optimizes the function or (ii) there are too many
  !  function evaluations (more than MAXEVL).
  do while (.true.)
     nup = 0
     nrej = 0
     nnew = 0
     ndown = 0
     lnobds = 0
     !
     do m = 1, nt
        do j = 1, ns
           do h = 1, n
              !  Generate XP, the trial value of X. Note use of VM to choose XP.
              do i = 1, n
                 if (i .eq. h) then
                    xp(i) = x(i) + (ranmar()*2.- 1.) * vm(i)
                 else
                    xp(i) = x(i)
                 endif
                 !  If XP is out of bounds, select a point in bounds for the trial.
                 if ((xp(i) .lt. lb(i)) .or. (xp(i) .gt. ub(i))) then
                    xp(i) = lb(i) + (ub(i) - lb(i))*ranmar()
                    lnobds = lnobds + 1
                    nobds = nobds + 1
                    if (iprint .ge. 3) call siman_prt3(max,n,xp,x,fp,f)
                 endif
              enddo
              !  Evaluate the function with the trial point XP and return as FP.
              call fcn(n,xp,fp,ier)
              if (ier.eq.-1) then
                 call sic_message (seve%i,rname,'Aborted by user (^C)')
                 return
              endif
              if (.not. max) fp = -fp
              nfcnev = nfcnev + 1
              if (iprint .ge. 3) call siman_prt4(max,n,xp,x,fp,f)
              !  If too many function evaluations occur, terminate the algorithm.
              if (nfcnev .ge. maxevl) then
                 if (iprint.ge.0) then
                    call sic_message (seve%w,rname,'Too many functions evaluations')
                    write(mess,*) 'Increase MAXEVL ',maxevl,' or EPS ',eps
                    call sic_message (seve%w,rname,mess)
                 endif
                 if (.not. max) fopt = -fopt
                 ier = 1
                 return
              endif
              !  Accept the new point if the function value increases.
              if (fp .ge. f) then
                 if (iprint .ge. 3) then
                    write(*,'(''  POINT ACCEPTED'')')
                 endif
                 x(1:n) = xp(1:n)
                 f = fp
                 nacc = nacc + 1
                 nacp(h) = nacp(h) + 1
                 nup = nup + 1
                 !  If greater than any other point, record as new optimum.
                 if (fp .gt. fopt) then
                    if (iprint .ge. 3) then
                       write(*,'(''  NEW OPTIMUM'')')
                    endif
                    xopt(1:n) = xp(1:n)
                    fopt = fp
                    nnew = nnew + 1
                 endif
                 !  If the point is lower, use the Metropolis criteria to decide on
                 !  acceptance or rejection.
              else
                 p = exprep((fp - f)/t)
                 pp = ranmar()
                 if (pp .lt. p) then
                    if (iprint .ge. 3) call siman_prt6(max)
                    x(1:n) = xp(1:n)
                    f = fp
                    nacc = nacc + 1
                    nacp(h) = nacp(h) + 1
                    ndown = ndown + 1
                 else
                    nrej = nrej + 1
                    if (iprint .ge. 3) call siman_prt7(max)
                 endif
              endif
           enddo
        enddo
        !  Adjust VM so that approximately half of all evaluations are accepted.
        do i = 1, n
           ratio = dfloat(nacp(i)) /dfloat(ns)
           if (ratio .gt. .6) then
              vm(i) = vm(i)*(1. + c(i)*(ratio - .6)/.4)
           elseif  (ratio .lt. .4) then
              vm(i) = vm(i)/(1. + c(i)*((.4 - ratio)/.4))
           endif
           if (vm(i) .gt. (ub(i)-lb(i))) then
              vm(i) = ub(i) - lb(i)
           endif
        enddo
        if (iprint .ge. 2) then
           call siman_prt8(n,vm,xopt,x)
        endif
        nacp(1:n) = 0
     enddo
     !
     if (iprint .ge. 1) then
        call siman_prt9(max,n,t,xopt,vm,fopt,nup,ndown,nrej,lnobds,nnew)
     endif
     !  Check termination criteria.
     quit = .false.
     fstar(1) = f
     if ((fopt - fstar(1)) .le. eps) quit = .true.
     do i = 1, neps
        if (abs(f - fstar(i)) .gt. eps) quit = .false.
     enddo
     !  Terminate SA if appropriate.
     if (quit) then
        x(1:n) = xopt(1:n)
        ier = 0
        if (.not. max) fopt = -fopt
        if (iprint.ge.0) then
           write(mess,*) 'Termination criterium achieved ',ier,nfcnev
           call sic_message (seve%i,rname,mess)
        endif
        return
     endif
     !
     !  If termination criteria is not met, prepare for another loop.
     t = rt*t
     do i = neps, 2, -1
        fstar(i) = fstar(i-1)
     enddo
     f = fopt
     x(1:n) = xopt(1:n)
     !  Loop again.
  enddo
end subroutine simann
!
function exprep(rdum)
  !---------------------------------------------------------------------
  ! @ private
  !  This function replaces exp to avoid under- and overflows and is
  !  designed for IBM 370 type machines. It may be necessary to modify
  !  it for other machines. Note that the maximum and minimum values of
  !  EXPREP are such that they has no effect on the algorithm.
  !---------------------------------------------------------------------
  real(kind=8) :: exprep  ! Function value on return
  real(kind=8), intent(in) :: rdum  !
  !
  if (rdum.gt.174.d0) then
     exprep = 3.69d+75
  elseif (rdum.lt.-180.d0) then
     exprep = 0.0
  else
     exprep = exp(rdum)
  endif
  !
end function exprep
!
subroutine rmarin(ij,kl)
  use sic_interfaces, except_this=>rmarin
  !---------------------------------------------------------------------
  ! @ private
  !  This subroutine and the next function generate random numbers. See
  !  the comments for SA for more information. The only changes from the
  !  orginal code is that (1) the test to make sure that RMARIN runs first
  !  was taken out since SA assures that this is done (this test didn't
  !  compile under IBM's VS Fortran) and (2) typing ivec as integer was
  !  taken out since ivec isn't used. With these exceptions, all following
  !  lines are original.
  ! This is the initialization routine for the random number generator
  !     RANMAR()
  ! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
  !                                                      0 <= KL <= 30081
  !---------------------------------------------------------------------
  integer :: ij                     !
  integer :: kl                     !
  ! Local
  real :: u(97), c, cd, cm
  integer :: i97, j97
  common /raset1/ u, c, cd, cm, i97, j97
  !
  integer :: i,j,k,l, ii, jj, m
  real :: s, t
  !
  if ( ij.lt.0 .or. ij.gt.31328 .or. kl.lt.0 .or. kl.gt.30081 ) then
     print '(A)',' The first random number seed must have a value '//  &
     'between 0 and 31328'
     print '(A)',' The second seed must have a value between 0 and 30081'
     stop
  endif
  i = mod(ij/177, 177) + 2
  j = mod(ij    , 177) + 2
  k = mod(kl/169, 178) + 1
  l = mod(kl,     169)
  !
  do ii = 1, 97
     s = 0.0
     t = 0.5
     do jj = 1, 24
        m = mod(mod(i*j, 179)*k, 179)
        i = j
        j = k
        k = m
        l = mod(53*l+1, 169)
        if (mod(l*m, 64) .ge. 32) then
           s = s + t
        endif
        t = 0.5 * t
     enddo
     u(ii) = s
  enddo
  !
  c = 362436.0 / 16777216.0
  cd = 7654321.0 / 16777216.0
  cm = 16777213.0 /16777216.0
  i97 = 97
  j97 = 33
  return
end subroutine rmarin
!
function ranmar()
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real :: ranmar                    !
  ! Local
  real :: u(97), c, cd, cm
  integer :: i97, j97
  common /raset1/ u, c, cd, cm, i97, j97
  !
  real :: uni
  !
  uni = u(i97) - u(j97)
  if ( uni .lt. 0.0 ) uni = uni + 1.0
  u(i97) = uni
  i97 = i97 - 1
  if (i97 .eq. 0) i97 = 97
  j97 = j97 - 1
  if (j97 .eq. 0) j97 = 97
  c = c - cd
  if ( c .lt. 0.0 ) c = c + cm
  uni = uni - c
  if ( uni .lt. 0.0 ) uni = uni + 1.0
  ranmar = uni
  !
end function ranmar
!
subroutine siman_prt1
  !---------------------------------------------------------------------
  ! @ private
  !  This subroutine prints intermediate output, as does SIMAN_PRT2 through
  !  SIMAN_PRT10. Note that if SA is minimizing the function, the sign of the
  !  function value and the directions (up/down) are reversed in all
  !  output to correspond with the actual function optimization. This
  !  correction is because SA was written to maximize functions and
  !  it minimizes by maximizing the negative a function.
  !---------------------------------------------------------------------
  write(*,'(/,''  The starting value (X) is outside the bounds ''  &
       &    /,''  (LB and UB). execution terminated without any''  &
       &    /,''  optimization. respecify X, UB or LB so that  ''  &
       &    /,''  LB(I) .LT. X(I) .LT. UB(I), I = 1, N. ''/)')
  return
end subroutine siman_prt1
!
subroutine siman_prt2(max,n,x,f)
  use sic_interfaces, except_this=>siman_prt2
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  integer ::  n                     !
  real(kind=8) ::   x(*)            !
  real(kind=8) ::   f               !
  !
  write(*,'(''  '')')
  call siman_prtvec(x,n,'Initial X')
  if (max) then
     write(*,'(''  Initial F: '',1PG25.18)') f
  else
     write(*,'(''  Initial F: '',1PG25.18)') -f
  endif
  return
end subroutine siman_prt2
!
subroutine siman_prt3(max,n,xp,x,fp,f)
  use sic_interfaces, except_this=>siman_prt3
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  integer ::  n                     !
  real(kind=8) ::   xp(*)           !
  real(kind=8) ::   x(*)            !
  real(kind=8) ::   fp              !
  real(kind=8) ::   f               !
  !
  write(*,'(''  '')')
  call siman_prtvec(x,n,'Current X')
  if (max) then
     write(*,'(''  Current F: '',1PG25.18)') f
  else
     write(*,'(''  Current F: '',1PG25.18)') -f
  endif
  call siman_prtvec(xp,n,'Trial X')
  write(*,'(''  Point rejected since out of bounds'')')
  return
end subroutine siman_prt3
!
subroutine siman_prt4(max,n,xp,x,fp,f)
  use sic_interfaces, except_this=>siman_prt4
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  integer ::  n                     !
  real(kind=8) ::   xp(*)           !
  real(kind=8) ::   x(*)            !
  real(kind=8) ::   fp              !
  real(kind=8) ::   f               !
  !
  write(*,'(''  '')')
  call siman_prtvec(x,n,'Current X')
  if (max) then
     write(*,'(''  Current F: '',1PG25.18)') f
     call siman_prtvec(xp,n,'Trial X')
     write(*,'(''  Resulting F: '',1PG25.18)') fp
  else
     write(*,'(''  Current F: '',1PG25.18)') -f
     call siman_prtvec(xp,n,'Trial X')
     write(*,'(''  Resulting F: '',1PG25.18)') -fp
  endif
  return
end subroutine siman_prt4
!
subroutine siman_prt6(max)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  if (max) then
     write(*,'(''  Though lower, point accepted'')')
  else
     write(*,'(''  Though higher, point accepted'')')
  endif
  return
end subroutine siman_prt6
!
subroutine siman_prt7(max)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  if (max) then
     write(*,'(''  Lower point rejected'')')
  else
     write(*,'(''  Higher point rejected'')')
  endif
  return
end subroutine siman_prt7
!
subroutine siman_prt8(n,vm,xopt,x)
  use sic_interfaces, except_this=>siman_prt8
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer ::  n                     !
  real(kind=8) ::   vm(*)           !
  real(kind=8) ::   xopt(*)         !
  real(kind=8) ::   x(*)            !
  !
  write(*,'(/,'' Intermediate results after step length adjustment'',/)')
  call siman_prtvec(vm,n,'New step length (VM)')
  call siman_prtvec(xopt,n,'Current optimal X')
  call siman_prtvec(x,n,'Current X')
  write(*,'('' '')')
  return
end subroutine siman_prt8
!
subroutine siman_prt9(max,n,t,xopt,vm,fopt,nup,ndown,nrej,lnobds,nnew)
  use sic_interfaces, except_this=>siman_prt9
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical ::  max                   !
  integer ::  n                     !
  real(kind=8) ::   t               !
  real(kind=8) ::   xopt(*)         !
  real(kind=8) ::   vm(*)           !
  real(kind=8) ::   fopt            !
  integer ::  nup                   !
  integer ::  ndown                 !
  integer ::  nrej                  !
  integer ::  lnobds                !
  integer ::  nnew                  !
  ! Local
  integer ::  totmov
  !
  totmov = nup + ndown + nrej
  write(*,'(/,'' Intermediate results before next temperature reduction'',/)')
  write(*,'(''  Current temperature:            '',G12.5)') t
  if (max) then
     write(*,'(''  Max value so far:  '',G25.18)') fopt
     write(*,'(''  Total moves:                '',i8)') totmov
     write(*,'(''     Uphill:                  '',i8)') nup
     write(*,'(''     Accepted Downhill:       '',i8)') ndown
     write(*,'(''     Rejected Downhill:       '',i8)') nrej
     write(*,'(''  Out of bounds trials:       '',i8)') lnobds
     write(*,'(''  New maxima this temperature:'',i8)') nnew
  else
     write(*,'(''  Min value so far:  '',g25.18)') -fopt
     write(*,'(''  Total moves:                '',i8)') totmov
     write(*,'(''     Downhill:                '',i8)')  nup
     write(*,'(''     Accepted uphill:         '',i8)')  ndown
     write(*,'(''     Rejected uphill:         '',i8)')  nrej
     write(*,'(''  Trials out of bounds:       '',i8)')  lnobds
     write(*,'(''  New minima this temperature:'',i8)')  nnew
  endif
  call siman_prtvec(xopt,n,'Current optimal X')
  call siman_prtvec(vm,n,'Step length (VM)')
  write(*,'('' '')')
  return
end subroutine siman_prt9
    !
subroutine siman_prtvec(vector,ncols,name)
  !---------------------------------------------------------------------
  ! @ private
  !  This subroutine prints the real(kind=8)  vector named VECTOR.
  !  Elements 1 thru NCOLS will be printed. NAME is a character variable
  !  that describes VECTOR. Note that if NAME is given in the call to
  !  SIMAN_PRTVEC, it must be enclosed in quotes. If there are more than 10
  !  elements in VECTOR, 10 elements will be printed on each line.
  !---------------------------------------------------------------------
  integer :: ncols                  !
  real(kind=8) ::  vector(ncols)    !
  character(len=*) :: name          !
  !
  write(*,1001) name
  write(*,1000) vector
  !
1000 format(10(g12.5,1x))
1001 format(/,25x,a)
  return
end subroutine siman_prtvec

subroutine titout(type,error)
  use gkernel_interfaces
  use gbl_constant
  use gildas_def
  use clic_title
  use classic_api  
  !---------------------------------------------------------------------
  ! CLIC	Internal routine
  !	Write a title
  ! Arguments :
  !	TYPE	C*(*)	Type of title to be displayed:
  !
  !      FULL = all informations - used by HEADER command
  !      LONG = part/all informations, depending on SET FORMAT  - used by
  !             LIST /LONG command
  !      SHORT/ZHORT = first/last scans on same line - used by LIST /SHORT
  !             command; NB: SHORT = first pass, ZHORT = 2nd pass
  !      NORMAL = summary information on one line - used by LIST, PLOT,
  !             CURSOR commands
  !      PLOT/BLOT = special for PLOT command (NGRx); NB: PLOT = first
  !             pass, BLOT = 2nd pass
  !---------------------------------------------------------------------
  character(len=*) :: type          !
  logical :: error                  !
  ! Global
  character(len=4) :: procname
  include 'clic_parameter.inc'
  include 'gbl_pi.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_title.inc'
  include 'clic_display.inc'
  include 'clic_dheader.inc'
  ! Local
  integer :: mg
  parameter (mg=1000)
  integer :: ng, sg(2,mg)
  common/scan_group/ng, sg
  save /scan_group/
  character(len=60) :: pad
  character(len=255) :: ch,ch1,ch2
  character(len=2) :: systext(0:6)
  character(len=5) :: veltext(0:4)
  integer :: i, l_ifpb, lch, npad, npad1, ier
  logical :: long, full, short, plot
  character(len=1) :: chartype(0:3), ctype
  character(len=4) :: cproc
  integer :: msourc(3),mline(3),mteles(3), mscan, nscan, mproject(2), mnum
  character(len=11) :: mch1
  character(len=4) :: mctype,mcproc
  character(len=5) :: mch2
  real :: nhoura, mhoura
  character(len=11) :: mdate
  real*8 :: lut8
  character(len=12) :: aline
  character(len=8) :: aproject
  character(len=12) :: ateles,asourc
  integer :: qq, quarter, corr_input, intw
  character(len=36) :: narrow(2)
  character(len=3) :: pol, fre
  !
  data systext /'Un','Un','Eq','Ga','Ho','Pl','Ea'/
  data veltext /'Unkn.','LSR  ','Hel. ','Obs. ','Null '/
  data chartype /'*','O','P','R'/
  data mscan/0/,mproject/2*0/,mhoura/0/,nscan/0/,nhoura/0/,mnum/0/
  data msourc,mline,mteles/3*0,3*0,3*0/
  !------------------------------------------------------------------------
  save mscan, mproject, mhoura, nscan, nhoura,   &
    msourc, mline, mteles, mcproc, mctype, mdate, mnum, mch1, mch2
  ! Code:
  if (title%num.le.0) then
    call message(6,3,'TITOUT','No header in memory')
    error = .true.
    return
  endif
  !
  call chtoby('IFPB',l_ifpb,4)
  !
  full = type(1:1).eq.'F'
  long = type(1:1).eq.'L'
  short = (type(1:1).eq.'S').or.(type(1:1).eq.'Z')
  plot = (type(1:1).eq.'P').or.(type(1:1).eq.'B')
  !
  ! Long title -------------------------------------------------------------
  ! CALL TITOUT(LONG) or CALL TITOUT(FULL)
  !
  if (long .or. full) then
    !
    ! First line:
    call outlin(' ',1)
    call datec (r_dobs,ch1,error)
    if (r_itype.ge.0 .and. r_itype.le.3) then
      ctype = chartype(r_itype)
    else
      ctype = '?'
    endif
    cproc = procname(r_proc)
    lut8 = title%ut
    call sexag(ch2,lut8,24)
    call bytoch(title%project,aproject,8)
    call bytoch(title%sourc,asourc,12)
    call bytoch(title%teles,ateles,12)
    write(ch,210,iostat=ier) mod(title%num,100000),   &
      mod(title%scan,10000),aproject,asourc,ctype,cproc,   &
      ateles, ch1(1:11),ch2(2:6),title%houra*12./pi
    call outlin(ch,80)
    !
    ! Position
    if (t_position .or. full) then
      call outlin(' ',1)
      if (abs(r_typec).eq.type_eq .or. r_typec.eq.0) then
        call sexag(ch2,r_lam,24)
        ch = 'RA:'//ch2(1:13)
        lch = 17
        call sexag(ch2,r_bet,360)
        ch(lch+1:) = 'Dec:'//ch2(1:13)
        lch = lch+18
        write(ch(lch+1:),103) r_epoch
        lch=lch+8
      else
        write(ch,104) 180.*r_lam/pi,180.*r_bet/pi
        lch = 43
      endif
      ch(lch+2:) = 'Offs: '
      lch = lch+6
      call offsec(r_lamof,ch(lch+1:),error)
      lch = lch+7
      call offsec(r_betof,ch(lch+1:),error)
      lch = lch+7
      if (r_typec .lt. 0) then
        ch(lch+1:) = 'Ho'
      else
        ch(lch+1:)= systext(r_typec)
      endif
      lch = lch+3
      write(ch(lch+1:),'(a6,f6.1)') 'Flux: ', r_flux
      lch = lch+12
      call outlin(ch,lch)
    endif
    !
    ! Noise information
    if (t_quality .or. full) then
      call outlin(' ',1)
      ch1 = 'Unflagged'
      do i=1, r_nant
        if (dh_aflag(i).ne.0) ch1='FLAGGED'
      enddo
      do i=1, r_nbas
        if (dh_bflag(i).ne.0) ch1='FLAGGED'
      enddo
      write(ch,102) quality(r_qual), ch1, r_nrec, r_ndump,   &
        r_az*180./pi, r_el*180./pi
      call outlin(ch,80)
    endif
    !
    ! Radio Frequency
    if (t_status .or. full) then
      call outlin(' ',1)
      ch='Line: '//r_line
      lch = 19
      write(ch(lch+1:),'(a5,f10.3)') 'Fr.: ',r_restf
      lch = lch+16
      if (r_isb.gt.0) then
        ch(lch+1:) = 'USB'
      else
        ch(lch+1:) = 'LSB'
      endif
      lch = lch+4
      if (r_lock.gt.0) then
        ch(lch+1:) = 'HIGH'
      else
        ch(lch+1:) = 'LOW'
      endif
      lch = lch+5
      write(ch(lch+1:),'(a5,e12.5)') 'Dop: ',r_doppl
      lch = lch+18
      write(ch(lch+1:),'(a5,f6.1)') 'Vel: ',r_veloc
      lch = lch+12
      ch(lch+1:) = veltext(r_typev)
      lch = lch+5
      call outlin(ch,lch)
    endif
    !
    ! Correlator information
    if (t_spectral.or.full) then   !
      call outlin(' ',1)
      if (new_receivers) then
        ch = 'Narrow-band correlator:'
        call outlin(ch,23)
        do i=1, r_lband
          ch = ' '
          lch = 6
          qq = quarter(r_flo2(i),r_flo2bis(i))
          corr_input = r_bb(i) 
          if (r_lpolmode(i).ne.1) then
            pol = 'Mix'
          else
            if (r_lpolentry(1,i).eq.1) then
              pol = 'HOR'
            else
              pol = 'VER'
            endif
          endif
          intw = r_lnch(i)*abs(r_lfres(i))
          write(ch(lch+1:),108) 'L',i,intw, r_lfcen(i),   &
            r_iunit(i),qq,pol,corr_input
          !                  LCH = LENC(CH)
          if (r_iunit(i).lt.9) then
             call outlin(ch,lch)
          endif
        enddo
        if (r_nband_widex.ne.0) then
          ch = 'Wide-band correlator:'
          call outlin(ch,23)
          do i=1, r_lband
             if (r_iunit(i).gt.8) then
                ch = ' '
                lch = 6
                if (r_lpolmode(i).ne.1) then
                   pol = 'Mix'
                else
                   if (r_lpolentry(1,i).eq.1) then
                      pol = 'HOR'
                   else
                      pol = 'VER'
                   endif
                endif
                if (r_flo2(i).lt.9000) then
                   fre = 'Low'
                else
                   fre = 'Up '
                endif
                write(ch(lch+1:),109) 'L',   &
                       i, r_iunit(i),pol,fre
                call outlin(ch,lch)
             endif
          enddo
        endif
      else                     ! Old receivers
        ch = 'Corr: '
        lch = 6
        do i=1, r_lband
          write(ch(lch+1:),107) 'L',i,r_lnch(i)*abs(r_lfres(i)),   &
            r_lfcen(i),r_iunit(i)
          lch = lch+38
          if (lch.gt.60) then
            call outlin(ch,lch)
            ch = ' '
            lch = 6
          endif
        enddo
        if (lch.gt.20) call outlin(ch,lch)
      endif
    endif
    !
    ! Interferometer
    ! (ca tient jusqu'a 8 antennes...)
    pad = '  '
    npad = 67/r_nant - 7
    npad1 = 67-r_nant*(npad+7)+1
    if (t_interfero .or. full) then
      call outlin(' ',1)
      write(ch,'(a10,a,12(a,i7))') 'Antennas: ',pad(1:npad1),   &
        (pad(1:npad),r_kant(i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,'(a10,a,12(a,4x,a3))') 'Stations: ',pad(1:npad1),   &
        (pad(1:npad),r_config(3*i-2:3*i),i=1,r_nant)
      call outlin(ch,79)
    endif
    !
    ! Calibration information
    if (t_pointing .or. full) then
      call outlin(' ',1)
      write(ch,113) 'Cor.Az:   ',pad(1:npad1),   &
        (pad(1:npad),r_collaz(i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,113) 'Cor.El:   ',pad(1:npad1),   &
        (pad(1:npad),r_collel(i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,113) 'Cor.Fo:   ',pad(1:npad1),   &
        (pad(1:npad),r_corfoc(i),i=1,r_nant)
      call outlin(ch,79)
    endif
    ! NGRX: TODO ... better than using the first polar only here.
    if (t_calibration .or. full) then
      call outlin(' ',1)
      write(ch,113) 'Trec:     ',pad(1:npad1),   &
        (pad(1:npad),r_trec(1,i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,113) 'G.Im.:    ',pad(1:npad1),   &
        (pad(1:npad),r_gim(1,i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,113) 'Water:    ',pad(1:npad1),   &
        (pad(1:npad),r_h2o_mon(i),i=1,r_nant)
      call outlin(ch,79)
      write(ch,113) 'Tsys:     ',pad(1:npad1),   &
        (pad(1:npad),r_tsyss(1,i),i=1,r_nant)
      call outlin(ch,79)
    endif
  !
  ! Brief title --------------------------------------------------------------
  ! CALL TITOUT(NORMAL) or CALL TITOUT(SHORT) or CALL TITOUT(ZHORT)
  ! or CALL TITOUT(PLOT) or CALL TITOUT(BLOT)
  !
  else
    call datec(title%dobs,ch1,error)
    if (title%itype.ge.0 .and. title%itype.le.3) then
      ctype = chartype(title%itype)
    else
      ctype = '?'
    endif
    cproc = procname(title%proc)
    if (short) then
      !
      ! CALL TITOUT(SHORT) or CALL TITOUT(ZHORT)
      !
      if (mscan.ne.0 .and.   &
        (type(1:1).eq.'Z' .or. msourc(1).ne.title%sourc(1)   &
        .or. msourc(2).ne.title%sourc(2) .or. msourc(3).ne.title%sourc(3)   &
        .or. mctype.ne.ctype   &
        .or. mcproc.ne.cproc   &
        .or. mline(1).ne.title%line(1)   &
        .or. mline(2).ne.title%line(2)   &
        .or. mline(3).ne.title%line(3)   &
        .or. mproject(1).ne.title%project(1)  &
        .or. mproject(2).ne.title%project(2)  &
        .or. mteles(1).ne.title%teles(1)   &
        .or. mteles(2).ne.title%teles(2)   &
        .or. mteles(3).ne.title%teles(3)   &
        .or. mdate.ne.ch1(1:11))) then
        if (mcproc.ne.'IFPB'.and.mcproc.ne.'CALI') then
          call bytoch(mproject,aproject,8)
          call bytoch(msourc,asourc,12)
          call bytoch(mline,aline,12)
          call bytoch(mteles,ateles,12)
          write(ch,301,iostat=ier) mod(nscan,10000),   &
            mod(mscan,10000), aproject, asourc, mctype, mcproc,   &
            aline(1:12), ateles, mdate, nhoura*12/pi,   &
            mhoura*12/pi
          ng = ng + 1
          if (ng.gt.mg) then
            call message(8,4,'TITOUT','Too many lines')
            error = .true.
            return
          endif
          sg(1,ng) = mod(nscan,10000)
          sg(2,ng) = mod(mscan,10000)
          call outlin(ch,80)
          nscan = title%scan
        endif
        if (title%proc.ne.l_ifpb) nhoura = title%houra
      endif
      do i=1, 3
        msourc(i) = title%sourc(i)
        mline(i) = title%line(i)
        mteles(i) = title%teles(i)
      enddo
      mdate = ch1(1:11)
      mscan = title%scan
      if (nscan.le.0) then
        nscan = title%scan
        nhoura = title%houra
      endif
      if (type(1:1).eq.'Z') then
        mscan = 0
        nscan = 0
      endif
      mhoura = title%houra
      mproject(1) = title%project(1)
      mproject(2) = title%project(2)
      mctype = ctype
      mcproc = cproc
    elseif (plot) then
      if (type(1:1).eq.'P') then
        !
        ! CALL TITOUT(PLOT)
        !
        call bytoch(title%project,aproject,8)
        call bytoch(title%line,aline,12)
        call decode_backend(narrow)
        write(ch,202,iostat=ier) aproject, aline,   &
          nint(r_restf)/1000., r_nrec, narrow(1), narrow(2)
        call outlin(ch,80)
        !
        ! prepare for second line of plot
        !
        mnum = title%num
        mscan = title%scan
        mctype = ctype
        mcproc = cproc
        mch1 = ch1(1:11)
        lut8 = title%ut
        call sexag(ch2,lut8,24)
        mch2 = ch2(2:6)
        mhoura = title%houra
      else
        !
        ! CALL TITOUT(BLOT)
        !
        lut8 = title%ut
        call sexag(ch2,lut8,24)
        write(ch,203,iostat=ier)   &
          !     &         MNUM, LNUM, MSCAN, LSCAN, MCTYPE, MCPROC, CTYPE, CPROC,
          mnum, mscan, mctype, mcproc, title%num, title%scan, ctype, cproc,   &
          mch1, mch2, ch2(2:6)
        call outlin(ch,80)
        mscan = 0
        nscan = 0
      endif
    else
      !
      ! CALL TITOUT(NORMAL)
      !
      lut8 = title%ut
      call sexag(ch2,lut8,24)
      call bytoch(title%project,aproject,8)
      call bytoch(title%sourc,asourc,12)
      call bytoch(title%line,aline,12)
      call bytoch(title%teles,ateles,12)
      lch = lenc(ateles)
      write(ch,201,iostat=ier) mod(title%num,100000)   &
        ,mod(title%scan,10000),aproject,asourc,ctype,cproc   &
        ,aline(1:8),ateles(1:lch), ch1(1:11),ch2(2:6)!,title%houra*12./pi
      call outlin(ch,80)
    endif
  endif
  !
301 format(i4,'_',i4,1x,a,1x,a,a1,1x,a4,1x,a,1x,a,1x,a11,   &
    1x,f5.1,'_',f5.1)
  !201   FORMAT(I4,1X,I4,1X,A4,1X,3A4,1X,A1,1X,A4,
  !     &1X,2A4,1X,3A4,1X,A11,1X,A5,F5.1)
201 format(i5,1x,i4,1x,a,1x,a,1x,a1,1x,a,   &
    1x,a,1x,a,1x,a,1x,a,f5.1)
202 format(a,1x,a,1x,f7.3,'GHz B',i1,1x,a,1x,a)
203 format('(',i5,1x,i4,1x,a1,1x,a4,')-(',i5,1x,i4,1x,a1,1x,a4,')',   &
    1x,a11,1x,a5,'-',a5)
  !210   FORMAT(I4,1X,I4,1X,A4,1X,3A4,1X,A1,1X,A4,1X,3A4,1X,A11,
  !     &1X,'UT: ',A5,' HA:',F5.1)
210 format(i5,1x,i4,1x,a,1x,a,1x,a1,1x,a4,1x,a,1x,a11,   &
    1x,'UT: ',a5,' HA:',f5.1)
100 format(i5,';',i2,1x,a,1x,a1,1x,a4,1x,a,1x,a,1x,a,1x,a)
102 format('Quality: ',a10,2x,a10,'  Rec.: ',i1,'  Ndump: ',i3,   &
    '  Az:',f7.2,2x,'  El: ',f6.2)
103 format('(',f6.1,')')
104 format('l: ',1pg13.6,2x,'b: ',1pg13.6,2x)
105 format(a1,i2.2,a,'  N: ',i3,'  Line: ',a12,'  I0: ',1pg11.4)
107 format(a1,i2.2,'  W: ',f4.0,'  Cen.: ',f6.2,' Unit: ',i1)
108 format(a1,i2.2,'  W: ',i3,'  Cen.: ',f7.2,'  Unit: ',i1,   &
    '  Quarter: Q',i1,'  Pol: ',a3,'  Input:',i1)
109 format (a1,i2.2,' Unit: ',i2,' Pol: ',a3, ' ',a3)
113 format(a10,a,12(a,f7.2))
end subroutine titout
!
function procname (nproc)
  character(len=4) :: procname      !
  integer :: nproc                  !
  ! Local
  integer :: mproc,iproc
  parameter (mproc=29)
  character(len=4) :: charproc(0:mproc)
  data charproc /'?...',5*'----','SKYD',4*'----',   &
    'CORR','AUTO','GAIN','DELA','FOCU','POIN','CALI','IFPB',   &
    'ONOF','HOLO','FIVE','PSEU','FLUX','STAB','CWVR',   &
    'VLBI','VLBG','OTF','BAND'/
  !
  iproc = max(0,nproc)
  procname = charproc(iproc)
end function procname
!
subroutine vartitout(short,scan,nv,type,addr,form,end,error)
  use gkernel_interfaces
  use gildas_def
  use gbl_format
  logical :: short                          !
  integer :: scan                           !
  integer :: nv                             !
  integer(kind=address_length) :: type(nv)  !
  integer(kind=address_length) :: addr(nv)  !
  character(len=12) :: form(nv)             !
  logical :: end                            !
  logical :: error                          !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=256) :: chain,old_chain
  character(len=80) :: ch
  character(len=10) :: ch1
  integer :: lch, lchain, iv, lcv, ll, l1, l2
  integer(kind=address_length) :: ipv, ipc, add
  logical :: err
  integer :: first_scan, last_scan
  data first_scan/-1/
  save first_scan, last_scan, old_chain
  integer :: mg
  parameter (mg=1000)
  integer :: ng, sg(2,mg)
  real :: x
  common/scan_group/ng, sg
  save /scan_group/
  !-----------------------------------------------------------------------
  lchain = 1
  chain = ' '
  do iv = 1, nv
    ipv = gag_pointer(addr(iv),memory)
    err = .false.
    if (type(iv).gt.0) then
      lcv = type(iv)
      l1 = index(form(iv),'A')
      if (l1.gt.0) then
        l2 = index(form(iv),')')
        lch = l2-l1-1
        if (lch.gt.0) then
          read(form(iv)(l1+1:l2-1),'(i3)') ll
          lcv = min(ll,lcv)
        endif
      endif
      lch = lcv
      add = locstr(ch)
      ipc = bytpnt(add,membyt)
      call bytoby(memory(ipv),membyt(ipc),lcv)
    elseif (type(iv).eq.fmt_r4) then
      call r4form(memory(ipv),ch,lch,form(iv),err)
    elseif (type(iv).eq.fmt_r8) then
      call r8form(memory(ipv),ch,lch,form(iv),err)
    elseif (type(iv).eq.fmt_i4) then
      call i4form(memory(ipv),ch,lch,form(iv),err)
    elseif (type(iv).eq.fmt_i8) then
      call i8form(memory(ipv),ch,lch,form(iv),err)
    elseif (type(iv).eq.fmt_l) then
      call lform(memory(ipv),ch,lch,form(iv),err)
    else
      call message(8,3,'VARTITOUT','Not implemented for this type')
      error = .true.
      return
    endif
    if (.not.err .and. lchain+lch+1.le.256) then
      chain(lchain:) = ' '//ch(1:lch)
      lchain = lchain+lch+1
    endif
  enddo
  ! on ecrit
  if (short) then
    if (first_scan.gt.0   &
      .and. (end .or. chain.ne.old_chain   &
      .or. scan.lt.last_scan)) then
      write(ch1,'(i4,a,i4,1x)') first_scan, '_', last_scan
      call outlin(ch1//old_chain,lchain+10)
      ng = ng + 1
      if (ng.gt.mg) then
        call message(8,4,'TITOUT','Too many lines')
        error = .true.
        return
      endif
      sg(1,ng) = mod(first_scan,10000)
      sg(2,ng) = mod(last_scan,10000)
      first_scan = scan
    endif
    old_chain = chain
    last_scan = scan
    if (first_scan.le.0) first_scan = scan
    if (end) then
      first_scan = -1
      last_scan = -1
    endif
  else
    call outlin(chain,lchain)
  endif
  return
end subroutine vartitout
!
subroutine i4form(iv,ch,lch,form,error)
  use gkernel_interfaces
  integer :: iv                     !
  character(len=*) :: ch            !
  integer :: lch                    !
  character(len=12) :: form         !
  logical :: error                  !
  ! Local
  real*4 :: r4v
  real*8 :: r8v
  logical :: lv
  integer :: ier
  !-----------------------------------------------------------------------
  !
  if (form.eq.'*') then
    write(ch,'(i8)',iostat=ier) iv
  else
    write(ch,form,iostat=ier) iv
  endif
  goto 10
  !
entry i8form(lv,ch,lch,form,error)
  if (form.eq.'*') then
    write(ch,'(i8)',iostat=ier) lv
  else
    write(ch,form,iostat=ier) lv
  endif
  goto 10
  !
entry lform(lv,ch,lch,form,error)
  if (form.eq.'*') then
    write(ch,'(l1)',iostat=ier) lv
  else
    write(ch,form,iostat=ier) lv
  endif
  goto 10
  !
entry r4form(r4v,ch,lch,form,error)
  if (form.eq.'*') then
    write(ch,'(1pg12.5)',iostat=ier) r4v
  else
    write(ch,form,iostat=ier) r4v
  endif
  goto 10
  !
entry r8form(r8v,ch,lch,form,error)
  if (form.eq.'*') then
    write(ch,'(1pg12.5)',iostat=ier) r8v
  else
    write(ch,form,iostat=ier) r8v
  endif
  !
10 if (ier.ne.0) then
    call message(6,3,'CFORM','Invalid format '//form)
    error  = .true.
  else
    lch = lenc(ch)
  endif
end subroutine i4form
!
subroutine decode_backend(narrow)
  use gkernel_interfaces
  use classic_api  
  character(len=36) :: narrow(2)    !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  character(len=36) :: ch
  character(len=3) :: tmp
  character(len=1) :: pol(6)
  integer :: i, k, n, q(2), j(2), s(8,2)
  integer :: quarter
  !
  j(1) = 0
  j(2) = 0
  k = 3
  do i=1,r_lband
    if (r_iunit(i).lt.9) then
       n = r_bb(i)
       q(n) = quarter(r_flo2(i),r_flo2bis(i))
       j(n) = j(n)+1
       s(j(n),n) = r_lnch(i)*abs(r_lfres(i))
       if (r_lpolentry(1,i).eq.1) then
         pol(n) = 'H'
       else
         pol(n) = 'V'
       endif
    endif
  enddo
  !
  do n=1,2
    write(ch,'(A,I1,A)') 'Q',q(n),'('
    do i=1,j(n)
      if (s(i,n).lt.100) then
        write(tmp,'(I2)') s(i,n)
      else
        write(tmp,'(I3)') s(i,n)
      endif
      ch = ch(1:lenc(ch))//tmp(1:lenc(tmp))
      if (i.ne.j(n)) ch = ch(1:lenc(ch))//','
    enddo
    narrow(n) = ch(1:lenc(ch))//')'//pol(n)
  enddo
!
end subroutine decode_backend

subroutine clic_get(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_title
  use clic_index
  use clic_rdata
  !---------------------------------------------------------------------
  ! SAS	Support routine for command
  !	GET Number [Version] /DUMP idump
  !	    NEXT
  !	    FIRST
  ! Arguments :
  !	LINE	C*(*)	Command line
  !	ERROR	L	Logical error flag
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_virtual.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: end
  integer(kind=entry_length)   :: kx, nnn
  integer(kind=data_length)    :: h_offset, c_offset, l_offset
  integer(kind=data_length)    :: ldata_in
  integer(kind=address_length) :: data_in, kin, ipk
  integer :: mmm, idump, n, k, ib, isb, nch, ir
  character(len=12) :: argum
  character(len=100) :: nombre
  !------------------------------------------------------------------------
  ! Code:
  !
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  !
  ! Locate the observation to get
  argum=' '
  call sic_ke(line,0,1,argum,nch,.false.,error)
  if (error) return
  if (argum(1:1).eq.'F') then
    call check_index(error)
    if (error) return
    call get_first(.true.,error)
    if (error) return
    goto 30
  elseif (argum(1:1).eq.'N') then
    end = .false.
    call get_next(end,error)
    if (error) return
    if (end) then
      call message(6,3,'CLIC_GET',   &
        'End of current index encountered')
      error = .true.
      return
    endif
    goto 30
  endif
  if (sic_present(0,1)) then
    call sic_i8 (line,0,1,nnn,.false.,error)
    if (error) return
  else
    ! Get with no argument
    ! Take previous one
    call check_index(error)
    if (error) return
    kx = r_xnum
    if (kx.le.0 .or. kx.ge.cxnext) then
      call message(6,3,'CLIC_GET','Please use GET with argument')
      error = .true.
      return
    endif
    call get_num(kx,error)
    if (error) return
    goto 30
  endif
  !
  ! Else search
  mmm = 0
  call sic_i4 (line,0,2,mmm,.false.,error)
  if (error) return
  call get_sub (nnn,mmm,error)
  if (error) return
  !
  ! Read data dump(s)
30 continue
  idump = 0
  if (sic_present(1,1)) then
    call sic_i4(line,1,1,idump,.true.,error)
    if (error) return
  endif
  kx = r_xnum
  if (got_header(kx)) then
    call robs(kx,error)
    if (error) return
    r_dobs = mod(r_dobs+32768,65536)-32768
    r_dred = mod(r_dred+32768,65536)-32768
  endif
  if (sic_present(2,0)) return
  !
  ! Get data
  call get_data(ldata_in,data_in,error)
  if (error) return
  if (idump.eq.0) then
    ! Select corrected/uncorrect record following /ATM
    ir = r_ndump + 1
    if (sic_present(3,0)) then
      if (r_ndatl.eq.2) then
        call message(6,1,'CLIC_GET',   &
          'selecting atm. phase corrected record')
        ir = r_ndump + 2
      else
        call message(6,3,'CLIC_GET',   &
          'No atm. phase corrected record in data')
        error = .true.
        return
      endif
    endif
  else
    if (sic_present(3,0)) then
      call message(6,3,'CLIC_GET',   &
        'conflicting options')
      error = .true.
      return
    endif
    ir = idump
  endif
  kin = gag_pointer(data_in,memory)
  ipk = kin + h_offset(ir)
  call decode_header (memory(ipk))
  !
  ! get only continuum if not average record..
  ipk = kin + c_offset(ir)
  k = 1
  if (r_lmode.eq.1) then
    do ib = 1, r_nbas
      do isb = 1, r_nsb
        call r4tor4 (memory(ipk),datac(k),2*r_nband)
        k = k + r_nband
        ipk = ipk+2*r_nband
      enddo
    enddo
  else
    do ib = 1, r_nant
      call r4toc4 (memory(ipk), datac(k), r_nband)
      call r4toc4 (memory(ipk), datac(k+r_nband), r_nband)
      k = k + 2*r_nband
      ipk = ipk + r_nband
    enddo
  endif
  ipk = kin + l_offset(ir)
  ! get continuum and line if average record ...
  k = 1
  if (r_lmode.eq.1) then
    do ib = 1, r_nbas
      do isb=1, r_lnsb
        call r4tor4 (memory(ipk),datal(k),2*r_lntch)
        k = k + r_lntch
        ipk = ipk+2*r_lntch
      enddo
    enddo
  else
    do ib = 1, r_nant
      call r4toc4 (memory(ipk), datal(k), r_lntch)
      call r4toc4 (memory(ipk), datal(k+r_lntch), r_lntch)
      k = k + 2*r_lntch
      ipk = ipk + r_lntch
    enddo
  endif
  call data_variables(.true.)
  call data_variables(.false.)
  !
  ! Notify
  if (idump.ne.0) then
    write (nombre,'(A,I12,A,I12)')   &
      ' Record ',dh_dump,' of ',r_ndump
  else
    write (nombre,'(A,I12)') ' Average Record of ',r_ndump
  endif
  call noir (nombre,nombre,n)
  call message(2,1,'GET',nombre(1:n))
  if (title%qual.eq.9) then
    call message(6,2,'GET','Observation marked for deletion')
  endif
  return
end subroutine clic_get
!
subroutine get_sub(nnn,mmm,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  use clic_find
  use clic_rdata
  !---------------------------------------------------------------------
  !     GET Entry Version
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: nnn                    !
  integer :: mmm                    !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_virtual.inc'
  ! Local
  integer(kind=entry_length) :: kx, i, ifound 
  integer :: nff, cver
  character(len=20) :: nombr1
  !------------------------------------------------------------------------
  ! Code:
  xnum=nnn
  ynum=nnn
  fnum=.true.
  if (mmm.le.0) then
    last=.true.
    fver=.false.
  else
    xver=mmm
    yver=mmm
    fver=.true.
    last=.false.
  endif
  !
  ! Search first in index
  kx = 0
  ifound = 0
  cver = 0
  if (last) then
    do i=1,cxnext-1
      if (cx_num(i).eq.xnum) then
        if (cx_ver(i).ge.0) then
          write(nombr1,'(I10)') xnum
          knext = i
          kx = cx_ind(i)
          call get_num(kx,error)
          return
        elseif (cx_ver(i).lt.cver) then
          ifound = i
          cver = cx_ver(i)
        endif
      endif
    enddo
    if (ifound.ne.0) then
      knext = ifound
      kx = cx_ind(ifound)
      call get_num(kx,error)
      return
    endif
  else
    do i=1,cxnext-1
      if (cx_num(i).eq.xnum .and. abs(cx_ver(i)).eq.xver) then
        kx = cx_ind(i)
        knext = i
        call get_num(kx,error)
        return
      endif
    enddo
  endif
  !
  ! Else, search in input file
  kx = 0
  nff=1
  error = .false.
  ykind = 3                    ! old format
  xkind = 4                    ! new format
  ! RL 05-oct-1987 do not wait for new data
  call fix(nff,kx,.false.,.false.,error)
  if (nff.eq.0) then
    if (fver) then
      write(nombr1,'(I10,A,I6)' ) xnum,';',abs(xver)
    else
      write(nombr1,'(I10)') xnum
    endif
    call message(8,3,'GET','Observation # '   &
      //nombr1(1:lenc(nombr1))//' not Found')
    error = .true.
    return
  endif
  call get_num(kx,error)
  return
end subroutine get_sub
!
subroutine get_it (kx,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_title
  use clic_index
  use clic_file, except=>i
  integer(kind=entry_length) :: kx                     !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_virtual.inc'
  include 'gbl_memory.inc'
  ! Local
  logical :: fsec
  integer :: j, i, min, n, ipol
  character(len=100) :: nombre
  integer(kind=address_length) :: ipv
  !
  call rzero                   ! initialise le buffer R
  if (got_header(kx)) then
    ipv = gag_pointer(v_header(kx),memory)
    call r4tor4 (memory(ipv),r_xnum,m_header)
  else
    call robs (kx,error)
    if (error) return
    do j=-mnsec,0
      r_presec(j) = fsec(j)
    enddo
    if (r_presec(interc_sec)) then
      call rinterc (error)
    else
      call message(8,3,'GET','No interferometer Configuration')
    endif
    !
    ! Patch in receiver 2 data
    if (r_presec(atmon_sec)) then
      call ratmon (error)
      do i=1, r_nant
        r_tsys_mon(i) = min(r_tsys_mon(i),1e10)
        r_tsys_mon(i) = max(0.,r_tsys_mon(i))
      enddo
    elseif(e%version.lt.2) then
      call fill_rec2(kx,error)
    endif
    ! WVR Data
    if (r_presec(wvr_sec)) then
      call rwvr(error)
    endif
    !
    r_dobs = mod(r_dobs+32768,65536)-32768
    r_dred = mod(r_dred+32768,65536)-32768
    r_xnum = kx
    title%ver = abs(title%ver)
    call rgen (error)          ! infos generales
    error=.false.
    if (r_kind.le.2) then
      call message(8,3,'GET_FIRST','Observation is Single-Dish')
      error = .true.
      return
    endif
    call rpos (error)          ! positions
    error = .false.
    !
    ! Others are independent of kind
    if (r_presec(rfset_sec)) then
      call rrfset (error)
    else
      call message(8,3,'GET','No RF Setup')
    endif
    !
    if (r_presec(contset_sec)) then
      call rcontset (error)
    endif
    if (r_presec(lineset_sec)) then
      call rlineset (error)
    endif
    if (r_presec(atparm_sec)) then
      call ratparm (error)
      do i=1, r_nant
        do ipol = 1, r_npol_rec
          r_tsyss(ipol,i) = min(r_tsyss(ipol,i),1e10)
          r_tsyss(ipol,i) = max(0.,r_tsyss(ipol,i))
          r_tsysi(ipol,i) = min(r_tsysi(ipol,i),1e10)
          r_tsysi(ipol,i) = max(0.,r_tsysi(ipol,i))
        enddo
      enddo
    endif
    call check_eff
    if (r_presec(scanning_sec)) then
      call rscanning (error)
    endif
    if (r_presec(alma_sec)) then
      call ralma(error)
    endif
    if (r_presec(monitor_sec)) then
      call rmoni(error)
    endif
    if (r_presec(bpcal_sec)) then
      call rbpcal (error)
    else
      r_bpc = 0
    endif
    if (r_presec(ical_sec)) then
      call rical (error)
    else
      r_ic = 0
    endif
    ! antenna based calibrations
    if (r_presec(abpcal_sec)) then
      call rabpcal (error)
    else
      r_abpc = 0
    endif
    if (r_presec(aical_sec)) then
      call raical (error)
    else
      r_aic = 0
    endif
    ! Data descriptor
    if (r_presec(descr_sec)) then
      call rdescr (error)
    else
      call message(8,3,'GET','No Data Section Descriptor')
      error = .true.
      return
    endif
    if (r_presec(file_sec)) then
      call rdfile (error)
    endif
    if (r_presec(modify_sec)) then
      call rdmodif (error)
    endif
    !
    ! Some more memory
    call get_memory(int(m_header,kind=address_length),v_header(kx),error)
    if (error) then
      call message(8,4,'GET_IT','Problems with getting memory')
      return
    endif
    ipv = gag_pointer(v_header(kx),memory)
    call r4tor4 (r_xnum,memory(ipv),m_header)
  endif
  if (.not.got_header(kx)) then
    got_header(kx) = .true.
  endif
  write (nombre,'(A,I12,A,I12,A,I12)') 'Entry ',r_xnum,   &
    ' Observation ',r_num,';',abs(r_ver)
  call noir (nombre,nombre,n)
  call message(2,1,'GET',nombre)
  return
end subroutine get_it
!
subroutine fill_rec2(kx,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api
  use clic_index
  use clic_find
  !---------------------------------------------------------------------
  ! fill in atmospheric data from receiver 2
  !---------------------------------------------------------------------
  integer(kind=entry_length) :: kx                     !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_virtual.inc'
  include 'gbl_memory.inc'
  include 'clic_clic.inc'
  ! Local
  integer :: nff, i, j
  integer(kind=entry_length) :: iff(2),kxsave
  integer(kind=address_length) :: ipv
  logical :: fsec
  !-----------------------------------------------------------------------
  kxsave = kx
  if (r_presec(interc_sec)) call rinterc (error)
  if (r_presec(atparm_sec)) call ratparm (error)
  if (r_presec(rfset_sec)) call rrfset (error)
  if (r_nrec.ne.2) then
    nff = 2
    fnum = .false.
    xscan(1) = r_scan
    yscan(1) = r_scan
    xnscan = 1
    fscan = .true.
    xrecei = 2
    call fix(nff,iff,.false.,.false.,error)
    error = .false.
    if (nff.lt.1) then
      call message(4,2,'FILL_REC2',   &
        'Receiver 2 parameters are not available')
      r_presec(atmon_sec) = .false.
      return
    endif
    kx = iff(1)
    call rzero                 ! initialise le buffer R
    if (got_header(kx)) then
      ipv = gag_pointer(v_header(kx),memory)
      call r4tor4 (memory(ipv),r_xnum,m_header)
    else
      call robs(kx,error)
      do j=-mnsec,0
        r_presec(j) = fsec(j)
      enddo
      if (r_presec(interc_sec)) call rinterc (error)
      if (r_presec(rfset_sec)) call rrfset (error)
      if (r_presec(atparm_sec)) call ratparm (error)
    endif
  endif
  r_frs_mon = r_flo1+r_isb*r_fif1
  r_fri_mon = r_flo1-r_isb*r_fif1
  r_nrec_mon = 2
  !
  ! use first polar, may be should average if 2 had been present...
  ! but there was only one at the time.
  !
  do i=1, r_nant
    r_h2o_mon(i) = r_h2omm(1,i)
    r_tatms_mon(i) = r_tatms(1,i)
    r_tatmi_mon(i) = r_tatmi(1,i)
    r_taus_mon(i) = r_taus(1,i)
    r_taui_mon(i) = r_taui(1,i)
    r_feff_mon(i) = r_feff(1,i)
    r_tchop_mon(i) = r_tchop(1,i)
    r_tcold_mon(i) = r_tcold(1,i)
    r_trec_mon(i) = r_trec(1,i)
    r_gim_mon(i) = r_gim(1,i)
    r_csky_mon(i) = r_csky(1,i)
    r_cchop_mon(i) = r_cchop(1,i)
    r_ccold_mon(i) = r_ccold(1,i)
    r_cmode_mon(i) = r_cmode(1,i)
  enddo
  if (kx.ne.kxsave) then
    kx = kxsave
    call robs(kx,error)
    do j=-mnsec,0
      r_presec(j) = fsec(j)
    enddo
    if (r_presec(interc_sec)) call rinterc (error)
  endif
  r_presec(atmon_sec) = .true.
  call message(8,2,'FILL_REC2',   &
    'Receiver 2 parameters patched in')
  return
end subroutine fill_rec2
!
subroutine check_eff
  use classic_api
  !---------------------------------------------------------------------
  ! CLIC
  !	Define Efficiencies if not known.
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  ! Local
  integer :: i, ipol
  !------------------------------------------------------------------------
  ! Code:
  do i=1, r_nant
    do ipol=1, r_npol_rec
      if (r_jykel(ipol,i).le.0) then
        if (r_beef(ipol,i).gt.0) then
          r_jykel(ipol,i) = 18.7/r_beef(ipol,i)
        else
          r_jykel(ipol,i) = 22.
        endif
      endif
    enddo
  enddo
end subroutine check_eff
!
subroutine get_memory(length,address,error)
  use gildas_def
  use gkernel_interfaces
  use clic_file
  use clic_index
  !---------------------------------------------------------------------
  ! Get some virtual memory, new or used.
  !---------------------------------------------------------------------
  integer(kind=address_length) :: length  ! Memory length
  integer(kind=address_length) :: address ! Memory adress
  logical :: error                        ! Error logical flag
  ! Global
  include 'clic_parameter.inc'
  include 'clic_virtual.inc'
  ! Local
  integer :: j, k, ier
  real :: space_clic
  character*6 :: ch
  !------------------------------------------------------------------------
  ! Code:
  if (n_regions.eq.0) then
    n_regions = 1
    current_region = 1
    ! Simplify the previous scheme. locical name SPACE_CLIC is the number of
    ! Megabytes available for CLIC. Should be tuned for each system ...
    space_clic = 1024
    ier = sic_ramlog('SPACE_CLIC',space_clic)
    if (ier.ne.0) then
      ! Not found or translation failed
      call message(8,2,'GET_MEMORY','Trying to get 1024 Mbytes')
    endif
    region_length(1:m_region) = space_clic*1024*256/m_region
    error = (sic_getvm(region_length(1),region(1)).ne.1)
    if (error) return
  endif
  k = current_region
  ! Move to next region ?
  if (length+next_offset .gt. region_length(k)) then
    next_offset = 0
    k = k + 1
    if (k.gt.m_region) k = 1
    if (k.gt.n_regions) then
      error = (sic_getvm(region_length(k),region(k)).ne.1)
      if (error) return      
      n_regions = n_regions + 1
    endif
    current_region = k
    if (length.gt.region_length(k)) then
      call message(6,4,'GET_MEMORY', &
           'SPACE_CLIC is too small to handle this observation')
      write(ch,'(i3)') int(length*4/1000/1000)+1
      call message(6,2,'GET_MEMORY', &
           'You need at least '//ch(1:lenc(ch))//'MB')
      call sysexi(fatale)
    endif
  endif
  address = region(current_region)+next_offset*4
  next_offset = next_offset+length
  do j=1, i%desc%xnext-1
    if (got_header(j)) then
      if (v_header(j).ge.address   &
        .and. v_header(j).lt.address+length*4) then
        got_header(j) = .false.
      endif
    endif
    if (got_data(j)) then
      if (v_data(j).ge.address   &
        .and. v_data(j).lt.address+length*4) then
        got_data(j) = .false.
      endif
    endif
  enddo
  return
end subroutine get_memory
!
subroutine new_file
  use gildas_def
  use clic_index
  !---------------------------------------------------------------------
  ! A New File : deassign IO channel, unmap all sections, open again
  !---------------------------------------------------------------------
  ! Global
  include 'clic_parameter.inc'
  include 'clic_virtual.inc'
  ! Local
  integer :: i
  !------------------------------------------------------------------------
  ! Code:
  !
  do i=1, m_ix
    got_header(i) = .false.
    got_data(i) = .false.
  enddo
  current_region = min(current_region,1)
  next_offset = 0
  return
end subroutine new_file

subroutine free_memory
  use gildas_def
  use gkernel_interfaces
  use clic_file,except=>i
  use clic_index
  include 'clic_parameter.inc'
  include 'clic_virtual.inc'
  integer :: i
  do i=1, n_regions
    call free_vm(region_length(i),region(i))
  enddo
  do i=1, m_ix
    got_header(i) = .false.
    got_data(i) = .false.
  enddo
  n_regions=0
  return
end subroutine free_memory

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_read_header_init(file,hdu,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_header_init
  !---------------------------------------------------------------------
  ! @ private
  !  Read the elements in the 'imbfits_header_t' type
  !---------------------------------------------------------------------
  type(imbfits_file_t),   intent(in)    :: file
  type(imbfits_header_t), intent(inout) :: hdu
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>HEADER>INIT'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  hdu%status = code_imbfits_started
  call imbfits_read_key(rname,file,'xtension',hdu%xtension,error)
  if (error) return
  call imbfits_read_key(rname,file,'bitpix',hdu%bitpix,error)
  if (error) return
  call imbfits_read_key(rname,file,'naxis',hdu%naxis,error)
  if (error) return
  call imbfits_read_key(rname,file,'naxis1',hdu%naxis1,error)
  if (error) return
  call imbfits_read_key(rname,file,'naxis2',hdu%naxis2,error)
  if (error) return
  call imbfits_read_key(rname,file,'pcount',hdu%pcount,error)
  if (error) return
  call imbfits_read_key(rname,file,'gcount',hdu%gcount,error)
  if (error) return
  call imbfits_read_key(rname,file,'tfields',hdu%tfields,error)
  if (error) return
  call imbfits_read_key(rname,file,'extname',hdu%extname,error)
  if (error) return
  !
end subroutine imbfits_read_header_init
!
subroutine imbfits_free_header_init(hdu,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_free_header_init
  !---------------------------------------------------------------------
  ! @ private
  !  Free the elements in the 'imbfits_header_t' type
  !---------------------------------------------------------------------
  type(imbfits_header_t), intent(inout) :: hdu
  logical,                intent(inout) :: error
  !
  ! Scalar elements:
  !  => nothing to be freed.
  ! Nullify elements for safety
  hdu%xtension%val = ''
  hdu%bitpix%val   = 0
  hdu%naxis%val    = 0
  hdu%naxis1%val   = 0
  hdu%naxis2%val   = 0
  hdu%pcount%val   = 0
  hdu%gcount%val   = 0
  hdu%tfields%val  = 0
  hdu%extname%val  = ''
  !
  ! Array elements:
  !  => none
  !
  hdu%status = code_imbfits_init
  !
end subroutine imbfits_free_header_init
!
subroutine imbfits_read_header_done(file,hdu,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_header_done
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)      :: file
  type(imbfits_header_t), intent(inout) :: hdu
  logical,              intent(inout)   :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>HEADER>DONE'
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  hdu%status = code_imbfits_done
end subroutine imbfits_read_header_done
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Reading routines (0D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_read_dble_0d(caller,file,key,dble,error,default)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_dble_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_read_key
  !---------------------------------------------------------------------
  character(len=*),     intent(in)           :: caller
  type(imbfits_file_t), intent(in)           :: file
  character(len=*),     intent(in)           :: key
  type(fits_dble_0d_t), intent(out)          :: dble
  logical,              intent(inout)        :: error
  real(kind=8),         intent(in), optional :: default
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>DBLE>0D'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  dble%key = key
  status = 0
  call ftgkyd(file%unit,dble%key,dble%val,dble%comment,status)
  if (status.gt.0) then
    if (present(default) .and. status.eq.code_cfitsio_error_missingkey) then
      ! Keyword not found
      dble%val     = default
      dble%comment = 'WARNING! Keyword not found in header'
    else
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(dble%key)//'''')
      call cfitsio_message(status)
      error = .true.
      return
    endif
  endif
  !
end subroutine imbfits_read_dble_0d
!
subroutine imbfits_read_inte_0d(caller,file,key,inte,error,default)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_inte_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_read_key
  !---------------------------------------------------------------------
  character(len=*),     intent(in)           :: caller
  type(imbfits_file_t), intent(in)           :: file
  character(len=*),     intent(in)           :: key
  type(fits_inte_0d_t), intent(out)          :: inte
  logical,              intent(inout)        :: error
  integer(kind=4),      intent(in), optional :: default
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>INTE>0D'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  inte%key = key
  status = 0
  call ftgkyj(file%unit,inte%key,inte%val,inte%comment,status)
  if (status.gt.0) then
    if (present(default) .and. status.eq.code_cfitsio_error_missingkey) then
      ! Keyword not found
      inte%val     = default
      inte%comment = 'WARNING! Keyword not found in header'
    else
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(inte%key)//'''')
      call cfitsio_message(status)
      error = .true.
      return
    endif
  endif
  !
end subroutine imbfits_read_inte_0d
!
subroutine imbfits_read_logi_0d(caller,file,key,logi,error,default)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_logi_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_read_key
  !---------------------------------------------------------------------
  character(len=*),     intent(in)           :: caller
  type(imbfits_file_t), intent(in)           :: file
  character(len=*),     intent(in)           :: key
  type(fits_logi_0d_t), intent(out)          :: logi
  logical,              intent(inout)        :: error
  logical,              intent(in), optional :: default
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>LOGI>0D'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  logi%key = key
  status = 0
  call ftgkyl(file%unit,logi%key,logi%val,logi%comment,status)
  if (status.gt.0) then
    if (present(default) .and. status.eq.code_cfitsio_error_missingkey) then
      ! Keyword not found
      logi%val     = default
      logi%comment = 'WARNING! Keyword not found in header'
    else
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(logi%key)//'''')
      call cfitsio_message(status)
      error = .true.
      return
    endif
  endif
  !
end subroutine imbfits_read_logi_0d
!
subroutine imbfits_read_char_0d(caller,file,key,char,error,default)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_char_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_read_key
  !---------------------------------------------------------------------
  character(len=*),     intent(in)           :: caller
  type(imbfits_file_t), intent(in)           :: file
  character(len=*),     intent(in)           :: key
  type(fits_char_0d_t), intent(out)          :: char
  logical,              intent(inout)        :: error
  character(len=*),     intent(in), optional :: default
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>CHAR>0D'
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  char%key = key
  status = 0
  call ftgkys(file%unit,char%key,char%val,char%comment,status)
  if (status.gt.0) then
    if (present(default) .and. status.eq.code_cfitsio_error_missingkey) then
      ! Keyword not found
      char%val     = default
      char%comment = 'WARNING! Keyword not found in header'
    else
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Some error reading '''//trim(char%key)//'''')
      call cfitsio_message(status)
      error = .true.
      return
    endif
  endif
  !
end subroutine imbfits_read_char_0d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Reading routines (1D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_read_logi_1d(caller,file,key,n,logi,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_logi_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller
  type(imbfits_file_t), intent(in)    :: file
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: n
  type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>LOGI>1D'
  integer(kind=4) :: colnum,status
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,caller,'Error')
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  ! Allocations
  call reallocate_fits_logi_1d(key,n,logi,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,logi%key,colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  if (tval.ne.'L' .and. tval.ne.'1L') then
    write(mess,'(A,A,A,A,A)')  &
      'Attempt to read column ''',trim(key),''' (type ',trim(tval),') in a logical*4 vector'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,logi%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Read the column data
  if (n.eq.0)  return  ! No data, nothing more to do
  call ftgcl(file%unit,colnum,1,1,n,logi%val,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
    call imbfits_message(seve%e,rname,mess)
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
end subroutine imbfits_read_logi_1d
!
subroutine imbfits_read_inte_1d(caller,file,key,n,inte,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_inte_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller
  type(imbfits_file_t), intent(in)    :: file
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: n
  type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>INTE>1D'
  integer(kind=4) :: colnum,status
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Input file not opened')
    error = .true.
    return
  endif
  !
  ! Allocations
  call reallocate_fits_inte_1d(key,n,inte,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,inte%key,colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  if (tval.ne.'J' .and. tval.ne.'1J') then
    write(mess,'(A,A,A,A,A)')  &
      'Attempt to read column ',trim(key),' (type ',trim(tval),') in an integer*4 vector'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,inte%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Read the column data
  if (n.eq.0)  return  ! No data, nothing more to do
  anynull = .false.
  call ftgcvj(file%unit,colnum,1,1,n,-1,inte%val,anynull,status)
  if (anynull .or. status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
    call imbfits_message(seve%e,rname,mess)
    if (anynull) then
      call imbfits_message(seve%e,rname,'Some null values found')
    else
      call cfitsio_message(status)
    endif
    error = .true.
    return
  endif
  !
end subroutine imbfits_read_inte_1d
!
subroutine imbfits_read_real_1d(caller,file,key,n,real,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_real_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller
  type(imbfits_file_t), intent(in)    :: file
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: n
  type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>REAL>1D'
  integer(kind=4) :: colnum,status
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  ! Allocations
  call reallocate_fits_real_1d(key,n,real,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,real%key,colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  if (tval.ne.'E' .and. tval.ne.'1E') then
    write(mess,'(A,A,A,A,A)')  &
      'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*4 vector'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,real%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Read the column data
  if (n.eq.0)  return  ! No data, nothing more to do
  anynull = .false.
  call ftgcve(file%unit,colnum,1,1,n,-1.e0,real%val,anynull,status)
  if (anynull .or. status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
    call imbfits_message(seve%e,rname,mess)
    if (anynull) then
      call imbfits_message(seve%e,rname,'Some null values found')
    else
      call cfitsio_message(status)
    endif
    error = .true.
    return
  endif
  !
end subroutine imbfits_read_real_1d
!
subroutine imbfits_read_dble_1d(caller,file,key,n,dble,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_dble_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller
  type(imbfits_file_t), intent(in)    :: file
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: n
  type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>DBLE>1D'
  integer(kind=4) :: colnum,status
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Input file not opened')
    error = .true.
    return
  endif
  !
  ! Allocations
  call reallocate_fits_dble_1d(key,n,dble,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,dble%key,colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  if (tval.ne.'D' .and. tval.ne.'1D') then
    write(mess,'(A,A,A,A,A)')  &
      'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 vector'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,dble%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Read the column data
  if (n.eq.0)  return  ! No data, nothing more to do
  anynull = .false.
  call ftgcvd(file%unit,colnum,1,1,n,-1.d0,dble%val,anynull,status)
  if (anynull .or. status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    write(mess,'(A,I0,A,A,A,I0)')  &
      'Error while reading column #',colnum,' (',trim(key),'), row #',1
    call imbfits_message(seve%e,rname,mess)
    if (anynull) then
      call imbfits_message(seve%e,rname,'Some null values found')
    else
      call cfitsio_message(status)
    endif
    error = .true.
    return
  endif
  !
end subroutine imbfits_read_dble_1d
!
subroutine imbfits_read_char_1d(caller,file,key,n,char,error,default)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_char_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)           :: caller
  type(imbfits_file_t), intent(in)           :: file
  character(len=*),     intent(in)           :: key
  integer(kind=4),      intent(in)           :: n
  type(fits_char_1d_t), intent(inout)        :: char    ! INOUT: keep allocation status
  logical,              intent(inout)        :: error
  character(len=*),     intent(in), optional :: default  ! If absent column or NULL values in column
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>CHAR>1D'
  integer(kind=4) :: colnum,status,nc
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  character(len=char1d_length) :: defstring
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  ! Allocations
  call reallocate_fits_char_1d(key,n,char,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,char%key,colnum,status)
  if (status.gt.0) then
    ! Error, probably no such column
    if (present(default)) then
      char%val(:) = default
      char%comment = 'WARNING! Column not found in table'
      return
    else
      call imbfits_message(seve%e,caller,'Error')
      call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
      call cfitsio_message(status)
      error = .true.
      return
    endif
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  nc = len_trim(tval)
  if (tval(nc:nc).ne.'A') then
    write(mess,'(A,A,A,A,A)')  &
      'Attempt to read column ',trim(key),' (type ',trim(tval),') in a character vector'
    call imbfits_message(seve%w,rname,mess)
  endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,char%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Read the column data
  if (n.eq.0)  return  ! No data, nothing more to do
  if (present(default)) then
    defstring = default
  else
    defstring = 'NULL'
  endif
  anynull = .false.
  call ftgcvs(file%unit,colnum,1,1,n,defstring,char%val,anynull,status)
  if (anynull .or. status.gt.0) then
    if (status.eq.0 .and. anynull .and. present(default)) then
      ! Caller gave a default in case of undefined values. Not an error
      continue
    else
      call imbfits_message(seve%e,caller,'Error')
      write(mess,'(A,I0,A,A,A,I0)')  &
        'Error while reading column #',colnum,' (',trim(key),'), row #',1
      call imbfits_message(seve%e,rname,mess)
      if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
      else
        call cfitsio_message(status)
      endif
      error = .true.
      return
    endif
  endif
  !
end subroutine imbfits_read_char_1d
!
subroutine imbfits_read_dble_2d_into_1d(caller,file,key,nrow,ncol,dble,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_dble_2d_into_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_read_column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller
  type(imbfits_file_t), intent(in)    :: file
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: nrow
  integer(kind=4),      intent(in)    :: ncol
  type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>DBLE>2D>INTO>1D'
  integer(kind=4) :: colnum,status,nelem
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  ! *** JP Next block should be factorized
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  ! Allocations
  call reallocate_fits_dble_1d(key,nrow*ncol,dble,error)
  if (error)  return
  !
  ! *** JP Next two blocks should be factorized
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,dble%key,colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column '''//trim(key)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
     call imbfits_message(seve%e,caller,'Error')
     call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
     call cfitsio_message(status)
     error = .true.
     return
  endif
  ! ZZZ Some clever check here!
  !   if (tval.ne.'E') then
  !     write(mess,'(A,A,A,A,A)')  &
  !       'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*8 array'
  !     call imbfits_message(seve%w,rname,mess)
  !   endif
  !
  ! Get corresponding TTYPE so that we get its comment
  tkey = 'TTYPE'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,dble%comment,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  nelem = nrow*ncol
  anynull = .false.
  call ftgcvd(file%unit,colnum,1,1,nelem,-1.d0,dble%val,anynull,status)
  ! *** JP Next block could be factorized
  if (anynull .or. status.gt.0) then
     call imbfits_message(seve%e,caller,'Error')
     write(mess,'(A,I0,A,A,A,I0)')  &
          'Error while reading column #',colnum,' (',trim(key),'), row #',1
     call imbfits_message(seve%e,rname,mess)
     if (anynull) then
        call imbfits_message(seve%e,rname,'Some null values found')
     else
        call cfitsio_message(status)
     endif
     error = .true.
     return
  endif
  !
end subroutine imbfits_read_dble_2d_into_1d
!
subroutine imbfits_read_data(caller,file,nchan,npix,ftime,ntime,  &
  imbdata,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_read_data
  !---------------------------------------------------------------------
  ! @ public
  ! Reading subroutine specific to the 'DATA' column
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: caller   ! Name of calling subroutine
  type(imbfits_file_t), intent(in)    :: file     !
  integer(kind=4),      intent(in)    :: nchan    !
  integer(kind=4),      intent(in)    :: npix     !
  integer(kind=4),      intent(in)    :: ftime    ! First 'time' row read
  integer(kind=4),      intent(in)    :: ntime    ! Number of 'time' rows read
  type(imbfits_data_t), intent(inout) :: imbdata  !
  logical,              intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='IMBFITS>READ>DATA'
  integer(kind=4) :: colnum,status,nelem
  logical :: anynull
  character(len=message_length) :: mess
  character(len=10) :: tkey,tval
  character(len=comment_length) :: tcomm
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (file%unit.eq.0) then
     call imbfits_message(seve%e,rname,'Input file not opened')
     error = .true.
     return
  endif
  !
  ! Allocations
  call reallocate_imbfits_data_val(nchan,npix,ntime,imbdata,error)
  if (error)  return
  !
  ! Get column number
  status = 0
  call ftgcno(file%unit,.false.,'DATA',colnum,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Error while searching for column ''DATA''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! Get corresponding TFORM
  tkey = 'TFORM'
  write(tkey(6:7),'(I0)')  colnum
  call ftgkys(file%unit,tkey,tval,tcomm,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    call imbfits_message(seve%e,rname,'Some error reading '''//trim(tkey)//'''')
    call cfitsio_message(status)
    error = .true.
    return
  endif
! ZZZ Some clever check here!
!   if (tval.ne.'E') then
!     write(mess,'(A,A,A,A,A)')  &
!       'Attempt to read column ',trim(key),' (type ',trim(tval),') in a real*4 array'
!     call imbfits_message(seve%w,rname,mess)
!   endif
  !
  nelem = nchan*npix*ntime
  anynull = .false.
  call ftgcve(file%unit,colnum,ftime,1,nelem,-1.e0,imbdata%val,anynull,status)
  if (anynull .or. status.gt.0) then
    call imbfits_message(seve%e,caller,'Error')
    write(mess,'(A,I0,A,I0)')  &
      'Error while reading column #',colnum,' (DATA), time row #',ftime
    call imbfits_message(seve%e,rname,mess)
    if (anynull) then
      call imbfits_message(seve%e,rname,'Some null values found')
    else
      call cfitsio_message(status)
      call ftrprt('STDOUT',status)  ! Much verbose for debugging
    endif
    error = .true.
    return
  endif
  !
  ! Weight (1D array, shared by all time dumps and pixels)
  imbdata%wei(:) = 1.
  !
end subroutine imbfits_read_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Making routines (1D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_make_inte_1d(key,n,comment,inte,error)
  use gbl_message
  use imbfits_interfaces, except_this=>imbfits_make_inte_1d
  use imbfits_types
  !-------------------------------------------------------------------
  ! @ private-generic imbfits_make_column
  ! Allocate and fill a column with continuous numbering.
  !-------------------------------------------------------------------
  character(len=*),     intent(in)    :: key
  integer(kind=4),      intent(in)    :: n
  character(len=*),     intent(in)    :: comment
  type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MAKE>INTE>1D'
  integer(kind=4) :: i
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  call reallocate_fits_inte_1d(key,n,inte,error)
  if (error)  return
  inte%comment = comment
  !
  do i=1,n
    inte%val(i) = i
  enddo
  !
end subroutine imbfits_make_inte_1d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Compression routines (1D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_compress_inte_1d(inte,flag,nnew,buf,error)
  use imbfits_interfaces, except_this=>imbfits_compress_inte_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_compress_column
  ! Compress the column according to the flag array. Assume the column,
  ! the flag array, and the buffer have a consistent size.
  !---------------------------------------------------------------------
  type(fits_inte_1d_t), intent(inout) :: inte     !
  logical,              intent(in)    :: flag(:)  !
  integer(kind=4),      intent(in)    :: nnew     ! Number of .true. flag values
  integer(kind=4)                     :: buf(:)   ! Working buffer
  logical,              intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: nold,iold,inew
  !
  ! Save previous values
  nold = inte%n
  buf(1:nold) = inte%val(1:nold)
  !
  call reallocate_fits_inte_1d(inte%key,nnew,inte,error)
  if (error)  return
  write(inte%comment,'(A,I0,A)')  &
    'WARNING! ',nold-nnew,' values removed because of ISWITCH'
  !
  inew = 0
  do iold=1,nold
    if (.not.flag(iold))  cycle
    inew = inew+1
    inte%val(inew) = buf(iold)
  enddo
  !
end subroutine imbfits_compress_inte_1d
!
subroutine imbfits_compress_dble_1d(dble,flag,nnew,buf,error)
  use imbfits_interfaces, except_this=>imbfits_compress_dble_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_compress_column
  ! Compress the column according to the flag array. Assume the column,
  ! the flag array, and the buffer have a consistent size.
  !---------------------------------------------------------------------
  type(fits_dble_1d_t), intent(inout) :: dble     !
  logical,              intent(in)    :: flag(:)  !
  integer(kind=4),      intent(in)    :: nnew     ! Number of .true. flag values
  real(kind=8)                        :: buf(:)   ! Working buffer
  logical,              intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: nold,iold,inew
  !
  ! Save previous values
  nold = dble%n
  buf(1:nold) = dble%val(1:nold)
  !
  call reallocate_fits_dble_1d(dble%key,nnew,dble,error)
  if (error)  return
  write(dble%comment,'(A,I0,A)')  &
    'WARNING! ',nold-nnew,' values removed because of ISWITCH'
  !
  inew = 0
  do iold=1,nold
    if (.not.flag(iold))  cycle
    inew = inew+1
    dble%val(inew) = buf(iold)
  enddo
  !
end subroutine imbfits_compress_dble_1d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Deallocation routines (1D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_free_logi_1d(logi,error)
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_free_logi_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_free_column
  !---------------------------------------------------------------------
  type(fits_logi_1d_t), intent(inout) :: logi    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  !
  call free_fits_logi_1d(logi,error)
  if (error)  return
  !
end subroutine imbfits_free_logi_1d
!
subroutine imbfits_free_inte_1d(inte,error)
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_free_inte_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_free_column
  !---------------------------------------------------------------------
  type(fits_inte_1d_t), intent(inout) :: inte    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  !
  call free_fits_inte_1d(inte,error)
  if (error)  return
  !
end subroutine imbfits_free_inte_1d
!
subroutine imbfits_free_real_1d(real,error)
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_free_real_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_free_column
  !---------------------------------------------------------------------
  type(fits_real_1d_t), intent(inout) :: real    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  !
  call free_fits_real_1d(real,error)
  if (error)  return
  !
end subroutine imbfits_free_real_1d
!
subroutine imbfits_free_dble_1d(dble,error)
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_free_dble_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_free_column
  !---------------------------------------------------------------------
  type(fits_dble_1d_t), intent(inout) :: dble    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  !
  call free_fits_dble_1d(dble,error)
  if (error)  return
  !
end subroutine imbfits_free_dble_1d
!
subroutine imbfits_free_char_1d(char,error)
  use gbl_message
  use imbfits_interfaces, except_this => imbfits_free_char_1d
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_free_column
  !---------------------------------------------------------------------
  type(fits_char_1d_t), intent(inout) :: char    ! INOUT: keep allocation status
  logical,              intent(inout) :: error
  !
  call free_fits_char_1d(char,error)
  if (error)  return
  !
end subroutine imbfits_free_char_1d
!
subroutine imbfits_free_data(imbdata,error)
  use imbfits_interfaces, except_this=>imbfits_free_data
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Freeing subroutine specific to the 'DATA' column
  !---------------------------------------------------------------------
  type(imbfits_data_t), intent(inout) :: imbdata  !
  logical,              intent(inout) :: error    !
  !
  call free_imbfits_data_val(imbdata,error)
  if (error)  return
  !
end subroutine imbfits_free_data
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Dumping routines (0D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_dump_dble_0d(dble,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_dble_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_dump_key
  !---------------------------------------------------------------------
  type(fits_dble_0d_t), intent(in)    :: dble
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=key_length) :: key
  !
  key = dble%key
  call sic_upper(key)
  write(olun,100) key,dble%val,trim(dble%comment)
  !
100 format(A8,' (R8) = ',1PG22.15,' / ',A)
end subroutine imbfits_dump_dble_0d
!
subroutine imbfits_dump_inte_0d(inte,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_inte_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_dump_key
  !---------------------------------------------------------------------
  type(fits_inte_0d_t), intent(in)    :: inte
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=key_length) :: key
  !
  key = inte%key
  call sic_upper(key)
  write(olun,100) key,inte%val,trim(inte%comment)
  !
100 format(A8,' (I4) = ',I22,' / ',A)
end subroutine imbfits_dump_inte_0d
!
subroutine imbfits_dump_logi_0d(logi,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_logi_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_dump_key
  !---------------------------------------------------------------------
  type(fits_logi_0d_t), intent(in)    :: logi
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=key_length) :: key
  !
  key = logi%key
  call sic_upper(key)
  write(olun,100) key,logi%val,trim(logi%comment)
  !
100 format(A8,' (L)  = ',L22,' / ',A)
end subroutine imbfits_dump_logi_0d
!
subroutine imbfits_dump_char_0d(char,olun,error)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_char_0d
  !---------------------------------------------------------------------
  ! @ private-generic imbfits_dump_key
  !---------------------------------------------------------------------
  type(fits_char_0d_t), intent(in)    :: char
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=key_length) :: key
  !
  key = char%key
  call sic_upper(key)
  write(olun,100) key,char%val,trim(char%comment)
  !
100 format(A8,' (C)  = ',A22,' / ',A)
end subroutine imbfits_dump_char_0d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Dumping routines (1D)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_dump_inte_1d(inte,olun,error,full)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_inte_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_dump_column
  !---------------------------------------------------------------------
  type(fits_inte_1d_t), intent(in)    :: inte
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  logical, optional,    intent(in)    :: full   ! Full output (all values)?
  ! Local
  character(len=key_length) :: key
  logical :: dofull
  !
  if (present(full)) then
    dofull = full
  else
    dofull = .false.
  endif
  key = inte%key
  call sic_upper(key)
  if (.not.associated(inte%val)) then
    write(olun,100)  key,trim(inte%comment)
  elseif (dofull) then
    write(olun,'(4A,I0)')  &
      trim(key),' (',trim(inte%comment),') is an integer column of dimensions ',inte%n
    call i4_type(inte%n,inte%val)
  elseif (inte%n.ge.3) then
    write(olun,103)  key,inte%val(1),inte%val(inte%n),trim(inte%comment)
  elseif (inte%n.eq.2) then
    write(olun,102)  key,inte%val(1:2),trim(inte%comment)
  else  ! 1 value
    write(olun,101)  key,inte%val(1),trim(inte%comment)
  endif
  !
100 format(A8,' (I4) = NO DATA ASSOCIATED!',              T64,'/ ',A)
101 format(A8,' (I4) =',1(1X,I14),                        T64,'/ ',A)
102 format(A8,' (I4) =',2(1X,I14),                        T64,'/ ',A)
103 format(A8,' (I4) =',1(1X,I14),'      ...     ',1X,I14,T64,'/ ',A)
end subroutine imbfits_dump_inte_1d
!
subroutine imbfits_dump_real_1d(real,olun,error,full)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_real_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_dump_column
  !---------------------------------------------------------------------
  type(fits_real_1d_t), intent(in)    :: real
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  logical, optional,    intent(in)    :: full   ! Full output (all values)?
  ! Local
  character(len=key_length) :: key
  logical :: dofull
  !
  if (present(full)) then
    dofull = full
  else
    dofull = .false.
  endif
  key = real%key
  call sic_upper(key)
  if (.not.associated(real%val)) then
    write(olun,100)  key,trim(real%comment)
  elseif (dofull) then
    write(olun,'(4A,I0)')  &
      trim(key),' (',trim(real%comment),') is a real column of dimensions ',real%n
    call r4_type(real%n,real%val)
  elseif (real%n.ge.3) then
    write(olun,103)  key,real%val(1),real%val(real%n),trim(real%comment)
  elseif (real%n.eq.2) then
    write(olun,102)  key,real%val(1:2),trim(real%comment)
  else
    write(olun,101)  key,real%val(1),trim(real%comment)
  endif
  !
  ! Single precision floats: precision is 7.22 decimal digits
100 format(A8,' (R4) = NO DATA ASSOCIATED!',                         T64,'/ ',A)
101 format(A8,' (R4) =',1(1X,1PG14.7),                               T64,'/ ',A)
102 format(A8,' (R4) =',2(1X,1PG14.7),                               T64,'/ ',A)
103 format(A8,' (R4) =',1(1X,1PG14.7),'      ...     ',1(1X,1PG14.7),T64,'/ ',A)
end subroutine imbfits_dump_real_1d
!
subroutine imbfits_dump_dble_1d(dble,olun,error,full)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_dble_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_dump_column
  !---------------------------------------------------------------------
  type(fits_dble_1d_t), intent(in)    :: dble
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  logical, optional,    intent(in)    :: full   ! Full output (all values)?
  ! Local
  character(len=key_length) :: key
  logical :: dofull
  !
  if (present(full)) then
    dofull = full
  else
    dofull = .false.
  endif
  key = dble%key
  call sic_upper(key)
  if (.not.associated(dble%val)) then
    write(olun,100)  key,trim(dble%comment)
  elseif (dofull) then
    write(olun,'(4A,I0)')  &
      trim(key),' (',trim(dble%comment),') is a double column of dimensions ',dble%n
    call r8_type(dble%n,dble%val)
  elseif (dble%n.ge.3) then
    write(olun,103)  key,dble%val(1),dble%val(dble%n),trim(dble%comment)
  elseif (dble%n.eq.2) then
    write(olun,102)  key,dble%val(1:2),trim(dble%comment)
  else
    write(olun,101)  key,dble%val(1),trim(dble%comment)
  endif
  !
  ! Double precision floats: precision is 15.95 decimal digits (using
  ! more than 15 digits can make appear roundoff problems because of
  ! precision is not exactly 16).
100 format(A8,' (R8) = NO DATA ASSOCIATED!',                  T64,'/ ',A)
101 format(A8,' (R8) =',1(1X,1PG22.15),                       T64,'/ ',A)
102 format(A8,' (R8) =',2(1X,1PG22.15),                       T64,'/ ',A)
103 format(A8,' (R8) =',1(1X,1PG22.15),' ... ',1(1X,1PG22.15),T64,'/ ',A)
end subroutine imbfits_dump_dble_1d
!
subroutine imbfits_dump_char_1d(char,olun,error,full)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_char_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_dump_column
  !---------------------------------------------------------------------
  type(fits_char_1d_t), intent(in)    :: char
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  logical, optional,    intent(in)    :: full   ! Full output (all values)?
  ! Local
  character(len=key_length) :: key
  logical :: dofull
  !
  if (present(full)) then
    dofull = full
  else
    dofull = .false.
  endif
  key = char%key
  call sic_upper(key)
  if (.not.associated(char%val)) then
    write(olun,100)  key,trim(char%comment)
  elseif (dofull) then
    write(olun,'(4A,I0,A,I0)')  &
      trim(key),' (',trim(char%comment),') is a character*',len(char%val(1)),' column of dimensions ',char%n
    call ch_type(char%n,char%val,len(char%val(1)))
  elseif (char%n.ge.3) then
    write(olun,103)  key,char%val(1),char%val(char%n),trim(char%comment)
  elseif (char%n.eq.2) then
    write(olun,102)  key,char%val(1:2),trim(char%comment)
  else
    write(olun,101)  key,char%val(1),trim(char%comment)
  endif
  !
100 format(A8,' (C)  = NO DATA ASSOCIATED!',                 T64,'/ ',A)
101 format(A8,' (C)  =',1(1X,A14),                           T64,'/ ',A)
102 format(A8,' (C)  =',2(1X,A14),                           T64,'/ ',A)
103 format(A8,' (C)  =',1(1X,A14),'      ...     ',1(1X,A14),T64,'/ ',A)
end subroutine imbfits_dump_char_1d
!
subroutine imbfits_dump_logi_1d(logi,olun,error,full)
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_logi_1d
  !---------------------------------------------------------------------
  ! @ public-generic imbfits_dump_column
  !---------------------------------------------------------------------
  type(fits_logi_1d_t), intent(in)    :: logi
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  logical, optional,    intent(in)    :: full   ! Full output (all values)?
  ! Local
  character(len=key_length) :: key
  logical :: dofull
  !
  if (present(full)) then
    dofull = full
  else
    dofull = .false.
  endif
  key = logi%key
  call sic_upper(key)
  if (.not.associated(logi%val)) then
    write(olun,100)  key,trim(logi%comment)
  elseif (dofull) then
    write(olun,'(4A,I0)')  &
      trim(key),' (',trim(logi%comment),') is a logical column of dimensions ',logi%n
    call l_type(logi%n,logi%val)
  elseif (logi%n.ge.3) then
    write(olun,103)  key,logi%val(1),logi%val(logi%n),trim(logi%comment)
  elseif (logi%n.eq.2) then
    write(olun,102)  key,logi%val(1:2),trim(logi%comment)
  else
    write(olun,101)  key,logi%val(1),trim(logi%comment)
  endif
  !
100 format(A8,' (L)  = NO DATA ASSOCIATED!',         T64,'/ ',A)
101 format(A8,' (L)  =',1(1X,L8),                    T64,'/ ',A)
102 format(A8,' (L)  =',2(1X,L8),                    T64,'/ ',A)
103 format(A8,' (L)  =',1(1X,L8),'   ...  ',1(1X,L8),T64,'/ ',A)
end subroutine imbfits_dump_logi_1d
!
subroutine imbfits_dump_imbfdata(imbf,olun,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_dump_imbfdata
  use ram_sizes
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_data_t), intent(in)    :: imbf
  integer(kind=4),      intent(in)    :: olun   ! Output LUN
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>DUMP>IMBFDATA'
  !
  if (.not.associated(imbf%val)) then
    call imbfits_message(seve%e,rname,'No data associated')
    error = .true.
    return
  endif
  !
  write(olun,'(A,I8,A,F0.1,A)')  &
    '   ',imbf%nchan,' channels (',1.d0*imbf%nchan*bytes_per_real/kB,' kB)'
  write(olun,'(A,I8,A)')  &
    ' x ',imbf%npix,' pixel(s)'
  write(olun,'(A,I8,A)')  &
    ' x ',imbf%ntime,' time dumps'
  write(olun,'(A,I8,A,F0.1,A)')  &
    ' = ',size(imbf%val),' values (',1.d0*size(imbf%val)*bytes_per_real/MB,' MB)'
  !
end subroutine imbfits_dump_imbfdata
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_hdus(file,hdus,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_hdus
  !---------------------------------------------------------------------
  ! @ private
  !  Set up the HDUs description which is used later on when we
  ! access the subscan HDUs.
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file
  type(imbfits_hdus_t), intent(out)   :: hdus
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='HDUS'
  type(fits_dble_0d_t) :: imbftsve
  type(fits_inte_0d_t) :: nsub
  !
  ! Get the IMB-FITS version
  call imbfits_mvhdu_pos(1,file,error)  ! Primary is always #1
  if (error)  return
  call imbfits_read_key(rname,file,'imbftsve',imbftsve,error)
  if (error) then
    call imbfits_message(seve%e,rname,'Not an IMB-FITS file?')
    return
  endif
  call imbfits_read_key(rname,file,'n_obsp',nsub,error)
  if (error)  return
  !
  ! Number of HDUs
  hdus%n = 0
  ! Computing NHDU with FTTHDU is highly unefficient => not available.
  ! call ftthdu(file%unit,hdus%n,status)
  ! if (status.gt.0) then
  !   call imbfits_message(seve%e,rname,'Could not find number of HDUs')
  !   call cfitsio_message(status)
  !   error = .true.
  !   return
  ! endif
  !
  if (imbftsve%val.gt.2.2099999d0) then  ! 2.21 and above
    ! For latest IMB-FITS, the structure has no possible latitude
    call imbfits_message(seve%w,rname,'IMB-FITS version 2.21 and above have experimental support')
    call imbfits_hdus_preset_2_21(file,nsub%val,hdus,error)
    if (error)  return
  elseif (imbftsve%val.gt.2.199999d0) then  ! 2.20
    ! For latest IMB-FITS, the structure has no possible latitude
    call imbfits_message(seve%w,rname,'IMB-FITS version 2.20 and above have experimental support')
    call imbfits_hdus_preset_2_20(file,nsub%val,hdus,error)
    if (error)  return
  elseif (imbftsve%val.ge.2.d0) then  ! 2.0 and above
    ! For latest IMB-FITS, the structure has no possible latitude
    call imbfits_hdus_preset_2_0(file,hdus,error)
    if (error)  return
  else  ! Below 2.0
    ! For old IMB-FITS, there are various case (e.g. HERA or not HERA, etc)
    ! Use the auto-detection engine
    call imbfits_hdus_autodetect(file,hdus,error)
    if (error)  return
  endif
  !
end subroutine imbfits_hdus
!
subroutine imbfits_hdus_preset_2_0(file,hdus,error)
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set up the HDUs description which is used later on when we access
  ! the subscan HDUs. The description is forced to the IMB-FITS V2.0
  ! (included) up to V2.2 (excluded)
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file
  type(imbfits_hdus_t), intent(out)   :: hdus
  logical,              intent(inout) :: error
  !
  hdus%nlead = 4
  hdus%npersubscan = 3
  !
  ! Leading HDUs: absolute positions
  hdus%pos(:) = 0
  hdus%pos(hdu_scan)     = 1
  hdus%pos(hdu_frontend) = 2
  hdus%pos(hdu_backend)  = 3
  !
  ! Subscan HDUs: relative positions in subscan
  hdus%pos(hdu_backdata)     = 1
  hdus%pos(hdu_antslow)      = 2
  hdus%pos(hdu_antfast)      = 2
  hdus%pos(hdu_subreflector) = 3
  !
  ! Derot and/or cryostat were never written in this format.
  !
end subroutine imbfits_hdus_preset_2_0
!
subroutine imbfits_hdus_preset_2_20(file,nsub,hdus,error)
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set up the HDUs description which is used later on when we access
  ! the subscan HDUs. The description is forced to the IMB-FITS V2.20
  ! (included)
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file   !
  integer(kind=4),      intent(in)    :: nsub   ! Number of subscans in file
  type(imbfits_hdus_t), intent(out)   :: hdus   !
  logical,              intent(inout) :: error  !
  !
  hdus%nlead = 4
  hdus%npersubscan = 3
  !
  ! Leading HDUs: absolute positions (NB: numering starts at 1 for Primary)
  hdus%pos(:) = 0
  hdus%pos(hdu_scan)     = 2
  hdus%pos(hdu_frontend) = 3
  hdus%pos(hdu_backend)  = 4
  !
  ! Subscan HDUs: relative positions in subscan
  hdus%pos(hdu_antslow)      = 1
  hdus%pos(hdu_antfast)      = 1
  hdus%pos(hdu_subreflector) = 2
  hdus%pos(hdu_backdata)     = 3
  !
  ! If present, cryot assumed to be found at right after the subscans
  !
  ! If present, derot assumed to be found at right after cryot
  hdus%pos(hdu_derot) = hdus%nlead + hdus%npersubscan*nsub + 2
  !
end subroutine imbfits_hdus_preset_2_20
!
subroutine imbfits_hdus_preset_2_21(file,nsub,hdus,error)
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Set up the HDUs description which is used later on when we access
  ! the subscan HDUs. The description is forced to the IMB-FITS V2.21
  ! (included)
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file   !
  integer(kind=4),      intent(in)    :: nsub   ! Number of subscans in file
  type(imbfits_hdus_t), intent(out)   :: hdus   !
  logical,              intent(inout) :: error  !
  !
  hdus%nlead = 6
  hdus%npersubscan = 3
  !
  ! Leading HDUs: absolute positions (NB: numering starts at 1 for Primary)
  hdus%pos(:) = 0
  hdus%pos(hdu_scan)     = 2
  hdus%pos(hdu_frontend) = 3
  hdus%pos(hdu_backend)  = 4
! hdus%pos(hdu_cryot)    = 5
  hdus%pos(hdu_derot)    = 6
  !
  ! Subscan HDUs: relative positions in subscan
  hdus%pos(hdu_antslow)      = 1
  hdus%pos(hdu_antfast)      = 1
  hdus%pos(hdu_subreflector) = 2
  hdus%pos(hdu_backdata)     = 3
  !
end subroutine imbfits_hdus_preset_2_21
!
subroutine imbfits_hdus_autodetect(file,hdus,error)
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_hdus_autodetect
  !---------------------------------------------------------------------
  ! @ private
  !  Analyse the (first) HDUs in the FITS file in order to guess:
  !   - the number of "leading" HDUs (i.e. the ones which are present
  !     only once at the beginning)
  !   - the number of HDUs per subscan
  !   - the order of the HDUs
  !  There is a slight cost because we open several HDUs.
  !---------------------------------------------------------------------
  type(imbfits_file_t), intent(in)    :: file
  type(imbfits_hdus_t), intent(out)   :: hdus
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='HDUS>AUTODETECT'
  integer(kind=4) :: ihdu
  type(fits_char_0d_t) :: extname
  logical :: first
  !
  hdus%pos(:) = 0
  hdus%nlead = 0
  hdus%npersubscan = 0
  !
  ihdu = 1
  do
    ! Next HDU (NB: numbering starts at 1, we skip the Primary)
    ihdu = ihdu+1
    !
    ! Move to the HDU
    call imbfits_mvhdu_pos(ihdu,file,error)
    if (error) then
      ! We can have a "read past end of file" if the number of subscan is 0 or 1
      ! If Nsub is 0, the following has no meaning but anyway Mrtcal will not
      ! attempt to read a subscan HDU
      ! If Nsub is 1, the following should be correct, and anyway not really
      ! important for a single subscan (see where it is used).
      hdus%npersubscan = ihdu-hdus%nlead-1
      ! ZZZ we could think having a non-verbose mode in imbfits_mvhdu_pos.
    endif
    ! Get its name
    call imbfits_read_key(rname,file,'extname',extname,error)
    if (error) return
    !
    first = .true.  ! This will skip the HDUs we do not (want to) recognize
    ! Leading HDUs
    if (extname%val.eq.'IMBF-scan') then
      call leadinghdu(ihdu,hdu_scan,first)
    elseif (extname%val.eq.'IMBF-frontend') then
      call leadinghdu(ihdu,hdu_frontend,first)
    elseif (extname%val.eq.'IMBF-backend') then  ! Full name search
      call leadinghdu(ihdu,hdu_backend,first)
    !
    ! Subscan HDUs
    elseif (extname%val(1:12).eq.'IMBF-backend') then  ! Substring search e.g. IMBF-backendVESPA
      call subscanhdu(ihdu,hdu_backdata,first)
    elseif (extname%val.eq.'IMBF-antenna') then
      call subscanhdu(ihdu,hdu_antslow,first)
      call subscanhdu(ihdu,hdu_antfast,first)
    elseif (extname%val.eq.'IMBF-subreflector') then
      call subscanhdu(ihdu,hdu_subreflector,first)
    elseif (extname%val.eq.'IMBF-hera-derot') then  ! We could search only for 'derot'
      call subscanhdu(ihdu,hdu_derot,first)
    endif
    !
    if (.not.first) then
      ! This means we reached the 2nd subscan
      hdus%npersubscan = ihdu-hdus%nlead-1
      exit
    endif
    !
  enddo
  !
contains
  subroutine leadinghdu(ihdu,kind,first)
    integer(kind=4), intent(in)  :: ihdu,kind
    logical,         intent(out) :: first
    !
    first = hdus%pos(kind).eq.0  ! Should never be .false. for a leading HDU
    if (first)  hdus%pos(kind) = ihdu
  end subroutine leadinghdu
  !
  subroutine subscanhdu(ihdu,kind,first)
    integer(kind=4), intent(in)  :: ihdu,kind
    logical,         intent(out) :: first
    !
    if (hdus%nlead.eq.0)  hdus%nlead = ihdu-1
    first = hdus%pos(kind).eq.0
    if (first)  hdus%pos(kind) = ihdu-hdus%nlead
  end subroutine subscanhdu
  !
end subroutine imbfits_hdus_autodetect
!
subroutine imbfits_mvhdu_name(key,file,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_mvhdu_name
  !---------------------------------------------------------------------
  ! @ private
  ! Move to the ***first*** HDU with the given name
  !---------------------------------------------------------------------
  character(len=*),     intent(in)    :: key
  type(imbfits_file_t), intent(in)    :: file
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MVHDU>NAME'
  ! character(len=message_length) :: mess
  integer(kind=4) :: status
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  if (file%unit.eq.0) then
    call imbfits_message(seve%e,rname,'No file connected to unit')
    error = .true.
    return
  endif
  !
  status = 0
  call ftmnhd(file%unit,code_cfitsio_binary_tbl,key,0,status)
  if (status.gt.0) then
    call imbfits_message(seve%e,rname,'Error while moving to HDU '//key)
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! write(mess,'(A,A,A)')  'Moved to HDU ''',trim(key),''''
  ! call imbfits_message(seve%i,rname,mess)
  !
end subroutine imbfits_mvhdu_name
!
subroutine imbfits_mvhdu_subscan(isub,hduid,imbf,error)
  use imbfits_interfaces, except_this => imbfits_mvhdu_subscan
  use imbfits_messaging
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Move to appropriate HDU for the isub-th subscan
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: isub   ! Subscan number
  integer(kind=4), intent(in)    :: hduid  ! HDU identifier
  type(imbfits_t), intent(in)    :: imbf   !
  logical,         intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MVHDU>SUBSCAN'
  integer(kind=4) :: ihdu
  character(len=message_length) :: mess
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
  if (isub.le.0 .or. isub.gt.imbf%primary%n_obs%val) then
    write(mess,'(A,I0,A,I0,A)')  &
      'No subscan #',isub,' (file has only ',imbf%primary%n_obs%val,' subscans)'
    call imbfits_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (imbf%hdus%pos(hduid).eq.0) then
    call imbfits_message(seve%e,rname,'HDU position not known')
    error = .true.
    return
  endif
  !
  select case (hduid)
  case (hdu_scan,hdu_frontend,hdu_backend)  ! Leading HDUs
    ! This is not a subroutine for those HDUs (but we could enable this anyway)
    call imbfits_message(seve%e,rname,'Incorrect HDU identifier')
    error = .true.
    return
  case (hdu_backdata,hdu_antslow,hdu_antfast,hdu_subreflector,hdu_derot)  ! Subscan HDUs
    ihdu = imbf%hdus%nlead + (isub-1)*imbf%hdus%npersubscan + imbf%hdus%pos(hduid)
  case default
    call imbfits_message(seve%e,rname,'HDU kind not implemented')
    error = .true.
    return
  end select
  !
  write(mess,'(A,I0,A,I0,A,I0,A)')  &
    'Moving to subscan #',isub,', HDU id: ',hduid,' (#',ihdu,')'
  call imbfits_message(iseve%other,rname,mess)
  call imbfits_mvhdu_pos(ihdu,imbf%file,error)
  if (error)  return
  !
end subroutine imbfits_mvhdu_subscan
!
subroutine imbfits_mvhdu_pos(ihdu,file,error)
  use gbl_message
  use cfitsio_api
  use imbfits_types
  use imbfits_interfaces, except_this => imbfits_mvhdu_pos
  !---------------------------------------------------------------------
  ! @ private
  ! Move to the HDU with the given absolute position
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: ihdu
  type(imbfits_file_t), intent(in)    :: file
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='IMBFITS>MVHDU>POS'
  character(len=message_length) :: mess
  integer(kind=4) :: status,hdutype
  !
  call imbfits_message(seve%t,rname,'Welcome')
  !
! Computing NHDU with FTTHDU is highly unefficient => not available.
!   if (ihdu.gt.file%nhdu) then
!     write(mess,'(A,I0,A,I0,A)')  &
!       'IMBFITS file has only ',file%nhdu,' HDUs (requested ',ihdu,')'
!     call imbfits_message(seve%e,rname,mess)
!     error = .true.
!     return
!   endif
  !
  ! Sanity check
  if (file%unit.eq.0) then
    call imbfits_message(seve%e,rname,'No file connected to unit')
    error = .true.
    return
  endif
  !
  status = 0
  call ftmahd(file%unit,ihdu,hdutype,status)
  if (status.gt.0) then
    write(mess,'(A,I0)')  'Error while moving to HDU #',ihdu
    call imbfits_message(seve%e,rname,mess)
    call cfitsio_message(status)
    error = .true.
    return
  endif
  !
  ! write(mess,'(A,I0)')  'Moved to HDU #',ihdu
  ! call imbfits_message(seve%i,rname,mess)
  !
end subroutine imbfits_mvhdu_pos
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine cfitsio_message(status)
  use cfitsio_api
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Print the CFITSIO error message given the error status. Should
  ! probably be public.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: status
  ! Local
  character(len=*), parameter :: rname='CFITSIO'
  character(len=message_length) :: mess
  !
  call ftgerr(status,mess)
  !
  if (status.eq.0) then
    call imbfits_message(seve%i,rname,mess)
  else
    call imbfits_message(seve%e,rname,mess)
  endif
  !
end subroutine cfitsio_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_resample_header_backend(in,owidth,out,error)
  use imbfits_interfaces, except_this=>imbfits_resample_header_backend
  use imbfits_messaging
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Resample a backend table, by splitting each chunk into several
  ! "sub-chunks". Cut at best in the USED channels at almost equal
  ! width.
  !---------------------------------------------------------------------
  type(imbfits_back_t),  intent(in)    :: in
  real(kind=4),          intent(in)    :: owidth   ! Desired cal. bandwidth [MHz]
  type(imbfits_back_t),  intent(inout) :: out
  logical,               intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='RESAMPLE>HEADER>BACKEND'
  integer(kind=4) :: nsub(in%head%desc%naxis2%val)  ! Number of divisions for each chunk
  integer(kind=4) :: nline2,iin,iout,isub,used,usedtot,nchanshift
  character(len=message_length) :: mess
  real(kind=4) :: iwidth,ispacing,awidth
  !
  !-----------
  ! Divisions
  ! Do not assume each chunk has same width, must loop on all of them
  do iin=1,in%head%desc%naxis2%val
    ispacing = abs(in%table%spacing%val(iin))  ! 1 channel
    iwidth = in%table%used%val(iin)*ispacing   ! USED channels
    if (owidth.gt.iwidth) then
      write(mess,'(A,2(F0.2,A))')  'Desired calibration bandwidth (',owidth,  &
        ' MHz) is larger than native bandwidth (',iwidth,' MHz) in USED channels'
      call imbfits_message(iseve%other,rname,mess)
      nsub(iin) = 1
    elseif (owidth.lt.ispacing) then
      ! Note that this happens every time with BBC = single 8000 MHz channel
      write(mess,'(A,2(F0.2,A))')  'Desired calibration bandwidth (',owidth,  &
        ' MHz) is lower than channel spacing (',ispacing,' MHz)'
      call imbfits_message(iseve%other,rname,mess)
      nsub(iin) = in%table%used%val(iin)
    else
      nsub(iin) = nint(iwidth/owidth)
    endif
  enddo
  !
  if (in%head%desc%naxis2%val.le.0) then
    ! This happens in case of empty IMBF-backend table (0 rows).
    call imbfits_message(iseve%other,rname,'IMBF-Backend tables are 0 sized')
    awidth = 0.
  else
    ! Some feedback for the time being (print last chunk division)
    awidth = iwidth/nsub(in%head%desc%naxis2%val)  ! Actual width
    write(mess,'(A,F0.1,A,I0,A)')  &
      'IMBF-Backend tables sliced to ',awidth,  &
      ' MHz (',nsub(in%head%desc%naxis2%val),' subdivisions)'
    call imbfits_message(iseve%other,rname,mess)
  endif
  !
  !--------
  ! Header
  ! Everything identical...
  out%head = in%head
  ! ... except one:
  out%head%desc%naxis2%val = sum(nsub)
  !
  !--------
  ! Tables
  !
  ! (Re)allocations:
  nline2 = out%head%desc%naxis2%val
  call reallocate_fits_inte_1d(in%table%part%key,nline2,out%table%part,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%refchan%key,nline2,out%table%refchan,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%chans%key,nline2,out%table%chans,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%dropped%key,nline2,out%table%dropped,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%used%key,nline2,out%table%used,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%pixel%key,nline2,out%table%pixel,error)
  if (error)  return
  call reallocate_fits_char_1d(in%table%receiver%key,nline2,out%table%receiver,error)
  if (error)  return
  call reallocate_fits_inte_1d(in%table%ifront%key,nline2,out%table%ifront,error)
  if (error)  return
  call reallocate_fits_char_1d(in%table%band%key,nline2,out%table%band,error)
  if (error)  return
  call reallocate_fits_char_1d(in%table%frontend%key,nline2,out%table%frontend,error)
  if (error)  return
  call reallocate_fits_char_1d(in%table%polar%key,nline2,out%table%polar,error)
  if (error)  return
  call reallocate_fits_real_1d(in%table%reffreq%key,nline2,out%table%reffreq,error)
  if (error)  return
  call reallocate_fits_real_1d(in%table%spacing%key,nline2,out%table%spacing,error)
  if (error)  return
  call reallocate_fits_char_1d(in%table%linename%key,nline2,out%table%linename,error)
  if (error)  return
  call reallocate_fits_logi_1d(in%table%dataflip%key,nline2,out%table%dataflip,error)
  if (error)  return
  !
  ! Resampling:
  iout = 0
  do iin=1,in%head%desc%naxis2%val
    ! Split each line into Nsub(iin) "sub-chunks":
    usedtot = 0
    nchanshift = in%table%dropped%val(iin)
    do isub=1,nsub(iin)
      iout = iout+1
      !
      ! Easy ones (unchanged)
      out%table%part%val(iout)     = in%table%part%val(iin)
      out%table%pixel%val(iout)    = in%table%pixel%val(iin)
      out%table%receiver%val(iout) = in%table%receiver%val(iin)
      out%table%ifront%val(iout)   = in%table%ifront%val(iin)
      out%table%band%val(iout)     = in%table%band%val(iin)
      out%table%frontend%val(iout) = in%table%frontend%val(iin)
      out%table%polar%val(iout)    = in%table%polar%val(iin)
      out%table%spacing%val(iout)  = in%table%spacing%val(iin)
      out%table%linename%val(iout) = in%table%linename%val(iin)
      out%table%dataflip%val(iout) = in%table%dataflip%val(iin)
      !
      ! More complicated: frequency axis. Build new chunks with USED channels
      ! only, no DROPPED at the edges.
      !
      ! USED: example 20 channels divided in 6
      ! - Naive code would give equal length like this:
      !     3+3+3+3+3+3 = 18 channels (loose or add channels!)
      ! - Less naive would fix this in the last:
      !     3+3+3+3+3+5 = 20 channels (can end with very inegal division)
      ! - Following code does:
      !     3+4+3+3+4+3 = 20 channels (better alignment of the integer grid
      !       onto the floating point grid, + at most 1 channel difference)
      used = nint(real(isub*in%table%used%val(iin),kind=8)/nsub(iin) - usedtot)
      out%table%used%val(iout) = used
      !
      out%table%dropped%val(iout) = 0
      !
      out%table%chans%val(iout) = used
      !
      out%table%refchan%val(iout) = in%table%refchan%val(iin)+nchanshift
      !
      ! Shift REFFREQ by nchanshift, but be careful not to introduce roundoff
      ! errors (=> use double precision computations)
      out%table%reffreq%val(iout) = real(in%table%reffreq%val(iin),kind=8) +  &
        nchanshift*real(in%table%spacing%val(iin),kind=8)
      !
      ! For next sub-chunk:
      nchanshift = nchanshift+used
      usedtot = usedtot+used
    enddo
    !
    ! Safe-guard: ensure we do not loose or add USEful channels:
    if (usedtot.ne.in%table%used%val(iin)) then
      write(mess,'(A,I0,A,I0,A)')  'Error splitting the USED channels (got ',  &
        usedtot,', expected ',in%table%used%val(iin),')'
      call imbfits_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  ! Add a comment in CHANS column (should be done in all columns actually...)
  write(out%table%chans%comment,'(A,F0.1,A)')  &
    'WARNING! Chunks were sliced by pieces of ',awidth,' MHz'
  !
end subroutine imbfits_resample_header_backend
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine imbfits_copy_back_chunks(ichunks,ochunks,error)
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(in)    :: ichunks
  type(imbfits_back_chunks_t), intent(inout) :: ochunks
  logical,                     intent(inout) :: error
  !
  call reallocate_eclass_2inte2char(ochunks%eclass,ichunks%eclass%nval,error)
  if (error)  return
  ochunks%eclass%nval = ichunks%eclass%nval
  ochunks%eclass%nequ = ichunks%eclass%nequ
  ochunks%eclass%val1 = ichunks%eclass%val1
  ochunks%eclass%val2 = ichunks%eclass%val2
  ochunks%eclass%val3 = ichunks%eclass%val3
  ochunks%eclass%val4 = ichunks%eclass%val4
  ochunks%eclass%cnt  = ichunks%eclass%cnt
  ochunks%eclass%bak  = ichunks%eclass%bak
  !
  if (allocated(ochunks%used))  deallocate(ochunks%used)
  allocate(ochunks%used(size(ichunks%used)))
  ochunks%used(:) = ichunks%used(:)
  !
  if (allocated(ochunks%kind))  deallocate(ochunks%kind)
  allocate(ochunks%kind(size(ichunks%kind)))
  ochunks%kind(:) = ichunks%kind(:)
  !
end subroutine imbfits_copy_back_chunks
!
subroutine imbfits_free_back_chunks(chunks,error)
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(inout) :: chunks
  logical,                     intent(inout) :: error
  !
  if (allocated(chunks%used))  deallocate(chunks%used)
  if (allocated(chunks%kind))  deallocate(chunks%kind)
  call free_eclass_2inte2char(chunks%eclass,error)
  !
end subroutine imbfits_free_back_chunks
!
subroutine imbfits_init_stokesloop(book,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_init_stokesloop
  !---------------------------------------------------------------------
  ! @ public
  !  Initialize the stokesset_book_t for later use by
  ! imbfits_get_next_stokesset
  !---------------------------------------------------------------------
  type(stokesset_book_t), intent(inout) :: book
  logical,                intent(inout) :: error
  !
  book%next = 1
  !
end subroutine imbfits_init_stokesloop
!
subroutine imbfits_get_next_stokesset(cdesc,book,error)
  use gbl_message
  use imbfits_types
  use imbfits_interfaces, except_this=>imbfits_get_next_stokesset
  !---------------------------------------------------------------------
  ! @ public
  !  Get the next stokeset. As of today a stokeset can be:
  !  - A unique NONE chunkset (no polarimetry)
  !  - A collection AXISH+AXISV+REAL+IMAG (polarimetric chunksets)
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
  type(stokesset_book_t),      intent(inout) :: book   !
  logical,                     intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='IMBFITS>GET>NEXT>STOKESSET'
  integer(kind=4) :: iequ,istokes
  ! logical :: found(mstokes)
  !
  book%found = .false.
  book%nstokes = 0
  ! found(:) = .false.
  !
  ! ZZZ Should trap N inserted at bad place e.g. H V N R I
  ! ZZZ Should trap incorrect sequence e.g. H V H V R I
  ! ZZZ Do we want to reorder the chunksets found in the stokesset?
  do iequ=book%next,cdesc%eclass%nequ
    istokes = cdesc%kind(iequ)
    book%nstokes = book%nstokes+1
    book%kind(book%nstokes) = istokes
    book%iset(book%nstokes) = iequ
    book%next = iequ+1
    !
    select case (istokes)
    case (code_n)
      book%found = .true.
      return  ! NONE is returned alone
      !
    case (code_h,code_v,code_r,code_i)
      book%found = book%nstokes.eq.mstokes
      if (book%found)  return
      !
    case default
      call imbfits_message(seve%e,rname,'Unexpected stokes kind')
      error = .true.
      return
    end select
    !
  enddo
  !
end subroutine imbfits_get_next_stokesset
!
subroutine imbfits_count_polar_stokesset(cdesc,nset,error)
  use imbfits_interfaces, except_this=>imbfits_count_polar_stokesset
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  !  Count the number POLARIMETRIC stokesets that would be found when
  ! iterating with imbfits_get_next_stokesset
  !---------------------------------------------------------------------
  type(imbfits_back_chunks_t), intent(in)    :: cdesc  ! Chunks description
  integer(kind=4),             intent(out)   :: nset   ! Number of stokesset
  logical,                     intent(inout) :: error  ! Logical error flag
  ! Local
  type(stokesset_book_t) :: book
  !
  call imbfits_init_stokesloop(book,error)
  if (error) return
  !
  nset = 0
  do
    call imbfits_get_next_stokesset(cdesc,book,error)
    if (error) return
    if (.not.book%found)  exit
    if (book%nstokes.eq.4)  nset = nset+1
  enddo
  !
end subroutine imbfits_count_polar_stokesset
!
subroutine imbfits_upcase_column(char,error)
  use imbfits_interfaces, except_this => imbfits_upcase_column
  use imbfits_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(fits_char_1d_t), intent(inout) :: char
  logical,              intent(inout) :: error
  ! Local
  integer(kind=4) :: iline
  !
  do iline=1,char%n
    call sic_upper(char%val(iline))
  enddo
  !
end subroutine imbfits_upcase_column

subroutine gtx_chopper(out,cx1,cy1,cx2,cy2,up)
  use gtv_interfaces, except_this=>gtx_chopper
  use gtv_types
  use gtv_graphic
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  !  Dashed pattern and thickness generator
  !  Tente de corriger problemes vicieux si segments aleatoires tres
  ! courts ET segments nuls en mode pointille... Supprime le code
  ! specifique "segment longueur nulle"
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out      ! Input gt_display
  real*4,           intent(in)    :: cx1,cy1  ! X,Y coordinate of start point
  real*4,           intent(in)    :: cx2,cy2  ! X,Y coordinate of end point
  logical,          intent(in)    :: up       ! Force goto (CX1,CY1) pen up
  ! Local
  logical :: penup,trace, debut_trace
  save debut_trace
  real*4 :: start, dist, dtogo
  real*4 :: xc, yc, xd, yd, frac, d
  integer*4 :: istart, k
  !
  if (out%idashe.eq.1) then
    ! Solid line: no dash generator to use
    call gtx_weight(out,cx1,cy1,cx2,cy2,up)
    return
  endif
  !
  start = amod(out%totdist,onofflen(out%idashe))
  out%totdist = start
  do istart = 1,4
    if (start.lt.onoff(istart,out%idashe))  goto 6
    start = start - onoff(istart,out%idashe)
  enddo
  istart = 1                   ! Take care of rounding errors
6 continue
  !
  debut_trace = up .or. debut_trace
  penup       = debut_trace
  !
  dist = sqrt((cx2-cx1)*(cx2-cx1)+(cy2-cy1)*(cy2-cy1))
  xc = cx1
  yc = cy1
  dtogo = dist
  !
  k = istart
  d = onoff(k,out%idashe) - start
  trace = mod(istart,2).eq.1
  !
  do while (.true.)
    if (dtogo .eq. 0.0) then
      frac = 1.0
    else
      frac = min(d,dtogo) / dtogo
    endif
    xd = xc + frac*(cx2-xc)
    yd = yc + frac*(cy2-yc)
    if (trace) then
      if (out%iweigh.le.graisse(1)) then
        if (penup) call gtx_plot(out,xc,yc,3)
        call gtx_plot(out,xd,yd,2)
      else
        call gtx_weight(out,xc,yc,xd,yd,penup)
      endif
      debut_trace = .false.
    else
      debut_trace = .true.
      penup = .true.
    endif
    dtogo = dtogo - d
    if (dtogo.le.0.) goto 10
    xc = xd
    yc = yd
    if (k.lt.4) then
      k = k+1
    else
      k = 1
    endif
    trace = .not.trace
    d = onoff(k,out%idashe)
  enddo
  !
10 out%totdist = out%totdist + dist
end subroutine gtx_chopper
!
subroutine gtx_weight(out,cxa,cya,cxb,cyb,up)
  use gtv_interfaces, except_this=>gtx_weight
  use gtv_types
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ private
  !  Thickness generator (Suited for pencil plotters)
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: out      ! Input gt_display
  real*4,           intent(in)    :: cxa,cya  ! X,Y coordinate of start point
  real*4,           intent(in)    :: cxb,cyb  ! X,Y coordinate of end point
  logical,          intent(in)    :: up       ! Force goto (CXA,CYA) pen up
  ! Local
  real*4 :: cx1,cx2,cy1,cy2
  integer :: lw,lw1,lw2,j
  !
  if (up) call gtx_plot(out,cxa,cya,3)
  ! Suppress above line for raster devices
  !
  if (out%dev%hardw_line_weig) then
    ! Device knows how to produce line width
    call gtx_plot(out,cxb,cyb,2)
    return
  endif
  !
  lw = max(set_weight_pixel(out),1)  ! We can get 0 for "hairline"
  lw1 = -(lw-1)/2
  lw2 = lw/2
  !
  do j=lw1,lw2
    !
    if (abs(cyb-cya).gt.abs(cxb-cxa)) then
      if (j.gt.0) then
        cx1 = min(cxa+j/60.,out%gx2)
        cx2 = min(cxb+j/60.,out%gx2)
      elseif (j.lt.0) then
        cx1 = max(cxa+j/60.,out%gx1)
        cx2 = max(cxb+j/60.,out%gx1)
      else
        cx1 = cxa
        cx2 = cxb
      endif
      cy1 = cya
      cy2 = cyb
    else
      if (j.gt.0) then
        cy1 = min(cya+j/60.,out%gy2)
        cy2 = min(cyb+j/60.,out%gy2)
      elseif (j.lt.0) then
        cy1 = max(cya+j/60.,out%gy1)
        cy2 = max(cyb+j/60.,out%gy1)
      else
        cy1 = cya
        cy2 = cyb
      endif
      cx1 = cxa
      cx2 = cxb
    endif
    !
    call gtx_plot(out,cx1,cy1,2)
    ! call gtx_plot(out,cx1,cy1,3) ! For raster devices
    !
    call gtx_plot(out,cx2,cy2,2)
    !
  enddo  ! j
  !
end subroutine gtx_weight

subroutine get(set,line,r,error,user_function)
  use gildas_def
  use gbl_constant
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>get
  use class_parameter
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ public
  ! CLASS Support routine for command
  !      GET Number|NEXT|FIRST|LAST|PREVIOUS [Version]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  character(len=*),    intent(in)    :: line           ! Command line
  type(observation),   intent(inout) :: r              !
  logical,             intent(inout) :: error          ! Error flag
  logical,             external      :: user_function  !
  ! Local
  character(len=*), parameter :: rname='GET'
  logical :: endof
  integer(kind=entry_length) :: kx
  integer(kind=obsnum_length) :: nnn
  integer(kind=4) :: mmm,nc,nfound
  character(len=varname_length) :: argum,found
  character(len=message_length) :: mess
  integer, parameter :: nkey=5
  character(len=12) :: keys(nkey)
  ! Data
  data keys / 'FIRST','LAST','NEXT','PREVIOUS','ZERO' /
  !
  ! Initialization
  endof = .false.
  !
  ! Verify if any input file
  if (.not.filein_opened(rname,error))  return
  !
  if (.not.sic_present(0,1)) then
    ! No argument: Take last selected entry
    kx = last_xnum
    if (kx.eq.0) then
      call class_message(seve%e,rname,'No R spectrum in memory')
      error = .true.
      return
    endif
    if (kx.le.0 .or. kx.ge.ix%next) then
      write(mess,'(A,I0)') 'Non-existant index entry #',kx
      call class_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    call get_it(set,r,kx,user_function,error)
    !
  else
    call sic_ke (line,0,1,argum,nc,.true.,error)
    if (error) return
    !
    ! 'sic_ambigs_sub' will return nfound=0 without complaining if
    ! argum is not in the list of known keywords (except if the known
    ! keywords have ambiguities)
    call sic_ambigs_sub(rname,argum,found,nfound,keys,nkey,error)
    if (error)  return
    !
    select case (nfound)
    case(1)  ! FIRST
      if (cx%next.le.1) then
        call class_message(seve%e,rname,'Index is empty')
        error = .true.
        return
      endif
      call get_first(set,r,user_function,error)
      !
    case(2)  ! LAST
      if (cx%next.le.1) then
        call class_message(seve%e,rname,'Index is empty')
        error = .true.
        return
      endif
      call get_last(set,r,user_function,error)
      !
    case(3)  ! NEXT
      call get_next(set,r,endof,user_function,error)
      if (endof) then
        call class_message(seve%e,rname,'End of current index encountered')
        error = .true.
        return
      endif
     !
    case(4)  ! PREVIOUS
      if (knext.le.1) then
        call class_message(seve%e,rname,'Beginning of index encountered')
        error = .true.
        return
      endif
      knext = knext-1
      kx = cx%ind(knext)
      call get_it(set,r,kx,user_function,error)
      !
    case(5)  ! ZERO
      knext = 0
      return  ! Nothing more to do
      !
    case(0)  ! Not a known keyword
      call sic_i8 (line,0,1,nnn,.false.,error)
      if (error) return
      mmm = 0
      call sic_i4 (line,0,2,mmm,.false.,error)
      if (error) return
      call get_num(set,r,nnn,mmm,user_function,error)
      !
    case default
      call class_message(seve%e,rname,'Internal error: argument not understood')
      error = .true.
      return
    end select
  endif
  if (error)  return
  !
  ! User feedback
  write(mess,'(a,i0,a,i0,a,i0)')  'Observation ',r%head%gen%num,'; Vers ',  &
    r%head%gen%ver,' Scan ',r%head%gen%scan
  call class_message(seve%i,rname,mess)
  if (r%head%gen%qual.eq.qual_deleted)  &
    call class_message(seve%w,rname,'Observation marked for deletion')
  !
  ! Initialize X,Y,Z
  call newdat(set,r,error)
  call newdat_assoc(set,r,error)
  call newdat_user(set,r,error)
  !
  last_xnum = r%head%xnum
end subroutine get
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_first(set,obs,user_function,error)
  use gildas_def
  use classcore_interfaces, except_this=>get_first
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get the first index entry
  ! An index must exist
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  type(observation),   intent(inout) :: obs            ! Current observation
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  integer(kind=entry_length) :: kx
  !
  knext = 1
  kx = cx%ind(knext)
  obs%head%des%rec = 1
  call get_it(set,obs,kx,user_function,error)
end subroutine get_first
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_next(set,obs,endof,user_function,error)
  use gildas_def
  use classcore_interfaces, except_this=>get_next
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get next index entry
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  type(observation),   intent(inout) :: obs            ! Current observation
  logical,             intent(out)   :: endof          ! End of index
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  integer(kind=entry_length) :: kx
  !
  if (knext.ge.cx%next-1) then
    endof = .true.
    return
  endif
  knext=knext+1
  !
  kx = cx%ind(knext)
  obs%head%des%rec = 1
  call get_it(set,obs,kx,user_function,error)
end subroutine get_next
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_last(set,obs,user_function,error)
  use gildas_def
  use classcore_interfaces, except_this=>get_last
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get the last index entry
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set            !
  type(observation),   intent(inout) :: obs            ! Current observation
  logical,             external      :: user_function  !
  logical,             intent(inout) :: error          ! Error flag
  ! Local
  integer(kind=entry_length) :: kx
  !
  knext = cx%next-1
  kx = cx%ind(knext)
  obs%head%des%rec = 1
  call get_it(set,obs,kx,user_function,error)
end subroutine get_last
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_num(set,obs,nnn,mmm,user_function,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>get_num
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Get VERSION mmm of ENTRY nnn
  ! First look for in the Current Index
  ! If not in Current Index, search in File
  !---------------------------------------------------------------------
  type(class_setup_t),         intent(in)    :: set            !
  type(observation),           intent(inout) :: obs            ! Current observation
  integer(kind=obsnum_length), intent(in)    :: nnn            ! Entry number
  integer(kind=4),             intent(in)    :: mmm            ! Version number
  logical,                     external      :: user_function  !
  logical,                     intent(out)   :: error          ! Error flag
  ! Local
  character(len=*), parameter :: rname='GET'
  integer(kind=entry_length) :: kx
  character(len=20) :: nombr1
  logical :: found
  !
  error = .false.
  !
  ! Search first in Current Index
  call get_num_cx(nnn,mmm,found,kx,error)
  if (error)  return
  !
  if (.not.found) then
    ! Else, search in Input Index (input file)
    call get_num_ix(set,nnn,mmm,found,kx,error)
    if (error) return
  endif
  !
  if (.not.found) then
     ! Nothing found...
     if (mmm.gt.0) then
        write(nombr1,'(I0,A,I0)' ) nnn,'; ',mmm
     else
        write(nombr1,'(I0)') nnn
     endif
     call class_message(seve%e,rname,'Observation #'//trim(nombr1)//' not found')
     error = .true.
     return
  endif
  !
  obs%head%des%rec = 1
  call get_it(set,obs,kx,user_function,error)
end subroutine get_num
!
subroutine get_num_cx(num,ver,found,kx,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>get_num_cx
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! Get VERSION ver of ENTRY num. Look in Current Index
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in)    :: num    ! Observation number
  integer(kind=4),             intent(in)    :: ver    ! Version number
  logical,                     intent(out)   :: found  !
  integer(kind=entry_length),  intent(out)   :: kx     ! Entry number
  logical,                     intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=entry_length) :: i,ifound
  integer(kind=4) :: cver
  !
  found = .false.
  kx = 0
  ifound = 0
  cver = 0
  !
  if (ver.le.0) then
     ! Search for last version
     do i=1,cx%next-1
        if (cx%num(i).eq.num) then
           if (cx%ver(i).ge.0) then
              found = .true.
              knext = i
              kx = cx%ind(i)
              return
           elseif (cx%ver(i).lt.cver) then
              ifound = i
              cver = cx%ver(i)
           endif
        endif
     enddo
     if (ifound.ne.0) then
        found = .true.
        knext = ifound
        kx = cx%ind(ifound)
        return
     endif
  else
     ! Search for given version
     do i=1,cx%next-1
        if (cx%num(i).eq.num) then
           cver = iabs(cx%ver(i))
           if (cver.eq.ver) then
              found = .true.
              kx = cx%ind(i)
              knext = i
              return
           endif
        endif
     enddo
  endif
end subroutine get_num_cx
!
subroutine get_num_ix(set,num,ver,found,kx,error)
  use gildas_def
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>get_num_ix
  use class_index
  use class_parameter
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get VERSION ver of ENTRY num. Search in the Input File Index
  !---------------------------------------------------------------------
  type(class_setup_t),         intent(in)    :: set    !
  integer(kind=obsnum_length), intent(in)    :: num    ! Observation number
  integer(kind=4),             intent(in)    :: ver    ! Version number
  logical,                     intent(out)   :: found  !
  integer(kind=entry_length),  intent(out)   :: kx     ! Entry number
  logical,                     intent(inout) :: error  ! Error flag
  ! Local
  type(optimize), save :: mycx  ! See call to FIX below
  integer(kind=entry_length) :: nfound,more
  !
  found = .false.
  kx = 0
  !
  ! Tune the searching flags used by subroutine FIX. NB: the other flags
  ! have been reset at the end of previous call to FIX.
  flg%num=.true.
  smin%num=num
  smax%num=num
  if (ver.le.0) then
    flg%last=.true.
    flg%ver=.false.
  else
    flg%last=.false.
    flg%ver=.true.
    smin%ver=ver
    smax%ver=ver
  endif
  !
  ! Prepare the local CX to be filled by FIX
  mycx%next = 1  ! This index is marked empty
  more = 1  ! We will store only 1 more entry is this index. This avoids
            ! allocating a huge index (size of IX) while we know we are
            ! searching for 1 entry.
  !
  call fix(set,ix,mycx,nfound,error,more=more)
  if (error)  return
  if (nfound.eq.0)  return
  !
  found = .true.
  kx = mycx%ind(1)
  !
end subroutine get_num_ix
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine get_it(set,obs,kx,user_function,error)
  use gildas_def
  use gbl_message
  use gbl_constant
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>get_it
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get observation (header+data) number KX into observation structure OBS
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set            !
  type(observation),          intent(inout) :: obs            ! Observation structure
  integer(kind=entry_length), intent(in)    :: kx             ! Entry number
  logical,                    external      :: user_function  ! intent(in)
  logical,                    intent(out)   :: error          ! Error flag
  ! Local
  character(len=*), parameter :: rname='GET_IT'
  character(len=message_length) :: mess
  integer(kind=4) :: ndata,ldata,ier,nchan,nrec
  logical :: notok
  real(kind=4), allocatable :: loc_buffer(:)
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  !
  error = .false.
  !
  ! Should use subroutine 'rheader' (which all reads all the available
  ! sections), but what about 'rzero' with the 'NULL' code?
  ! 'rzero' must come before 'robs', which partially fills the header.
  call rzero(obs,'NULL',user_function)
  !
  ! ROBS has 2 purposes:
  ! 1) read the sections informations (addresses, lengths, etc).
  !    Note that it is important to have an up-to-date User or X
  !    coordinate section length because we always read them from
  !    file
  ! 2) read the index block, in particular OBS%DESC%LDATA which we need
  !    for reading the data
  ! Call to ROBS is factorized here because:
  ! 1) we do not want to call it twice (one time when reading the
  !    header from file, again when reading the data from file)
  ! 2) ROBS copies the index block duplicate values in the header
  !    (is this really needed?), which is not satisfying because
  !    we can update e.g. the POSITION information (convert_pos)
  !    after reading the header and before reading the data
  call robs(obs,kx,error)
  if (error) return
  !
  ! --- HEADER reading ---
  ndata = 0
  if (set%verbose) then
    write(mess,*) 'Get header for obs: ',kx
    call class_message(seve%i,rname,mess)
  endif
  !
  obs%head%xnum = 0
  !
  ! Read all (the available) sections
  readsec(:) = .true.
  call rheader_sub(set,obs,readsec,error)
  if (error)  return
  !
  if (obs%head%gen%kind.eq.kind_sky) then
    ! Skydips
    obs%head%xnum = kx
    ndata = 0
    return
    !
  elseif (obs%head%gen%kind.eq.kind_spec) then
    ! Spectroscopic data
    ndata = obs%head%spe%nchan
    !
  elseif (obs%head%gen%kind.eq.kind_cont .or.  &
          obs%head%gen%kind.eq.kind_onoff) then
    ! Continuum drift or ONOFF
    ndata = obs%head%dri%npoin
  endif
  !
  ! Read User Defined section
  notok = user_function('GET')
  if (notok)  call class_message(seve%w,rname,'Error reading user sections')
  !
  obs%head%xnum = kx
  !
  ! --- HEADER update ---
  ! Convert coordinates
  call convert_pos(set,obs%head,error)
  if (error)  return
  ! Convert velocity type
  call convert_vtype(set,obs%head,error)
  if (error)  return
  !
  ! --- DATA reading ---
  if (set%verbose) then
     ! Debugging message
     write(mess,*) 'Get data for obs: ',kx,ndata
     call class_message(seve%i,rname,mess)
  endif
  ! Enlarge data space when needed
  call reallocate_obs(obs,ndata,error)
  if (error) return
  ! Additional allocation for old OTF format
  if (obs%is_otf) then
     nchan = obs%head%spe%nchan
     nrec  = obs%head%des%ndump
     ! Deallocate first? *** JP
     allocate(obs%data2(nchan,nrec),stat=ier)
     if (failed_allocate(rname,'data2',ier,error))  return
     allocate(obs%dap(nrec),stat=ier)
     if (failed_allocate(rname,'dap',ier,error))  return
  endif
  ! Now read irregular X axis if present
  if (obs%head%presec(class_sec_xcoo_id)) then
     call rxcoo(set,obs,error)
     error = .false.
  endif
  !
  ! OBS%DESC%LDATA already read with ROBS
  ! Should we enable this test (this can happen if data is not correctly
  ! written at the telescope)? Or is it a waste of time?
  ! if (ndata.ne.obs%desc%ldata) then
  !   write (mess,'(3(A,I0))')  &
  !     'Spurious data for observation #',kx,': expected ',ndata, &
  !     ' values, found ',obs%desc%ldata
  !   call class_message(seve%e,rname,mess)
  !   error = .true.
  !   return
  ! endif
  !
  ! Read data from file to obs
  ldata = obs%desc%ldata  ! Store into INTEGER*4
  if (obs%is_otf) then
    ! Allocate local buffer
    allocate(loc_buffer(obs%desc%ldata),stat=ier)
    if (failed_allocate(rname,'local buffer',ier,error))  return
    ! Read into local buffer
    call rdata(set,obs,ldata,loc_buffer,error)
    if (error) then
      call class_message(seve%e,rname,'Reading data from file')
      return
    endif
    ! Fill obs%dap and obs%data2 from loc_buffer
    call extract_otf(loc_buffer,obs%head%des%ldump,obs%dap,obs%data2,nchan,nrec)
    ! Not saved in the virtual buffer (useless/not available)
  else
    call rdata(set,obs,ldata,obs%data1,error)
    if (error) then
      call class_message(seve%e,rname,'Reading data from file')
      return
    endif
  endif
  ! Deallocate loc_buffer if needed
  if (obs%is_otf) deallocate(loc_buffer)
  !
  if (obs%is_otf) then
     ! Copy record #1 into OBS structure
     call get_rec(obs,1,error)
     if (error) return
  else
     ! Initialize these for compatibility
     obs%cnchan         = ndata
     obs%head%des%ndump = 1
     obs%head%des%ldump = 0
     obs%head%des%ldpar = 0
     obs%head%des%ldatl = 0
     obs%head%des%rec = 1
     obs%spectre => obs%data1
  endif
  !
  ! --- DATA update ---
  call convert_drop(set,obs,error)  ! Drop edge channels if needed
  if (error)  return
  call convert_scale(set,obs,.true.,error)  ! Rescale the Y data to desired unit
  if (error)  return
  !
  ! Not here: depends on calling program
  ! call newdat(set,obs,error)
end subroutine get_it
!
subroutine get_it_subset(set,obs,kx,extr,user_function,error)
  use gbl_message
  use gbl_constant
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>get_it_subset
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! *** (Much) simplified duplicate of 'get_it', combined with ***
  ! *** partial duplicate of 'do_extract'                      ***
  ! - Get observation (header + SUBSET of data) number KX, FROM FILE
  ! (always), into observation structure OBS.
  ! - No support for OTF data, no use of the virtual buffers, no
  ! annoying message, no DROP support
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)    :: set            !
  type(observation),          intent(inout) :: obs            ! Observation structure
  integer(kind=entry_length), intent(in)    :: kx             ! Entry number
  type(extract_t),            intent(inout) :: extr           ! Extraction description
  logical,                    external      :: user_function  !
  logical,                    intent(inout) :: error          ! Error flag
  ! Local
  character(len=*), parameter :: rname='GET_IT_SUB'
  integer(kind=data_length) :: ifirst,ilast,nv
  integer(kind=4) :: ofirst,olast,old_nchan
  real(kind=4) :: bad
  logical :: notok
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  !
  ! Should use subroutine 'rheader' (which all reads all the available
  ! sections), but what about 'rzero' with the 'NULL' code?
  ! 'rzero' must come before 'robs', which partially fills the header.
  call rzero(obs,'NULL',user_function)
  !
  call robs(obs,kx,error)
  if (error) return
  !
  ! Now read irregular X axis if present
  if (obs%head%presec(class_sec_xcoo_id)) then
    call class_message(seve%e,rname,'Irregularly spaced data not yet supported')
    error = .true.
    return
  elseif (obs%head%presec(class_sec_desc_id)) then
    call class_message(seve%e,rname,'Old OTF data not supported here')
    error = .true.
    return
  endif
  !
  ! --- HEADER reading ---
  obs%head%xnum = kx
  !
  ! Read all (the available) sections
  readsec(:) = .true.
  call rheader_sub(set,obs,readsec,error)
  if (error)  return
  !
  ! Set up extraction for header and data (comes after header reading)
  call do_extract_units(obs,extr,error)
  if (error)  return
  !
  ! Special treatment for Associated Arrays
  if (obs%head%presec(class_sec_assoc_id)) then
    call extract_assoc(obs%assoc,extr,error)
    if (error)  return
  endif
  !
  ! Read User Defined section
  notok = user_function('GET')
  if (notok)  call class_message(seve%w,rname,'Error reading user sections')
  !
  ! --- HEADER update ---
  ! Convert coordinates
  call convert_pos(set,obs%head,error)
  if (error)  return
  ! Convert velocity type
  call convert_vtype(set,obs%head,error)
  if (error)  return
  !
  ! --- DATA reading ---
  !
  ! Enlarge data space when needed
  call reallocate_obs(obs,extr%nc,error)
  if (error) return
  !
  ! Reading algorithm made efficient:
  ! 1) avoid filling data1(:) beyond extr%nc
  ! 2) avoid initializing with blanks everywhere before overwriting with real data
  ! 3) read only the needed part from file
  if (obs%head%gen%kind.eq.kind_spec) then
    bad = obs%head%spe%bad
    old_nchan = obs%head%spe%nchan
  else
    bad = obs%head%dri%bad
    old_nchan = obs%head%dri%npoin
  endif
  !
  if (extr%c1.le.0) then
    ifirst = 1_8         ! First channel read from input array
    ofirst = -extr%c1+2  ! First channel written in output array
    obs%data1(1:ofirst-1) = bad
  else
    ifirst = extr%c1
    ofirst = 1
  endif
  if (extr%c2.gt.old_nchan) then
    ilast = old_nchan            ! Last channel read from input array
    olast = old_nchan-extr%c1+1  ! Last channel written in output array
    obs%data1(olast+1:extr%nc) = bad
  else
    ilast = extr%c2
    olast = extr%c2-extr%c1+1
  endif
  nv = ilast-ifirst+1_8  ! Number of values to read from file
  !
  ! Read data from file to obs
  call rdata_sub(set,obs,ifirst,ilast,nv,obs%data1(ofirst:),error)
  if (error) then
    call class_message(seve%e,rname,'Reading data from file')
    return
  endif
  !
  ! Update the header. Easy: just change Nchan and shift Rchan
  if (obs%head%gen%kind.eq.kind_spec) then
    obs%head%spe%nchan = extr%nc
    obs%head%spe%rchan = obs%head%spe%rchan-extr%c1+1.d0
  else
    obs%head%dri%npoin = extr%nc
    obs%head%dri%rpoin = obs%head%dri%rpoin-extr%c1+1
  endif
  !
  ! Disable PLOT section. We can also choose to update the Vmin-Vmax values
  ! but we don't want to recompute the Ymin-Ymax in order to save time
  obs%head%presec(class_sec_plo_id) = .false.
  !
  ! Initialize these for old OTF compatibility
  obs%cnchan         = extr%nc
  obs%head%des%ndump = 1
  obs%head%des%ldump = 0
  obs%head%des%ldpar = 0
  obs%head%des%ldatl = 0
  obs%head%des%rec = 1
  obs%spectre => obs%data1
  !
  ! --- DATA update ---
  call convert_scale(set,obs,.true.,error)  ! Rescale the Y data to desired unit
  if (error)  return
  !
end subroutine get_it_subset
!
subroutine get_rec(obs,ir,error)
  use gildas_def
  use gbl_message
  use classcore_interfaces, except_this=>get_rec
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Copy record IR into OBS structure
  ! The content of DAPS in CLASS old OTF format
  !     type      number      content
  !     Real*4    1           RAZ           Azimuth in radians
  !     Real*4    1           REL           Elevation in radians
  !     Real*4    1           R4ST          LST       in radians
  !     Real*4    1           R4UT          UT        in radians
  !     Real*4    1           RLAMOF        Lambda offset in radians
  !     Real*4    1           RBETOF        Beta   offset in radians
  !     Integer*4 1           RFEED         feed number of array rec.
  !---------------------------------------------------------------------
  type (observation), intent(inout) :: obs    ! Current observation
  integer,            intent(in)    :: ir     ! Record number
  logical,            intent(out)   :: error  ! Error flag
  ! Local
  character(len=13) :: ch
  !
  if (.not.obs%is_otf) return
  !
  if (ir.lt.1 .or. ir.gt.obs%head%des%ndump) then
     write (ch,'(i6,a,i6)') ir,'/',obs%head%des%ndump
     call class_message(seve%f,'GET_REC','Invalid record '//ch(1:13))
     error = .true.
     return
  endif
  !
  obs%spectre => obs%data2(:,ir)
  !
  ! Data Associated Parameters
  obs%head%gen%az    = obs%dap(ir)%az
  obs%head%gen%el    = obs%dap(ir)%el
  obs%head%gen%st    = obs%dap(ir)%st
  obs%head%gen%ut    = obs%dap(ir)%ut
  obs%head%pos%lamof = obs%dap(ir)%lamof
  obs%head%pos%betof = obs%dap(ir)%betof
  obs%head%des%rec = ir
end subroutine get_rec
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine extract_otf(raw,ndat,dap,datotf,nchan,nrec)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Separate spectral intensities from DAPS for an old OTF format scan
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: ndat                ! nchan+ndaps
  integer(kind=4), intent(in)  :: nrec                ! Nb of records
  real(kind=4),    intent(in)  :: raw(ndat,nrec)      ! Complete data array
  type (dapotf),   intent(out) :: dap(nrec)           ! DAPs array
  integer(kind=4), intent(in)  :: nchan               ! Nb of channels
  real(kind=4),    intent(out) :: datotf(nchan,nrec)  ! Spectral data array
  ! Local
  integer(kind=4) :: i,j
  !
  do j=1,nrec
     call r4tor4 (raw(1,j),datotf(1,j),nchan)
     i = ndat-19
     dap(j)%irec = j
     i = i+1
     dap(j)%az = raw(i,j)
     i = i+1
     dap(j)%el = raw(i,j)
     i = i+1
     dap(j)%st = raw(i,j)
     i = i+1
     dap(j)%ut = raw(i,j)
     i = i+1
     dap(j)%lamof = raw(i,j)
     i = i+1
     dap(j)%betof = raw(i,j)
  enddo
end subroutine extract_otf
!
subroutine copy_header(in,out)
  use class_types
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Copy the header of IN into OUT
  !---------------------------------------------------------------------
  type(header), intent(in)  :: in   !
  type(header), intent(out) :: out  !
  out = in
end subroutine copy_header

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_bookkeeping_init_time(bufsize,subs,time,error)
  use gbl_message
  use ram_sizes
  use imbfits_types
  use mrtcal_bookkeeping_types
  use mrtcal_interfaces, except_this => mrtcal_bookkeeping_init_time
  use mrtcal_messaging
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize a time loop
  !---------------------------------------------------------------------
  integer(kind=8),         intent(in)    :: bufsize
  type(imbfits_subscan_t), intent(in)    :: subs
  type(book_t),            intent(inout) :: time
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: npix,nchan
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='BOOKKEEPING>INIT>TIME'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Buffer size
  if (bufsize.le.0) then
     write(mess,'(a,f0.1,a)') 'Buffer size is <=0 (',float(bufsize)/MB,' MB)'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! time%tot% is usually set by get_time_range_for_backend()
  time%tot%i = 0  ! Unused for time%tot% (iteration is done with time%cur%)
  !
  ! Element size
  npix = 1 ! ZZZ TBD: set correctly
  nchan = subs%backdata%head%channels%val
  if (nchan.gt.0 .and. time%tot%n.gt.0) then
    time%block%eltsize = npix*nchan*bytes_per_real
    ! Maximum number of elements (dumps) which can fit per block
    time%block%nelt = bufsize/time%block%eltsize
    ! time%block%nelt is left possibly much larger than needed. Do not truncate
    ! it! In particular, time%tot%n (number of useful elements in compressed
    ! columns) may not reflect the actual number of rows to read in the DATA
    ! (uncompressed) column.
  else
    time%block%eltsize = 0
    time%block%nelt = 0
  endif
  !
  time%block%bufsize = time%block%nelt*time%block%eltsize
  !
  ! Initialize memory current
  time%cur%vfirst = 0.d0
  time%cur%vlast = 0.d0
  time%cur%first = 0
  time%cur%last = 0
  time%cur%n = 0
  time%cur%i = 0
  !
  ! User feedback
  write(mess,'(a,i0,a,i0,a,i0,a)') 'Will iterate by blocks of max size ',  &
    time%block%bufsize/kB,' kB (',time%block%nelt,' x ',time%block%eltsize/kB,' kB)'
  call mrtcal_message(mseve%calib%book,rname,mess)
  !
end subroutine mrtcal_bookkeeping_init_time
!
subroutine mrtcal_bookkeeping_iterate(time,subs,first,last,needupdate,error)
  use imbfits_types
  use mrtcal_interfaces, except_this => mrtcal_bookkeeping_iterate
  use mrtcal_bookkeeping_types
  use mrtcal_messaging
  !---------------------------------------------------------------------
  ! @ private
  !  Fill the time%cur% structure suited for reading at least dumps
  ! 'first' to 'last'. They are the first and last dumps the caller
  ! wants to be present AT LEAST in the buffer. 'first' and 'last' are
  ! absolute positions in the compressed backdata columns.
  !---------------------------------------------------------------------
  type(book_t),            intent(inout) :: time
  type(imbfits_subscan_t), intent(in)    :: subs
  integer(kind=4),         intent(in)    :: first
  integer(kind=4),         intent(in)    :: last
  logical,                 intent(out)   :: needupdate
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='BOOKKEEPING>ITERATE'
  character(len=message_length) :: mess
  integer(kind=size_length) :: itime,dfirst,dlast
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity check: valid inputs?
  if (first.lt.time%tot%first .or. last.gt.time%tot%last .or. last.lt.first) then
    write(mess,'(4(A,I0))') 'Invalid first and/or last dumps to read: ',  &
      first,'-',last,' not in range ',time%tot%first,'-',time%tot%last
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Does the current buffer already contain the desired range?
  needupdate = first.lt.time%cur%first .or. last.gt.time%cur%last
  if (.not.needupdate) then
    ! Nothing to do
    return
  endif
  !
  ! Must load a new piece of the buffer. Convert absolute positions in
  ! compressed columns to absolute position in non-compressed DATA column
  dfirst = subs%backdata%table%backpoin%val(first)
  dlast = subs%backdata%table%backpoin%val(last)
  !
  ! Ensure the desired range will fit in memory
  if (dlast-dfirst+1.gt.time%block%nelt) then
    call mrtcal_message(seve%e,rname,'Desired range does not fit in buffer. Increase buffer size.')
    error = .true.
    return
  endif
  !
  ! Design the new DATA block (described by time%cur%). Note that by construction,
  ! the first and last elements in the buffer are always valid time dumps. In other
  ! words we do not ask CFITSIO to read useless dumps at the block boundaries (there
  ! still can be bad dumps within the block)
  !
! dfirst = unchanged, match the 'first' to read
  time%cur%first = first  ! By construction
  !
  dlast = dfirst+time%block%nelt-1
  if (dlast.ge.subs%backdata%table%backpoin%val(time%tot%last)) then
    ! Reached the end of the total number of dumps
    time%cur%last = time%tot%last
  else
    ! Search the compressed 'last' corresponding to the uncompressed 'dlast'
    time%cur%last = 0
    do itime=dlast,dfirst,-1
      if (subs%backdata%table%forepoin%val(itime).ne.0) then
        time%cur%last = subs%backdata%table%forepoin%val(itime)
        exit
      endif
    enddo
  endif
  !
  time%cur%n = time%cur%last-time%cur%first+1
  time%cur%i = 1
  time%cur%vfirst = subs%backdata%table%mjd%val(time%cur%first)
  time%cur%vlast = subs%backdata%table%mjd%val(time%cur%last)
  !
  ! User feedback
  write(mess,'(2(a,i0))') &
       ' Processing block from element ',time%cur%first,' to ',time%cur%last
  call mrtcal_message(mseve%calib%book,rname,mess)
  !
end subroutine mrtcal_bookkeeping_iterate
!
subroutine mrtcal_bookkeeping_all(subs,time,error)
  use imbfits_types
  use mrtcal_interfaces, except_this=>mrtcal_bookkeeping_all
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ public (for mrtholo)
  !  Fill the time%cur% structure suited for reading ALL the block
  ! of data at once.
  !  This is suited for applications which do not want to iterate the
  ! DATA block, i.e. reading it all at once. Use with caution, memory
  ! consumption may be large.
  !  This must come after a 'get_time_range_*' call (which fills the
  ! time%tot).
  !---------------------------------------------------------------------
  type(imbfits_subscan_t), intent(in)    :: subs
  type(book_t),            intent(inout) :: time
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='BOOKKEEPING>ALL'
  !
  ! Compute time%data%tot from time%tot. NB: use dummy value for buffer
  ! size, since we assume we don't have a limited one.
  call mrtcal_bookkeeping_init_time(1_8,subs,time,error)
  if (error)  return
  !
  ! Set the current blocks, i.e. everything selected here.
  time%cur = time%tot
  !
end subroutine mrtcal_bookkeeping_all
!
subroutine mrtcal_bookkeeping_compr2uncompr(compr,backpoin,uncompr,error)
  use mrtcal_bookkeeping_types
  !---------------------------------------------------------------------
  ! @ private
  !   Convert a "compressed" range_t (i.e. providing indices in the
  ! compressed columns to an "uncompressed" range_t.
  !   "compressed" columns are present in the BackendData e.g. if SET
  ! CALIB BAD is NO
  !---------------------------------------------------------------------
  type(range_t),   intent(in)    :: compr        !
  integer(kind=4), intent(in)    :: backpoin(:)  ! Back-pointer array
  type(range_t),   intent(out)   :: uncompr      !
  logical,         intent(inout) :: error        !
  !
  uncompr%first  = backpoin(compr%first)
  uncompr%last   = backpoin(compr%last)
  uncompr%n      = uncompr%last-uncompr%first+1
  if (compr%i.le.0) then
    uncompr%i    = 0  ! unset -> unset
  else
    uncompr%i    = backpoin(compr%i)
  endif
  uncompr%vfirst = compr%vfirst  ! Associated values are the same!
  uncompr%vlast  = compr%vlast   ! Associated values are the same!
  !
end subroutine mrtcal_bookkeeping_compr2uncompr

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wifisyn_ift_kern(nift,kern,error)
  use gbl_message
  use phys_const
  use wifisyn_interfaces, except_this=>wifisyn_ift_kern
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the inverse Fourier transform of the gridding function
  ! on the full image support (i.e. much larger number of pixels than the
  ! initial definition). The result is centered on kern%ft%n/2+1.
  ! I guess that kern%ft%n must be even (not checked...).
  !---------------------------------------------------------------------
  integer,           intent(in)    :: nift
  type(kernel_1d_t), intent(inout) :: kern
  logical,           intent(inout) :: error
  !
  real :: kw,ku
  integer :: iu,ix,mx
  character(len=*), parameter :: rname='GRIDDING/IFT/KERN'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  call wifisyn_reallocate_real_1d('Kernel IFT',nift,kern%ft,error)
  if (error) return
  !
  mx = nift/2+1
  kw = pi / mx / kern%fac
  kern%ft%val = 0.0
  do iu=1,kern%fn%n
     if (kern%fn%val(iu).ne.0.0) then
        ku = kw*(float(iu)-kern%zero)
        do ix=1,nift
           kern%ft%val(ix) = kern%ft%val(ix) + kern%fn%val(iu) * cos(ku*float(ix-mx))
        enddo
     endif
  enddo
end subroutine wifisyn_ift_kern
!
subroutine wifisyn_ift_shift_and_plunge(ic,cube,image)
  use gbl_message
  use wifisyn_interfaces, except_this=>wifisyn_ift_shift_and_plunge
  use wifisyn_array_types
  !---------------------------------------------------------------------
  ! @ private
  ! Extract a Fourier plane from the FFT cube
  !---------------------------------------------------------------------
  integer,            intent(in)    :: ic
  type(complex_3d_t), intent(in)    :: cube
  type(complex_2d_t), intent(inout) :: image
  !
  integer :: ix,imx,iy,imy
  integer :: jx,jmx,jy,jmy
  character(len=*), parameter :: rname='IFT/SHIFT+PLUNGE'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  imx = cube%nx/2
  imy = cube%ny/2
  jmx = image%nx/2
  jmy = image%ny/2
  !
  ! Initialization
  image%val = (0.0,0.0)
  ! Negative y spatial frequencies
  do iy=1,imy
     jy = iy+jmy-imy
     ! Negative x spatial frequencies
     do ix=1,imx
        jx = ix+jmx-imx
        image%val(jx+jmx,jy+jmy) = cube%val(ic,ix,iy)
     enddo
     ! Positive x spatial frequencies
     do ix=1,imx
        image%val(ix,jy+jmy) = cube%val(ic,ix+imx,iy)
     enddo
  enddo
  !
  ! Positive y spatial frequencies
  do iy=1,imy
     ! Negative x spatial frequencies
     do ix=1,imx
        jx = ix+jmx-imx
        image%val(jx+jmx,iy) = cube%val(ic,ix,iy+imy)
     enddo
     ! Positive x spatial frequencies
     do ix=1,imx
        image%val(ix,iy) = cube%val(ic,ix+imx,iy+imy)
     enddo
  enddo
end subroutine wifisyn_ift_shift_and_plunge
!
subroutine wifisyn_ift_shift_and_real(ic,image,cube)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_ift_shift_and_real
  use wifisyn_array_types
  !---------------------------------------------------------------------
  ! @ private
  ! Extract real image from an IFT image with appropriate recentering
  !---------------------------------------------------------------------
  integer,            intent(in)    :: ic
  type(complex_2d_t), intent(in)    :: image
  type(gildas),       intent(inout) :: cube
  !
  integer :: ix,mx
  integer :: iy,my
  character(len=*), parameter :: rname='IFT/SHIFT+REAL'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  mx = image%nx/2
  my = image%ny/2
  !
  do iy=1,my
     do ix=1,mx
        cube%r3d(ix+mx,iy+my,ic) = real(image%val(ix,iy))
     enddo
     do ix=1,mx
        cube%r3d(ix,iy+my,ic) = real(image%val(ix+mx,iy))
     enddo
  enddo
  do iy=1,my
     do ix=1,mx
        cube%r3d(ix+mx,iy,ic) = real(image%val(ix,iy+my))
     enddo
     do ix=1,mx
        cube%r3d(ix,iy,ic) = real(image%val(ix+mx,iy+my))
     enddo
  enddo
end subroutine wifisyn_ift_shift_and_real
!
subroutine wifisyn_ift_compute_grid_correction(beam,ukern,vkern,corr,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_ift_compute_grid_correction
  use wifisyn_array_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  ! Compute grid correction array, with normalisation of beam to 1.0
  ! at maximum pixel
  !---------------------------------------------------------------------
  type(gildas),      intent(in)    :: beam  ! Beam before normalization
  type(kernel_1d_t), intent(in)    :: ukern ! U gridding kernel
  type(kernel_1d_t), intent(in)    :: vkern ! V gridding kernel
  type(real_2d_t),   intent(inout) :: corr  ! Beam-normalized 2D grid correction
  logical,           intent(inout) :: error
  !
  real :: norm
  integer :: ix,nx
  integer :: iy,ny
  character(len=*), parameter :: rname='IFT/COMPUTE/GRID/CORR'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  nx = ukern%ft%n
  ny = vkern%ft%n
  !
  norm = ukern%ft%val(nx/2+1)*vkern%ft%val(ny/2+1)/beam%r3d(nx/2+1,ny/2+1,1)
  do iy=1,ny
    do ix=1,nx
      corr%val(ix,iy) = norm/(ukern%ft%val(ix)*vkern%ft%val(iy))
    enddo
  enddo
end subroutine wifisyn_ift_compute_grid_correction
!
subroutine wifisyn_ift_apply_grid_correction(win,corr,cube,error)
  use gbl_message
  use image_def
  use wifisyn_interfaces, except_this=>wifisyn_ift_apply_grid_correction
  use wifisyn_array_types
  use wifisyn_gridding_types
  !---------------------------------------------------------------------
  ! @ private
  ! Apply gridding kernel correction to map
  !---------------------------------------------------------------------
  type(window_t),  intent(in)    :: win
  type(real_2d_t), intent(in)    :: corr
  type(gildas),    intent(inout) :: cube
  logical,         intent(inout) :: error
  !
  integer :: ix,iy,ic
  character(len=*), parameter :: rname='IFT/APPLY/GRID/CORR'
  !
  call wifisyn_message(seve%t,rname,'Welcome')
  !
  do ic=win%first,win%last
     do iy=1,cube%gil%dim(2)
        do ix=1,cube%gil%dim(1)
           cube%r3d(ix,iy,ic) = cube%r3d(ix,iy,ic)*corr%val(ix,iy)
        enddo ! ix
     enddo ! iy
  enddo ! ic
  !
end subroutine wifisyn_ift_apply_grid_correction
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine flag (line,comm,error)
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  !
  write(6,*) 'W-FLAG,  Not yet implemented'
end
!<FF>
subroutine plot_result (line,comm,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Global
  include 'setup.inc'
  ! Local
  integer :: mvoc1,mvoc2
  parameter (mvoc1=6,mvoc2=2)
  integer :: nkey1,nkey2,na
  character(len=12) :: vocab1(mvoc1),vocab2(mvoc2),argum,keyw1,keyw2
  !
  data vocab1 /'ERRORS','RESIDUALS','SUMMARY','TIME','CIRCLE',   &
     &    'COVERAGE'/
  data vocab2 /'AZIMUTH','ELEVATION'/
  !
  if (.not.fitted) write(6,*) 'W-PLOT,  No fit was done'
  if (sic_present(0,1)) then
    call sic_ke (line,0,1,argum,na,.true.,error)
    if (error) return
    call sic_ambigs('PLOT',argum,keyw1,nkey1,vocab1,mvoc1,   &
     &      error)
    if (error) return
  else
    nkey1 = 3
    keyw1 = 'SUMMARY'
  endif
  !
  dobad = sic_present(1,0)
  !
  if (nkey1.le.2) then
    call sic_ke (line,0,2,argum,na,.true.,error)
    if (error) return
    call sic_ambigs('PLOT',argum,keyw2,nkey2,vocab2,mvoc2,error)
    if (error) return
    if (keyw1.eq.'ERRORS') then
      if (keyw2.eq.'AZIMUTH') then
        call plot_err_az
      else
        call plot_err_el
      endif
    else
      if (keyw2.eq.'AZIMUTH') then
        call plot_res_az
      else
        call plot_res_el
      endif
    endif
  elseif (keyw1.eq.'SUMMARY') then
    call plot_summary
  elseif (keyw1.eq.'COVERAGE') then
    call plot_coverage
  elseif (keyw1.eq.'TIME') then
    call plot_time
  elseif (keyw1.eq.'CIRCLE') then
    call plot_circle
  endif
end
!<FF>
subroutine plot_summary
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  ! Local
  integer :: i
  real*8 :: zmax
  real*4 :: ymax
  character(len=4) :: chain
  logical :: err
  !
  err = .false.
  !
  call gr_exec1('SET FONT SIMPLEX')
  call gr_exec1('SET PLOT_PAGE LANDSCAPE')
  call gr_exec1('SET BOX SQUARE')
  call gr_exec1('SET COORDINATE USER')
  !
  ! Compute limits
  zmax = 0.0
  do i=1,ndata
    if (dobad) then
      zmax = max(zmax,abs(resel(i)),abs(resaz(i)))
    elseif (good(i) .or. good(ndata+i)) then
      zmax = max(zmax,abs(resel(i)),abs(resaz(i)))
    endif
  enddo
  zmax = 1.1*zmax
  if (zmax.eq.0.0) zmax = 0.1
  ymax = zmax
  call gr_limi (4,-ymax,ymax,-ymax,ymax)
  call gr_exec1 ('BOX')
  call gr_exec1 ('SET EXPAND 0.6')
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      write (chain,'(I4)') scan(i)
      call relocate (resaz(i),resel(i))
      call gr_labe (chain)
    endif
  enddo
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        write (chain,'(I4)') scan(i)
        call relocate (resaz(i),resel(i))
        call gr_labe (chain)
      endif
    enddo
    call gr_pen(ipen=0,error=err)
  endif
  call gr_exec1 ('SET EXPAND 0.8')
  call gr_exec2 ('ELLIPSE 2 /USER 0 0')
  call gr_exec2 ('ELLIPSE 5 /USER 0 0')
  call gr_exec2 ('ELLIPSE 10 /USER 0 0')
  call gr_exec1 ('DRAW TEXT 0 2.1 "2`" 8')
  call gr_exec1 ('DRAW TEXT 0 5.1 "5`" 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.5 '//   &
     &    '"Residual pointing errors in Azimuth (`)" 5 /BOX 2')
  call gr_exec1 ('SET ORIENTATION 90')
  call gr_exec1 ('DRAW TEXT -1.5 0.0 '//   &
     &    '"Residual pointing errors in Elevation (`)" 5 /BOX 4')
  call gr_exec1 ('SET ORIENTATION 0')
  call gr_exec1 ('DRAW TEXT  0.0 0.6 '//   &
     &    '"Residual pointing errors" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 1.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 0.6 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_coverage
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  include 'pi.inc'
  ! Local
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('LIMITS -180 180 0 90')
  call gr_exec1 ('SET PLOT_PAGE LANDSCAPE')
  call gr_exec1 ('BOX')
  call gr_limi (4,-pis,pis,0.0,pis/2.)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      ! call GR8_marker (1,azis(i),eles(i),0.0D0,-1.0D0)
      call gr8_marker (1,x(1,i),x(2,i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(1,i),x(2,i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('DRAW TEXT 0 -1.5 "Azimuth" 5 /BOX 2')
  call gr_exec1 ('SET ORIENTATION 90')
  call gr_exec1 ('DRAW TEXT -1.5 0.0 "Elevation" 5 /BOX 4')
  call gr_exec1 ('SET ORIENTATION 0')
  call gr_exec1 ('DRAW TEXT 0.0 0.6 '//   &
     &    '"Pointing sampling in Azimuth and Elevation" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 1.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 0.6 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_err_az
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  include 'pi.inc'
  ! Local
  real*4 :: xmin,xmax
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('SET PLO POR')
  call gr_exec1 ('SET BOX 4 20 15 26')
  call limipo (ndata,fobs,good,xmin,xmax,dobad)
  call gr_limi (4,-180.0,180.0,xmin*secpi,xmax*secpi)
  call gr_exec1 ('BOX')
  call gr_limi (4,-pis,pis,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      ! call GR8_marker (1,azis(i),eraz(i),0.0D0,-1.0D0)
      call gr8_marker (1,x(1,i),fobs(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(1,i),fobs(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('SET BOX 4 20 2 13')
  call gr_limi (4,0.0,90.0,xmin*secpi,xmax*secpi)
  call gr_exec1 ('BOX')
  call gr_limi (4,0.0,pis/2,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,x(2,i),fobs(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(2,i),fobs(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('DRAW TEXT 0.0 0.75 "Azimuth" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.2 "Elevation" 5 /BOX 2')
  call gr_exec1 ('DRAW TEXT -0.95 2.2 "\gDA(`)" 5 /BOX 4')
  call gr_exec1 ('DRAW TEXT -0.95 9.8 "\gDA(`)" 5 /BOX 7')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 '//   &
     &    '"Pointing errors in Azimuth " 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 1.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_err_el
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  include 'pi.inc'
  ! Local
  real*4 :: xmin,xmax
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('SET PLO POR')
  call gr_exec1 ('SET BOX 4 20 15 26')
  call limipo(ndata,fobs(ndata+1),good,xmin,xmax,dobad)
  call gr_limi (4,-180.0,180.0,xmin*secpi,xmax*secpi)
  call gr_exec1('BOX')
  call gr_limi (4,-pis,pis,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      ! call GR8_marker (1,azis(i),erel(i),0.0D0,-1.0D0)
      call gr8_marker (1,x(1,i),fobs(i+ndata),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(1,i),fobs(i+ndata),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('SET BOX 4 20 2 13')
  call gr_limi (4,0.0,90.0,xmin*secpi,xmax*secpi)
  call gr_exec1 ('BOX')
  call gr_limi (4,0.0,pis/2,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,x(2,i),fobs(i+ndata),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(2,i),fobs(i+ndata),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('DRAW TEXT 0.0 0.75 "Azimuth" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.2 "Elevation" 5 /BOX 2')
  call gr_exec1 ('DRAW TEXT -0.95 2.2 "\gDE(`)" 5 /BOX 4')
  call gr_exec1 ('DRAW TEXT -0.95 9.8 "\gDE(`)" 5 /BOX 7')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 '//   &
     &    '"Pointing errors in Elevation " 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 14.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_res_az
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  include 'pi.inc'
  ! Local
  real*4 :: xmin,xmax
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('SET PLO POR')
  call gr_exec1 ('SET BOX 4 20 15 26')
  call limipo(ndata,resaz,good,xmin,xmax,dobad)
  call gr_limi (4,-180.0,180.0,xmin,xmax)
  call gr_exec1 ('BOX')
  call gr_limi (4,-pis,pis,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      ! call GR8_marker (1,azis(i),resaz(i),0.0D0,-1.0D0)
      call gr8_marker (1,x(1,i),resaz(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gtsegm('BAD',err)
    call gr_pen(ipen=2,error=err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(1,i),resaz(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('SET BOX 4 20 2 13')
  call gr_limi  (4,0.0,90.0,xmin,xmax)
  call gr_exec1 ('BOX')
  call gr_limi  (4,0.0,pis/2,xmin,xmax)
  !
  call gtsegm ('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,x(2,i),resaz(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gtsegm('BAD',err)
    call gr_pen(ipen=2,error=err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(2,i),resaz(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('DRAW TEXT 0.0 0.75 "Azimuth" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.2 "Elevation" 5 /BOX 2')
  call gr_exec1 ('DRAW TEXT -0.95 2.2 "\gDA(`)" 5 /BOX 4')
  call gr_exec1 ('DRAW TEXT -0.95 9.8 "\gDA(`)" 5 /BOX 7')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 '//   &
     &    '"Residual pointing errors in Azimuth" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 14.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_res_el
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  include 'pi.inc'
  ! Local
  real*4 :: xmin,xmax
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('SET PLO POR')
  call gr_exec1 ('SET BOX 4 20 15 26')
  call limipo (ndata,resel,good,xmin,xmax,dobad)
  call gr_limi (4,-180.0,180.0,xmin,xmax)
  call gr_exec1('BOX')
  call gr_limi (4,-pis,pis,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      ! call GR8_marker (1,azis(i),resel(i),0.0D0,-1.0D0)
      call gr8_marker (1,x(1,i),resel(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(1,i),resel(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('SET BOX 4 20 2 13')
  call gr_limi (4,0.0,90.0,xmin,xmax)
  call gr_exec1 ('BOX')
  call gr_limi (4,0.0,pis/2,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,x(2,i),resel(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,x(2,i),resel(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('DRAW TEXT 0.0 0.75 "Azimuth" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.2 "Elevation" 5 /BOX 2')
  call gr_exec1 ('DRAW TEXT -0.95 2.2 "\gDE(`)" 5 /BOX 4')
  call gr_exec1 ('DRAW TEXT -0.95 9.8 "\gDE(`)" 5 /BOX 7')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 '//   &
     &    '"Residual pointing errors in Elevation" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 14.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_time
  use gkernel_interfaces
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  ! Local
  real*4 :: xmin,xmax,tmin,tmax
  integer :: i
  logical :: err
  !
  err = .false.
  !
  call gr_exec1 ('SET PLO POR')
  call gr_exec1 ('SET BOX 4 20 15 26')
  call limipo (ndata,resaz,good,xmin,xmax,dobad)
  call limipo (ndata,tiem,good,tmin,tmax,dobad)
  call gr_limi (4,tmin,tmax,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,tiem(i),resaz(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,tiem(i),resaz(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  !
  call gr_exec1 ('BOX')
  call gr_exec1 ('SET BOX 4 20 2 13')
  call limipo (ndata,resel,good,xmin,xmax,dobad)
  call gr_limi (4,tmin,tmax,xmin,xmax)
  !
  call gtsegm('POINT',err)
  do i=1,ndata
    if (good(i).or.good(ndata+i)) then
      call gr8_marker (1,tiem(i),resel(i),0.0d0,-1.0d0)
    endif
  enddo
  call gr_segm_close(err)
  !
  if (dobad) then
    call gr_pen(ipen=2,error=err)
    call gtsegm('BAD',err)
    do i=1,ndata
      if (.not.(good(i).or.good(ndata+i))) then
        call gr8_marker (1,tiem(i),resel(i),0.0d0,-1.0d0)
      endif
    enddo
    call gr_segm_close(err)
    call gr_pen(ipen=0,error=err)
  endif
  call gr_exec1 ('BOX')
  ! call gr_exec1 ('POINT')
  call gr_exec1 ('DRAW TEXT 0.0 0.75 "Time" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 -1.2 "Time" 5 /BOX 2')
  call gr_exec1 ('DRAW TEXT -0.95 2.2 "\gDE(`)" 5 /BOX 4')
  call gr_exec1 ('DRAW TEXT -0.95 9.8 "\gDA(`)" 5 /BOX 7')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 '//   &
     &    '"Residual pointing errors versus Time" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 14.2 "'//cfile//'" 5 /BOX 8')
  call gr_exec1 ('DRAW TEXT 0.0 13.5 "'//stat_ant//'" 6 /BOX 7')
end
!<FF>
subroutine plot_circle
  ! Global
  include 'size.inc'
  include 'setup.inc'
  include 'data.inc'
  ! Local
  integer :: i
  real :: rad,crad,srad,pi,rmax,scal,taill,err,r,sina,cosa
  real :: x0,y0,x1,y1
  !
  character(len=2) :: cij(10)
  character(len=4) :: chain
  data cij/'0','10','20','30','40','50','60','70','80','90'/
  !
  pi = acos(-1.0)
  call gr_exec1 ('SET PLO PORTRAIT')
  call gr_exec1 ('SET BOX_LOCATION 2 19 6 23')
  call gr_exec1 ('SET EXPAND 0.7')
  call gr_exec1 ('LIMITS 90 -90 90 -90')
  call gr_exec1 ('SET COOR USER')
  do i = 1,10
    call relocate(0.0d0,0.0d0)
    call gr_exec2('ELLIPSE '//cij(i))
    if (i.gt.1 .and. i.lt.10) then
      call relocate (-5.0d0,-103.0d0+10.0d0*dble(i))
      call gr_labe  (cij(i))
    endif
  enddo
  do i=-180,150,30
    rad = i*pi/180.0
    srad = sin(rad)
    crad = cos(rad)
    call relocate (0.0d0,0.0d0)
    call draw (dble(90.0*srad),dble(90.0*crad))
    call relocate (dble(100.0*srad),dble(100.0*crad))
    write (chain,'(I4)') i
    call gr_labe (chain)
  enddo
  call gr_exec1 ('DRAW TEXT 0 -120 "'//stat_ant//'" 5')
  call gr_exec1 ('DRAW TEXT 0 -110 '//   &
     &    '"Residual pointing errors in function of Azimuth and Elevation"'   &
     &    //' 5')
  call gr_exec1 ('DRAW MARKER 90 90')
  !
  rmax = 0.0
  do i=1,ndata
    err = sqrt(resaz(i)**2+resel(i)**2)
    rmax= max(rmax,err)
  enddo
  scal  = 25.0/rmax            ! 25 Degrees for maximum error
  taill = 5.0*scal             ! Size of 5" marker
  call gr_draw ('ARROW',2,90.0-taill,90.0)
  call relocate (90d0-0.5d0*taill,90.0d0)
  call gr_labe_cent(8)
  call gr_labe ('5`')
  do i=1,ndata
    r = 90.0-180.0*x(2,i)/pi   ! Degrees
    sina = sin(x(1,i))
    cosa = cos(x(1,i))
    x0 = r*sina
    y0 = r*cosa
    x1 = x0+(resaz(i)*cosa-resel(i)*sina)*scal
    y1 = y0-(resaz(i)*sina+resel(i)*cosa)*scal
    call gr_draw ('MARKER',2,x0,y0)
    call gr_draw ('ARROW',2,x1,y1)
  enddo
end
!<FF>
subroutine limipo (n,x,good,dmin,dmax,bad)
  integer :: n                      !
  real*8 :: x(*)                    !
  logical :: good(*)                !
  real :: dmin                      !
  real :: dmax                      !
  logical :: bad                    !
  ! Local
  integer :: i,k
  real*8 :: xdiff,xmin,xmax
  k = 0
  xmin = 1d38
  xmax = -1d38
  if (bad) then
    do i=1,n
      xmin = min(x(i),xmin)
      xmax = max(x(i),xmax)
    enddo
    k = n
  else
    do i=1,n
      if (good(i).or.good(n+i)) then
        xmin = min(x(i),xmin)
        xmax = max(x(i),xmax)
        k = k+1
      endif
    enddo
  endif
  if (k.eq.0) then
    dmin = -0.1
    dmax =  0.1
    return
  endif
  if (xmin.lt.xmax) then
    xdiff = 0.1*(xmax-xmin)
  elseif (xmin.ne.0.) then
    xdiff = 0.1*abs(xmin)
  else
    xdiff = 0.1
  endif
  dmin = xmin-xdiff
  dmax = xmax+xdiff
end

!
!--------------------------------------------------------------------------------
!
! <DOCUMENTATION name="modulePakoLissajous.f90">
!   <VERSION>
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-12-15 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-10-20 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-09-25 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-08-28 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-07-17 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.3  2014-07-08 Hans Ungerechts
!                Id: modulePakoLissajous.f90,v 1.2.2  2013-02-06 Hans Ungerechts
!                based on:
!                Id: modulePakoLissajous.f90,v 1.1.12 2012-03-12 Hans Ungerechts
!   </VERSION>
!   <HISTORY>
!                2012-03-12: new for GISMO run
!   <PROGRAM>
!                Pako
!   </PROGRAM>
!   <FAMILY>
!                Observing Modes
!   </FAMILY>
!   <SIBLINGS>

!   </SIBLINGS>        
!
!   Pako module for command: LISSAJOUS
!
! </DOCUMENTATION> <!-- name="modulePakoLissajous.f90" -->
!
!--------------------------------------------------------------------------------
!
Module modulePakoLissajous
  !
  Use modulePakoTypes
  Use modulePakoMessages
  Use modulePakoGlobalParameters
  Use modulePakoLimits
  Use modulePakoXML
  Use modulePakoUtilities
  Use modulePakoPlots
  Use modulePakoDisplayText
  Use modulePakoGlobalVariables
  Use modulePakoSubscanList
  Use modulePakoReceiver
  Use modulePakoBackend
  Use modulePakoSource
  Use modulePakoSwBeam
  Use modulePakoSwFrequency
  Use modulePakoSwWobbler
  Use modulePakoSwTotalPower
  Use modulePakoDIYlist
  !
  Use gbl_message
  !
  Implicit None
  Save
  Private
  Public :: Lissajous
  Public :: saveLissajous
  Public :: startLissajous
  !     
  ! *** Variables for Lissajous ***
  Include 'inc/variables/variablesLissajous.inc'
!!!   
!!!   
Contains
!!!
!!!
  Subroutine LISSAJOUS(programName,line,command,error)
    !
    ! *** Arguments ***
    Include 'inc/variables/headerForCommandHandler.inc'
    !
    ! *** standard working variables ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
!! OLD !!$      Integer              ::  iMatch = 0 , nMatch = 0
!! OLD !!$      Character (len=128)  ::  errorCode = 'none'
!! OLD !!$      Logical              ::  errorM = .False.
    !
    ! *** special working variables:   ***
    Logical               :: optionSpeedIsPresent, optionTotfIsPresent
    Logical, Dimension(3) :: alternative
    Real                  :: vIn, vStdMin, vStdMax, vLimitMin, vLimitMax
    !
    Real                  :: vLissMaxX,   vLissMaxY,   aLissMaxX,   aLissMaxY,   vLissLimit, aLissLimit
    Real                  :: vLissFacX,   vLissFacY,   aLissFacX,   aLissFacY
    Real                  :: vLissMaxXel, vLissMaxYel, aLissMaxXel, aLissMaxYel, lissMaxEl
    !
    Logical               :: isConnected   = .False.
    Real                  :: mapRotation   = 0.0
    !
    Integer               :: ierr
    !
    Real, Dimension(2)    :: rr 
    !
    Logical :: receiverIsBolo
    Logical :: receiverIsEMIR
    Character (len=lenCh) :: bolometerName
    !
    Type(conditionMinMax)  ::  condElevation                                     &
         &                     = conditionMinMax("elevation",                    &
         &                                        0.0, Pi/2.0,                   &
         &                                       "rad",                          &
         &                                       .False.         )               ! 
    !
    Call pako_message(seve%t,programName,                                        &
         &    " module Lissajous, 1.2.3 2014-12-15 ---> SR: Lissajous ")         ! trace execution
    !
    ERROR = .False.
    !
    optionSpeedIsPresent = .False.
    optionTotfIsPresent  = .False.
    alternative          = .False.
    !
    !D     Write (6,*) "   modulePakoLissajous: --> SR Lissajous "
    !
    Include 'inc/ranges/rangesLissajous.inc'
    !
    ! *** initialize:   ***
    If (.Not.isInitialized) Then
       Include 'inc/variables/setDefaults.inc'
       isInitialized = .True.
    Endif
    !
    ! *** set In-values = previous Values ***
    If (.Not.ERROR) Then
       vars(iIn) = vars(iValue)
    End If
    !
    ! *** check N of Parameters: 0, n --> at  most n allowed  ***
    Call checkNofParameters(command,                                             &
         &     0, 2,                                                             &
         &     nArguments,                                                       &
         &     errorNumber)                                                      !
    ERROR = ERROR .Or. errorNumber
    !
    Call queryReceiver(rec%bolo, receiverIsBolo,                                 &
         &       bolometerName = bolometerName)                                  !
    !
    !D     Write (6,*) "      receiverIsBolo:   ", receiverIsBolo
    !D     Write (6,*) "      bolometerName:    ", bolometerName
    !
    If (   .Not.                                                                 &
         & (     receiverIsBolo.And.bolometerName.Eq.bolo%GISMO                  &
         &  .Or. receiverIsBolo.And.bolometerName.Eq.bolo%NIKA                   &
         &  .Or. GV%privilege.Eq.setPrivilege%ncsTeam                            &
         & )    ) Then                                                           !
       ERROR = .True.
       Write (messageText, *) " works only with ", bolo%GISMO, " or ", bolo%NIKA
       Call pakoMessage(priorityE,severityE,command,                             &
            &           messageText)                                             !
    End If
    !
!!$!! OLD !!$    If (   .Not.                                                                 &
!!$!! OLD !!$         & (     GV%privilege.Eq.setPrivilege%GISMO                              &
!!$!! OLD !!$         &  .Or. GV%privilege.Eq.setPrivilege%ncsTeam                            &
!!$!! OLD !!$         &  .Or. GV%privilege.Eq.setPrivilege%staff                              &
!!$!! OLD !!$         & )    ) Then                                                           !
!!$!! OLD !!$       ERROR = .True.
!!$!! OLD !!$       Write (messageText, *) " requires privilege"
!!$!! OLD !!$       Call pakoMessage(priorityE,severityE,command,                             &
!!$!! OLD !!$            &           messageText)                                             !
!!$!! OLD !!$    End If
    !
    ! *** read Parameters, Options (to detect errors)         ***
    ! *** and check for validity and ranges                   ***
    ! *** pako (error) messages are turned ON                 ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOn = .True.)
       Include 'inc/parameters/parametersAmplitudeXY.inc'
       Include 'inc/options/readOptionsLissajous.inc'
    End If
    !
    ! *** set defaults   ***
    If (.Not. ERROR) Then
       option = 'DEFAULTS'
       Call indexCommmandOption                                                  &
            &        (command,option,commandFull,optionFull,                     &
            &        commandIndex,optionIndex,iCommand,iOption,                  &
            &        errorNotFound,errorNotUnique)                               !
       setDefaults = SIC_PRESENT(iOption,0)
       If (setDefaults) Then
          Include 'inc/variables/setDefaults.inc'
       Endif
    Endif
    !
    ! *** Read Parameters, Options (again, after defaults!)   ***
    ! *** and check for validity and ranges                   ***
    ! *** pako (error) messages are turned OFF                ***
    If (.Not. ERROR) Then
       Call pakoMessageSwitch (setOff = .True.)
       Include 'inc/parameters/parametersAmplitudeXY.inc'
       Include 'inc/options/readOptionsLissajous.inc'
    End If
    Call pakoMessageSwitch (setOn = .True.)
    !
    !
    ! *** check consistency and                           ***
    ! *** store into temporary (intermediate) variables   ***
    If (.Not.ERROR) Then    !!   check consistency
       !
       errorInconsistent = .False.
       !
       If (vars(iIn)%tOtf .Lt. 5*GV%tRecord) Then
          If (vars(iIn)%tOtf .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tOtf",messageText)             !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tOtf",messageText)             !
          End If
       End If
       !
       If (vars(iIn)%doReference                                                 &
            &  .And.   vars(iIn)%tReference .Lt. 5*GV%tRecord) Then              !
          If (vars(iIn)%tReference .Lt. 3*GV%tRecord) Then
             errorInconsistent = .True.
             Write (messageText,*)    "must be at least 3 times "                &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityE,severityE,                               &
                  &           command(1:l)//"/"//"tReference",messageText)       !
          Else
             Write (messageText,*)    "should be at least 5 times "              &
                  &                // "tRecord = tPhase*nPhases*nCycles = "      &
                  &                 ,  GV%tRecord                                &
                  &                 , "of switching mode "//GV%switchingMode     !
             Call pakoMessage(priorityW,severityW,                               &
                  &           command(1:l)//"/"//"tReference",messageText)       !
          End If
       End If
       !
       If (vars(iIn)%doReference                                                 &
            &  .And. vars(iIn)%systemNameRef.Ne.vars(iIn)%systemName) Then
          errorInconsistent = .True.
          GV%notReadyLissajous = .True.
          Write (messageText,*) "different values for /SYSTEM ",                 &  
               &  "and /REFERENCE are not yet allowed "   
          Call pakoMessage(priorityE,severityE,                                  &
               &           command//"/"//"REFERENCE",messageText)
       End If
       !
       If (    .Not. (GV%privilege.Eq.setPrivilege%staff                         &
            &  .Or.   GV%privilege.Eq.setPrivilege%ncsTeam)) Then                !
       If (GV%switchingMode.Eq.swMode%Beam) Then
          errorInconsistent = .True.
          GV%notReadyLissajous = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                 swModePako%Beam
          Call PakoMessage(priorityE,severityE,command,messageText)
       End If
       End If
       !
       If (        vars(iIn)%doReference .And. GV%switchingMode.Eq.swMode%Freq   &
            & .Or. vars(iIn)%doReference .And. GV%switchingMode.Eq.swMode%Wobb ) &
            & Then
          errorInconsistent = .True.
          GV%notReadyLissajous = .True.
          Write (messageText,*)  "will not work with switching mode ",           &
               &                 GV%switchingMode
          Call PakoMessage(priorityE,severityE,command//" /reference",           &
               &                 messageText)
          Write (messageText,*)  "consider to use: /reference no" 
          Call PakoMessage(priorityI,severityI,command,                          &
               &                 messageText)
       End If
       !
       If (        vars(iIn)%doFocus .And. vars(iIn)%doPointing ) Then
          errorInconsistent = .True.
          Write (messageText,*)  "can not have both /pointing and /focus"
          Call PakoMessage(priorityE,severityE,command,                          &
               &                 messageText)                                    !
       End If
       !
       If (.Not. errorInconsistent) Then
          vars(iTemp) = vars(iIn)
       End If
       !
    End If   !!   check consistency
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    If (.Not.error) Then   !!   check Lissajous
       !
       vLissMaxX  =   vars(iIn)%amplitude%x*GV%angleUnit * vars(iIn)%omega%x
       vLissMaxY  =   vars(iIn)%amplitude%y*GV%angleUnit * vars(iIn)%omega%y
       !
       aLissMaxX  =   vars(iIn)%amplitude%x*GV%angleUnit * vars(iIn)%omega%x**2
       aLissMaxY  =   vars(iIn)%amplitude%y*GV%angleUnit * vars(iIn)%omega%y**2
       !
       vLissLimit = 300.0*arcsec
       aLissLimit = 108.0*arcsec
       !
       !D        Write (6,*) "      vLissMaxX:  ", vLissMaxX
       !D        Write (6,*) "      vLissMaxY:  ", vLissMaxY
       !D        Write (6,*) "      aLissMaxX:  ", aLissMaxX
       !D        Write (6,*) "      aLissMaxY:  ", aLissMaxY
       !D        Write (6,*) "      vLissLimit: ", vLissLimit
       !D        Write (6,*) "      aLissLimit: ", aLissLimit
       !
       vLissFacX  = vLissMaxX/vLissLimit
       vLissFacY  = vLissMaxY/vLissLimit
       aLissFacX  = aLissMaxX/aLissLimit
       aLissFacY  = aLissMaxY/aLissLimit
       !
       If (vLissMaxX.Gt.vLissLimit) Then
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("x max. speed = amplitude x [",    F12.1,                    &
               &    " ] * frequency x [",            F12.4,                      &
               &    " ] is too large by factor: ",  F12.3 )' )                   &
               & vars(iIn)%amplitude%x,                                          &
               & vars(iIn)%frequency%x,                                          &
               & vLissFacX                                                       !
          Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("to correct his, try frequency x:  ", F12.4                  &
               &                                          )' )                   &
               & 0.999*vars(iIn)%frequency%x/(vLissFacX)                         !
          Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
          errorInconsistent = .True.
       End If
       !
       If (vLissMaxY.Gt.vLissLimit) Then
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("y max. speed = amplitude y [",    F12.1,                    &
               &    " ] * frequency y [",            F12.4,                      &
               &    " ] is too large by factor: ",  F12.3 )' )                   &
               & vars(iIn)%amplitude%y,                                          &
               & vars(iIn)%frequency%y,                                          &
               & vLissFacY                                                       !
          Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("to correct his, try frequency y:  ", F12.4                  &
               &                                          )' )                   &
               & 0.999*vars(iIn)%frequency%y/(vLissFacY)                         !
          Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
          errorInconsistent = .True.
       End If
       !
       If (aLissMaxX.Gt.aLissLimit) Then
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("x max. acceleration = amplitude y [",  F12.1,               &
               &    " ] * frequency x [",                 F12.4,                 &
               &    " ] ^2 is too large by factor: ",    F12.3 )' )              &
               & vars(iIn)%amplitude%x,                                          &
               & vars(iIn)%frequency%x,                                          &
               & aLissFacX                                                       !
          Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("to correct his, try: frequency x  ", F12.4                  &
               &                                          )' )                   &
               & 0.999*vars(iIn)%frequency%x/sqrt(aLissFacX)                     !
          Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
          errorInconsistent = .True.
       End If
       !
       If (aLissMaxY.Gt.aLissLimit) Then
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("y max. acceleration = amplitude y [",  F12.1,               &
               &    " ] * frequency y [",                 F12.4,                 &
               &    " ] ^2 is too large by factor ",     F12.3 )' )              &
               & vars(iIn)%amplitude%y,                                          &
               & vars(iIn)%frequency%y,                                          &
               & aLissFacY                                                       !
          Call pakoMESSAGE(priorityE,severityE,"DIY",messageText)
          Write (messageText, iostat=ierr, fmt =                                 &
               &  '("to correct his, try: frequency y  ", F12.4                  &
               &                                          )' )                   &
               & 0.999*vars(iIn)%frequency%y/sqrt(aLissFacY)                     !
          Call pakoMESSAGE(priorityI,severityI,"DIY",messageText)
          errorInconsistent = .True.
       End If
       !
!! TBD:          !D           Write (6,*) "   vars(iIn)%doRampUp   ", vars(iIn)%doRampUp
!! TBD:          !D           Write (6,*) "   vars(iIn)%doRampDown ", vars(iIn)%doRampDown
!! TBD:          !
!! TBD:          If (.Not.vars(iIn)%doRampUp) Then
!! TBD:             Write (messageText,*) "/ramp up [tRamp] is REQUIRED for Lissajous"
!! TBD:             Call pakoMESSAGE(priorityE,severityE,"SUBSCAN",messageText)
!! TBD:             errorInconsistent = .True.
!! TBD:          End If
       !
       !  ** calculate maximum allowed elevation:
       !
       If (.Not.errorInconsistent) Then   !!  calculate maximum allowed elevation
          !
          vLissMaxXel = Acos(vLissMaxX/(2*vLissLimit))
          vLissMaxYel = Acos(vLissMaxY/(2*vLissLimit))
          !
          aLissMaxXel = Acos(aLissMaxX/(2*aLissLimit))  ! <-- corrected aLissLimit on 2010-03-18 
          aLissMaxYel = Acos(aLissMaxY/(2*aLissLimit))  ! <-- corrected aLissLimit on 2010-03-18 
          !
          If (         vars(iIn)%systemName.Eq.offsPako%tru                      &
               &  .Or. vars(iIn)%systemName.Eq.offsPako%hor) Then                !
             lissMaxEl   = min(vLissMaxXel,aLissMaxXel)                          ! use only "x" offsets (Azimuth) for el. condition
          Else
             lissMaxEl   = min(vLissMaxXel,vLissMaxYel,                          &
                  &            aLissMaxXel,aLissMaxYel)                          !
          End If
          !
          !D           Write (6,*) " max el vLissMaxXel: ", vLissMaxXel/deg
          !D           Write (6,*) " max el vLissMaxYel: ", vLissMaxYel/deg
          !D           Write (6,*) " max el aLissMaxXel: ", aLissMaxXel/deg
          !D           Write (6,*) " max el aLissMaxYel: ", aLissMaxYel/deg
          !
          !D           Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
          !
          lissMaxEl  =  lissMaxEl-2.0*deg                                        !!  2 deg safety marging
          !
          lissMaxEl  =  min(lissMaxEl,85.0*deg)                                  !!  max. elevatio: 85 deg
          !D           Write (6,*) "  "
          !D           Write (6,*) " max el  lissMaxEl:  ", lissMaxEl/deg
          !
          !!             If (lissMaxEl.Ge.60.0*deg) Then
          !
          condElevation%isSet     = .True.
          condElevation%maximum   = lissMaxEl
!! OLD !!$          If (condElevation%isSet) Then                                          ! maximum elevation: minimum over subsans
!! OLD !!$             condElevation%maximum   = min(condElevation%maximum,lissMaxEl)
!! OLD !!$          Else
!! OLD !!$             condElevation%isSet     = .True.
!! OLD !!$             condElevation%maximum   = lissMaxEl
!! OLD !!$          End If
          !
          !D           Write (6,*) " condElevation%isSet:   ", condElevation%isSet
          !D           Write (6,*) " condElevation%maximum: ", condElevation%maximum/deg
          !
          Write (messageText, fmt =                                              &
               &  '("WARNING--CONDITION: Elevation must be less than ",          &
               &     F10.2,                                                      &
               &    " [deg] ")' )                                                &
               & condElevation%maximum/deg                                       !
          Call pakoMESSAGE(priorityW,severityW,"LISSAJOUS",messageText)
          !
       End If   !!   calculate maximum allowed elevation
       !
    End If   !!   check Lissajous
    !
    ERROR = ERROR .Or. errorInconsistent
    !
    ! *** store from temporary into final variables ***
    If (.Not.ERROR) Then
       vars(iValue)  = vars(iTemp)
    End If
    !
    ! *** set "selected" observing mode & plot ***
    If (.Not.error) Then
       GV%observingMode     = OM%Lissajous
       GV%observingModePako = OMpako%Lissajous
       !D        Write (6,*) "   GV%observingMode: ", GV%observingMode
       GV%omSystemName      = vars(iValue)%systemName 
       GV%condElevation     = condElevation
       !D        Write (6,*) "   GV%condElevation: ", GV%condElevation                                                                               
       !
       GV%notReadySWafterOM = .False.
       GV%notReadySecondaryRafterOM = .False.
       !
       GV%notReadyLissajous    = .False.
       LissajousCommand        = line(1:lenc(line))
       Call analyzeLissajous (errorA)
!!$       Call plotLissajous (errorP)
       Call plotDIYlist(errorP)
    End If
    !
    ! *** display values ***
    If (.Not. ERROR) Then
       Call displayLissajous
       Call listDIYlist (error)
    End If
    !
    Return
  End Subroutine LISSAJOUS
!!!
!!!
  Subroutine displayLissajous
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Character(len=24)  :: command
    !
    Integer            :: larg
    !
    Include 'inc/display/commandDisplayLissajous.inc'
    !
  End Subroutine displayLissajous
!!!
!!!
  Subroutine analyzeLissajous (errorA)
    !
    ! TBD:  support of several reference positions
    !
    ! <DOCUMENTATION name="analyzeLissajous">
    !
    ! </DOCUMENTATION> <!-- name="analyzeLissajous" -->
    !
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Integer                :: nScan 
    Character (len=lenCh)  :: aUnit, sUnit
    Integer                :: iSS           = 0     ! counts subcans/segment
    Integer                :: nSS           = 1
    !
    Integer                :: iQuery
    Character(len=lenCh)   :: nameQuery
    Logical                :: isSet
    Type(xyPointType)      :: pointResult
    !
    Integer                :: nSub, nSeg
    Integer                :: nFocus
    !
!!$!! OLD !!$    Integer              :: nScan 
!!$!! OLD !!$    Character (len=12)   :: aUnit, sUnit
!!$!! OLD !!$    Integer              :: iCRO          = 0     ! counts through CRO loop
!!$!! OLD !!$    Integer              :: iCROnext      = 0     !        next iCRO
!!$!! OLD !!$    Integer              :: iSS           = 0     ! counts subcans/segment
!!$!! OLD !!$    Integer              :: iOTF          = 0     ! counts OTF subscans
!!$!! OLD !!$    !
!!$!! OLD !!$    Character (len=1)    :: cCroII        = ''    ! stores previous CRO code    
!!$    !
    !
    !! TBD: fix need for explicit "paKo"
    Call pako_message(seve%t,"paKo",                                             &
         &    " module Lissajous, 1.2.3 2014-08-27 ---> SR: analyzeLissajous ")  ! trace execution
    !
    errorA = .False.
    !
    !D     Write (6,*) " --> modulePakoLissajous: SR analyzeLissajous "
    !
    !D     Write (6,*) "     segList(1): ", segList(1) 
    !
    If (GV%doDebugMessages) Then
       Write (6,*) "      vars(iValue)%doTune :      ", vars(iValue)%doTune
       Write (6,*) "      vars(iValue)%tTune :       ", vars(iValue)%tTune
       Write (6,*) "      vars(iValue)%doFocus :     ", vars(iValue)%doFocus
       Write (6,*) "      vars(iValue)%nFocus :      ", vars(iValue)%nFocus
       Write (6,*) "      vars(iValue)%focusList :   "
       Write (6,*)        vars(iValue)%focusList
       Write (6,*) "   <- vars(iValue)%focusList :   "
    End If
    !
    segList(:) = segDefault                          !!  reset list of segments
    !
    Call countSubscans(value=0)                      !!  reset subscan counter
    Call countSegments(value=0)                      !!  reset segment counter
    !
    ii        = 0
    jj        = 0
    iSS       = 1
    nScan     = 1111
    aUnit     = GV%angleUnitC                        ! 
    sUnit     = GV%speedUnitC                        ! 
    !
!! OLD !!$    nLissajous = 0
!! OLD !!$    !
!! OLD !!$    condElevation%isSet     = .False.
!! OLD !!$    GV%condElevation%isSet  = .False.
    !
    Call getCountSubscans(nSub)
    !D     Write (6,*) "     nSub:   ", nSub
    !
    Call getCountSegments(nSeg)
    !D     Write (6,*) "     nSeg:   ", nSeg
    !
    If (.Not. errorA) Then
       !

       If (vars(ivalue)%doTune) Then
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "  --> Tune Subscan "
             Write (6,*) "      vars(iValue)%doTune : ", vars(iValue)%doTune
             Write (6,*) "      vars(iValue)%tTune :  ", vars(iValue)%tTune
          End If

          Call countSubscans(ii)
          Call countSegments(jj)
          !

   
          If (vars(ivalue)%doRampUp) Then
             !
             !D           Write (6,*) "            Ramp Up Segment"
             !D           Write (6,*) "            tRampUp   ", vars(ivalue)%tRampUp
             !D           Write (6,*) "            tRampDown ", vars(ivalue)%tRampDown
             !
             pStart%x =   vars(iValue)%pCenter%x                                    &
                  &     + vars(iValue)%amplitude%x * sin(vars(iValue)%phase%x)      !
             pStart%y =   vars(iValue)%pCenter%y                                    &
                  &     + vars(iValue)%amplitude%y * sin(vars(iValue)%phase%y)      !
             vStart%x =   vars(iValue)%omega%x                                      & 
                  &     * vars(iValue)%amplitude%x * cos(vars(iValue)%phase%x)      !
             vStart%y =   vars(iValue)%omega%y                                      &   
                  &     * vars(iValue)%amplitude%y * cos(vars(iValue)%phase%y)      !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to ", vars(ivalue)%tRampUp
                tAccel = vars(ivalue)%tRampUp
             End If
             !
             If (tAccel.Lt.5) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
                tAccel = 5
             End If
             !
             pAccel%x = pStart%x -0.5*vstart%x*tAccel
             pAccel%y = pStart%y -0.5*vstart%y*tAccel
             !
          End If   !!!   If (vars(ivalue)%doRampUp) Then

          segList(jj)%newSubscan =  .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%track
          segList(jj)%segType    =  seg%track
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          segList(jj)%flagOn     =  .True.
          segList(jj)%flagRef    =  .False.
          !
          segList(jj)%flagDropin =  .False.
          !
          segList(jj)%flagTune   =  vars(iIn)%doTune
          !
          If (vars(ivalue)%doRampUp) Then                                        !  !!  replaced by vars(iValue)%offsetTune
             !
             segList(jj)%pStart     =  pAccel
             !
          Else
             !
             segList(jj)%pStart     =  pStart
             !
          End If                                                                 !
          !
          segList(jj)%pStart     =  vars(iValue)%offsetTune
          !
          segList(jj)%pEnd       =  segList(jj)%pStart
          segList(jj)%speedStart =  0.0
          segList(jj)%speedEnd   =  0.0
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'tSegment'
          segList(jj)%tSegment   =  vars(iValue)%tTune
          segList(jj)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          segList(jj)%upDateDoppler = .False.
          !
          If (GV%doDebugMessages) Then
             Write (6,*) "        jj, segList(jj): ", jj
             Write (6,*)                          segList(jj)
             Write (6,*) "  <-- Tune Subscan "
          End If

       End If





       If (vars(iValue)%doReference) Then
          !
          !!  ** 
          !D           Write (6,*) "      -> REF 1 before Lissajous "
          !D           Write (6,*) "         vars(iValue)%doReference:    ", vars(iValue)%doReference
          !D           Write (6,*) "         vars(iValue)%offsetR:        ", vars(iValue)%offsetR
          !D           Write (6,*) "         vars(iValue)%systemNameRef:  ", vars(iValue)%systemNameRef
          !D           Write (6,*) "         vars(iValue)%tReference:     ", vars(iValue)%tReference
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          !
          !D           Write (6,*) "       ii: ", ii
          !D           Write (6,*) "       jj: ", jj
          !
          segList(jj)%newSubscan =  .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%track
          segList(jj)%segType    =  seg%track
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
!! OLD !!$          If      (vars(iValue)%croFlag.Eq."O") Then
!! OLD !!$             segList(jj)%flagOn     =  .True.
!! OLD !!$             segList(jj)%flagRef    =  .False.
!! OLD !!$          Else If (vars(iValue)%croFlag.Eq."R") Then
          segList(jj)%flagOn     =  .False.
          segList(jj)%flagRef    =  .True.
!! OLD !!$          Else
!! OLD !!$             segList(jj)%flagOn     =  .True.
!! OLD !!$             segList(jj)%flagRef    =  .False.
!! OLD !!$          End If
          !
          segList(jj)%flagDropin =  .False.
          !
          segList(jj)%pStart     =  vars(iValue)%offsetR
          segList(jj)%pEnd       =  segList(jj)%pStart
          segList(jj)%speedStart =  0.0
          segList(jj)%speedEnd   =  0.0
          segList(jj)%systemName =  vars(iValue)%systemNameRef
          segList(jj)%altOption  =  'tSegment'
          segList(jj)%tSegment   =  vars(iValue)%tReference
          segList(jj)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          segList(jj)%upDateDoppler = .False.
          !
          !D           Write (6,*) "        jj, segList(jj): ", jj
          !D           Write (6,*)                          segList(jj)
          !
       End If
       !
       !
       If (  .Not.vars(iValue)%doFocus ) Then
          nFocus = 1
       Else
          nFocus = vars(iValue)%nFocus
       End If
       !
       !D        Write (6,*) "      nFocus:         ",  nFocus
       !
       !D        Write (6,*) "         "
       !D        Write (6,*) "      -> OTF Lissajous "
       !

       Do kk = 1, nFocus, 1

          !!  ** 
          Call countSubscans(ii)
          Call countSegments(jj)
          !
          !D        Write (6,*) "       ii: ", ii
          !D        Write (6,*) "       jj: ", jj
          ! derived parameters positions in GV%angleUnit, speeds in GV%angleUnit/[s]
          ! derived parameters all other in [s], [rad], [rad/s], [rad/s^2]
          !
          !D        Write (6,*) "            doRampUp   ", vars(ivalue)%doRampUp
          !D        Write (6,*) "            doRampDown ", vars(ivalue)%doRampDown
          !
          !! NOTE: following code adapted from modulePakoDIYlist, SR analyzeSubscan
          !
          If (vars(ivalue)%doRampUp) Then
             !
             !D           Write (6,*) "            Ramp Up Segment"
             !D           Write (6,*) "            tRampUp   ", vars(ivalue)%tRampUp
             !D           Write (6,*) "            tRampDown ", vars(ivalue)%tRampDown
             !
             pStart%x =   vars(iValue)%pCenter%x                                    &
                  &     + vars(iValue)%amplitude%x * sin(vars(iValue)%phase%x)      !
             pStart%y =   vars(iValue)%pCenter%y                                    &
                  &     + vars(iValue)%amplitude%y * sin(vars(iValue)%phase%y)      !
             vStart%x =   vars(iValue)%omega%x                                      & 
                  &     * vars(iValue)%amplitude%x * cos(vars(iValue)%phase%x)      !
             vStart%y =   vars(iValue)%omega%y                                      &   
                  &     * vars(iValue)%amplitude%y * cos(vars(iValue)%phase%y)      !
             vStart%speed = sqrt(vStart%x**2+vStart%y**2)
             !
             accelMax = 0.03*degree                                       !  maximum aceleration in [rad/s^2]
             tAccel   = Int(vStart%speed*GV%angleUnit/accelMax) + 1.0     !  TBD: use max accel. from globals
             !
             If (tAccel.Lt.vars(ivalue)%tRampUp) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to ", vars(ivalue)%tRampUp
                tAccel = vars(ivalue)%tRampUp
             End If
             !
             If (tAccel.Lt.5) Then
                !D              Write (6,*) "             tAccel:    ", tAccel, " will be increased to 5 [sec]"
                tAccel = 5
             End If
             !
             pAccel%x = pStart%x -0.5*vstart%x*tAccel
             pAccel%y = pStart%y -0.5*vstart%y*tAccel
             !
             segList(jj)%newSubscan =  .True.
             segList(jj)%scanNumber =  nScan
             segList(jj)%ssNumber   =  jj
             segList(jj)%segNumber  =  1
             segList(jj)%ssType     =  ss%otf
             segList(jj)%segType    =  seg%linear
             segList(jj)%angleUnit  =  aUnit
             segList(jj)%speedUnit  =  sUnit
             !
             !! OLD !!$             If      (vars(iValue)%croFlag.Eq."O") Then
             segList(jj)%flagOn     =  .True.
             segList(jj)%flagRef    =  .False.
             !! OLD !!$             Else If (vars(iValue)%croFlag.Eq."R") Then
             !! OLD !!$                segList(jj)%flagOn     =  .False.
             !! OLD !!$                segList(jj)%flagRef    =  .True.
             !! OLD !!$             Else
             !! OLD !!$                segList(jj)%flagOn     =  .True.
             !! OLD !!$                segList(jj)%flagRef    =  .False.
             !! OLD !!$       End If
             !
             segList(jj)%flagDropin    =  .True.
             !
             segList(jj)%pStart     =  pAccel
             segList(jj)%pEnd       =  pStart
             segList(jj)%lengthOtf  =  Sqrt(                                        &
                  &                 (segList(jj)%pEnd%x-segList(jj)%pStart%x)**2    &
                  &                +(segList(jj)%pEnd%y-segList(jj)%pStart%y)**2 )  !
             segList(jj)%speedStart =  0.0
             segList(jj)%speedEnd   =  1.0001*vStart%speed      !  IMPORTANT: needed to get smoothly "into" Lissajous
             !                                                  !  TBD:       check /optimize
             segList(jj)%systemName =  vars(iValue)%systemName
             segList(jj)%altOption  =  'SPEED'                  !  TBD:       debug/generalize
             segList(jj)%tSegment   =  tAccel
             segList(jj)%tRecord    =  0.1
             !
             !D           Write (6,*) "        jj, segList(jj): ", jj
             !D           Write (6,*)                          segList(jj)
             ! TBD: clever /proper handling of Doppler 
             segList(jj)%upDateDoppler = .False.
             !

             If   (vars(iValue)%doFocus) Then
                segList(jj)%focusOffset     =  vars(iValue)%focusList(kk)
                segList(jj)%directionFocus  =  vars(iValue)%directionFocus
             Else
                segList(jj)%focusOffset     =  0.0
                segList(jj)%directionFocus  =  GPnone
             End If

             !
             Call countSegments(jj)
             !
          End If   !!   vars(ivalue)%doRampUp
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !D       Write (6,*) "       jj: ", jj
          !
          !D        Write (6,*) "             Lissajous Segment"
          !
          segList(jj)%newSubscan =  .False.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  2
          segList(jj)%ssType     =  ss%otf
          segList(jj)%segType    =  seg%lissajous
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
          !! OLD !!$       If      (vars(iValue)%croFlag.Eq."O") Then
          segList(jj)%flagOn     =  .True.
          segList(jj)%flagRef    =  .False.
          !! OLD !!$       Else If (vars(iValue)%croFlag.Eq."R") Then
          !! OLD !!$          segList(jj)%flagOn     =  .False.
          !! OLD !!$          segList(jj)%flagRef    =  .True.
          !! OLD !!$       Else
          !! OLD !!$          segList(jj)%flagOn     =  .True.
          !! OLD !!$          segList(jj)%flagRef    =  .False.
          !! OLD !!$       End If
          !
          segList(jj)%flagDropin    =  .False.
          !
          segList(jj)%pCenter    =  vars(iValue)%pCenter
          segList(jj)%xAmplitude =  vars(iValue)%amplitude%x
          segList(jj)%yAmplitude =  vars(iValue)%amplitude%y
          segList(jj)%omegaX     =  vars(iValue)%omega%x    
          segList(jj)%omegaY     =  vars(iValue)%omega%y    
          segList(jj)%phiX       =  vars(iValue)%phase%x      
          segList(jj)%phiY       =  vars(iValue)%phase%y      
          !
          segList(jj)%systemName =  vars(iValue)%systemName
          segList(jj)%altOption  =  'TOTF'
          segList(jj)%tSegment   =  vars(iValue)%tOtf
          segList(jj)%tRecord    =  0.1
          !
          ! TBD: clever /proper handling of Doppler 
          segList(jj)%upDateDoppler = .False.
          !
          !! OLD !!$       nLissajous = nLissajous+1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          !D        Write (6,*) "        jj, segList(jj): ", jj
          !D        Write (6,*)                          segList(jj)
          !

       End Do   !!   1, nFocus, 1

          !
       If (vars(iValue)%doReference) Then
          !
          !!  ** 
          !D           Write (6,*) "      -> REF 2 after Lissajous "
          !D           Write (6,*) "         vars(iValue)%doReference:    ", vars(iValue)%doReference
          !D           Write (6,*) "         vars(iValue)%offsetR:        ", vars(iValue)%offsetR
          !D           Write (6,*) "         vars(iValue)%systemNameRef:  ", vars(iValue)%systemNameRef
          !D           Write (6,*) "         vars(iValue)%tReference:     ", vars(iValue)%tReference
          !
          Call countSubscans(ii)
          Call countSegments(jj)
          !
          !D           Write (6,*) "       ii: ", ii
          !D           Write (6,*) "       jj: ", jj
          !
          segList(jj)%newSubscan =  .True.
          segList(jj)%scanNumber =  nScan
          segList(jj)%ssNumber   =  jj
          segList(jj)%segNumber  =  1
          segList(jj)%ssType     =  ss%track
          segList(jj)%segType    =  seg%track
          segList(jj)%angleUnit  =  aUnit
          segList(jj)%speedUnit  =  sUnit
          !
!! OLD !!$          If      (vars(iValue)%croFlag.Eq."O") Then
!! OLD !!$             segList(jj)%flagOn     =  .True.
!! OLD !!$             segList(jj)%flagRef    =  .False.
!! OLD !!$          Else If (vars(iValue)%croFlag.Eq."R") Then
          segList(jj)%flagOn     =  .False.
          segList(jj)%flagRef    =  .True.
!! OLD !!$          Else
!! OLD !!$             segList(jj)%flagOn     =  .True.
!! OLD !!$             segList(jj)%flagRef    =  .False.
!! OLD !!$          End If
          !
          segList(jj)%flagDropin =  .False.
          !
          segList(jj)%pStart%x   =  -vars(iValue)%offsetR%x        !!!  note - !!!
          segList(jj)%pStart%y   =  -vars(iValue)%offsetR%y        !!!  note - !!!
          segList(jj)%pEnd       =  segList(jj)%pStart
          segList(jj)%speedStart =  0.0
          segList(jj)%speedEnd   =  0.0
          segList(jj)%systemName =  vars(iValue)%systemNameRef
          segList(jj)%altOption  =  'tSegment'
          segList(jj)%tSegment   =  vars(iValue)%tReference
          segList(jj)%tRecord    =  0.1
          !
          iQuery    = iPro
          nameQuery = GPnone
          Call  queryOffsets(iQuery,nameQuery,isSet,pointResult)
          !D          Write (6,*) "  SUBSCAN:  isSet = ", isSet
          !D          Write (6,*) "  SUBSCAN:  pointResult = ", pointResult
          !
          ! TBD: clever /proper handling of Doppler 
          segList(jj)%upDateDoppler = .False.
          !
          !D           Write (6,*) "        jj, segList(jj): ", jj
          !D           Write (6,*)                          segList(jj)
          !
       End If   !!   doReference
       !
    End If    !!  not errorA
    !
    Call getCountSegments(nSegments)
    !
    If (GV%doDebugMessages) Then
       Do ii = 1, nSegments, 1
          !
          Write (6,*) "     ii, segList(ii): ", ii, segList(ii) 
          !
       End Do
    End If
    !
    Return 
    !
  End Subroutine analyzeLissajous
!!!
!! OLD !!$    from analyzeOtf:
!! OLD !!$    nScan     = 1111
!! OLD !!$    aUnit     = GV%angleUnitC
!! OLD !!$    sUnit     = GV%speedUnitC
!! OLD !!$    !
!! OLD !!$    iCRO = 0
!! OLD !!$    iSS  = 0
!! OLD !!$    iOTF = 0
!! OLD !!$    !
!! OLD !!$    cCroII = ''
!! OLD !!$    !
!! OLD !!$    Do While (iOTF .Lt. vars(iValue)%nOtf)
!! OLD !!$       !
!! OLD !!$       iCRO     = iCRO+1
!! OLD !!$       iCROnext = iCRO+1
!! OLD !!$       !
!! OLD !!$       !D           write (6,*) "   ++iCRO: ", iCRO
!! OLD !!$       !
!! OLD !!$       iCRO = Modulo(iCRO,vars(iValue)%croCodeCount)
!! OLD !!$       If (iCRO.Eq.0) iCRO = vars(iValue)%croCodeCount
!! OLD !!$       iCROnext = Modulo(iCROnext,vars(iValue)%croCodeCount)
!! OLD !!$       If (iCROnext.Eq.0) iCROnext = vars(iValue)%croCodeCount
!! OLD !!$       !
!! OLD !!$       !D           write (6,*) "     iCRO:     ", iCRO
!! OLD !!$       !D           write (6,*) "      CRO(",iCRO,"):   ->",                      &
!! OLD !!$       !D     &                 vars(iValue)%croCodeBites(iCRO:iCRO),"<-"
!! OLD !!$       !D           write (6,*) "     iCROnext: ", iCROnext
!! OLD !!$       !D           write (6,*) "      CRO(",iCROnext,"):   ->",                  &
!! OLD !!$       !D     &                 vars(iValue)%croCodeBites(iCROnext:iCROnext),"<-"
!! OLD !!$       !D
!! OLD !!$       !D           write (6,*) "     iSS:  ", iSS
!! OLD !!$       !D           write (6,*) "     iOTF: ", iOTF
!! OLD !!$       !D!
!! OLD !!$       !D           write (6,*) " is C? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."C"
!! OLD !!$       !D           write (6,*) " is c? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."c"
!! OLD !!$       !D           write (6,*) " is R? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."R"
!! OLD !!$       !D           write (6,*) " is r? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."r"
!! OLD !!$       !D           write (6,*) " is O? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."O"
!! OLD !!$       !D           write (6,*) " is o? ", vars(iValue)%croCodeBites(iCRO:iCRO).eq."o"
!! OLD !!$       !
!! OLD !!$       !D           write (6,*) '      cCroII: ', cCroII
!! OLD !!$       !
!! OLD !!$       If (vars(iValue)%croCodeBites(iCRO:iCRO).Eq."C") Then
!! OLD !!$          !
!! OLD !!$          iSS = iSS+1
!! OLD !!$          segList(iSS)            =  segDefault                    ! CAL COLD
!! OLD !!$          segList(iSS)%newSubscan =  .True.
!! OLD !!$          segList(iSS)%scanNumber =  nScan
!! OLD !!$          segList(iSS)%ssNumber   =  iSS
!! OLD !!$          segList(iSS)%segNumber  =  1
!! OLD !!$          segList(iSS)%ssType     =  ss%cc
!! OLD !!$          segList(iSS)%segType    =  seg%track
!! OLD !!$          segList(iSS)%angleUnit  =  aUnit
!! OLD !!$          segList(iSS)%speedUnit  =  sUnit
!! OLD !!$          segList(iSS)%flagOn     =  .False.
!! OLD !!$          segList(iSS)%flagRef    =  .False.
!! OLD !!$          If (vars(iValue)%doReference) Then
!! OLD !!$             segList(iSS)%pStart     =  vars(iValue)%offsetR
!! OLD !!$          Else If (iOTF.Eq.0) Then
!! OLD !!$             segList(iSS)%pStart     =  vars(iValue)%pStart
!! OLD !!$          Else If (vars(iValue)%croCodeBites(iCROnext:iCROnext).Eq."C") Then
!! OLD !!$             segList(iSS)%pStart%x   =  segOtfII%pEnd%x
!! OLD !!$             segList(iSS)%pStart%y   =  segOtfII%pEnd%y
!! OLD !!$          Else If (vars(iValue)%doZigzag) Then
!! OLD !!$             segList(iSS)%pStart%x   =  segOtfII%pEnd%x+vars(iValue)%delta%x
!! OLD !!$             segList(iSS)%pStart%y   =  segOtfII%pEnd%y+vars(iValue)%delta%y
!! OLD !!$          Else
!! OLD !!$             segList(iSS)%pStart%x   =  segOtfII%pStart%x+vars(iValue)%delta%x
!! OLD !!$             segList(iSS)%pStart%y   =  segOtfII%pStart%y+vars(iValue)%delta%y
!! OLD !!$          End If
!! OLD !!$          segList(iSS)%pEnd       =  segList(iSS)%pStart
!! OLD !!$          segList(iSS)%speedStart =  0.0
!! OLD !!$          segList(iSS)%speedEnd   =  0.0
!! OLD !!$          ! TBD: systemName in case of REF sysem .NE. OTF system
!! OLD !!$          segList(iSS)%systemName =  vars(iValue)%systemName
!! OLD !!$          segList(iSS)%altOption  =  'tSegment'
!! OLD !!$          ! TBD: time from CALIBRATE
!! OLD !!$          segList(iSS)%tSegment   =  5.0
!! OLD !!$          segList(iSS)%tRecord    =  vars(iValue)%tRecord
!! OLD !!$          Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$               &           segList(iSS)%ssType
!! OLD !!$          Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$          !
!! OLD !!$          iSS = iSS+1
!! OLD !!$          segList(iSS)            =  segList(iSS-1)                ! CAL AMBIENT
!! OLD !!$          segList(iSS)%ssNumber   =  iSS
!! OLD !!$          segList(iSS)%ssType     =  ss%ca
!! OLD !!$          Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$               &           segList(iSS)%ssType
!! OLD !!$          Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$          !
!! OLD !!$          iSS = iSS+1
!! OLD !!$          segList(iSS)            =  segList(iSS-1)                ! CAL SKY
!! OLD !!$          segList(iSS)%ssNumber   =  iSS
!! OLD !!$          segList(iSS)%ssType     =  ss%cs
!! OLD !!$          Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$               &           segList(iSS)%ssType, segList(iSS)%pStart
!! OLD !!$          Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$          !
!! OLD !!$          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
!! OLD !!$          !
!! OLD !!$       End If
!! OLD !!$       !
!! OLD !!$       If (vars(iValue)%doReference .And.                            &
!! OLD !!$            &         vars(iValue)%croCodeBites(iCRO:iCRO).Eq."R") Then
!! OLD !!$          !
!! OLD !!$          iSS = iSS+1
!! OLD !!$          segList(iSS)            =  segDefault                    ! REFERENCE
!! OLD !!$          segList(iSS)%newSubscan =  .True.
!! OLD !!$          segList(iSS)%scanNumber =  nScan
!! OLD !!$          segList(iSS)%ssNumber   =  iSS
!! OLD !!$          segList(iSS)%segNumber  =  1
!! OLD !!$          segList(iSS)%ssType     =  ss%ref
!! OLD !!$          segList(iSS)%segType    =  seg%track
!! OLD !!$          segList(iSS)%angleUnit  =  aUnit
!! OLD !!$          segList(iSS)%speedUnit  =  sUnit
!! OLD !!$          segList(iSS)%flagOn     =  .False.
!! OLD !!$          segList(iSS)%flagRef    =  .True.
!! OLD !!$          segList(iSS)%pStart     =  vars(iValue)%offsetR
!! OLD !!$          segList(iSS)%pEnd       =  vars(iValue)%offsetR
!! OLD !!$          ! TBD: system name for REF
!! OLD !!$          segList(iSS)%systemName =  vars(iValue)%systemName
!! OLD !!$          segList(iSS)%altOption  =  'tSegment'
!! OLD !!$          segList(iSS)%speedStart =  0.0
!! OLD !!$          segList(iSS)%speedEnd   =  0.0
!! OLD !!$          segList(iSS)%tSegment   =  vars(iValue)%tReference
!! OLD !!$          segList(iSS)%tRecord    =  vars(iValue)%tRecord
!! OLD !!$          Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$               &           segList(iSS)%ssType, segList(iSS)%pStart
!! OLD !!$          Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$          !
!! OLD !!$          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
!! OLD !!$          !
!! OLD !!$       End If
!! OLD !!$       !
!! OLD !!$       If (vars(iValue)%croCodeBites(iCRO:iCRO).Eq."O") Then
!! OLD !!$          !
!! OLD !!$          iSS  = iSS+1
!! OLD !!$          iOTF = iOTF+1
!! OLD !!$          If (iOTF.Eq.1) Then
!! OLD !!$             segOtfII            =  segDefault                    ! first OTF
!! OLD !!$             segList(iSS)%newSubscan =  .True.
!! OLD !!$             segOtfII%scanNumber =  nScan
!! OLD !!$             segOtfII%ssNumber   =  iSS
!! OLD !!$             segOtfII%segNumber  =  1
!! OLD !!$             segOtfII%ssType     =  ss%otf
!! OLD !!$             segOtfII%segType    =  seg%linear
!! OLD !!$             segOtfII%angleUnit  =  aUnit
!! OLD !!$             segOtfII%speedUnit  =  sUnit
!! OLD !!$             segOtfII%flagOn     =  .True.
!! OLD !!$             segOtfII%flagRef    =  .False.
!! OLD !!$             segOtfII%pStart     =  vars(iValue)%pStart  
!! OLD !!$             segOtfII%pEnd       =  vars(iValue)%pEnd  
!! OLD !!$             segOtfII%lengthOtf  =  vars(iValue)%lengthOtf
!! OLD !!$             segOtfII%systemName =  vars(iValue)%systemName
!! OLD !!$             segOtfII%altOption  =  vars(iValue)%altOption
!! OLD !!$             segOtfII%speedStart =  vars(iValue)%speedStart
!! OLD !!$             segOtfII%speedEnd   =  vars(iValue)%speedEnd
!! OLD !!$             segOtfII%tSegment   =  vars(iValue)%tOtf
!! OLD !!$             segOtfII%tRecord    =  vars(iValue)%tRecord
!! OLD !!$             segList(iSS)        =  segOtfII
!! OLD !!$          Else                                                 ! More OTF
!! OLD !!$             segOtfII%ssNumber   =  iSS
!! OLD !!$             If (vars(iValue)%doZigzag) Then
!! OLD !!$                pII              =  segOtfII%pStart
!! OLD !!$                segOtfII%pStart  =  segOtfII%pEnd
!! OLD !!$                segOtfII%pEnd    =  pII
!! OLD !!$             End If
!! OLD !!$             segOtfII%pStart%x   =  segOtfII%pStart%x+vars(iValue)%delta%x
!! OLD !!$             segOtfII%pStart%y   =  segOtfII%pStart%y+vars(iValue)%delta%y
!! OLD !!$             segOtfII%pEnd%x     =  segOtfII%pEnd%x  +vars(iValue)%delta%x
!! OLD !!$             segOtfII%pEnd%y     =  segOtfII%pEnd%y  +vars(iValue)%delta%y
!! OLD !!$             segList(iSS)        =  segOtfII
!! OLD !!$          End If
!! OLD !!$          !
!! OLD !!$          Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$               &           segList(iSS)%ssType, segList(iSS)%pStart, " to ",       &
!! OLD !!$               &           segList(iSS)%pEnd
!! OLD !!$          Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$          !
!! OLD !!$          cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
!! OLD !!$          !
!! OLD !!$       End If
!! OLD !!$       !
!! OLD !!$    End Do
!! OLD !!$    !
!! OLD !!$    If (iSS.Ge.1) Then
!! OLD !!$       If (vars(iValue)%systemName.Eq.offs%pro) Then
!! OLD !!$          segList(ii)%updateDoppler = .True.
!! OLD !!$          segList(ii)%pDoppler      = vars(iValue)%offset
!! OLD !!$       Else If (ii.Eq.1) Then
!! OLD !!$       segList(1)%updateDoppler = .True.
!! OLD !!$       segList(1)%pDoppler      = xyPointType(0.0,0.0)
!! OLD !!$    End If
!! OLD !!$    !
!! OLD !!$    nSegments = iSS
!! OLD !!$    !
!! OLD !!$    ii = vars(iValue)%croCodeCount
!! OLD !!$    If (vars(iValue)%doReference                                  &
!! OLD !!$         &         .And.((vars(iValue)%croCodeBites(ii:ii).Eq."R"            &      
!! OLD !!$         &                   .And. (segList(nSegments)%ssType.Eq.ss%otf))    &
!! OLD !!$         &               .Or.                                                &
!! OLD !!$         &               (vars(iValue)%croCodeBites(ii-1:ii).Eq."RC"         &      
!! OLD !!$         &                   .And. (segList(nSegments)%ssType.Eq.ss%otf))    &
!! OLD !!$         &              )                                                    &
!! OLD !!$         &        ) Then
!! OLD !!$       !
!! OLD !!$       iSS  = iSS+1
!! OLD !!$       segList(iSS)            =  segDefault                    ! add REFERENCE at end
!! OLD !!$       segList(iSS)%newSubscan =  .True.
!! OLD !!$       segList(iSS)%scanNumber =  nScan
!! OLD !!$       segList(iSS)%ssNumber   =  iSS
!! OLD !!$       segList(iSS)%segNumber  =  1
!! OLD !!$       segList(iSS)%ssType     =  ss%ref
!! OLD !!$       segList(iSS)%segType    =  seg%track
!! OLD !!$       segList(iSS)%angleUnit  =  aUnit
!! OLD !!$       segList(iSS)%speedUnit  =  sUnit
!! OLD !!$       segList(iSS)%flagOn     =  .False.
!! OLD !!$       segList(iSS)%flagRef    =  .True.
!! OLD !!$       segList(iSS)%pStart     =  vars(iValue)%offsetR  
!! OLD !!$       segList(iSS)%pEnd       =  vars(iValue)%offsetR  
!! OLD !!$       segList(iSS)%systemName =  vars(iValue)%systemName
!! OLD !!$       segList(iSS)%altOption  =  'tSegment'
!! OLD !!$       segList(iSS)%speedStart =  0.0
!! OLD !!$       segList(iSS)%speedEnd   =  0.0
!! OLD !!$       segList(iSS)%tSegment   =  vars(iValue)%tReference
!! OLD !!$       segList(iSS)%tRecord    =  vars(iValue)%tRecord
!! OLD !!$       Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$            &           segList(iSS)%ssType, segList(iSS)%pStart
!! OLD !!$       Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$       !
!! OLD !!$       cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
!! OLD !!$       !
!! OLD !!$    End If
!! OLD !!$    !
!! OLD !!$    nSegments = iSS
!! OLD !!$    !
!! OLD !!$    ii = vars(iValue)%croCodeCount
!! OLD !!$    If ( vars(iValue)%croCodeBites(ii:ii).Eq."C"                  &      
!! OLD !!$         &         .And. .Not. (segList(nSegments)%ssType.Eq.ss%cs)          &
!! OLD !!$         &        ) Then
!! OLD !!$       !                                                                      ! add CAL at end
!! OLD !!$       iSS  = iSS+1
!! OLD !!$       segList(iSS)            =  segDefault                    ! CAL COLD
!! OLD !!$       segList(iSS)%newSubscan =  .True.
!! OLD !!$       segList(iSS)%scanNumber =  nScan
!! OLD !!$       segList(iSS)%ssNumber   =  iSS
!! OLD !!$       segList(iSS)%segNumber  =  1
!! OLD !!$       segList(iSS)%ssType     =  ss%cc
!! OLD !!$       segList(iSS)%segType    =  seg%track
!! OLD !!$       segList(iSS)%angleUnit  =  aUnit
!! OLD !!$       segList(iSS)%speedUnit  =  sUnit
!! OLD !!$       segList(iSS)%flagOn     =  .False.
!! OLD !!$       segList(iSS)%flagRef    =  .False.
!! OLD !!$       If (vars(iValue)%doReference) Then
!! OLD !!$          segList(iSS)%pStart  =  vars(iValue)%offsetR  
!! OLD !!$       Else
!! OLD !!$          segList(iSS)%pStart  =  segOtfII%pEnd  
!! OLD !!$       End If
!! OLD !!$       segList(iSS)%pEnd       =  segList(iSS)%pStart  
!! OLD !!$       segList(iSS)%speedStart =  0.0
!! OLD !!$       segList(iSS)%speedEnd   =  0.0
!! OLD !!$       ! TBD: case ref system
!! OLD !!$       segList(iSS)%systemName =  vars(iValue)%systemName
!! OLD !!$       segList(iSS)%altOption  =  'tSegment'
!! OLD !!$       ! TBD: time from CALIBRATE
!! OLD !!$       segList(iSS)%tSegment   =  5.0
!! OLD !!$       segList(iSS)%tRecord    =  vars(iValue)%tRecord
!! OLD !!$       Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$            &           segList(iSS)%ssType
!! OLD !!$       Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$       !
!! OLD !!$       iSS = iSS+1
!! OLD !!$       segList(iSS)            =  segList(iSS-1)                ! CAL AMBIENT
!! OLD !!$       segList(iSS)%ssType     =  ss%ca
!! OLD !!$       Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$            &           segList(iSS)%ssType
!! OLD !!$       Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$       !
!! OLD !!$       iSS = iSS+1
!! OLD !!$       segList(iSS)            =  segList(iSS-1)                ! CAL SKY
!! OLD !!$       segList(iSS)%ssType     =  ss%cs
!! OLD !!$       Write (messageText,*)  "  subscan #:   ", iSS,        &
!! OLD !!$            &           segList(iSS)%ssType, segList(iSS)%pStart
!! OLD !!$       Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!! OLD !!$       !
!! OLD !!$       cCroII = vars(iValue)%croCodeBites(iCRO:iCRO)
!! OLD !!$       !
!! OLD !!$    End If
!! OLD !!$    !
!! OLD !!$    nSegments = iSS
!! OLD !!$    !
!! OLD !!$    Write (messageText,*)  "   number of Subscans/Segments: ", nSegments
!! OLD !!$    Call pakoMessage(priorityI,severityI,"LISSAJOUS "//" Analyze",messageText)
!!!
!!!
  Subroutine plotLissajous (errorP)
    !
    !**   Variables  for Plots   ***
    Include 'inc/variables/headerForPlotMethods.inc'
    !
    !**   standard working variables   ***
    Include 'inc/variables/standardWorkingVariables.inc'
    !
    Call pako_message(seve%t,"paKo",                                             &
         &    " module Lissajous, 1.2.3 2014-10-20 ---> SR: plotLissajous ")     ! trace execution
    !
    errorP = .False.
    !
    Call configurePlots
    !
    Call getCountSegments(nSegments)
    !
    !D     Write (messageText,*)  "  subscans #: 1 to ", nSegments
    !
    If (nSegments.Ge.1) Then
       !
       Do ii = 1, nSegments, 1
          !
          !D           Write (6,*) ii, segList(ii)%ssType, segList(ii)%segType
          !
          If      (segList(ii)%ssType.Eq.ss%otf                                  &  
               &   .And. segList(ii)%segType.Eq.seg%linear) Then                 !  !!  OTF linear
             !
             If (segList(ii)%flagDropin) Then
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii,                                          &
                     &  Type      = "dropin"                                     &
                     &  )                                                        !
             Else
                Call plotOtfLinearP(                                             &
                     &  segList(ii)%pStart,                                      &
                     &  segList(ii)%pEnd,                                        &
                     &  errorP,                                                  &
                     &  speedStart= segList(ii)%speedStart,                      &
                     &  speedEnd  = segList(ii)%speedEnd,                        &
                     &  tSegment  = segList(ii)%tSegment,                        &
                     &  tSample   = 1/GV%slowRateAMD,                            &
                     &  number    = ii)                                          !
             End If   !!   segList(ii)%flagDropin
             !
          Else If      (segList(ii)%ssType.Eq.ss%otf                             &
               &   .And. segList(ii)%segType.Eq.seg%lissajous) Then              !  !!  OTF Lissajous
             !
             !D              Write (6,*) "   --> plotDIYlist: about to call plotOtfLissajous"
             !D              Write (6,*) "                GV%slowRateAMD: ", GV%slowRateAMD
             !
             Call plotOtfLissajousP(                                             &
                  &  segList(ii)%pCenter,                                        &
                  &  segList(ii)%xAmplitude,                                     &
                  &  segList(ii)%yAmplitude,                                     &
                  &  segList(ii)%omegaX,                                         &
                  &  segList(ii)%omegaY,                                         &
                  &  segList(ii)%phiX,                                           &
                  &  segList(ii)%phiY,                                           &
                  &  segList(ii)%tSegment,                                       &
                  &  errorP,                                                     &
                  &  tSample=1/GV%slowRateAMD,                                   &
                  &  number=ii)                                                  !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagOn) Then                                !  !!  Track ON
             !
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%on)                                        !
             !
          Else If (segList(ii)%ssType .Eq.ss%track                               &
               &   .And. segList(ii)%segType.Eq.seg%track                        &
               &   .And. segList(ii)%flagRef) Then                               !  !!  Track REF
             !
             Call plotTrackP( segList(ii)%pStart,                                &
                  &           errorP,                                            &
                  &           number=segList(ii)%ssNumber,                       &
                  &           Type=ss%ref)                                       !
             !
          End If   !!   segList(ii)%ssType.Eq.ss%otf.And. segList(ii)%segType.Eq.seg%linear
          !        !!   Else ... other segment types
          !
       End Do   !!   ii = 1, nSegments, 1
       !
    Else
       !
       Write (messageText,*) '   list of subscans and segments is empty.'
       Call PakoMessage(priorityW,severityW,'DIY',messageText)
       !
    End If                      !!   nSegments.Ge.1
    !
    If (errorP)                                                                  &
         &        Call pakoMessage(priorityE,severityE,                          &
         &        'Lissajous',' could not plot ')                                !
    !
    Return
    !
  End Subroutine plotLissajous
!!!
!!!
  Subroutine saveLissajous(programName,LINE,commandToSave, iUnit, ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Call pako_message(seve%t,programName,                                        &
         &  " module Lissajous, v 1.2.3 2014-08-28 --> SR: saveLissajous ")      ! trace execution
    !
    ERROR = .False.
    !
    contC = contNN
    !
    Include 'inc/commands/saveCommand.inc'
    !
    doContinue = .True.
    !
    contC = contCC
    !
    Include 'inc/parameters/saveAmplitudeXY.inc'
    !
    Include 'inc/options/saveCenter.inc'
    Include 'inc/options/saveFrequencyXY.inc'
    Include 'inc/options/savePhasesXY.inc'
    Include 'inc/options/saveSystem.inc'
    !
    Include 'inc/options/saveFocus.inc'
    Include 'inc/options/savePointing.inc'
    !
!! TBD    Include 'inc/options/saveReference.inc'
!! TBD    Include 'inc/options/saveTreference.inc'
    !
    If (.Not. vars(iValue)%doTuneSet) Then
       doContinue = .False.
       contC = contCN
    End If
    Include 'inc/options/saveTotf.inc'
    !
    If (vars(iValue)%doTuneSet) Then
       If ( vars(iValue)%doTune) Then
          Include 'inc/options/saveTuneOffsets.inc'
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneTime.inc'
       Else 
          doContinue = .False.
          contC = contCN
          Include 'inc/options/saveTuneOffsets.inc'
       End If
    End If
    !
    Write (iUnit,*) "!"
    !
    Return
  End Subroutine saveLissajous
!!!
!!!
  Subroutine startLissajous(programName,LINE,commandToSave, iUnit, ERROR)
    !
    ! *** Variables ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    !
    Integer                 :: ii
    Character (len=lenCh)   :: valueC
    Character (len=lenLine) :: valueComment
    Character (len=lenLine) :: messageText
    Logical                 :: errorL, errorXML
    !
    Logical                 :: inOtfSubscan
    ! 
    ERROR = .False.
    !
    Call pako_message(seve%t,"paKo",                                             &
         &    " module Lissajous, 1.2.2 2013-02-06 ---> SR: startLissajous ")    ! trace execution
    ! 
    Call pakoXMLsetOutputUnit(iunit=iunit)
    Call pakoXMLsetIndent(iIndent=2)
    !
    Include 'inc/startXML/generalHead.inc'
    !
    Call writeXMLset(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call pakoXMLwriteStartElement("RESOURCE","pakoScript",                       &
         &                         comment="save from pako",                     &
         &                         error=errorXML)                               !
    Call pakoXMLwriteStartElement("DESCRIPTION",                                 &
         &                         doCdata=.True.,                               &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/savePakoScriptFirst.inc'
    !
    Call saveLissajous(programName,LINE,commandToSave, iUnit, errorL)
    !                                                                       
    Call pakoXMLwriteEndElement("DESCRIPTION", error=errorXML)                                             
    Call pakoXMLwriteEndElement("RESOURCE", "pakoScript",error=errorXML)
    !
    Call writeXMLantenna(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLreceiver(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Call writeXMLbackend(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/switchingMode.inc'
    !
    Call writeXMLsource(programName,LINE,commandToSave,iUnit, ERROR)
    !
    Include 'inc/startXML/generalScanHead.inc'
    !
    Include 'inc/startXML/conditions.inc'
    !
    ! **  Observing Mode to XML
    If (gv%doXMLobservingMode) Then
       Call writeXMLLissajous(programName,LINE,commandToSave,                    &
            &         iUnit, ERROR)                                              !
    End If
    !
    ! **  subscan list to XML
    Include 'inc/startXML/LissajousSubscansXML.inc'
    !   
    Include 'inc/startXML/generalTail.inc'
    !
    Return
    !
  End Subroutine startLissajous
!!!
!!!
  Subroutine writeXMLLissajous(programName,LINE,commandToSave,iUnit,ERROR)
    !
    ! *** Variables   ***
    Include 'inc/variables/headerForSaveMethods.inc'
    !
    Integer                 :: ii, iMatch, nMatch
    Character (len=lenCh)   :: valueC, errorCode
    Character (len=lenLine) :: valueComment
    Logical                 :: errorL, errorM, errorXML
    Character (len=lenCh)   :: systemName
    !
    ERROR = .False.
    !
    Call pako_message(seve%t,"paKo",                                             &
         &    " module Lissajous, 1.2.3 2014-10-14 ---> SR: writeXMLLissajous ") ! trace execution
    !
    Call pakoXMLwriteStartElement("RESOURCE","observingMode",                    &
         &                         space ="before",                              &
         &                         error=errorXML)                               !
    !
    valueC = GV%observingMode
    Call pakoXMLwriteElement("PARAM","observingMode",valueC,                     &
         &                         dataType="char",                              &
         &                         error=errorXML)                               !
    !
    Include 'inc/startXML/parametersAmplitudeXY.inc'
    !
    Include 'inc/startXML/optionSystemXML.inc'
    Include 'inc/startXML/optionCenterXML.inc'
    Include 'inc/startXML/optionFrequencyXML.inc'
    Include 'inc/startXML/optionPhaseXML.inc'
    !
    Include 'inc/startXML/optionTotfXML.inc'
    !
    Include 'inc/startXML/optionReferenceXML.inc'
    Include 'inc/startXML/optionTreferenceXML.inc'
    !
    systemName = vars(iValue)%systemName
    If (vars(iValue)%doTune) Then 
       Include 'inc/startXML/optionTuneXML.inc'
       Include 'inc/startXML/optionTtuneXML.inc'
    End If
    !
    If (vars(iValue)%doFocus) Then 
       Include 'inc/startXML/optionFocusXML.inc'
    End If
    !
    Include 'inc/startXML/lissajousAnnotationsXML.inc'
    !
    Call pakoXMLwriteEndElement("RESOURCE","observingMode",                      &
         &                         error=errorXML)                               !
    !
    Return
  End Subroutine writeXMLLissajous
!!!
!!!
End Module modulePakoLissajous

subroutine clic_table(line,error)
  use gildas_def
  use gkernel_interfaces
  use classic_api
  use clic_xypar
  use clic_index
  use clic_rdata
  !---------------------------------------------------------------------
  ! CLIC  Internal routine.
  ! Prepare a UV Table (GILDAS Format)
  ! Command :
  !   TABLE file_name OLD|NEW
  ! 1   /RESAMPLE nchan rchan res VELOCITY|FREQUENCY
  ! 2   /DROP n1 n2
  ! 3   /COMPRESS tmax uvmax
  ! 4   /FREQUENCY name frest
  ! 5   /NOCHECK [SOURCE|POINTING|EPOCH|PHASE|SCAN]
  ! 6   /SCAN Replace w coordinate by scan number.  (set by default  !...)
  ! 7   /FFT  Fourier Transform resampling algorithm
  ! 8   /MOSAIC   Add Phase offsets, without checking POINTING & PHASE
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: mfvoc, mfilvoc, nkey, mshavoc, mchavoc, nk
  parameter (mfvoc=2, mfilvoc=2, mshavoc=4, mchavoc=5)
  logical :: lcheck(mchavoc)
  integer :: tnchan, ndrop(2), nvis, nvisi, nfl, new_scans(m_cx),  nchan
  integer :: new_dates(m_cx), n_new
  integer(kind=address_length) :: ipk, ipkc, ipkl
  integer(kind=address_length) :: ipkt, addr,  data_in, ip_data, kin
  integer(kind=data_length)    :: ldata_in, h_offset, c_offset, l_offset
  integer :: ir, ib, kr
  integer :: n_vis, nout, isb, isb1, isb2, narg, is, nch, nd1, nd2, ni
  integer :: ifirst, ilast, i, j, k, i1, i2, iw, nchannels, nbc
  integer :: isub, inbc, inbc1, inbc2, ninput, savenbc(mnbb)
  integer :: lsub_nbc(mnbb), isub_nbc(mnbb,mrlband),n_visi(mnbb)
  integer :: lsubb_out_saved, isubb_out_saved(mrlband), isid_auto(mnbb)
  integer :: iwin(mrlband), iov(mrlband), jov(mrlband), kov, nov, iwi, jwi
  integer :: imin(mnbb,2*(mwin_out+mrlband)), ismin
  integer :: imax(mnbb,2*(mwin_out+mrlband)), ismax
  logical :: myend, ok, down_baseline, good, flagged, positions
  logical :: append, compr, frequency, warning, warned
  logical :: check, scan, noloop, resample, fft, skip, initialized
  logical :: do_select, first, overlap, counting, newinput
  integer :: found_unit, sbout
  real :: trchan, tfres, tvres, tvoff
  real :: uv_max, time_max, width, bandwidth(mnbb), gain(mnbb)
  real :: fmin(mnbb,2*(mwin_out+mrlband)), fmini
  real :: fmax(mnbb,2*(mwin_out+mrlband)), fmaxi
  real(8) :: newfreq, tfoff, clight, ff, f1, fn, fr, fs
  character(len=256) :: chain
  character(len=12) :: key, fvoc(mfvoc), filvoc(mfilvoc)
  character(len=12) :: shavoc(mshavoc), chavoc(mchavoc)
  character(len=12) :: newname, shape
  character(len=13) :: xch, ych
  parameter (clight=299792.458d0)
  !
  ! test coordinates to specific precision ..
  real(8), parameter :: sec=pi/180D0/3600.D0
  real(8) :: coo_test=0.01d0*sec
  real(8) :: fre_test=1d-7
  real(8) :: point_check=0.05d0*sec
  real(8) :: phase_check=0.005d0*sec
  logical :: setup=.true.
  character(len=10) :: strnam
  !
  integer :: o_vis
  integer :: ier
  real, allocatable :: dima(:,:)
  !
  data shavoc/'TBOX','TPARABOLA','FBOX','FTRIANGLE'/
  data fvoc/'FREQUENCY','VELOCITY'/
  data filvoc/'NEW','OLD'/
  data chavoc/'SOURCE','POINTING','PHASE','EPOCH','SCAN'/
  !
  ! Only FILE should be saved ?
  character(len=256), save :: file=' '
  integer, save :: file_uv_version
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  if (setup) then
     strnam = 'TOLERANCE%'
     call sic_defstructure(strnam,.true.,error)
     call sic_def_dble(strnam//'POINT',point_check,0,0,.false.,error)
     call sic_def_dble(strnam//'PHASE',phase_check,0,0,.false.,error)
     call sic_def_dble(strnam//'COORDINATES',coo_test,0,0,.false.,error)
     call sic_def_dble(strnam//'FREQUENCY',fre_test,0,0,.false.,error)
     setup = .false.
  endif
  !
!  if (.not.new_receivers) then
!     call message(6,3, 'TABLE',   &
!          'This version does not process old data')
!     error = .true.
!     return
!  endif
  !
  ! Verify if any input file
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  do i=1,mchavoc
     lcheck(i) = .true.
  enddo
  check = .not.sic_present(5,0)
  if (.not.check) then
     do i=1,sic_narg(5)
        call clic_kw (line,5,i,key,nkey,chavoc,mchavoc,   &
             .false.,error,.true.)
        lcheck(nkey) = .false.
        check = .true.
     enddo
  endif
  !      scan = sic_present(6,0)
  scan = .true.
  resample = .false.
  fft = sic_present(7,0)
  !
  positions = sic_present(8,0)
  !
  ! Decode Command Line ----------------------------------------------------
  ! Get file name
  if (sic_present(0,1)) then
     file = ' '  ! Reset file name to protect against errors
     ! New name
     call sic_ch (line,0,1,chain,narg,.true.,error)
     if (error) return
     call sic_parsef(chain,file,' ','.uvt')
     key = 'OLD'
     call clic_kw (line,0,2,key,nkey,filvoc,mfilvoc,.false.,error,.true.)
     if (error) return
     if (key.eq.'NEW') then
        append = .false.
        initialized = .false.
       ! A new table will be created in X image: initialize
       call gildas_null(xima, type = 'UVT')
     elseif (key.eq.'OLD') then
        append = .true.
        call gildas_null(xima, type = 'UVT')
        ! this puts the table header in X and Y buffers.
          !!Print *,'Calling NEWUVT_OPEN '
        call newuvt_open(xima,file,file_uv_version,error)
        if (error) return
        ! Copy to Y buffer (Y buffer is used when reading scan headers and comparing to X)
        call gdf_copy_header(xima,yima,error)
        call newuvt_close (xima) ! Free the image slot, as newuvt_extend will be called
     endif
  elseif (len_trim(file).ne.0) then
     ! No name, use current table
     append = .true.
     ! No "call gildas_null(xima)" here, since its header has to be
     ! remembered from one call to another.
     ! But one need to convert the header in the correct version
     ! CLIC is working in this version of the header
     call gdf_uv_doppler(xima,code_version_uvt_freq)
  else
     ! No name, no current image
     call message(6,3, 'TABLE','No table to append to ...')
     error = .true.
     return
  endif
  n_vis = 0
  warned = .false.
  !
  ! Target sampling : /RESAMPLE
  tnchan = 0
  trchan = 0
  tfres = 0.
  tvres = 0.
  tfoff = 0.
  tvoff = 0.
  shape = 'TPAR'
  width = 1
  if (sic_present(1,0)) then
     if (append) then
        call message(8,2,'TABLE','OLD Table: /RESAMPLE ignored')
     else
        call sic_i4(line,1,1,tnchan,.true.,error)
        if (error) return
        call sic_r4(line,1,2,trchan,.false.,error)
        if (error) return
        key = 'FREQUENCY'
        call clic_kw(line,1,5,key,nkey,fvoc,mfvoc,.false.,error,.true.)
        if (error) return
        if (key.eq.'FREQUENCY') then
           call sic_r8(line,1,3,tfoff,.false.,error)
           call sic_r4(line,1,4,tfres,.false.,error)
        elseif (key.eq.'VELOCITY') then
           call sic_r4(line,1,3,tvoff,.false.,error)
           call sic_r4(line,1,4,tvres,.false.,error)
        endif
        if (error) return
        call clic_kw(line,1,6,shape,nk,shavoc,mshavoc,.false.,error,.true.)
        if (error) return
        call sic_r4(line,1,7,width,.false.,error)
        if (error) return
        resample = .true.
     endif
  endif
  ndrop(1) = 0
  ndrop(2) = 0
  !
  ! Drop end channels (2)
  if (sic_present(2,0)) then
     call sic_i4(line,2,1,ndrop(1),.true.,error)
     call sic_i4(line,2,2,ndrop(2),.false.,error)
     if (error) return
  endif
  !
  ! Compress option (3)
  compr = sic_present(3,0)
  if (compr) then
     time_max = 60.
     uv_max = 7.5
     call sic_r4(line,3,1,time_max,.false.,error)
     call sic_r4(line,3,2,uv_max,.false.,error)
     if (error) return
  endif
  !
  ! Frequency option (4)
  frequency = sic_present(4,0)
  if (frequency) then
     if (append) then
        call message(8,2,'TABLE','OLD Table: /FREQUENCY ignored')
        newfreq = 0
     else
        call sic_ch(line,4,1,newname,narg,.true.,error)
        call sic_r8(line,4,2,newfreq,.true.,error)
        if (error) return
     endif
  else
     newfreq = 0
  endif
  ! -------------------------------------------------------------------------
  ! First loop on current index to check consistency
  n_new = 0
  myend = .false.
  call get_first(.false.,error)
  if (error) return
  !
  ! Check if data can be gotten
  call get_data (ldata_in,data_in,error)
  if (error) return
  !
  ! Select ALL - default are spectral bands
  if (all_select) then
     if (.not.widex_select) then
       if (r_nband_widex.ne.0) then
          call message(6,4,'CLIC_TABLE', &
                'Selecting ALL is not allowed with WIDEX units')
          error = .true.
          return
       endif
       lsubb_out = max(1,r_lband)
       do is=1, lsubb_out
          isubb_out(is) = is+mbands
       enddo
     else
       lsubb_out = 0
       do is = 1, r_lband
         if (r_iunit(is).ge.9) then
           lsubb_out =  lsubb_out + 1
           isubb_out(lsubb_out) = is+mbands
           found_unit = r_iunit(is)-8
           write (chain,'(a,i1,a)') 'Selecting widex unit ',found_unit, &
               ': it is logical unit '//csub(isubb_out(lsubb_out))
           call message(6,1,'CLIC_TABLE',chain(1:lenc(chain)))
         endif
       enddo
     endif
     do_select = .true.
  else
     do_select = .false.
  endif
  !
  ! No loop on records if spectral bands are to be written OR if scan average
  noloop = (isubb_out(1).gt.mbands) .or. (i_average.eq.1)
  !
  ! cut_header updates the Y image in the loop hereafter: initialize it
  ! (only once, out of the loop for efficiency reasons)
  call gildas_null(yima, type = 'UVT')
  !
  first = .true.
  do while (.not.myend)
     !
     ! Check spectral setup
     call check_units(first,error)
     if (error) return
     if (frequency) then
        call vel_scale_2 (newname,newfreq)
     endif
     ! Cut_header update the Y buffer according to scan header,
     ! in order to compare it with the Y buffer corresponding to the current Table.
     call cut_header (ndrop,newfreq,positions,error)
     if (error) return
     !
     ! We use the first scan header to initialise the table header,
     ! if not in append mode.
     if (.not.append .and. .not.initialized) then
        call gdf_copy_header(yima,xima,error)
        ! We use the line command optional parameters, if any.
        ! 7 daps + (real, imag, weight)*nchannels
        if (tnchan .ne. 0) then
            !!Print *,'Setting number of channels ',tnchan
           xima%gil%nchan = tnchan
           xima%gil%dim(1) = 3*tnchan+7
           xima%gil%fcol = 8
           xima%gil%lcol = xima%gil%dim(1)
           if (positions) then
             ! Add offset positions at the end of each visibility
             xima%gil%dim(1) = xima%gil%dim(1)+2
           endif
           if (trchan .ne. 0) then
              xima%gil%ref(1) = trchan
           else
              xima%gil%ref(1) = xima%gil%ref(1) + nint(0.5*(tnchan+1)-xima%gil%ref(1))
           endif
           !           
           ! fres,vres in the source frame, inc(1) in the topocentric frame
           if (tfres .ne. 0) then
              xima%gil%inc(1) = tfres*xima%gil%val(1)/xima%gil%freq
              xima%gil%vres = -tfres*clight/xima%gil%freq
              xima%gil%fres = tfres
           elseif (tvres .ne. 0) then
              xima%gil%vres = tvres
              xima%gil%inc(1) = -tvres*xima%gil%val(1)/clight
              xima%gil%fres = - tvres*xima%gil%freq/clight
           endif
           ! Make velocity or frequency  change possible :
           if (tvoff.ne.0) then
              xima%gil%voff = tvoff
           elseif (tfoff.ne.0) then
              tvoff = xima%gil%voff-tfoff/xima%gil%freq*clight
              xima%gil%voff = tvoff
           endif
           ! or even frequency offset ...
        else
          Print *,'TNCHAN is 0'
        endif
        xima%gil%vtyp = r_typev ! Velocity referential
        !
        ! Define the primary beam size
        xima%gil%majo = 56.0*(90.0e3/xima%gil%freq)
        print *,'I-CLIC,  Primary beam size ',xima%gil%majo,'"'
        xima%gil%majo = xima%gil%majo*pi/180.0/3600.0
        !
        ok = .true.
        warning = .false.
        warned = .false.
        initialized = .true.
     else
        ! Append to an existing table (X) - check consistency
        warning = .false.
        ok =   &
             yima%gil%epoc .eq. xima%gil%epoc   &
             .and. (abs(yima%gil%ra-xima%gil%ra).lt.coo_test)   &
             .and. (abs(yima%gil%dec-xima%gil%dec).lt.coo_test)   &
             .and. (abs(yima%gil%a0-xima%gil%a0).lt.coo_test)   &
             .and. (abs(yima%gil%d0-xima%gil%d0).lt.coo_test)   &
             .and. (yima%gil%version_uv.eq.xima%gil%version_uv)
        nchan = max(xima%gil%nchan,int(abs(xima%gil%ref(1))))
        warning = warning   &
             .or. abs(yima%gil%freq-xima%gil%freq).gt.fre_test*xima%gil%freq   &
             .or. abs(yima%gil%fres-xima%gil%fres)*nchan.gt.0.1   &
             .or. yima%gil%dim(1) .ne. xima%gil%dim(1)   &
             .or. abs(yima%gil%ref(1)-xima%gil%ref(1)).gt.fre_test*xima%gil%freq/yima%gil%fres
        ! force resampling for multiple line subbands.
        warning = warning .or.   &
             (lsubb_out.gt.1) .and. (isubb_out(1).gt.mbands)
     endif
     !
     ! First check for inconsistent headers : This is an error.
     !
     if (check .and. .not. ok) then
        if (lcheck(1) .and. yima%char%name .ne. xima%char%name) then
           write(6,*) 'Source :',yima%char%name, xima%char%name
           error = .true.
        endif
        if (lcheck(4) .and. yima%gil%epoc .ne. xima%gil%epoc) then
           write(6,*) 'Epoch :',yima%gil%epoc, xima%gil%epoc
           error = .true.
        endif
        if (lcheck(2) .and. abs(yima%gil%ra-xima%gil%ra).gt.point_check) then
           call sexag(xch,xima%gil%ra,24)
           call sexag(ych,yima%gil%ra,24)
           write(6,*) 'Pointing RA :',ych,xch
           error = .true.
        endif
        if (lcheck(2) .and. abs(yima%gil%dec-xima%gil%dec).gt.point_check) then
           call sexag(xch,xima%gil%dec,360)
           call sexag(ych,yima%gil%dec,360)
           write(6,*) 'Pointing DEC :',ych,xch
           error = .true.
        endif
        if (lcheck(3) .and. abs(yima%gil%a0-xima%gil%a0).gt.phase_check) then
           call sexag(xch,xima%gil%a0,24)
           call sexag(ych,yima%gil%a0,24)
           write(6,*) 'Phase A0 :',ych,xch,abs(xima%gil%a0-yima%gil%a0)/sec
           error = .true.
        endif
        if (lcheck(3) .and. abs(yima%gil%d0-xima%gil%d0).gt.phase_check) then
           call sexag(xch,xima%gil%d0,360)
           call sexag(ych,yima%gil%d0,360)
           write(6,*) 'Phase D0 :',ych,xch,abs(xima%gil%d0-yima%gil%d0)/sec
           error = .true.
        endif
        if (yima%gil%version_uv.ne.xima%gil%version_uv) then
           write(6,*) 'Version UVT :',xima%gil%version_uv/10.0,  &
                       yima%gil%version_uv/10.0
           error = .true.
        endif
        if (error) then
           write (chain,'(A,I5,A,I5)')   &
                'Inconsistent observation set, obs. # ',r_num,   &
                ' Scan ',r_scan
           call message(6,3,'TABLE',chain(1:lenc(chain)))
           return
        endif
     endif
     !
     ! Warning if different frequency parameters, which must force resampling.
     !
     if (warning .and. .not.warned) then
        resample = .true.
        write (chain,'(A,I5,A,I5)')   &
             'Spectrum resampling is needed, obs. # ',r_num,   &
             ' Scan ',r_scan
        call message(6,2,'TABLE',chain(1:lenc(chain)))
        if (yima%gil%freq.ne. xima%gil%freq) then
           write(chain,*) 'Rest frequencies :',yima%gil%freq,   &
                xima%gil%freq
           call message(6,2,'TABLE',chain(1:lenc(chain)))
        endif
        if (yima%gil%voff.ne. xima%gil%voff) then
           write(chain,*) 'Velocities :',yima%gil%voff,   &
                xima%gil%voff
           call message(6,2,'TABLE',chain(1:lenc(chain)))
        endif
        if (yima%gil%fres .ne. xima%gil%fres) then
           write(chain,*) 'Frequency resolutions :',yima%gil%fres,   &
                xima%gil%fres
           call message(6,2,'TABLE',chain(1:lenc(chain)))
        endif
        if (yima%gil%ref(1) .ne. xima%gil%ref(1)) then
           write(chain,*) 'Reference channels :',yima%gil%ref(1),   &
                xima%gil%ref(1)
           call message(6,2,'TABLE',chain(1:lenc(chain)))
        endif
        warned = .true.
        if (yima%gil%dim(1) .ne. xima%gil%dim(1)) then
           ! yima%gil%dim = current data
           ! xima%gil%dim = existing table
           if ((positions).and.(yima%gil%dim(1).eq.(xima%gil%dim(1)+2))) then
              write(chain,*) 'Option /POSITIONS cannot be used to write in this table'
              call message(6,2,'TABLE',chain(1:lenc(chain)))
              error = .true.
              return
           endif
           if ((.not.positions).and.(xima%gil%dim(1).eq.(yima%gil%dim(1)+2))) then
              write(chain,*) 'Option /POSITIONS must be used to write in this table'
              call message(6,2,'TABLE',chain(1:lenc(chain)))
              error = .true.
              return
           endif
           write(chain,*) 'Number of channels :',(yima%gil%dim(1)-7)/3,   &
                (xima%gil%dim(1)-7)/3
           call message(6,2,'TABLE',chain(1:lenc(chain)))
           warned = .true.
        endif
     endif
     if (noloop) then
        n_vis = n_vis + r_nbas
     else
        n_vis = n_vis + r_ndump*r_nbas
     endif
     if (sic_ctrlc()) then
        error = .true.
        goto 200
     endif
     n_new = n_new+1
     new_scans(n_new) = r_scan
     new_dates(n_new) = r_dobs
     call get_next(myend,error)
     if (error) return
     first = .false.
  enddo
  !
  ! Determines receiver tuning for each narrow input
  do j = 1, mnbb
     gain(j) = 0.
     do i = 1, r_nant
        gain(j) = max(gain(j),r_gim(j,i))
     enddo
  enddo
  !
  ! Automatic receiver tuning determination per narrow.
  if (isideb_out.eq.4 .and. cont_select) then
     do j = 1, mnbb
        isid_auto(j) = 1 ! Default is USB
        if (gain(j).lt.0.1) then
           isid_auto(j) = (3-r_isb)/2
           n_visi(j) = 1
        else
           isid_auto(j) = 3
           n_visi(j) = 2
        endif
     enddo
  elseif (isideb_out.eq.3.and.cont_select) then
     do i = 1, mnbb
        n_visi(i) = 2
     enddo
  else
     do i = 1, mnbb
        n_visi(i) = 1
     enddo
  endif
  !
  ! Automatic sideband determination
  if (isideb_out.ge.3.and..not.cont_select) then
     do j = 1, mnbb
        isid_auto(j) = 3
     enddo
  endif
  !
  ! Select all: refne the choice of subbands, depending on the
  ! table spectral parameters.
  if (all_select .and. .not.cont_select) then
     lsubb_out=0
     do is = 1, r_lband
        nch = r_lnch(is)
        nd1 = max(ndrop(1),nint(fdrop(1)*nch))
        nd2 = max(ndrop(2),nint(fdrop(2)*nch))
        ok = .false.
        if (abs(xima%gil%fres).ge.abs(r_lrfres(1,is))) then
           do isb=1,2
              ff = r_lrfoff(isb,is)-xima%gil%freq   &
                   -(r_lvoff(isb,is)-xima%gil%voff)/299792.d0*xima%gil%freq
              f1 = ff+(nd1+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
              fn = ff+(nch-nd2+0.5-r_lrch(isb,is))*r_lrfres(isb,is)
              if (r_lrfres(isb,is)*xima%gil%fres.gt.0) then
                 ifirst = nint(f1/xima%gil%fres+xima%gil%ref(1))
                 ilast  = nint(fn/xima%gil%fres+xima%gil%ref(1))
              else
                 ilast = nint(f1/xima%gil%fres+xima%gil%ref(1))
                 ifirst  = nint(fn/xima%gil%fres+xima%gil%ref(1))
              endif
              ok = ok .or.   &
                   ((ilast.ge.1) .and. (ifirst.le.(xima%gil%dim(1)-7)/3))
           enddo
        endif
        if (widex_select) ok = r_iunit(is).ge.9
        if (ok) then
           lsubb_out = lsubb_out + 1
           isubb_out(lsubb_out) = is+mbands
        endif
     enddo
     if (lsubb_out.gt.0) then
        write(chain,*) (csub(isubb_out(is))//' ',is=1,lsubb_out)
        call message(6,1,'TABLE','Using '//chain(1:lenc(chain)))
     else
        call message(8,3,'TABLE','No matching subband')
        error = .true.
        return
     endif
  endif
  !
  ! How many quarters in observations
  ! ... and continuum effective bandwith
  !
  if (cont_select) then
     first = .true.
     ninput = 0
     do inbc = 1,mnbb
        iwin(inbc) = 0
     enddo
     fmini = 1e6
     fmaxi = 0.
     if(isideb_out.eq.3) then
        isb = 1
     else
        isb = isideb_out
     endif
     do isub = 1,lsubb_out
        i = isubb_out(isub)
        if (i.gt.mbands) then
           is = i-mbands
        else
           is = i
        endif
        if (r_lpolmode(is).ne.1) then
           return
        endif
        nbc = r_bb(is)
        if (isideb_out.gt.3) then
           if (isid_auto(nbc).eq.3) then
              isb = 1
           else
              isb = isid_auto(nbc)
           endif
        endif
        if (cont_select) then
           if (i.gt.mbands) then
              nch = r_lnch(is)
              nd1 = max(ndrop(1),nint(fdrop(1)*nch))+1
              nd2 = nch-max(ndrop(2),nint(fdrop(2)*nch))
              ni = nch-nd1-nd2
              f1 = r_lfcen(is)+r_lfres(is)*(1+nd1-r_lcench(is))
              counting = .false.
              !
              ! Avoid Gibbs-affected channels:
              if (ngibbs.gt.0.and.abs(r_lfres(is)).gt.0.1 &
     &              .and.r_lnch(is).le.1000) then
                 i1 = nch/2-ngibbs
                 i2 = nch/2+ngibbs+1
              else
                 i1 = nch/2
                 i2 = i1+1
              endif
              do j = nd1, nd2
                 fr = r_lfcen(is)+r_lfres(is)*(j-r_lcench(is))
                 fs = r_lrfoff(isb,is)   &
                      +(j-r_lrch(isb,is))*r_lrfres(isb,is)
                 if (nwin_out.gt.0) then
                    ok = .false.
                    do iw = 1, nwin_out
                       ok = ok .or. (fs.gt.window_out(1,iw).and.   &
                            fs.le.window_out(2,iw))
                    enddo
                 else
                    ok = .true.
                 endif
                 ok = ok .and. (j.le.i1 .or. j.ge.i2)
                 !
                 ! Split corr. unit if continuum windows
                 if (.not.ok) then
                    if (counting) then
                       fn = fr
                       iwin(nbc) = iwin(nbc)+1
                       if (f1.lt.fn) then
                          fmin(nbc,iwin(nbc)) = f1
                          fmax(nbc,iwin(nbc)) = fn
                       else
                          fmin(nbc,iwin(nbc)) = fn
                          fmax(nbc,iwin(nbc)) = f1
                       endif
                       imin(nbc,iwin(nbc)) = is
                       imax(nbc,iwin(nbc)) = is
                       counting = .false.
                       call check_window(fmin,fmax,imin,imax,nbc,iwin(nbc))
                    endif
                 else
                    if (.not.counting) then
                       f1 = fr
                       counting = .true.
                    endif
                 endif
              enddo
              if (counting) then
                 fn = r_lfcen(is)+r_lfres(is)*(nch-nd2-r_lcench(is))
                 fn = fr
                 iwin(nbc) = iwin(nbc)+1
                 if (f1.lt.fn) then
                    fmin(nbc,iwin(nbc)) = f1
                    fmax(nbc,iwin(nbc)) = fn
                 else
                    fmin(nbc,iwin(nbc)) = fn
                    fmax(nbc,iwin(nbc)) = f1
                 endif
                 imin(nbc,iwin(nbc)) = is
                 imax(nbc,iwin(nbc)) = is
                 call check_window(fmin,fmax,imin,imax,nbc,iwin(nbc))
              endif
           else
              iwin(nbc) = iwin(nbc)+1
              f1 = r_cfcen(is)-r_cfwid(is)/2.
              fn = r_cfcen(is)+r_cfwid(is)/2.
              if (f1.lt.fn) then
                 fmin(nbc,iwin(nbc)) = f1
                 fmax(nbc,iwin(nbc)) = fn
              else
                 fmin(nbc,iwin(nbc)) = fn
                 fmax(nbc,iwin(nbc)) = f1
              endif
              imin(nbc,iwin(nbc)) = is
              imax(nbc,iwin(nbc)) = is
              call check_window(fmin,fmax,imin,imax,nbc,iwin(nbc))
           endif
        endif
        if (first) then
           if (nbc.ne.0) then
              ninput = 1
              savenbc(ninput) = nbc
              first = .false.
           endif
        endif
        newinput = .true.
        do inbc =1, ninput
           if (nbc.eq.savenbc(inbc).and.nbc.ne.0) newinput = .false.
        enddo
        if (newinput) then
           ninput = ninput+1
           savenbc(ninput) = nbc
        endif
     enddo
     if (cont_select) then
        do inbc = 1, mnbb
           bandwidth(inbc) = 0
        enddo
        do inbc = 1, ninput
           print *,"----------"
           if (ninput.eq.1) then
              i = isubb_out(1)
              if (i.gt.mbands) i = i-mbands
              if (r_lpolmode(i).ne.1) then
                 return
              endif
              nbc = r_bb(i)
           else
              nbc = inbc
           endif
           nbc = savenbc(inbc)
           print *,"Spectral windows for input ",nbc
           do iwi = 1, iwin(nbc)
              print *,"Window # ",iwi,": fmin ",fmin(nbc,iwi),", fmax ",fmax(nbc,iwi)
              bandwidth(nbc) = bandwidth(nbc)+(fmax(nbc,iwi)-fmin(nbc,iwi))
              ismin = imin(nbc,iwi)
              ismax = imax(nbc,iwi)
              if (isideb_out.lt.3) then
                 fmini = min(fmini, &
                      r_flo1 + (3-2*isideb_out)* (r_flo2(ismin)   &
                      + r_band2(ismin)  * (r_flo2bis(ismin)   &
                      + r_band2bis(ismin)* fmin(nbc,iwi))), &
                      r_flo1 + (3-2*isideb_out)* (r_flo2(ismax)   &
                      + r_band2(ismax) * (r_flo2bis(ismax)   &
                      + r_band2bis(ismax)* fmax(nbc,iwi))))
                 fmaxi = max(fmaxi, &
                      r_flo1 + (3-2*isideb_out)* (r_flo2(ismin)   &
                      + r_band2(ismin) * (r_flo2bis(ismin)   &
                      + r_band2bis(ismin)* fmin(nbc,iwi))), &
                      r_flo1 + (3-2*isideb_out)* (r_flo2(ismax)   &
                      + r_band2(ismax) * (r_flo2bis(ismax)   &
                      + r_band2bis(ismax)* fmax(nbc,iwi))))
              elseif (isideb_out.gt.3) then
                 if (isid_auto(inbc).lt.3) then
                    fmini = min(fmini, &
                         r_flo1 + (3-2*isid_auto(inbc))* (r_flo2(ismin)   &
                         + r_band2(ismin) * (r_flo2bis(ismin)   &
                         + r_band2bis(ismin)* fmin(nbc,iwi))), &
                         r_flo1 + (3-2*isid_auto(inbc))* (r_flo2(ismax)   &
                         + r_band2(ismax) * (r_flo2bis(ismax)   &
                         + r_band2bis(ismax)* fmax(nbc,iwi))))
                    fmaxi = max(fmaxi, &
                         r_flo1 + (3-2*isid_auto(inbc))* (r_flo2(ismin)   &
                         + r_band2(ismin) * (r_flo2bis(ismin)   &
                         + r_band2bis(ismin)* fmin(nbc,iwi))), &
                         r_flo1 + (3-2*isid_auto(inbc))* (r_flo2(ismax)   &
                         + r_band2(ismax) * (r_flo2bis(ismax)   &
                         + r_band2bis(ismax)* fmax(nbc,iwi))))
                 endif
              else
                 fmini = 0
                 fmaxi = 1e6
              endif
           enddo
           if (freq_out.eq.0.and..not.append) then
              if (isideb_out.lt.3) then
                 xima%gil%val(1) = (fmaxi+fmini)/2
              elseif (isideb_out.gt.3.and.(fmaxi-fmini).lt.9e5) then
                 xima%gil%val(1) = (fmaxi+fmini)/2
              else
                 xima%gil%val(1) = r_flo1
              endif
           endif
           print *,"Effective bandwith :",bandwidth(nbc)
           if (isideb_out.eq.3.and.gain(inbc).lt.0.1) then
              call message (6,2,'TABLE','DSB selected but SSB receiver tuning')
              write (chain,'(A,I1,A,F5.3)')   &
                 'Narrow input ',nbc,' has a maximum rejection of ',gain(nbc)
              call message (6,2,'TABLE',chain(1:lenc(chain)))
           endif
        enddo
        print *,"----------"
     endif
     !
     nvisi = 0
     if (cont_select.and..not.append) xima%gil%fres = 0
     do inbc = 1, ninput
        nvisi = nvisi+ n_visi(savenbc(inbc))
        if (cont_select.and..not.append) then
           xima%gil%fres = xima%gil%fres + bandwidth(savenbc(inbc))
        endif
     enddo
     n_vis = n_vis * nvisi
     if (cont_select.and..not.append) then
        xima%gil%fres = xima%gil%fres/ninput
        xima%gil%vres = xima%gil%fres/xima%gil%val(1)*299792.458d0
        xima%gil%freq = xima%gil%val(1)/(1.d0+r_doppl)
     endif
  else
    ninput = 1
  endif
  if (.not.cont_select) n_vis = n_vis * n_visi(1)
  call message(6,1,'TABLE',   &
       'Table parameters for '//trim(file)//':')
  write(chain,'(A,A12,2(A,F12.3))')   &
       'X_LINE = ',xima%char%line ,' X_FREQ = ',xima%gil%freq,' X_VAL1 = ',xima%gil%val(1)
  call message(6,1,'TABLE',chain(1:lenc(chain)))
  write(chain,'(3(A,F12.3))')  'X_FRES = ',xima%gil%fres,   &
       ' X_VRES = ',xima%gil%vres,' X_VOFF = ',xima%gil%voff
  call message(6,1,'TABLE',chain(1:lenc(chain)))
  write(chain,'(A,I12,A,F12.4,A)')   &
       ' NCHAN = ',xima%gil%nchan ,' X_REF1 = ',xima%gil%ref(1)
  call message(6,1,'TABLE',chain(1:lenc(chain)))
  !
  ! Create new file or append to existing one
  if (append) then
    !!Print *,'Calling newuvt_extend'
    call newuvt_extend(xima,file,n_vis,n_new,new_dates,new_scans,   &
          error,lcheck(5))
    if (error) return
    o_vis = xima%gil%nvisi
    !!Print *,'FCOL ', xima%gil%fcol , xima%gil%lcol
  else
    !!Print *,'Calling NEWUVT_INIT '
    call newuvt_init(xima,file,n_vis,scan, positions, error)
    o_vis = 0
    call gdf_copy_header(xima,yima,error)
  endif
  !
  ! Here, allocate the data space, only new region
  allocate (dima(xima%gil%dim(1),n_vis), stat=ier)
  dima = 0.0
  !
  ! Loop on current index to write the visibilities
  myend = .false.
  nfl = 0
  call get_first(.false.,error)
  if (error) goto 98
  nvis = 0
  skip = .false.
  do while (.not.myend)
     if (frequency) then
        call vel_scale_2 (newname,newfreq)
     endif
     call get_data (ldata_in,data_in,error)
     if (error) goto 98
     call check_cal(skip)
     if (skip) then
        skip = .false.
        goto 180
     endif
     if (do_pass) then
        call set_pass (r_nsb,r_nband,r_nbas+r_ntri,   &
             r_lntch, passc, passl, error)
        if (error) goto 98
     endif
     call set_corr(error)
     ! Optionnally compress the data
     if (compr) then
        ip_data = gag_pointer(data_in,memory)
        call compress(time_max, uv_max, memory(ip_data),nout,error)
        if (error) goto 98
        r_ndump = nout
        call loose_data
     endif
     !
     noloop = .false.
     kin = gag_pointer(data_in, memory)
     do ir = 1, r_ndump
        ! Read only the average record if needed
        if (noloop) goto 180
        noloop = (isubb_out(1).gt.mbands) .or. (i_average.eq.1)
        ! Note: take the data header from uncorrected data.
        if (noloop) then
           call spectral_dump(kr,0,0)
        else
           kr = ir
        endif
        ipk = kin+ h_offset(kr)
        call decode_header (memory(ipk))
        call set_scaling(error)
        if (error) return
        flagged = .false.
        if (isideb_out.le.2) then
           isb1 = isideb_out
           isb2 = isideb_out
        elseif (isideb_out.ge.3) then
           if (cont_select) then
              isb1 = 1
              isb2 = 2
              ! fnd the good sideband if declared LINE DSB
           else
              sbout = 0
              do is = 1, lsubb_out
                if (isubb_out(is).gt.mbands) i = isubb_out(is) - mbands
                if (sbout.eq.0) then
                  sbout = r_sb(i)
                elseif (r_sb(i).ne.sbout) then
                  call message(6,3,'CLIC_TABLE', &
                            'Cannot mix sidebands in LINE mode')
                  error= .true.
                  return
                endif
              enddo
              isb1 = (3-sbout)/2
              isb2 = isb1
           endif
        endif
        !
        ! Writes a visibility for each different "input" for continuum
        if (cont_select) then
           do inbc = 1, mnbb
              lsub_nbc(inbc) = 0
           enddo
           do is = 1, lsubb_out
              isub = isubb_out(is)
              i = isub
              if (isub.gt.mbands) i = isub - mbands
              if (r_lpolmode(i).eq.1) then
                 inbc = r_bb(i)
                 lsub_nbc(inbc) = lsub_nbc(inbc) + 1
                 isub_nbc(inbc,lsub_nbc(inbc)) = isub
              endif
           enddo
        else
           inbc1 = 1
           inbc2 = inbc1
        endif
        !
        do ib = 1, r_nbas
           if (.not.down_baseline(ib)) then
              ! Take corrected or uncorrected
              if (noloop) then
                 call spectral_dump(kr,0,ib)
                 ipkl = kin + l_offset(kr)
              else
                 kr = ir
                 ipkl = kin + l_offset(r_ndump+1)   ! dummy
              endif
              ipkc = kin + c_offset(kr)
              do isb = isb1, isb2
                 if (ninput.gt.1) then
                    lsubb_out_saved = lsubb_out
                    do is = 1, lsubb_out
                       isubb_out_saved(is) = isubb_out(is)
                    enddo
                 endif
                 do inbc = 1, ninput
                    if (cont_select) then
                       nbc = savenbc(inbc)
                    else
                       nbc = 1
                    endif
                    if (isideb_out.le.3.or.isid_auto(inbc).eq.3.or.isid_auto(inbc).eq.isb) then
                       if (ninput.gt.1) then
                          lsubb_out = lsub_nbc(nbc)
                          do is = 1, lsubb_out
                             isubb_out(is) = isub_nbc(nbc,is)
                          enddo
                       endif
                       nchannels = xima%gil%nchan
                       ! NVIS is used to increment
           !!Print *,'Calling newuvt_addvisi ',nvis, nchannels
                       call newuvt_addvisi (xima,dima(1,nvis+1), r_nsb, r_nband, r_nbas, r_lntch,   &
                          nchannels, ib, isb, nbc, xima%gil%val(1), bandwidth(nbc),  &
                          memory(ipkc), memory(ipkl), passc, passl, ndrop, good, &
                          scan, width, shape, resample, fft, positions, error)
                       if (error) goto 98
                       if (good) then
                          nvis = nvis + 1
                       else
                          flagged = .true.
                       endif
                    endif
                    if (ninput.gt.1) then
                       lsubb_out = lsubb_out_saved
                       do is = 1, lsubb_out
                          isubb_out(is) = isubb_out_saved(is)
                       enddo
                    endif
                 enddo
              enddo
           else
              flagged = .true.
           endif
        enddo
        if (flagged) nfl = nfl + 1
     enddo
     ! End of scan
180  if (sic_ctrlc()) goto 98
     if (nfl.ne.0) then
        write(chain,'(I6,A)') nfl,' records flagged or unused'
        call message(4,2,'TABLE',chain(1:lenc(chain)))
        nfl = 0
     endif
     call get_next(myend,error)
     if (error) goto 98
  enddo
  !
  ! The table is now fnished
  write(chain,'(I6,A,I6,A)') nvis,   &
       ' visibilities written (out of ',n_vis,' possible)'
  call message(6,1,'TABLE', chain(1:lenc(chain)))
  call gdf_write_data (xima, dima, error)
  !!Print *,'Calling newuvt_cut ',nvis
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis+o_vis,file_uv_version,error)
!
200 continue
  deallocate (dima, stat=ier)
  !!Print *,'Done deallocation '
  call newuvt_close(xima)
  return
  ! Error return
98 continue
  deallocate (dima, stat=ier)
  if (.not.append) then
    ! Write a new file with current header version
    call gdf_get_uvt_version(file_uv_version)  ! Get code_version_uvt_current
  endif
  call newuvt_cut(xima,nvis+o_vis,file_uv_version,error)
  call newuvt_close(xima)
  error = .true.
  return
end subroutine clic_table
!
subroutine check_table(nc, nv, vis, nn, ndobs, ndscan, error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! CLIC TABLE command :
  ! Check that new data is really new
  !---------------------------------------------------------------------
  integer :: nc                     !
  integer :: nv                     !
  real :: vis(nc,nv)                !
  integer :: nn                     !
  integer :: ndobs(nn)              !
  integer :: ndscan(nn)             !
  logical :: error                  !
  ! Local
  integer :: i, j, iscan, idobs, lch
  character(len=11) :: cdobs
  character(len=80) :: ch
  !-----------------------------------------------------------------------
  !
  do i=1, nv
    iscan = vis(3,i)
    idobs = vis(4,i)
    do j=1, nn
      if ((ndobs(nn).eq.idobs).and.(ndscan(nn).eq.iscan)) then
        error = .true.
        call datec(idobs,cdobs,error)
        ch = 'Scan '
        write(ch(6:10),'(i5)') iscan
        ch (11:) = ' Date '//cdobs//' already in output table'
        lch = lenc(ch)
        call message(8,4,'CHECK_TABLE',ch(1:lch))
        return
      endif
    enddo
  enddo
end subroutine check_table
!
subroutine dummy_visi(visi,n)
  !---------------------------------------------------------------------
  ! Add a dummy (zero weight) visibility in the table to defne the
  ! field of view for automatic imaging
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: visi(n)                   !
  ! Local
  integer :: i
  !
  visi(1) = 7.5                ! meter
  do i = 2, n
    visi(i) = 0.0
  enddo
end subroutine dummy_visi
!
subroutine check_window(fmin,fmax,imin,imax,inbc,nwin)
  !
  ! Checks windows overlap, optionally, reduce window number
  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  !
  integer :: inbc, nwin, imin(mnbb,2*(mwin_out+mrlband))
  integer :: imax(mnbb,2*(mwin_out+mrlband))
  real :: fmin(mnbb,2*(mwin_out+mrlband))
  real :: fmax(mnbb,2*(mwin_out+mrlband))
  ! Local
  integer :: iwi, kov, nov, iov(mrlband)
  logical :: overlap
  real :: f1, fn
  !
  overlap = .false.
  nov = 0
  !
  f1 = fmin(inbc,nwin)
  fn = fmax(inbc,nwin)
  do iwi=1, nwin - 1
     if (((f1.ge.fmin(inbc,iwi)).and.(f1.le.fmax(inbc,iwi))).or.((fn.ge.fmin(inbc,iwi)).and.(fn.le.fmax(inbc,iwi)))) then
        overlap = .true.
        nov = nov+1
        iov(nov) = iwi
     endif
  enddo
  if (overlap) then
     ! Checks and extends existing windows if applicable
     do kov = nov, 1, -1
        fmin(inbc,iov(kov)) = min(fmin(inbc,iov(kov)), &
             fmin(inbc,nwin))
        if (fmin(inbc,iov(kov)).gt.fmin(inbc,nwin)) then
           imin(inbc,iov(kov)) = imin(inbc,nwin)
        endif
        fmax(inbc,iov(kov)) = max(fmax(inbc,iov(kov)), &
             fmax(inbc,nwin))
        if (fmax(inbc,iov(kov)).lt.fmax(inbc,nwin)) then
           imax(inbc,iov(kov)) = imax(inbc,nwin)
        endif
        nwin = nwin-1
     enddo
  endif
end subroutine check_window

subroutine print_window(fmin,fmax,nbc,nwin)
  !
  ! Print windows
  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  !
  integer :: nwin, nbc
  real :: fmin(mnbb,2*(mwin_out+mrlband))
  real :: fmax(mnbb,2*(mwin_out+mrlband))
  !
  integer :: iwin
  !
  print *,"I-PRINT_WINDOW",nwin,"windows"
  do iwin=1,nwin
     print *,"Window #",iwin,"fmin",fmin(nbc,iwin),"fmax",fmax(nbc,iwin)
  enddo
end subroutine print_window

subroutine check_units(first,error)
  use gildas_def
  use classic_api
  logical :: first
  logical :: error
  ! Global
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  ! Local
  integer :: i, iunit, save_unit(mrlband)
  real*8  :: save_cen(mrlband)
  real*4  :: save_res(mrlband)
  character(len=80) :: ch
  save save_unit, save_cen, save_res
  !-----------------------------------------------------------------------------
  if (first) then
    if (lsubb_out.lt.1.or.lsubb_out.gt.r_lband) then
       call message(6,3,'CHECK_UNITS','Invalid selection')
       error = .true.
       return
    endif
    do iunit =1, lsubb_out
       if (isubb_out(iunit).gt.mbands) then
         i = isubb_out(iunit)-mbands
       else
         i = isubb_out(iunit)
       endif
       save_unit(iunit) = r_iunit(i)
       save_cen(iunit) = r_lfcen(i)
       save_res(iunit) = r_lfres(i)
    enddo
  else
    do iunit =1, lsubb_out
       if (isubb_out(iunit).gt.mbands) then
         i = isubb_out(iunit)-mbands
       else
         i = isubb_out(iunit)
       endif
       if (i.gt.r_lband) then
         call message(6,3,'CHECK_UNITS','Unit '//csub(isubb_out(iunit))// &
            ' absent from dataset')
         error = .true.
         return
       endif
       if (r_iunit(i).ne.save_unit(iunit)) then
         write (ch,'(a,a,a,i2,a,i2)') 'Logical unit ', &
           csub(isubb_out(iunit)), ' modified from physical unit ', &
            save_unit(iunit),' to physical unit ',r_iunit(i)
         call message(6,3,'CHECK_UNITS',trim(ch))
         error = .true.
         return
       endif
       if ((r_lfcen(i).ne.save_cen(iunit)).or.  &
           (r_lfres(i).ne.save_res(iunit))) then
         write (ch,'(a,a,a)') 'Setup of subband ', &
           csub(isubb_out(iunit)), ' modified in data set'
         call message(6,3,'CHECK_UNITS',trim(ch))
         error = .true.
         return
       endif
    enddo
  endif
  return
end subroutine check_units

module uv_sort_codes
  !
  integer(kind=4), parameter :: code_sort_bt=1     ! BASE then TIME
  integer(kind=4), parameter :: code_sort_tb=2     ! TIME then BASE
  integer(kind=4), parameter :: code_sort_ubt=3    ! UNIQUE-BASE then TIME
  integer(kind=4), parameter :: code_sort_field=4  ! FIELD
  !
  integer(kind=4), parameter :: ncode_sort=4
  character(len=6), parameter :: sort_names(ncode_sort) = &
    (/ 'BASE  ','TIME  ','UNIQUE','FIELD ' /)
  !
end module uv_sort_codes

subroutine display_uv(chain,error)
  use gbl_message
  use mapping_interfaces, except_this=>display_uv
  use clean_def
  use clean_arrays
  use uv_sort_codes
  !----------------------------------------------------------------------
  ! @ private
  !   SHOW UV
  !     TIME-BASE sort the UV table before displaying it
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  logical,          intent(inout) :: error  ! Logical error flag
  !
  ! Check data presence in buffer
  if (.not.associated(duv)) then
     call map_message(seve%e,'SHOW','No UV data')
     error = .true.
     return
  endif
  !
  ! Sort buffer (TIME-BASE) when needed and create the associated SIC buffer
  if (.not.allocated(duvt)) then
     call uv_tri(code_sort_tb,error)
     if (error) return
  endif
  !
  ! Plot SIC buffer
  call exec_program('@ p_uvshow_w.map w '//chain)
  !
end subroutine display_uv
!
subroutine uv_sort_comm(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_sort_comm
  use uv_sort_codes
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   UVSORT [TIME|BASE|FIELD]
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line  ! Command line
  logical,          intent(inout) :: error ! Logical error flag
  ! Local
  integer(kind=4) :: code,na
  character(len=6) :: argu,vvoc
  !
  ! Parse input line. Default argument is TIME
  argu = 'TIME'
  call sic_ke(line,0,1,argu,na,.false.,error)
  if (error) return
  call sic_ambigs('UV_SORT',argu,vvoc,code,sort_names,ncode_sort,error)
  if (error) return
  !
  ! Sort uv buffer
  if (code.eq.code_sort_field) then
     call uv_fsort(error)
  else
     call uv_tri(code,error)
  endif
  if (error) return
  !
end subroutine uv_sort_comm
!
subroutine uv_fsort(error)
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces, except => uv_fsort
  use clean_def
  use clean_arrays
  !-----------------------------------------------------------------
  ! @ private
  ! Support routine for command UV_SORT
  ! Allows for sorting for fields using mosaic uv sorting routines
  !-----------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='UV_SORT'
  logical :: warning,sorted
  logical, allocatable :: signv(:)
  integer(kind=4) :: ier,ncol,nv,nf,xoff,yoff,loff,moff,ixcol,iycol
  integer(kind=index_length) :: iv,ifi,fsize(1)
  integer(kind=4), allocatable :: it(:)
  real(kind=4) :: cs(2),uvmax,uvmin,xy(2)
  real(kind=4), allocatable :: uarr(:),varr(:),foff(:,:),newv(:)
  real(kind=8), allocatable :: farr(:)
  !
  if (.not.associated(duv)) then
     call map_message(seve%e,rname,'No UV data')
     error = .true.
     return
  endif
  ! Do we find pointing offsets?
  xoff = huv%gil%column_pointer(code_uvt_xoff)
  yoff = huv%gil%column_pointer(code_uvt_yoff)
  if ((xoff.ne.0).or.(yoff.ne.0)) then
     ! Yes => This is a mosaic
     if (yoff.ne.xoff+1) then
        ! Ill-defined mosaic
        call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
        error = .true.
        return
     endif
     ixcol = xoff
     iycol = yoff
  else
     ! No => Do we find phase offsets?
     loff = huv%gil%column_pointer(code_uvt_loff)
     moff = huv%gil%column_pointer(code_uvt_moff)
     if ((loff.ne.0).or.(moff.ne.0)) then
        ! Yes => This is a mosaic
        if (moff.ne.loff+1) then
           ! Ill-defined mosaic
           call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
           error = .true.
           return
        endif
        ixcol = loff
        iycol = moff
     else
        ! No => This is a single-field
        error = .true.
        call map_message(seve%e,rname,'UV table contains a single field, cannot sort it by field')
        return
     endif
  endif  
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check if new UV Table (duvt) is already allocated
  if (allocated(duvt))  deallocate (duvt)
  !
  ! Copy header information
  call gildas_null(huvt)
  call gdf_copy_header(huv,huvt,error)
  if (error) return
  !
  ! Allocate duvt
  allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
     call map_message(seve%e,rname,'Error allocating secondary UV buffer')
     error = .true.
     return
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  ! Start sorting using routines from Mosaic mode
  !
  nv = huv%gil%dim(2)
  ncol = huv%gil%dim(1)
  cs(1) = 1.0 ! no UV shift
  cs(2) = 0.0 ! no UV shift
  xy(1) = 0.0 ! no UV shift
  xy(2) = 0.0 ! no UV shift
  !
  allocate(uarr(nv), varr(nv), signv(nv), farr(nv), it(nv), stat=ier)
  if (ier.ne.0) then
     call map_message(seve%e,rname,'Error allocating work arrays')
     error = .true.
     return
  endif
  call loaduv(duv, ncol, nv, cs, uarr, varr, signv, uvmax, uvmin)
  ! Loading field numbers
  call loadfiuv(duv, ncol, nv, farr, it, sorted, ixcol, iycol, varr, nf, foff)
  !
  ! Proceed to sorting
  if (.not.sorted) then
     call gr8_trie (farr,it,nv,error) ! Actual sorting using quicksort
     deallocate (farr, stat=ier) ! Deallocate farr to save some memory
     allocate (newv(nv), stat=ier)
     if (ier.ne.0) then
        call map_message(seve%e,rname,'Error allocating work arrays')
        error = .true.
        return
     endif
     !
     ! v is sorted here so sortuv can be used later
     do iv=1,nv
        newv(iv) = varr(it(iv))
     enddo
     varr(:) = newv(:)
     deallocate (newv,stat=ier) ! Deallocate newv to save some memory
  else
     deallocate (farr,stat=ier) ! if data is already sorted dealocate farr since it will not be used
  endif
  ! Apply sorting to output visibilities
  call sortuv (duv, duvt, ncol, nv, huv%gil%ntrail, xy, uarr, varr, signv, it)
  !
  ! Deallocate reamining arrays to avoid leaks
  deallocate(uarr, varr, signv, it)
  !
  ! Adding field start and end info to Fields variable
  if (allocated(themap%ifields)) deallocate(themap%ifields)
  allocate(themap%ifields(nf+1))
  ifi = 1
  themap%ifields(ifi) = 1
  do iv=1,nv
     if ( (foff(1,ifi).ne.duvt(ixcol,iv)) .or. &
          &  (foff(2,ifi).ne.duvt(iycol,iv)) ) then
        ifi = ifi+1
        themap%ifields(ifi) = iv
     endif
  enddo
  themap%ifields(nf+1) = nv+1
  fsize(1) = nf+1  
  call sic_def_inte("FIELDS%ifields",themap%ifields,1,fsize,.true.,error)
  deallocate(foff)
  !
  error = .false.
end subroutine uv_fsort
!
subroutine uv_tri(code,error)
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_tri
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   UVSORT [TIME|BASE|UNIQUE]
  !----------------------------------------------------------------------
  integer(kind=4), intent(in)    :: code  ! Sorting code
  logical,         intent(inout) :: error ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_SORT'
  integer(kind=4) :: ier,nd,nv,id,iv
  integer(kind=4), allocatable :: it(:),ot(:)
  real(kind=8), allocatable :: order(:)
  logical :: sorted, warning, alloc
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check first if UVT is already matching UV
  alloc = .false.
  if (allocated(duvt)) then
    if ( (huv%gil%dim(2).ne.huvt%gil%dim(1)) .or. &
      & (huv%gil%dim(1)+3.ne.huvt%gil%dim(2)) ) then
      deallocate (duvt)
    else
      alloc = .true.
    endif
  endif
  !
  call gildas_null (huvt, type = 'TUV')
  call gdf_transpose_header(huv,huvt,'21  ',error)
  if (error)  return
  nd = huvt%gil%dim(2)
  nv = huvt%gil%dim(1)
  huvt%gil%dim(2) = nd+3
  !
  if (.not.alloc) then
    allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Error getting UV memory ')
      error = .true.
      return
    endif
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  allocate(order(nv),it(nv),ot(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Error getting memory ')
    error = .true.
    return
  endif
  !
  call uv_findtb(code,duv,nv,nd,order,it,ot,sorted,error)
  if (error)  return
  if (sorted) then
    Print *,'****  SHOW UV -- already sorted for code ',code
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,iv)
      enddo
    enddo
  else
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duv(id,it(iv))
      enddo
    enddo
  endif
  do iv=1,nv
    duvt(iv,nd+1) = 1.0
  enddo
  deallocate(order,it,ot)
  !
end subroutine uv_tri
!
subroutine uv_findtb(code,uv,nv,nd,order,it,ot,sorted,error)
  use gbl_message
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_findtb
  use uv_sort_codes
  !---------------------------------------------------------------
  ! @ private
  !   Support for SHOW UV
  !---------------------------------------------------------------
  integer(kind=4), intent(in)    :: code       ! Code for sort operation
  integer(kind=4), intent(in)    :: nd,nv      ! Size of visibility table
  real(kind=4),    intent(in)    :: uv(nd,nv)  ! Input UV data
  real(kind=8),    intent(out)   :: order(nv)  ! Sorting array
  integer(kind=4), intent(out)   :: it(nv)     ! Sort index
  integer(kind=4), intent(out)   :: ot(nv)     ! Reverse order
  logical,         intent(out)   :: sorted     ! Is already sorted
  logical,         intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UV_SORT'
  integer(kind=4), parameter :: datecol=4
  integer(kind=4), parameter :: timecol=5
  integer(kind=4), parameter :: anticol=6
  integer(kind=4), parameter :: antjcol=7
  real(kind=4) :: rdate
  real(kind=8) :: olast
  integer(kind=4) :: iv
  real(kind=4) :: anti,antj,antmin,antmax  ! As they are also REAL*4 in the data
    ! format, avoid rounding issues as we use them as floats anyway.
  !
  select case (code)
  case (code_sort_bt)
    ! Order BASE(primary) then TIME(secondary). Build float list as:
    !   Antenna I   x  100*1000*86400 [pseudo-sec]
    ! + Antenna J   x      1000*86400 [pseudo-sec]
    ! + OffsetDate  x           86400 [sec]
    ! + Time                          [sec]
    ! This assumes 'OffsetDate' is less then 1000, and 'Antenna J' is less
    ! than 100.
    rdate = uv(datecol,1)
    do iv=1,nv
      order(iv) = 1000.d0*86400.0d0*(100.d0*uv(anticol,iv)+uv(antjcol,iv)) +  &
                  (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv)
    enddo
    !
  case (code_sort_ubt)
    ! Order by UNIQUE-BASE then TIME. UNIQUE-BASE means that bases 1-2
    ! and 2-1 are considered equal, and evaluated as 1-2. Then the sorting
    ! strategy is identical to BASE-TIME ordering.
    rdate = uv(datecol,1)
    do iv=1,nv
      anti = uv(anticol,iv)
      antj = uv(antjcol,iv)
      if (anti.lt.antj) then
        antmin = anti
        antmax = antj
      else
        antmin = antj
        antmax = anti
      endif
      order(iv) = 1000.d0*86400.0d0*(100.d0*antmin+antmax) +  &
                  (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv)
    enddo
    !
  case (code_sort_tb)
    ! Order TIME(primary) then BASE(secondary). Build float list as:
    !   OffsetDate  x  86400  [sec]
    ! + Time                  [sec]
    ! + Antenna I   x  0.01   [pseudo-sec]
    ! + Antenna J   x  0.0001 [pseudo-sec]
    ! This assumes 'Antenna I' and 'Antenna J' are less than 100.
    rdate = uv(datecol,1)
    do iv=1,nv
      order(iv) = (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv) +   &
                  (100.0d0*uv(anticol,iv)+uv(antjcol,iv))*1.0d-4
    enddo
    !
  case default
    call map_message(seve%e,rname,'Code is not implemented')
    error = .true.
    return
  end select
  !
  ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
  ! which have no unique ordering...
  olast = order(1)
  sorted = .true.
  do iv=1,nv
    if (order(iv).lt.olast) then
      sorted = .false.
      exit
    endif
    olast = order(iv)
  enddo
  if (sorted) return
  !
  call gr8_trie(order,it,nv,error)
  if (error) return
  !
  do iv=1,nv
    ot(it(iv)) = iv
  enddo
  !
end subroutine uv_findtb
!
subroutine uv_flag_comm(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_flag_comm
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Support routine for command
  !     UV_FLAG [/ANTENNA] [/RESET]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Logical error flag
  !
  integer :: iant
  integer, parameter :: O_RESET=2
  integer, parameter :: O_ANT=1
  !
  ! Parse input line
  if (sic_present(O_RESET,0)) then  ! /RESET
    ! Reset flag array
    call reset_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
  else if (sic_present(O_ANT,0) ) then  ! /ANTENNA
    call sic_i4(line,O_ANT,1,iant,.true.,error)
    if (error) return
    ! Plot data
    call sic_let_logi('uvshow%flag',.true.,error)
    call display_buffer_sub('UV_FLAG',2,line,error)
    if (error) return
    call get_uvflag_ant(duvt,huvt%gil%dim(1),huvt%gil%dim(2),iant)
  else
    ! Plot data
    call sic_let_logi('uvshow%flag',.true.,error)
    call display_buffer_sub('UV_FLAG',2,line,error)
    if (error) return
    ! Make user to define a polygon from cursor
    call greg_poly_define('UV_FLAG','',.false.,supportpol,supportvar,error)
    if (error)  return
    ! Get flag array
    call get_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    call sic_let_logi('uvshow%flag',.false.,error)
  endif
  ! Apply flag array to buffer
  call apply_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2)-3,duv)
  do_weig = .true.
  optimize(code_save_uv)%lastnc = -1 !  means UV data.
end subroutine uv_flag_comm
!
subroutine get_uvflag_ant(uvs,nv,nd,iant)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Set uvflag array from antenna number
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  integer, intent(in) :: iant
  !
  ! Local variables
  integer ne,nf,i
  !
  ne = nd-1
  nf = nd-2
  do i=1,nv
    if (uvs(i,6).eq.iant .or. uvs(i,7).eq.iant) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_ant
!
subroutine get_uvflag(uvs,nv,nd)
  use gildas_def
  use clean_support
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Get uvflag array from polygon (0 => Flag, 1 => Keep)
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)
  !
  ! Local variables
  integer ne,nf
  !
  ne = nd-1
  nf = nd-2
  !
  ! Oh gosh, all that logic assumes the plotted stuff is in
  ! ne, nd, nf ...
  call gr4_inout(supportpol,uvs(1,ne),uvs(1,nd),uvs(1,nf),nv,.true.)
  !
end subroutine get_uvflag
!
!
subroutine reset_uvflag(uvs,nv,nd)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Reset uvflag array to 1
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   ! UV data set
  !
  ! Local variables
  integer :: nf,i
  !
  nf = nd-2
  do i=1,nv
     uvs(i,nf) = 1.0
  enddo
end subroutine reset_uvflag
!
subroutine apply_uvflag(uvs,nv,nd,uv)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Apply uvflag array by making negative the weight of the flagged data
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd        ! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   ! UV data set
  real, intent(inout) :: uv(nd,nv)    ! Transposed version
  !
  ! Local variables
  real :: factor
  integer :: i,j
  !
  ! Loop on visibilities
  do i=1,nv
     ! Apply uvflag array
     factor = 2*uvs(i,nd+1)-1    ! 1 or -1 depending on selected option
     do j=10,nd,3
        uvs(i,j) = abs(uvs(i,j))*factor
     enddo
     ! Transpose uvs completely because uv and uvs may be ordered differently...
     do j=1,nd
        uv(j,i) = uvs(i,j)
     enddo
  enddo
end subroutine apply_uvflag
